#ifndef ALIGNDELEGATE_H
#define ALIGNDELEGATE_H

#include <QStyledItemDelegate>
#include <QDoubleSpinBox>

class AlignIconDelegate: public QStyledItemDelegate{
public:
    using QStyledItemDelegate::QStyledItemDelegate;

protected:
    void initStyleOption(QStyleOptionViewItem *option, const QModelIndex &index) const override
    {
        QStyledItemDelegate::initStyleOption(option, index);
        option->decorationPosition = QStyleOptionViewItem::Right;
        option->displayAlignment = Qt::AlignRight | Qt::AlignVCenter;
    }
};

class AlignFloatDelegate: public QStyledItemDelegate{
    public:
        using QStyledItemDelegate::QStyledItemDelegate;
        void setDecimals(int n) {mDecimals = n;}
        void setRange(float mini, float maxi) {minimum=mini; maximum=maxi;}

        QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& , const QModelIndex& ) const override
        {
                QDoubleSpinBox* box = new QDoubleSpinBox(parent);

                box->setDecimals(mDecimals);

                box->setSingleStep(0.01);
                box->setMinimum(minimum);
                box->setMaximum(maximum);

                return box;
         }
protected:
    QString displayText(const QVariant &value, const QLocale &locale) const override
    {
        return locale.toString(value.toFloat(),'f',mDecimals);
    }
    void initStyleOption(QStyleOptionViewItem *option, const QModelIndex &index) const override
    {
        QStyledItemDelegate::initStyleOption(option, index);
        option->displayAlignment = Qt::AlignRight | Qt::AlignVCenter;
    }

private:
    int mDecimals;
    int minimum;
    int maximum;
};

#endif // ALIGNDELEGATE_H

