! ----------------------------------------------------------------------

      integer function get_hill_formula(cform,hform) result(ier)
      use elements
      implicit none
      character(len=*), intent(in)  :: cform
      character(len=*), intent(out) :: hform
      character(len=:), allocatable :: hhform
!
      call read_chemformula(cform,strfor=hhform,ord=.true.,fform=0,
     *                      hide1=.true.,ier=ier)
      if (ier == 0) hform = trim(hhform)//char(0)
!
      end function get_hill_formula

! ----------------------------------------------------------------------
      subroutine MsgWinErr(String,mesg,nType,iExitC)
      USE General, only: Msg, Inte, lo, SEVERE_ERR_WINDOW, 
     *ifAutomatic, QUEST_WINDOW_NO_YES
      USE Molcom, only: kscreen
      USE prognames, only: package_alt_name
      USE strutil, only: Lung,write_formatted_message,f_to_c
      USE mpi_prog, only: mpi_prog_rank
      implicit none
      interface
         subroutine MsgWinErrC(inte, msg, tipo, exitC) 
     *   bind(C,name="MsgWinErrC1")
         use iso_c_binding
         character(c_char), intent(in)     :: inte(*), msg(*)
         integer(c_int), intent(in), value :: tipo
         integer(c_int), intent(out)       :: exitC
         end subroutine MsgWinErrC
      end interface 
!
      character*(*), intent(in) :: String, mesg
      integer, intent(in)       :: nType
      integer, intent(out)      :: iExitC
      integer                   :: kf
      integer                   :: l2
!
      l2 = min0(Lung(mesg), 240)
      if (l2.gt.0) then
          Msg = mesg(1:l2)                !mr 290702
      else
          Msg = ' '
      endif
      l2 = min0(Lung(String), 80)
      if (l2.gt.0) then
          Inte = String(1:l2)             !mr 300403
      else
          Inte = ' '
      endif
!
      kf = Lung(Msg)
      if (nType.eq.SEVERE_ERR_WINDOW) then
          Msg(kf+1:) = char(10)//package_alt_name//
     *    ' will be terminated!!!'
      endif

      if (mpi_prog_rank == 0) then
          call write_formatted_message(lo,Inte,Msg,74)
      endif
      
! ---
      if (kscreen > 0 .and. ifAutomatic == 0) then
          call MsgWinErrC(f_to_c(String), f_to_c(mesg),
     *                nType, iExitC)
      else
          if (nType == QUEST_WINDOW_NO_YES) then
              iExitC = 0
          else
              iExitC = 1
          endif
      endif
!
      return
      end subroutine MsgWinErr
!qt! ----------------------------------------------------------------------
!qt      subroutine ControllaDir(dir,ierw)
!qt!
!qt      character*(*) dir
!qt!
!qt      k = Lung(dir)
!qt      dir(k+1:k+1) = char(0)
!qt      call c_controlladir(dir,ierw)
!qt      if (ierw == 0) then
!qt          ierw = -1
!qt      else
!qt          ierw = 0
!qt      endif
!qt!
!qt      return
!qt      end
!qt! ----------------------------------------------------------------------
!qt      subroutine zflush
!qt!
!qt      call cflush()
!qt!
!qt      return
!qt      end
!qt! ----------------------------------------------------------------------
      subroutine punto_e_basta(ix, iy)
!
      call cpunto_e_basta(ix,iy)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine UpdateMenu()
      USE General
      USE Molcom
!
      call c_update_menu_recprj()
!
      return
      end
!---------------------------------------------------------------------
      subroutine manage_console(iAction)
!
      call c_manage_console(iAction)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Chiocciola(Megastringa, Buffer,ifLcase)
!
      character*(*) MegaStringa, Buffer
!
      ik = index(MegaStringa,'@')
      if (ik.le.1) then
          Buffer = ' '
      else
          Buffer = Megastringa(1:ik-1)
      endif
      Megastringa(1:ik) = ' '
      call shift(Megastringa,lenp)
      call shift(Buffer,lenp)
      if (ifLcase.eq.1) then
          call lcase(Buffer)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine save_as(filnam, dirnam)
      USE Molcom
      USE General
      USE PhaseModule
!
!     filnam = nome del file da scrivere
!     dirnam = directory del file da scrivere
!
      character*(*) filnam
      character*(*) dirnam
      character*80 line, filename
!
      Msg = dirnam(1:Lung(dirnam)) // filnam(1:Lung(filnam))
      nlenB = 80
      istat = 0
      iform = 1
      jop=jopen(99,Msg,istat,iform,ierr)
!
      filename = 'tmp.tmp'
      nlenB = 80
      istat = 0
      iform = 1
      jop=jopen(iscra,filename,istat,iform,ierr)
      iEOF = 0
      do while (iEOF.eq.0)
         read(iscra,'(a)',end=100) line
      enddo
!
  100 close(iscra, status='delete')
      close(99)
!
      return
      end
! ----------------------------------------------------------------------
!corr      subroutine init_becca_punti (iCod)
!corr      USE Molcom
!corr      integer*4 iCod 
!corr!
!corr      nptr = 0
!corr      iQualeBecca = iCod
!corr!
!corr      return
!corr      end
!corr
! ----------------------------------------------------------------------
!corr      subroutine becca_punti (ix,iy, ier)
!corr      USE view, only : individua_patt
!corr      USE Conteggi, only:npunti
!corr!
!corr      integer :: ix,iy
!corr      integer :: ier
!corr      character *120 TmpLab
!corr!
!corr      ier = 0
!corr!
!corr      if (npunti > 0) then
!corr          ier = Individua_patt(ix,iy)
!corr      endif
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
!corr      subroutine GetBinV2(nome,file1,file2)
!corr      USE General
!corr      character*(*) nome, file1, file2
!corr      character*80  file
!
!corr      fname(1) = file1
!corr      fname(15) = file2
!corr      k = Lung(nome)
!corr      do i=2,14
!corr         file=nome(1:k)//ext(i)
!corr         call xcmprp(file,lfile)
!corr         fname(i)=file(1:lfile)
!corr      enddo
!
!corr      iTipo = 2
!corr      call updSWRC(iTipo,file1,file2)
!corr      call updRecentProjects()                      !mr
!corr      call LoadFromBin(file1,file2,ier)
!
!corr      return
!corr      end
! ----------------------------------------------------------------------

      subroutine exitsir2002() bind(C,name="exitsir2002")
      USE Atomi, only: nats
      USE General, only: ListaOK
      USE PatternRef, only: kexitrun
      USE Molcom, only: ifBrekke
      USE enable_amb, only: STOP_EVENT
      implicit none
      integer :: interp
!
      kexitrun = 1
      ifBrekke = STOP_EVENT
      if (ListaOK(15) == 1 .and. nats /= 0) then
          interp = 1
          call frm15d(interp)
      endif
!
      return
      end

! ----------------------------------------------------------------------
      subroutine ridisegna()
      USE VIEW
      USE conteggi
      implicit none
!
      if (npunti > 0 .and. allocated(theta_int)) then
          call vedinew()
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine putlab95(filein, fileout, ierr)
      USE General
      USE strutil
      USE fileutil
      USE expo_main
!
      implicit none
      !character*256 :: filein, fileout
      character(len=*) :: filein,fileout
      integer       :: ierr
      character*256 file1, file2
      character*80 Titolo
!corr      integer :: n1,n2,n3,n4
      integer :: i,k,itype,iform,nkscrx,nkscry
      integer :: jop,jopen
      integer :: ier,ier2,iTipo
!
      file1 = remc0(filein)
      file2 = remc0(fileout)
      ierr = 0
      call chiudi_bin(2)
!
      StructureName = file_rem_ext(file_get_name(file1))
      k = Lung(StructureName)
      do i=1,size(fname)
         if (i /= INP_FILE .and. i /= OUT_FILE) then
             fname(i) = s_blank_delete(trim(StructureName)//ext(i))
         endif
      enddo
      fname(INP_FILE) = file1
      fname(OUT_FILE) = file2
      StructureName = file_rem_ext(file_get_name(file1))
      itype = 0
      iform = 1
      close(lo)
      jop = jopen(lo,file2,itype,iform,ier2)
!
      call CheckWindowCommand(file1,nkscrx,nkscry,
     *                        Titolo,ier)
      iTipo = 1
!qt      call updSWRC(iTipo,file1,file2)
      call CheckStructCommand(file1,ier)            !mr 020204
!
!qt      call updRecentProjects()
!qt      call SetWindowTitle(Titolo)
!
      call mainloop(.false.,file1,ierr,param_options_type())
!
      return
      end
!-----------------------------------------------------------------------
!corr      subroutine prefourier(natsC,nadd)
!corr      USE General, only: celem, spacegr, neutro
!corr      USE elements
!corr      USE variables, only: atm
!corr      USE atom_type_util
!corr!
!corr      implicit none
!corr      integer*4 natsC 
!corr      integer*4 nadd 
!corr      real :: anat0, anat1
!corr!
!corr      natsC = numatoms(atm)
!corr!
!corr!-- computes number of peaks to add
!corr!
!corr      anat1 = natom_cell(atm,spacegr%nsymop,neutro==0)
!corr      anat0 = nasym_unit(celem,spacegr%nsymop,neutro==0)
!corr      nadd = nint(( anat0 - anat1 ) / spacegr%nsymop)
!corr      if (nadd < 5) then
!corr          nadd = 5
!corr      endif
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
      BLOCK DATA DEPEND
      include 'sircom.fi'
c
      character *80 MessH,Messages(200)
      common /scmess/MessH,Messages
      data nlen/2048/
!corr      data kff/1/
c     Environment
c     kprog =  1     SIR97      ( DOS )
c     kprog =  2     SIRPOW.97  ( DOS )
c     kprog =  3     MOLPLO     ( DOS )
c     kprog =  4     EXTRA      ( DOS )
c     kprog =  5     RIETVELD   ( DOS )
c     kprog = 11     SIR97      ( NON DOS )
c     kprog = 12     SIRPOW.97  ( NON DOS )
c     kprog = 13     MOLPLO     ( NON DOS )
c     kprog = 14     EXTRA      ( NON DOS )
c     kprog = 15     RIETVELD   ( NON DOS )
      data MessH/' '/
!corr      data Messages /200*' '/
c
      end
c ----------------------------------------------------------------------
      subroutine polynomial(iAction,icoef,ival)
      USE view
      common /backp2/ npol(10)
      integer*4 iAction ![REFERENCE]

      jjj=ival+1
      if (iAction==1) then
          icoef = npol(jjj)
      else
          npol(jjj) = icoef
          icontrollo = 1
          call CalcoBacExt(icontrollo)
          call vedinew()
      endif

      return
      end
c ----------------------------------------------------------------------
      subroutine salva_background(iAction,n_intervals)
      USE PatternRef
      common /backp2/ npol(10)
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      integer*4 iAction ![REFERENCE]
      integer*4 n_intervals ![REFERENCE]
!
      common /picbkgsav/nntl,backp2(10000,2),bkkb(11,10),nback2,
     *npolb(10),itipbaI,nactbaI,back_sav(36),ntypb(10000),thminbkgb
!
!     iAction = 1 --> salva background prima delle modifiche
!     iAction = 2 --> ripristina il background salvato se premo CANCEL
!
      n_intervals=nnt - 2
      if (iAction==1) then
         do 1 i=1, nback
            backp2(i, 1) = backp(i,1)
            backp2(i, 2) = backp(i,2)
            ntypb(i)=ntyp(i)
 1       continue
         nback2 = nback
         nntl = nnt
         do i=1,11
            do j=1,10
               bkkb(i, j) = bkk(i, j)
            enddo
         enddo
         do 5 i=1, nnt
            npolb(i) = npol(i)
    5    continue
      else
         nback = nback2
         do 11 i=1, nback
            backp(i,1) = backp2(i, 1)
            backp(i,2) = backp2(i, 2)
            ntyp(i)=ntypb(i)
 11      continue
         nnt = nntl
         do i=1,11
            do j=1,10
               bkk(i, j) = bkkb(i, j)
            enddo
         enddo
         do 15 i=1, nnt
            npol(i) = npolb(i)
   15    continue
         icontrollo = 0
         call CalcoBacExt(icontrollo)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine disegna_interval(ival,kdraw)
      USE VIEW
      USE CommonExpo, only : ncoun1,ncoun2
      USE Conteggi, only: npunti
      USE PatternRef
!
      integer*4 ival  ![REFERENCE]
      integer*4 kdraw ![REFERENCE]
!
      if (kdraw == 2) then
          if (ival >=0) jjj = ival + 1
          if (jjj > 10) then
              xzleft=1
              xzright=npunti
          else
              xzleft=ncoun1(jjj)
              xzright=ncoun2(jjj)
          endif
          call vedinew()
          return
      else if (kdraw == 3) then
          call vedinew()
      endif
      return
      end
! ----------------------------------------------------------------------
      subroutine disegna_display_legend()
      USE PatternRef
!
      call draw_display()
      return
      end
! ---------------------------------------------------------------------
      subroutine change_fontheight(kfnt)
      USE view
      USE Molcom
      USE conteggi, only:npunti
      implicit none
      integer :: kfnt
!
      FntPixHeight = kfnt
      if (npunti > 0) call vedinew()
!
      return
      end
! ---------------------------------------------------------------------
      subroutine stop_fortran_visible(visible)
      USE General, only: ifAutomatic
      USE Molcom, only: kscreen
      implicit none
      interface
         subroutine c_stop_fortran_visible(visible) 
     *   bind(C,name="c_stop_fortran_visible")
         use iso_c_binding
         integer(c_int), intent(in), value :: visible
         end subroutine c_stop_fortran_visible
      end interface
      integer, intent(in) :: visible
!
      if (kscreen == 1 .and. ifAutomatic == 0) then
          call c_stop_fortran_visible(visible)
      endif
!      
      end subroutine stop_fortran_visible
! ---------------------------------------------------------------------
      subroutine stop_fortran()
      USE General, only: ifAutomatic
      USE Molcom, only: kscreen
      USE interop_cpp_for, only: dosingleiteration
      implicit none
      interface
         subroutine c_stop_fortran() bind(C,name="c_stop_fortran")
         end subroutine c_stop_fortran
      end interface
!
      if (kscreen == 1 .and. ifAutomatic == 0) then
          call c_stop_fortran()
          call DoSingleIteration()
      endif
!
      return
      end
! -----------------------------------------------------------------
!!mr      subroutine startlabelling()
!!mr      USE General
!!mr      USE PatternRef
!
!     nspec_lab      = numero di specie selezionate (1 o 2)
!
!     ncoord_lab     = 1 --> coordinazione tetraedrica
!     ncoord_lab     = 2 --> coordinazione ottaedrica
!     ncoord_lab(1)  = coordinazione della prima specie
!     ncoord_lab(2)  = coordinazione della seconda specie
!
!     ispecie_lab(1) = num. d'ordine della prima specie
!     ispecie_lab(2) = num. d'ordine della seconda specie
!
!     npeaks_lab(1)  = num. di picchi da rilabellare per la prima specie
!     npeaks_lab(2)  = num. di picchi da rilabellare per la seconda specie
!
!     valori_lab(1) = distanza pesante-pesante
!     valori_lab(2) = tolleranza sulla distanza pesante-pesante
!     valori_lab(3) = distanza pesante-leggero
!     valori_lab(4) = tolleranza sulla distanza pesante-leggero
!
!
!  10 format(
!    *  'Variabili in uscita dalla interfaccia LABELLING:',/
!    *  '    nspec_lab       =',i4)

!     write(0,20) (i,ncoord_lab(i),i=1,nspec_lab)
!  20 format(
!    *  '    ncoord_lab(',i2,')',i4)

!     write(0,30) (i,ispecie_lab(i),i=1,nspec_lab)
!  30 format(
!    *  '    ispecie_lab(',i2,')',i4)

!     write(0,40) (i,npeaks_lab(i),i=1,nspec_lab)
!  40 format(
!    *  '    npeaks_lab(',i2,')',i4)

!     write(0,50) (i,valori_lab(i),i=1,4)
!  50 format(
!    *  '    valori_lab(',i2,')',f6.3)
!
!!mr      jrests = 0
!!mr      call changelabel(ier,iier)
!
!!mr      if (iier < 0) then
!!mr          Msg = ' Programming error in Labelling'//char(10)//
!!mr     *          ' Check output'
!!mr          call MsgWinErr('Error', Msg, ERR_WINDOW, nExitCode)
!!mr      endif
!
!!mr      return
!!mr      end
!-----------------------------------------------------------------------
!corr      subroutine startpolpo()
!corr      USE General
!corr      USE Atomi
!corr      USE variables, only: atm,lconn
!corr      USE sinterface
!corr      USE Conteggi, only: npunti
!corr      common /graphic_restart/kgraph_restart,ncyc_restart,nset_restart
!corr      common /conteggisav/npuntisav,nrefsav
!corr!
!corr      kgraph_restart=1
!corr      call polyedra(ier)
!corr
!corr!Ripristina nrefl e npunti
!corr      npunti=npuntisav
!corr      nrefl=nrefsav
!corr
!corr      kgraph_restart=0
!corr      call scrper(' ',0,-1)
!corr      if (ier /= 0) then
!corr          Msg = ' Programming error in polyedra'//char(10)//
!corr     *          ' Check output'
!corr          call MsgWinErr('Error', Msg, ERR_WINDOW, nExitCode)
!corr          call atom_to_xyzs(atm,lconn)      ! ripristina il vecchio modello
!corr      else
!corr          call update_atm()   ! aggiorna atm, lconn
!corr      endif
!corr!
!corr      return
!corr      end
! ---------------------------------------------------------------------

      subroutine export_file_exp()
!
!     Crea un nuovo file .exp del tipo nomefile1.exp
!
      USE General
      USE programinput
      USE fileutil
      implicit none
      character(len=780)  :: newf
      integer             :: nExitC
!
!     Genera il nome del file
      newf = trim(file_rem_ext(fname(INP_FILE)))//'1'//'.exp'
!
!     Mostra messaggio informativo
      Msg = 'Input file '//trim(newf)//' with new '//
     *      'crystal data will be created'
      call MsgWinErr('Info', Msg, INFO_WINDOW, nExitC)
!
!     Leggi la cella dalla lista
      call xfl01()
!
!     Scrivi il nuovo file
      call write_input_file(input_file_create(newf))
!
      end subroutine export_file_exp

!-----------------------------------------------------------------------

      subroutine chiudi_bin(flag)
      USE General
      USE Molcom
      USE conteggi, only:npunti
!
      Integer*4 flag ![REFERENCE]
!
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
!
      if(flag.eq.1) then
         close(jdir, status = 'delete')
      else
         call xdump()
         close(jdir)
      endif
      icfle=-1
      ifProject = 0
      jscreen = 1
      call AllocaConteggi(2); npunti=0
      call AllocaCalcfig(2)
      call AllocaCalcProfile(2)
      call AllocaProfileApp(2)
      call AllocaSmoothing(2)
      call AllocaDeriv(2)
      call AllocaCalcProfileApp(2)
      call AllocaCorrelazione(2)
      call AllocaBackintsav(2)
      call AllocaExtraIndix(2)
C     call AllocaRiflessi(2)
C     call AllocaPhaseStuff(2)
C     call AllocaMappa(2)
!
      call InitExpo2002(1)
      return
      end
! ----------------------------------------------------------------------
      subroutine get_nz_from_F(nzeta)
      USE Atomi
      implicit none 
      integer nzeta(*), i
!
      do i=1,nats
         nzeta(i) = iabs(nz(i)) / nzConst
      enddo
!
      return
      end
! ----------------------------------------------------------------------
      subroutine toflush()
! ---
!     INTERFACE TO SUBROUTINE toflushc [C, ALIAS:'_toflushc'] ()
!     END
! ---
      !call toflushc()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cCopyFile(fsrc, fdst)
!
      implicit none
      integer Lung
      character*(*) fsrc, fdst
!
      call c_copyfile(fsrc(1:Lung(fsrc))//char(0),
     *                fdst(1:Lung(fdst))//char(0))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine lanciajavs()
      USE variables, only: cryst
      USE ilmviewmod
      USE General, only:StructureName
      implicit none
!
      call ilmview_open(StructureName)
      call ilmview_draw(cryst(1)%at,cryst(1)%bond,cryst(1)%elem,
     *cryst(1)%cell,cryst(1)%spg)
!
      end subroutine lanciajavs
