      module extramodule
      
      implicit none 
      
      real, dimension(:), allocatable    :: coef1,coef2
      integer, dimension(:), allocatable :: icare
      integer, dimension(:), allocatable :: inizc,ifinc

      integer, dimension(:), allocatable :: indovr
      integer, dimension(:), allocatable :: indov
      real, dimension(:), allocatable    :: eosse,weigt
      integer, dimension(:), allocatable :: ipres
      
      contains
      
        subroutine allocate_extra(nref)
        USE arrayutil
        integer, intent(in) :: nref
        call new_array(coef1,nref)
        call new_array(coef2,nref)
        call new_array(icare,nref)
        call new_array(inizc,nref)
        call new_array(ifinc,nref)

        call new_array(indovr,nref)
        call new_array(indov,nref)
        call new_array(eosse,nref)
        call new_array(weigt,nref)
        call new_array(ipres,nref)
        end subroutine allocate_extra
      
      end module extramodule

c ------------------------------------------------------------------
c     read reflexions from card input
      subroutine reflin(ier)
      USE Riflessi
      USE xdataMod
      USE RandomStaff, only:iprandom
      USE General
      USE Symmetry
      USE nr, only: indexx
      USE randofi
      use reflection_type_util, only: rhof
!
      common/ylimi/nfl,lfl,idummy(4),nfls
      common /celsav/cellas(6),porig(6)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /uno/ mxbg,indmb
      common /buffer/ vet(13,39)
!corr      common/bdata/ibig(124000)
c  if ibig dimension has to be changed, alter mxbg accordingly
      integer vsym(24)
      dimension ivet(13,39)
!corr      dimension abig(72000)
!corr      dimension abig(124000)
!corr      equivalence (ibig(1),abig(1))
      dimension vett(15),ivett(15)
      equivalence (vet(1,1),ivet(1,1))
      equivalence (vett,ivett)
      integer, dimension(:), allocatable :: iorder
c
      npseudsav=npseud
      nfl=1
      fosog=-999.9
      zero=0.000000001
      mxbg=120000
      nex=0
c  ksym=number of translational matrices different from ( 0.0 0.0 0.0 )
      ksym=0
      do 20 i=2,nsym
      ifl=0
      do 10 j=1,3
      if (abs(tsmat(j,i)).gt.0.00001) ifl=1
   10 continue
      if (ifl.eq.0) go to 20
      ksym=ksym+1
      vsym(ksym)=i
   20 continue
      klatt=latt-1
c-- reflections are in the direct access file
      iln=6
      call srlin (iln,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.le.0) then
                      write(Msg,3005)
 3005 format('No reflections in direct access file')
                      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
                      ier=-1
                      return
                    endif
!     call ysfl06(nrefl)
      call xfl06
!corr      nr=0
      if(itry.gt.0)then
      pp(1)=0.25*(astar**2)
      pp(2)=0.25*(bstar**2)
      pp(3)=0.25*(cstar**2)
      pp(4)=0.25*(2.0*astar*bstar*coscs )
      pp(5)=0.25*(2.0*astar*cstar*cosbs )
      pp(6)=0.25*(2.0*bstar*cstar*cosas )
      endif
      if(iprandom.gt.0)then
      do 4 i=1,3
      abc(i)=cellas(i)
      ang(i)=cellas(i+3)
   4  continue
      pp(1)=porig(1)              
      pp(2)=porig(2)                
      pp(3)=porig(3)             
      pp(4)=porig(4)                         
      pp(5)=porig(5)     
      pp(6)=porig(6)                                
      endif
!      
      call LeggiRiflessi
!g!   write(6,*) 'LISTA6R'
      do i=1,nrefl
         SetFob(i,4) = 0.0001
         SetFob(i,3) = 0.0    
         rho=rhof(pp,IndHKL(i,1),IndHKL(i,2),IndHKL(i,3))
         rho2=rho*rho
         twot=ctheta(rho2)
         TThet (i)   = twot     
         fext(i)=0.0
         if (neutro.eq.0.and.nsyn.eq.0) then
             alp = 1.0 + 0.8*(cos(TThet(i)*dtor))**2
         else
             alp = 1.0
         endif
         blp = sin(0.5*TThet(i)*dtor) * sin(TThet(i)*dtor)
         clp(i)=1.0
         if (abs(blp).gt.zero) clp(i)=alp/blp
         if (itry.gt.0) then
             ex(i)=fcvet(i)*Mult(i)*clp(i)
         endif
         if (knw.eq.0) then
             fxsav(i)=0.0
         else
             iknow=1
*            phasav(i)=iphiv(i)   ! gianluca 29/5/2008
         endif
         if (iext.eq.3) then
             fext(i)=fcvet(i)
         endif
!g!      write(6,7029) i,indhkl(i,1:5),setfob(i,1:4),
!g!  *               fxsav(i),fext(i),picran(i)
!g!      write(6,*) 'lista6r',setfob(i,4)
!g! 7029 format(i4,')',4i4,i6,4f8.3,5x,f12.3,2f8.3)
      enddo
!      
!      do 7030 i=1,nrefl
!      nr=nr+1
!      call snr06(vett)
!      IndHKL(nr,1) = ivett(1)
!      IndHKL(nr,2) = ivett(2)
!      IndHKL(nr,3) = ivett(3)
!      SetFob(nr,4) = 0.0001
!      SetFob(nr,3) = 0.0    
!      rho=rhof(pp,ivett(1),ivett(2),ivett(3))
!      rho2=rho*rho
!      twot=ctheta(rho2)
!      TThet (nr)   = twot     
!      Mult  (nr)   = ivett(11) 
!      fext(nr)=0.0
!      if(neutro.eq.0.and.nsyn.eq.0) then
!                 alp = 1.0 + 0.8*(cos(TThet(nr)*dtor))**2
!                     else
!                 alp = 1.0
!                   endif
!      blp = sin(0.5*TThet(nr)*dtor) * sin(TThet(nr)*dtor)
!      clp(nr)=1.0
!      if(abs(blp).gt.zero) clp(nr)=alp/blp
!      if(itry.gt.0)then
!      ex(nr)=vett(14)*Mult(nr)*clp(nr)
!      endif
!      if(knw.eq.0)then
!      fxsav(nr)=0.0
!      else
!      iknow=1
!      fxsav(nr)=vett(13)
!      IndHKL(nr,5) = ivett(12)
!     iphi8=mod(ivett(12),2**15)
!      phasav(nr)=float(iphi8/32)
!      endif
!      if(iext.eq.3)then
!     fext(nr)=vett(14)
!      endif
! 7030 continue
!
!corr
      allocate(iorder(nrefl))
      call indexx(TThet(:nrefl),iorder)
      IndHKL(:nrefl,1:5) = IndHKL(iorder,1:5)
      SetFob(:nrefl,1:5) = SetFob(iorder,1:5)
      TThet(:nrefl) = TThet(iorder)
      Mult(:nrefl) = Mult(iorder)
      WHM(:nrefl) = WHM(iorder)
      fxsav(:nrefl) = fxsav(iorder)
      fc(:nrefl) = SetFob(:nrefl,4)
!corr
!corr      lind=138001
!corr      iblk=15
!corr      jump=11
!corr      izer=15*nrefl
!corr      do 502 i=1,izer
!corr 502    abig(i) = 0.0
!corr      do 691 i=1,nrefl
!corr       ibig(15*(i-1)+1)=IndHKL(i,1)
!corr       ibig(15*(i-1)+2)=IndHKL(i,2)
!corr       ibig(15*(i-1)+3)=IndHKL(i,3)
!corr       ibig(15*(i-1)+4)=IndHKL(i,4)
!corr       ibig(15*(i-1)+5)=IndHKL(i,5)
!corr       abig(15*(i-1)+6)=SetFob(i,1)
!corr       abig(15*(i-1)+7)=SetFob(i,2)
!corr       abig(15*(i-1)+8)=SetFob(i,3)
!corr       abig(15*(i-1)+9)=SetFob(i,4)
!corr       abig(15*(i-1)+10)=SetFob(i,5)
!corr       abig(15*(i-1)+11)=TThet(i)
!corr       ibig(15*(i-1)+12)=Mult(i)
!corr       abig(15*(i-1)+13)=WHM(i)
!corr       abig(15*(i-1)+14)=fxsav(i)
!corr       abig(15*(i-1)+15)=SetFob(i,4)
!corr  691 continue
!corr*     call sortz(lind,nrefl,iblk,jump)
!corr!corr      idim = 72000
!corr      idim = izer
!corr      call sortz_dyn(abig,idim,1,nrefl,iblk,jump)
!corr      do 792 i=1,nrefl
!corr       IndHKL(i,1)=ibig(15*(i-1)+1)
!corr       IndHKL(i,2)=ibig(15*(i-1)+2)
!corr       IndHKL(i,3)=ibig(15*(i-1)+3)
!corr       IndHKL(i,4)=ibig(15*(i-1)+4)
!corr       IndHKL(i,5)=ibig(15*(i-1)+5)
!corr       SetFob(i,1)=abig(15*(i-1)+6)
!corr       SetFob(i,2)=abig(15*(i-1)+7)
!corr       SetFob(i,3)=abig(15*(i-1)+8)
!corr       SetFob(i,4)=abig(15*(i-1)+9)
!corr       SetFob(i,5)=abig(15*(i-1)+10)
!corr       TThet(i)=abig(15*(i-1)+11)
!corr       Mult(i)=ibig(15*(i-1)+12)
!corr       WHM(i)=abig(15*(i-1)+13)
!corr       fxsav(i)=abig(15*(i-1)+14)
!corr       fc(i)=abig(15*(i-1)+15)
!corr  792 continue
c---
c-- se faccio riciclo in extra e non richiamo la lista 7 ho pfwhm = valore
c-- della Fourier e non di data
      call ysfl07(iy)
      npseud=npseudsav
c---
      return
      end
c     ------------------------------------------------------------------
!corr      subroutine dirext(fileh,formt,nrun,ityp,fracout,ioptim,
      subroutine dirext(fileh,formt,nrun,ityp,nridb,nfspace,ksmoo,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE RandomStaff, only:ichoice
      USE randofi
!
      common /uffa/nnvolte,incremento,irefsem_tot(560)
      common /pesob/weigb(10000),nsmoothb
      character line*80,dire*80,diret*80,fileh*80,formt*80,filefc*80
      common /save/npolsav(10),refv(32,10)    !,fwb(3000,2)
!corr      common /savev/var(3100)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /cpseud_new/ ivet_new(3,4),percme   !,esqv(3000)
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
!corr      common /pkitc/ kit   !corr,kitvet(38)
      common/at/gis(142),giw(142)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /profp/dumpp,nprof,ipol
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common/try/itrysav,psav(12),nvoltemax
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /limiti/ nlini, nlfin
      common /backp2/ npol(10)
      common /pseudInv/ patom,qatom,lpseudInv(4,3)      
      dimension vet(40),ivet(40)
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
c
c set default values
c
c nprof=1 pearson
c nprof=2 gussian
c nprof=3 lorentzian
c nprof=4 pseudo-voigt
c
      ksmoo=0
      irandom=0
      iprandom=0
      sograndom=0.5
      nsmoothb=0
      nridb=0
      noback=0
      Msg='       '
      if(neutro.eq.1)then
       sogran=19.0
       else
       if(nsyn.eq.0)then
c      sogran=14.0
       sogran=8.0
       else
       sogran=4.0
       endif
       endif
      sogran2=sogran*2
      idump=0
      ipror=0
      if(nfspace.eq.0)then
c     ioptim=1
      ioptim=0
      else
      ioptim=0
      endif
      sigma=1.0
      ialt=0
      iext=0
      nstop=0
      do 8 i=1,12
      npse(i)=0
 8    continue
      do 9 i=1,8
      uvwt(i)=0.0
 9    continue
      cpse(1)=1.0
      cpse(2)=1.0
!corr      nk=0
      iknow=0
      if92=0
      nocell=0
!corr      if(kit.eq.1)if92=1
c     kequirip=0
c     pfwhm=0.1
      do 12 i=1,3
      iorie(i)=0
 12   continue
      gpror=0.0
      fracout=0.0
      nprof=1
      npseu=0
      noint=0
      nnt=1
      nsetint=0
      nosing=0
      iext=0
      iproff=0
      ipol=0
      inor=0
      izero=0
      iprin=0
      zeroprof=0.0
      dumpp=0.1
      nistp=0
      ityp=0
      iys=67543
      ncycle=22
      icycle=0
      jj=0
      do 10 i=1,19,2
      jj=jj+1
      j=i+20
      formt(i:i+1)='  '
   10 formt(j:j+1)='  '
      do 21 i=1,10
      npol(i)=11
      do 22 j=1,11
      bkg(j)=0.0
      bkk(j,i)=0.0
 22   continue
 21   continue
      do 51 i=1,10
      npolsav(i)=npol(i)
 51   continue
      mm=0
      mz=166
      th=2.0
      rhomin=0.0
      npc=1
      jjfile=jfile
c     jjfile=ln
      lix1=0
      lix2=0
      lix3=0
*     lix7=0
      lix37=0
!
      if(ichoice==1.and.nnvolte==0) call def_plus_rand(0)
!
c
c-- already exists a direct access file containing
c-- information concerning the structure
c
      iln=1
      call srlin (iln,lsn,lix1,ljxx,lkxx,llxx)
      if(lix1.gt.0) call xfl01
      iln=2
      call srlin (iln,lsn,lix2,ljxx,lkxx,llxx)
      if(lix2.gt.0) call yfl02
!corr      iln=3
!corr      call srlin (iln,lsn,lix3,ljxx,lkxx,llxx)
!corr      if(lix3.gt.0) call yfl03
      iln=6
      call srlin (iln,lsn,lix6,ljxx,lkxx,llxx)
!     if(lix6.gt.0) call ysfl06(nrefl)
      if(lix6.gt.0) call xfl06
      iln=37
      call srlin (iln,lsn,lix37,ljxx,lkxx,llxx)
      if(lix37.gt.0) call ysfl37(npunti)
      itrysav=itry
      if(nrun.eq.2.and.itry.eq.0)go to 8150
      if(nrun.eq.1)itry=0     
c
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if(nfspace.eq.1)icmax=0
      if (ic.gt.icmax) go to 8200
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with alphanumeric parameters
      if ((dire(1:4).eq.'frec').and.iext.eq.0) then
          iext=2
          formt(1:15)='(3i4,15x,f15.4)'
c         formt(1:15)='(3i4,f8.2)'
          call cutst(line,lenp,dire,lend)
          if(lend.le.0)go to 8000
          read(dire,'(a)') fileh
          jjfile=jfile
          go to 100
      endif
      if (dire(1:4).eq.'fsir') then
          iext=3
          itry=0
c          itry=1
          go to 100
      endif
      if (dire(1:4).eq.'form') then
          k=index(diret,'(')
          if (k.eq.0) go to 8000
          formt=diret(k:k+39)
          go to 100
      endif
      if (dire(1:4).eq.'calc') then
          iknow=1
          call cutst(line,lenp,dire,lend)
          if (lend.gt.0) then
              read(dire,'(a)')filefc
              fname(FC_FILE) = filefc
          endif
          go to 100
      endif
      if (dire(1:4).eq.'lowb') then
          nridb=1
          go to 100
      endif
      if (dire(1:4).eq.'bkgs') then
          ksmoo=1
          go to 100
      endif
      if (dire(1:4).eq.'opti') then
          ioptim=1
          noint=2
          go to 100
      endif
      if (dire(1:4).eq.'nosi') then
          nosing=1
          go to 100
      endif
      if (dire(1:4).eq.'noba') then
          noback=1
          go to 100
      endif
      if (dire(1:4).eq.'smoo') then
          nsmoothb=1
          go to 100
      endif
      if (dire(1:4).eq.'fast') then
          noint=1
          ioptim=0
          go to 100
      endif
      if (dire(1:4).eq.'slow') then
          noint=2
          ioptim=1
          go to 100
      endif
      if (dire(1:4).eq.'stan') then
          iproff=1
          go to 100
      endif
      if (dire(1:4).eq.'firs') then
          iproff=2
          go to 100
      endif
      if (dire(1:3).eq.'all') then
          iproff=3
          if(itrysav.gt.0)iproff=0
          go to 100
      endif
      if (dire(1:4).eq.'gaus') then
          nprof=2
          iproff=0
          go to 100
      endif
      if (dire(1:4).eq.'lore') then
          nprof=3
          iproff=0
          go to 100
      endif
      if (dire(1:4).eq.'pvoi') then
          nprof=4
          iproff=0
          go to 100
      endif
      if (dire(1:4).eq.'fval') then
          ityp=1
          go to 100
      endif
      if (dire(1:4).eq.'verb') then
          iprin=1
          go to 100
      endif
      if (dire(1:3).eq.'v92') then
          if92=1
          go to 100
      endif
      if (dire(1:4).eq.'noce') then
          nocell=1
          go to 100
      endif
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:4).eq.'pseu') then
          npseu=1
          iv1 = iv - 1
          if (mod(iv1,4).ne.0) go to 8000
          do 101 i=1,iv1
          npse(i)=ivet(i)
 101      continue
          cpse(2)=vet(iv)
          if(ipriorp.eq.2)cpse(2)=percme+(cpse(2)-percme)*0.5
          if(ipriorp.gt.2)go to 8001           
          percme=cpse(2)
          if(npse(12).gt.0.and.npse(8).gt.0)then
          prod=npse(4)*npse(8)*npse(12)
          npseud=3
          elseif(npse(8).gt.0)then
          prod=npse(4)*npse(8)
          npseud=2
          else
          prod=npse(4)
          npseud=1
          endif
          do 102 k=1,npseud
          do 103 kk=1,4
          lpseudInv(kk,k)=npse((k-1)*4+kk)
  103     continue
  102     continue
          jmme=nsym*(icent+1)
          emmem=float(jmme)
          go to 100
      endif
      if (dire(1:4).eq.'pror') then
          if (iv.ne.4) go to 8000
          ipror=1
          iorie(1)=ivet(1)
          iorie(2)=ivet(2)
          iorie(3)=ivet(3)
          gpror=vet(4)
          go to 100
      endif
      if (dire(1:4).eq.'rand') then
          iprandom=1         
          irandom=1                    ! random in extra
          if (iv.eq.1) sograndom=vet(1)
          if(sograndom.le.0) go to 8000
          go to 100
      endif
      if (dire(1:4).eq.'damp') then
          if (iv.ne.1) go to 8000
          idump=1
          dumpp=vet(1)
          go to 100
      endif
      if (dire(1:4).eq.'dif1') then
          ialt=2
          sigma=vet(1)
          go to 100
      endif
      if (dire(1:4).eq.'dif2') then
          ialt=1
          sigma=vet(1)
          go to 100
      endif
      if (dire(1:4).eq.'widt') then
          if (iv.ne.1) go to 8000
          fracout=vet(1)
          if (fracout.le.0) go to 8000
          go to 100
      endif
      if (dire(1:4).eq.'fwhm') then
          if (iv.ne.1) go to 8000
          uvwt(1)=vet(1)
          go to 100
      endif
      if (dire(1:4).eq.'zero') then
          if (iv.ne.1) go to 8000
          izero=1
          zeroprof=vet(1)
          if(abs(zeroprof).gt.1.0)go to 8199
          go to 100
      endif
      if (dire(1:4).eq.'ncyc') then
          if (iv.ne.1) go to 8000
          icycle=1
          ncycle=ivet(1)
          if(ncycle.lt.1.or.ncycle.gt.100)go to 8201
          go to 100
      endif
      if (dire(1:4).eq.'inte') then
          ipriort=ipriorp+ipriors+ipriopa+ipriofr
          if(itry.eq.0.and.ipriort.eq.0) then
             if (iv.ne.1) go to 8000
             if (ivet(1).le.0) go to 8000
             nsetint=1
             if(thmax-thmin.gt.sogran)then
                nthinte=int((thmax-thmin)/ivet(1))
                if(nthinte.lt.int(sogran))then
                   nnthinte=int((thmax-thmin)/sogran)
                   ivet(1)=nnthinte
                   if(itry.eq.0)then
                     if(ivet(1).le.8)then
                      write(Msg,998) ivet(1),sogran
  998 format('Supplied interval number has been',
     *' reduced  to',i5,' because the interval range should be ',
     *'greater than',f8.2,' degrees.')
                     call MsgWinErr('Warning',Msg,WARN_WINDOW,nExitCode)        
                     else
                       ivet(1)=8
                       write(Msg,988) ivet(1)
  988 format('Supplied interval number has been',
     *' reduced to',i4,' ( the program can manage up to 8 intervals )')
                     call MsgWinErr('Warning',Msg,WARN_WINDOW,nExitCode)
                     endif
                  endif
               endif
            else
               ivet(1)=1
            endif
            nnt=ivet(1)+1
            if(nnt.lt.2.or.nnt.gt.9)go to 8102
          endif
          go to 100
      endif
      if (dire(1:4).eq.'poly') then
          if (iv.ne.1) go to 8000
          ipol=1
          do 31 jj=1,10
          npol(jj)=ivet(1)+1
          if(npol(jj).lt.1.or.npol(jj).gt.11)go to 8103
 31       continue
          go to 100
      endif
      write(Msg,6000) diret(1:Lung(diret))
 6000 format('Wrong directive in extrac modulus: ',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      ier=-1
      return
 8000 continue
      ier=-1
      write(Msg,8101) diret(1:Lung(diret))
 8101 format('Error in extrac directive : ',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      return
 8001 continue
      write(Msg,8002)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
 8002 format('Pseudo information cannot '
     *,'be used more than twice')
      ier=-1
      return
 8199 continue
      write(Msg,999) 
  999 format('Supplied 2-theta shift could be large')
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
      ier=-1
      return
 8201 continue
      write(Msg,1001) diret(1:Lung(diret))
 1001 format('Forbidden value in directive',
     *' (cycle number must be positive and up to 50):',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      ier=-1
      return
 8102 continue
      write(Msg,1002) diret(1:Lung(diret))
 1002 format('Forbidden value in directive',
     *' (interval number must be positive and up to 8):',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      ier=-1
      return
 8103 continue
      write(Msg,1003) diret(1:Lung(diret))
 1003 format('Forbidden value in directive',
     *' (pol. back degree must be positive and up to 10):',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      ier=-1
      return
 8150 continue
      write(Msg,8241)                          
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      ier=-1
      return
 8241 format('No previous default run ')
 8200 continue
      if (ityp.gt.0.and.iext.eq.0)then
          write(Msg,8221)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
      endif
 8221 format('Directive fstarting is not in input')
      if (ialt.gt.0.and.itrysav.eq.0)then
          write(Msg,8222)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
      endif
 8222 format('Dif must be used with command restart ')
      if (sigma.le.0.0.and.itrysav.gt.0.and.ialt.gt.0)then
          write(Msg,8223)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
      endif
 8223 format('Sigma must be positive ')
      jfile=jjfile
      if (lix1.le.0) then
          write(Msg,8220)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
      endif
 8220 format('No cell parameters supplied')
      if (lix2.le.0) then
          write(Msg,8240)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
      else
c********
!corr          do 1050 kkkk=1,nsym
!corr          do 1050 iiii=1,3
!corr          do 1050 jjjj=1,3
!corr 1050     kmat(kkkk+nsym,iiii,jjjj)=-kmat(kkkk,iiii,jjjj)
!corr          do 1060 kkkk=1,nsym
!corr          do 1060 iiii=1,3
!corr 1060     tmat(kkkk+nsym,iiii)=-tmat(kkkk,iiii)
c********
          call musym()
c--
!corr          pop=pts*(float((icent+1)*nsym))
      endif
 8240 format('No space group symbol supplied')
c ---
c --- read scattering factors
c ---
*     if (lix3.le.0.and.inor.gt.0) then
!corr      if (lix3.le.0) then
!corr          write(Msg,8250)
!corr          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
!corr          ier=-1
!corr      endif
!corr 8250 format('No cell content supplied')
!corr      if (ier.lt.0) return
c ---
      if (lix6.le.0) then
          write(Msg,8260)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
      endif
 8260 format('No reflections in direct acces file')
      if (lix37.le.0) then
          write(Msg,8265)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
      endif
 8265 format('No counts in direct acces file')
c
      if (idump.eq.0.and.nsetint.eq.1) then 
          if(thmax-thmin.gt.sogran2.and.nnt.gt.1)then
             nthinte=int((thmax-thmin)/(nnt-1))
             if(nthinte.lt.int(sogran2))then
                dumpp=0.01
                if(itry.eq.0)then
                   write(Msg,997)
  997 format('Interval range is small:',
     *' the damping factor for refinement procedure has been reduced ')
                   call MsgWinErr('Warning',Msg,WARN_WINDOW,nExitCode)        
                endif
             endif
          endif
      endif
!corr      ipriort=ipriorp+ipriors+ipriopa+ipriofr
c     if(idump.eq.0.and.ipriort.gt.0)dumpp=0.2
      if(ialt.gt.0)itry=itrysav
      return
      end
c---------------------------------------------------------------------
c     read reflexions from card input
      subroutine profin(npoint,nridb,nfspace,ier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
!corr      include 'rando.fi'
      USE randofi
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common/try/itrysav,psav(12),nvolte
      common /uno/ mxbg,indmb
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /buffer/ vet(13,39)
      common/stima/nstima,ncodecyc
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
c  if ibig dimension has to be changed, alter mxbg accordingly
      dimension ivet(13,39),vat(12),ivat(12)
      equivalence (vet(1,1),ivet(1,1))
      equivalence (vat(1)  ,ivat(1)  )
c
      iprio = max0(ipriorp,ipriors)
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
      if (ipriorp.gt.0)  ipriosta = 2
      if (ipriors.gt.0)  ipriosta = ncodecyc
      zero=0.0000001
c  ksym=number of translational matrices different from ( 0.0 0.0 0.0 )
c-- counts are in the direct access file
      iln=37
      call srlin (iln,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.le.0) then
                      write(Msg,1260)
                      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
 1260 format('No counts in direct access file')
                      ier=-1
                      return
                    endif
      yminn=999999999.0
      ymaxx=-999999999.0
      do 7030 i=1,npunti
      call snr37(vat)
      if(itry.eq.0.and.ipriort.eq.0)then
      theta_int(i,1)=vat(1)
      theta_int(i,2)=vat(5)
      else
      theta_int(i,1)=vat(4)
      theta_int(i,2)=vat(2)
      theta_int(i,5)=vat(5)
      theta_int(i,4)=vat(1)
      endif
      theta_int(i,3)=vat(3) 
      theta_int(i,7)=0.0    
      back_int(i,1)=0.0
      back_int(i,2)=vat(6)
      if(theta_int(i,2).lt.yminn)yminn=theta_int(i,2)
      if(theta_int(i,2).gt.ymaxx)ymaxx=theta_int(i,2)
 7030 continue
      if(itry.eq.0.and.ipriort.eq.0)then
      thmin=theta_int(1,1)
      thmax=theta_int(npunti,1)
      endif
      yminmax=ymaxx-yminn
      if(yminmax.lt.yminn.or.nridb.eq.1)then
      write(Msg,7003)
      call MsgWinErr('Warning',Msg,WARN_WINDOW,nExitCode)        
 7003 format('The background level is too high. ',
     *' It has been reduced ')
      do 7031 i=1,npunti
      theta_int(i,2)=theta_int(i,2)-yminn*0.98
 7031 continue
      endif
      if(itry.gt.0.or.itrysav.gt.0)go to 8005
      dista=TThet(1)-thmin 
!corr      ran=dista-3.0
!corr      nn=int(ran/thstep)
      nn = clocate(theta_int(:npunti,1),TThet(1) - 3)
!corr
!corr      rangeminus=nn*thstep
      rangeminus=theta_int(nn+1,1) - thmin
      if(dista.gt.3.0)then
      thmin=thmin+rangeminus
      npoint=npunti-nn
c     npunti=npunti-nn
c     do 8000 i=1,npunti
      do 8000 i=1,npoint
         theta_int(i,7)=theta_int(i+nn,2)
 8000 continue
      if ((iprio.eq.0.or.iprio.eq.ipriosta).and.nfspace.eq.0) 
     *write(lo,8001)TThet(1),thmin  
 8001 format(3x,'The 2-theta observed pattern has been reduced because'
     * ,/,3x,'the first reflection is at',f10.5,/,/,
     *3x,'The minimum two-theta has been moved to ',f10.5,/)
c     do 9000 i=1,npunti
      do 9000 i=1,npoint
         theta_int(i,2)=theta_int(i,7)
!corr         theta_int(i,1)=thmin+(i-1)*thstep
!corr         write(0,*)theta_int(nn+i,1),thmin+(i-1)*thstep
         theta_int(i,1) = theta_int(nn+i,1)
9000  continue
      endif
8005  continue
      ineg=0
c     do 9100 i=1,npunti
      do 9100 i=1,npoint
      theta_int(i,7)=theta_int(i,1)     
      if(theta_int(i,2).lt.zero.and.i.ne.1.and.i.ne.npunti)then
      ineg=1
c     do 8100 j=i+1,npunti
      do 8100 j=i+1,npoint
      if(theta_int(j,2).gt.zero)then
      am=amin1(theta_int(i-1,2),theta_int(j,2))
      theta_int(i,2)=am 
      go to 9100
      endif
 8100 continue
      else if(theta_int(i,2).lt.zero.and.i.eq.1) then
      ineg=1
      theta_int(i,2)=theta_int(i+1,2)
      elseif(theta_int(i,2).lt.zero.and.i.eq.npunti)then
      ineg=1
      theta_int(i,2)=theta_int(i-1,2)
      endif
9100  continue
c     do 9200 i=1,npunti
      do 9200 i=1,npoint
      if(i.ne.1.and.theta_int(i,2).lt.zero)then
c     do 9300 j=i+1,npunti
      do 9300 j=i+1,npoint
      if(theta_int(j,2).gt.zero)then
      am=amin1(theta_int(i-1,2),theta_int(j,2))
      theta_int(i,2)=am
      go to 9200
      endif
 9300 continue
      elseif(i.eq.1.and.theta_int(i,2).lt.zero)then
c     do 9400 j=i+1,npunti
      do 9400 j=i+1,npoint
      if(theta_int(j,2).gt.zero)then
      theta_int(i,2)=theta_int(j,2)
      go to 9200
      endif
 9400 continue
      endif
9200  continue
      if ((iprio.eq.0.or.iprio.eq.ipriosta).and.nfspace.eq.0) then
      if(ineg.eq.1)write(lo,8003)
      endif
8003  format(/,' Some counts equal to zero are in the input profile ',/)
      return
      end
c-----------------------------------------------------------------------
C
      REAL FUNCTION GAMMAE (X)
C                                  SPECIFICATIONS FOR ARGUMENTS
      REAL               X
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      REAL               P,Q,P4,BIG1,PI,XMIN,XINF,XSIGN,Y,T,R,A,TOP,
     *                   DEN,B
      INTEGER            I,IEND,IEND1,IEND2,IER,J
      LOGICAL            MFLAG
      DIMENSION          P(5),Q(4),P4(3)
C                                  COEFFICIENTS FOR MINIMAX
C                                  APPROXIMATION TO GAMMA(X),
C                                  2.0 .LE. X .LE. 3.0
      DATA               P(1)/-51.49952/,P(2)/80.05398/,
     *                   P(3)/-201.4659/,P(4)/-1.889439/,
     *                   P(5)/9.895546/
      DATA               Q(1)/130.5263/,Q(2)/-303.5898/,
     *                   Q(3)/26.84174/,Q(4)/-19.52375/
C                                  APPROXIMATION TO LN(GAMMA(X)),
C                                  12.0 .LE. X
      DATA               P4(1)/.9189385/,P4(2)/.8333332E-01/,
     *                   P4(3)/-.2770927E-02/
      DATA               IEND/5/,IEND1/4/,IEND2/3/
      DATA               XINF/.3402823E+38/
      DATA               PI/3.141593/
C                                  GAMMA(XMIN) .APPROX. XINF
C                                  GAMMA(BIG1) .APPROX. XINF
      DATA               XMIN/1.2E-38/
      DATA               BIG1/34.844/
C                                  FIRST EXECUTABLE STATEMENT
      IER = 0
      MFLAG = .FALSE.
      T = X
      IF (ABS(T).GT.XMIN) GO TO 5
      IER = 130
      GAMMAE = XINF
      IF (T.LE.0.0) GAMMAE = -XINF
      GO TO 9000
    5 IF (ABS(T).LT.BIG1) GO TO 10
      IER = 129
      GAMMAE = XINF
      GO TO 9000
   10 IF (T.GT.0.0) GO TO 25
C                                  ARGUMENT IS NEGATIVE
      MFLAG = .TRUE.
      T = -T
      R = AINT(T)
      XSIGN = 1.0
      IF (AMOD(R,2.0) .EQ. 0.0) XSIGN = -1.
      R = T-R
      IF (R.NE.0.0) GO TO 20
      IER = 130
      GAMMAE = XINF
      IF (XSIGN.EQ.-1.0) GAMMAE = -XINF
      GO TO 9000
C                                  ARGUMENT IS NOT A NEGATIVE INTEGER
   20 R = PI/SIN(R*PI)*XSIGN
      T = T+1.0
C                                  EVALUATE APPROXIMATION FOR GAMMA(T)
C                                    T .GT. XMIN
   25 IF (T.GT.12.0) GO TO 60
      I = T
      A = 1.0
      IF (I.GT.2) GO TO 40
      I = I+1
      GO TO (30,35,50),I
C                                  0.0 .LT. T .LT. 1.0
   30 A = A/(T*(T+1.0))
      T = T+2.0
      GO TO 50
C                                  1.0 .LE. T .LT. 2.0
   35 A = A/T
      T = T+1.0
      GO TO 50
C                                  3.0 .LE. T .LE. 12.0
   40 DO 45 J=3,I
         T = T-1.0
         A = A*T
   45 CONTINUE
C                                  2.0 .LE. T .LE. 3.0
   50 TOP = P(IEND1)*T+P(IEND)
      DEN = T+Q(IEND1)
      DO 55 J=1,IEND2
         TOP = TOP*T+P(J)
         DEN = DEN*T+Q(J)
   55 CONTINUE
      Y = (TOP/DEN)*A
      IF (MFLAG) Y = R/Y
      GAMMAE = Y
      GO TO 9005
C                                  T .GT. 12.0
   60 TOP = ALOG(T)
      TOP = T*(TOP-1.0)-.5*TOP
      T = 1.0/T
      B = T*T
      Y = (P4(3)*B+P4(2))*T+P4(1)+TOP
      Y = EXP(Y)
      IF (MFLAG) Y = R/Y
      GAMMAE = Y
      GO TO 9005
 9000 CONTINUE
      CALL UERTST(-IER,' MGAMA')
      CALL UERTST(IER,'GAMMA ')
 9005 RETURN
      END
!corr C
!corr       SUBROUTINE UERTST (IER,NAME)
!corr C                                  SPECIFICATIONS FOR ARGUMENTS
!corr       INTEGER            IER
!corr       CHARACTER          NAME*(*)
!corr C                                  SPECIFICATIONS FOR LOCAL VARIABLES
!corr       INTEGER            I,IEQDF,IOUNIT,LEVEL,LEVOLD,NIN,NMTB
!corr       CHARACTER          IEQ,NAMEQ(6),NAMSET(6),NAMUPK(6)
!corr       DATA               NAMSET/'U','E','R','S','E','T'/
!corr       DATA               NAMEQ/6*' '/
!corr       DATA               LEVEL/4/,IEQDF/0/,IEQ/'='/
!corr C                                  UNPACK NAME INTO NAMUPK
!corr C                                  FIRST EXECUTABLE STATEMENT
!corr       CALL USPKD (NAME,6,NAMUPK,NMTB)
!corr C                                  GET OUTPUT UNIT NUMBER
!corr       CALL UGETIO(1,NIN,IOUNIT)
!corr C                                  CHECK IER
!corr       IF (IER.GT.999) GO TO 25
!corr       IF (IER.LT.-32) GO TO 55
!corr       IF (IER.LE.128) GO TO 5
!corr       IF (LEVEL.LT.1) GO TO 30
!corr C                                  PRINT TERMINAL MESSAGE
!corr       IF (IEQDF.EQ.1) WRITE(IOUNIT,35) IER,NAMEQ,IEQ,NAMUPK
!corr       IF (IEQDF.EQ.0) WRITE(IOUNIT,35) IER,NAMUPK
!corr       GO TO 30
!corr     5 IF (IER.LE.64) GO TO 10
!corr       IF (LEVEL.LT.2) GO TO 30
!corr C                                  PRINT WARNING WITH FIX MESSAGE
!corr       IF (IEQDF.EQ.1) WRITE(IOUNIT,40) IER,NAMEQ,IEQ,NAMUPK
!corr       IF (IEQDF.EQ.0) WRITE(IOUNIT,40) IER,NAMUPK
!corr       GO TO 30
!corr    10 IF (IER.LE.32) GO TO 15
!corr C                                  PRINT WARNING MESSAGE
!corr       IF (LEVEL.LT.3) GO TO 30
!corr       IF (IEQDF.EQ.1) WRITE(IOUNIT,45) IER,NAMEQ,IEQ,NAMUPK
!corr       IF (IEQDF.EQ.0) WRITE(IOUNIT,45) IER,NAMUPK
!corr       GO TO 30
!corr    15 CONTINUE
!corr C                                  CHECK FOR UERSET CALL
!corr       DO 20 I=1,6
!corr          IF (NAMUPK(I).NE.NAMSET(I)) GO TO 25
!corr    20 CONTINUE
!corr       LEVOLD = LEVEL
!corr       LEVEL = IER
!corr       IER = LEVOLD
!corr       IF (LEVEL.LT.0) LEVEL = 4
!corr       IF (LEVEL.GT.4) LEVEL = 4
!corr       GO TO 30
!corr    25 CONTINUE
!corr       IF (LEVEL.LT.4) GO TO 30
!corr C                                  PRINT NON-DEFINED MESSAGE
!corr       IF (IEQDF.EQ.1) WRITE(IOUNIT,50) IER,NAMEQ,IEQ,NAMUPK
!corr       IF (IEQDF.EQ.0) WRITE(IOUNIT,50) IER,NAMUPK
!corr    30 IEQDF = 0
!corr       RETURN
!corr    35 FORMAT(19H *** TERMINAL ERROR,10X,7H(IER = ,I3,
!corr      1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
!corr    40 FORMAT(27H *** WARNING WITH FIX ERROR,2X,7H(IER = ,I3,
!corr      1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
!corr    45 FORMAT(18H *** WARNING ERROR,11X,7H(IER = ,I3,
!corr      1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
!corr    50 FORMAT(20H *** UNDEFINED ERROR,9X,7H(IER = ,I5,
!corr      1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
!corr C
!corr C                                  SAVE P FOR P = R CASE
!corr C                                    P IS THE PAGE NAMUPK
!corr C                                    R IS THE ROUTINE NAMUPK
!corr    55 IEQDF = 1
!corr       DO 60 I=1,6
!corr    60 NAMEQ(I) = NAMUPK(I)
!corr       RETURN
!corr       END
!corr C
!corr       SUBROUTINE UGETIO(IOPT,NIN,NOUT)
!corr C                                  SPECIFICATIONS FOR ARGUMENTS
!corr       INTEGER            IOPT,NIN,NOUT
!corr C                                  SPECIFICATIONS FOR LOCAL VARIABLES
!corr       INTEGER            NIND,NOUTD
!corr       DATA               NIND/5/,NOUTD/6/
!corr C                                  FIRST EXECUTABLE STATEMENT
!corr       IF (IOPT.EQ.3) GO TO 10
!corr       IF (IOPT.EQ.2) GO TO 5
!corr       IF (IOPT.NE.1) GO TO 9005
!corr       NIN = NIND
!corr       NOUT = NOUTD
!corr       GO TO 9005
!corr     5 NIND = NIN
!corr       GO TO 9005
!corr    10 NOUTD = NOUT
!corr  9005 RETURN
!corr       END
!corr C
!corr       SUBROUTINE USPKD  (PACKED,NCHARS,UNPAKD,NCHMTB)
!corr C                                  SPECIFICATIONS FOR ARGUMENTS
!corr       INTEGER            NC,NCHARS,NCHMTB
!corr C
!corr       CHARACTER          UNPAKD(1),IBLANK
!corr CORO  CHARACTER*(1)      PACKED(1)
!corr       CHARACTER          PACKED*(*)
!corr       DATA               IBLANK /' '/
!corr C                                  INITIALIZE NCHMTB
!corr       NCHMTB = 0
!corr C                                  RETURN IF NCHARS IS LE ZERO
!corr       IF(NCHARS.LE.0) RETURN
!corr C                                  SET NC=NUMBER OF CHARS TO BE DECODED
!corr       NC = MIN0 (129,NCHARS)
!corr       DO 5 I=1,NC
!corr CORO     UNPAKD(I) = PACKED(I)
!corr          UNPAKD(I) = PACKED(I:I)
!corr     5 CONTINUE
!corr C                                  CHECK UNPAKD ARRAY AND SET NCHMTB
!corr C                                  BASED ON TRAILING BLANKS FOUND
!corr       DO 200 N = 1,NC
!corr          NN = NC - N + 1
!corr          IF(UNPAKD(NN) .NE. IBLANK) GO TO 210
!corr   200 CONTINUE
!corr       NN = 0
!corr   210 NCHMTB = NN
!corr       RETURN
!corr       END
!corr #endif
c-----------------------------------------------------------------------
      subroutine lebail(nvolte,nstop,nfspace,ier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE ExtraIndix
      USE view
      USE General
      USE Molcom      
      USE PatternRef
      USE arrayutil
!corr      include 'rando.fi'
      USE randofi
c
c Le Bail approach
c
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
!
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /limiti/ nlini, nlfin
      common/try/itrysav,psav(12),nvoltemax
      common /backp2/ npol(10)
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common/errer/erreprof,erreprofw,erre_old,erref,errerif
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
!corr      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      dimension ivat(3),sumback(nrefl),sumdiff(nrefl)
     *,fxprob(nrefl),fapp(nrefl,2)
!corr      dimension iindov(3000)
      dimension iindov(nrefl)
      real deltath
      character*80 MsgB
      real, allocatable :: summa(:,:)
      real, allocatable :: thetaapp(:,:)
      real, dimension(nrefl) :: fxappo
c------------------------------
      nbackg=0
      IF (.NOT.ALLOCATED(summa))
     *   ALLOCATE (summa(npunti,2), stat=ier4)
      IF (.NOT.ALLOCATED(thetaapp))
     *   ALLOCATE (thetaapp(npunti,2), stat=ier4)
!corr      call provajsys()
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
      cf=0.5
      mvolte=mod(nvolte,2)
      nleb=0
      kcod=0
      sogh=0.7
      if(iknow.gt.0)call defovlex(kcod,sogh,iindov,maxov)
      fff=0.0
      if(ialt.eq.2)then
      do 88 i=ncoun11(jjj),ncoun22(jjj)
      summa(i,1)=theta_int(i,2)
      summa(i,2)=back_int(i,2)
      thetaapp(i,1)=0.0
      thetaapp(i,2)=0.0
  88  continue
      endif
3000  continue
      if(jjj.eq.nnt.and.nvolte.eq.1.and.ialt.eq.0)mvolte=0
      ycalc=0.0
      ycalc1=0.0
      ycalc2=0.0
      if(nstop.eq.3)nleb=1    
      do 8 i=ncoun11(jjj),ncoun22(jjj)
      theta_int(i,3)=0.0
      theta_int(i,6)=0.0
      indix(i)=0
  8   continue
      if(iext.gt.0.and.nvolte.eq.1.and.itry.gt.0.and.nleb.eq.0)then
      sumfext=0.0
      sumfext2=0.0
      sumfo=0.0
      sumftrue=0.0
      do 500 i=1,nrefl                          
      if(ialt.ne.2)rapp(i)=1.0
      exsav(i)=ex(i)
      sumfext=sumfext+fx(i)
      if(ialt.eq.2)then
      sumfext2=sumfext2+fext(i)+(1.0-rapp(i))*sumfn(i)
      fapp(i,1)=0.0
      fapp(i,2)=0.0
      endif
      sumfo=sumfo+ex(i)/(clp(i)*Mult(i))
      if(iknow.gt.0)sumftrue=sumftrue+(fxsav(i)**2)
 500  continue
      scall=sumfo/sumfext
      if(ialt.eq.2)scal2=sumfo/sumfext2
      if(iknow.gt.0) scalll=sumfo/sumftrue
c     do 600 i=nref11(jjj),nref22(jjj)
      do 600 i=1,nrefl                      
      if(ialt.eq.2)then
      fxprob(i)=(fext(i)+(1.0-rapp(i))*sumfn(i))*scal2*clp(i)*Mult(i)
      fxfra(i)=fx(i)*scall*clp(i)*Mult(i)
      endif
      fxfrag(i)=fx(i)*scall*clp(i)*Mult(i)*rapp(i)
      fx(i)=fx(i)*scall*clp(i)*Mult(i)*rapp(i)
      if(iknow.gt.0)fxtrue(i)=(fxsav(i)**2)*scalll*clp(i)*Mult(i)
  600 continue
      endif
      if((jjj.eq.nnt.and.nvolte.eq.nvoltemax))then
      sumfo=0.0
      sumftrue=0.0
      do 505 i=1,nrefl                  
      sumfo=sumfo+fx(i)
      if(iknow.gt.0)sumftrue=sumftrue+(fxsav(i)**2)*clp(i)*Mult(i)
 505  continue
      if(iknow.gt.0) scalll=sumfo/sumftrue
      endif
      do 10 j=nref11(jjj),nref22(jjj)
      if(iext.gt.0.and.nvolte.eq.1.and.jjj.ne.nnt)
     *fx(j)=fx(j)*clp(j)*Mult(j)
      if(npseu.eq.1.and.nvolte.eq.1)then
      ivat(1)=IndHKL(j,1)
      ivat(2)=IndHKL(j,2)
      ivat(3)=IndHKL(j,3)
      alfa=0.0
!     write(6,*)'JJJJJ',j,fx(j),cpse(1),cpse(2),npseud
      call alfas(alfa,ivat)
      cpse(1)=(alfa-1.0)*cpse(2)+1.0
      fx(j)=fx(j)*cpse(1)
      endif
      theta0=TThet(j)
      rdeg = 0.5 * TThet(j) * dtor    
      cdeg= cos(rdeg)
      tdeg = sin(rdeg) / cos(rdeg)
      tdeg2=tdeg**2
      uvw2=phkl(j,5)
      thminn=amax1(theta0-uvw2,thmin)
      thmaxx=amin1(theta0+uvw2,thmax)
      thminnn=amax1(theta0-phkl(j,6)*0.5,thmin)
      thmaxxx=amin1(theta0+phkl(j,6)*0.5,thmax)
      if(j.eq.1)thminnsav=thminn
      if(j.eq.nrefl)thmaxxsav=thmaxx
      iniz = clocate(theta_int(:npunti,7),thminn)
      ifin = clocate(theta_int(:npunti,7),thmaxx)
      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
      if(ifin.lt.iniz) ifin=iniz         
      inp = clocate(theta_int(:npunti,7),TThet(j))
!
      if(inp.lt.ncoun11(jjj))inp=ncoun11(jjj)
      if(inp.gt.ncoun22(jjj))inp=ncoun22(jjj)
      sumback(j)=0.0
      sumdiff(j)=0.0
      intp=0
      intt=0
      do 20 nnn=iniz,ifin
c     if(back_int(nnn,1).lt.backmin(j))backmin(j)=back_int(nnn,1)
      th = theta_int(nnn,7)
      deltath=(th-theta0)
      deltath2=deltath**2
      if(nprof.eq.1)then
      cc=(1.0+phkl(j,2)*deltath2)
      ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
      asnum=asym*(deltath**3)
      asd1=deltath2
      asd2=1.0/phkl(j,2)
      asden=(asd1+asd2)**1.5
      asterm=asnum/asden+1.0
      elseif(nprof.eq.2)then
      cc=-phkl(j,2)*deltath2
      ffunct=phkl(j,1)*exp(cc)
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.3)then
      cc=1.0+phkl(j,2)*deltath2
      ffunct=phkl(j,1)/cc
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.4)then
      cc1=-phkl(j,2)*deltath2
      ffunct1=phkl(j,1)*exp(cc1)
      cc2=1.0+phkl(j,4)*deltath2
      ffunct2=phkl(j,3)/cc2
      eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2         
      ffunct=(1.0-eta)*ffunct1+eta*ffunct2
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      endif
      if(nvolte.eq.1.and.jjj.ne.nnt.and.nleb.eq.0)then
      if(iext.eq.0)then
      ffx=1.0           
      else
      ffx=fx(j)
      endif
      else
      ffx=fx(j)
      endif
      theta_int(nnn,3)=theta_int(nnn,3)+ffx*ffunct*asterm
      if(ialt.eq.2.and.nleb.eq.1)then
      thetaapp(nnn,1)=thetaapp(nnn,1)+fxfra(j)*ffunct*asterm
      thetaapp(nnn,2)=thetaapp(nnn,2)+fxprob(j)*ffunct*asterm
      endif
      if(theta_int(nnn,7).ge.thminnn.and.theta_int(nnn,7).le.thmaxxx)
     *indix(nnn)=1
      if(ialt.gt.0)then
      theta_int(nnn,6)=theta_int(nnn,6)+abs(ffx*ffunct*asterm)
      endif
   20 continue
   10 continue
      if(mvolte.eq.1.and.ialt.gt.0.and.nleb.eq.0)then
      yomin=9999999.0
      var2=0.0
      do 21 i=1,npunti
      theta_int(i,2)=theta_int(i,2)-scal*theta_int(i,3)-back_int(i,1)
      if(theta_int(i,2).lt.yomin)then
      yomin=theta_int(i,2)
      isav=i
      endif
      back_int(i,1)=0.0
      back_int(i,2)=0.0
   21 continue
      do 22 j=1,11
      bkg(j)=0.0
      bkk(j,jjj)=0.0
  22  continue
      npol(jjj)=3
      thetamin=theta_int(isav,7)
      tmm(jjj)=thetamin
      iext=0
      endif
      icall=2
      if(iext.gt.0.and.nvolte.eq.1.and.jjj.ne.1.and.jjj.ne.nnt)then
      call erre(nvolte,jjj,nstop,icall,erreprofA)
      if(iprin.gt.0.and.iknow.gt.0)write(lo,97)erref
 97   format(/,' R-effe from the external file ',f8.3,/)
      endif
      if(iext.gt.0.and.nvolte.eq.1.and.itry.gt.0)then
!     call erre(nvolte,jjj,nstop,icall,erreprofA,indix)
      call erre(nvolte,jjj,nstop,icall,erreprofA)
      if(iprin.gt.0.and.iknow.gt.0)write(lo,97)erref
      endif
      if(ialt.gt.0.and.nvolte.eq.1.and.nleb.eq.0)then
!     call erre(nvolte,jjj,nstop,icall,erreprofA,indix)
      call erre(nvolte,jjj,nstop,icall,erreprofA)
      endif
      if((nvolte.eq.1.and.jjj.ne.nnt.and.nleb.eq.0.and.iext.eq.0)
     *.or.(mvolte.eq.1.and.ialt.gt.0.and.nleb.eq.0))then
      do 99 j=nref11(jjj),nref22(jjj)
!corr
!corr      ranth=TThet(j)-thmin
!corr      in = int ( ranth/ thstep ) + 1
      in = clocate(theta_int(:npunti,7),TThet(j))
!corr
      if(in.lt.ncoun11(jjj))in=ncoun11(jjj)
      if(in.gt.ncoun22(jjj))in=ncoun22(jjj)
      if(ialt.eq.0)then
      if(theta_int(in,2).gt.back_int(in,1).
     *and.theta_int(in,3).gt.0.0)then
      fx(j)=((theta_int(in,2)-back_int(in,1))
     */theta_int(in,3)) 
c     else
c     fx(j)=0.0
      elseif(theta_int(in,2).gt.back_int(in,1))then
      fx(j)=(theta_int(in,2)-back_int(in,1))
      else
      fx(j)=0.0
      endif
      else
      fx(j)=fxfra(j)-fxfrag(j)
      endif
99    continue
      nleb=nleb+1
      go to 3000
      endif
      IF((MVOLTE.EQ.1.and.nstop.eq.0).or.
     *(MVOLTE.EQ.1.and.ialt.gt.0))THEN
      if(jjj.eq.1.and.nvolte.eq.1)then
      endif
      if(nstop.eq.3.and.ialt.eq.0)go to 452
      nright=0
      nwrong=0
      sumright=0.0
      sumwrong=0.0 
      sumfcright=0.0
      sumfcwrong=0.0
      sumtetright=0.0
      sumtetwrong=0.0
      if(irandom.gt.0)then
      if(jjj.ne.nnt.and.jjj.ne.1.and.nvolte.eq.1.and.irandom.gt.0)
corrado
c    *call prerandom(jjj,nvolte)
     *call prerandom(nvolte)
corrado
      if(jjj.ne.nnt.and.jjj.ne.1.and.irandom.gt.0.and.nvolte.gt.10
     *.and.nvolte.le.30)
     *call randomf(jjj,nvolte)
      endif
c     i111=0
c111   continue
c     i111=i111+1
      do 100 j=nref11(jjj),nref22(jjj)
!corr
!corr      ranth=TThet(j)-thmin
!corr      in = int ( ranth/ thstep ) + 1
      in = clocate(theta_int(:npunti,7),TThet(j))
!corr
      if(in.lt.ncoun11(jjj))in=ncoun11(jjj)
      if(in.gt.ncoun22(jjj))in=ncoun22(jjj)
      somed=0.0
      in1=max0(1,in-3)
      in2=min0(in+3,npunti)
      do 209 nnn=in1,in2
      somed=somed+theta_int(nnn,2)
 209  continue
      ffSum=0.0
      ff1=0.0
      ff2=0.0
      theta0=TThet(j)
      rdeg = 0.5 * TThet(j) * dtor    
      cdeg= cos(rdeg)
      tdeg = sin(rdeg) / cos(rdeg)
      tdeg2=tdeg**2
      uvw2=phkl(j,5)
      thminn=amax1(theta0-uvw2,thmin)
      thmaxx=amin1(theta0+uvw2,thmax)
!corr
!corr      ranth=thminn-thmin
!corr      iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
!corr      ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
!corr      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
!corr      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
!corr      if(ifin.lt.iniz) ifin=iniz
      iniz = clocate(theta_int(:npunti,7),thminn)
      ifin = clocate(theta_int(:npunti,7),thmaxx)
      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
      if(ifin.lt.iniz) ifin=iniz
!corr
      do 200 nnn=iniz,ifin
      th = theta_int(nnn,7)
      deltath=(th-theta0)
      deltath2=deltath**2
      if(nprof.eq.1)then
      cc=(1.0+phkl(j,2)*deltath2)
      ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
      asnum=asym*(deltath**3)
      asd1=deltath2
      asd2=1.0/phkl(j,2)
      asden=(asd1+asd2)**1.5
      asterm=asnum/asden+1.0
      elseif(nprof.eq.2)then
      cc=-phkl(j,2)*deltath2
      ffunct=phkl(j,1)*exp(cc)
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.3)then
      cc=1.0+phkl(j,2)*deltath2
      ffunct=phkl(j,1)/cc
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.4)then
      eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2         
      cc1=-phkl(j,2)*deltath2
      ffunct1=phkl(j,1)*exp(cc1)
      cc2=1.0+phkl(j,4)*deltath2
      ffunct2=phkl(j,3)/cc2
      ffunct=(1.0-eta)*ffunct1+eta*ffunct2
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      endif
      ffx=fx(j)
      if(ialt.eq.0)then
      if (theta_int(nnn,3).gt.0.00001) then
                 ycalc=((theta_int(nnn,2)-back_int(nnn,1))*
     *                  ffx*ffunct*asterm)
     *                  /theta_int(nnn,3)
                        else
                        ycalc=0.0
                        endif
                   else
      segno=sign(1.0,somed)*theta_int(nnn,2)
      if (abs(theta_int(nnn,6)).gt.0.00001.and.segno.gt.0.0.and.
     * abs(theta_int(nnn,2)-back_int(nnn,1)).gt.0)then
                 ycalc=((theta_int(nnn,2)-back_int(nnn,1))*
     *                  abs(ffx*ffunct*asterm))
     *                  /(theta_int(nnn,6))
                        else
                        ycalc=0.0
                        endif
      if (thetaapp(nnn,1).gt.0.00001) then
                 ycalc1=((summa(nnn,1)-summa(nnn,2))*
     *                  fxfra(j)*ffunct*asterm)
     *                  /thetaapp(nnn,1)
                        else
                        ycalc1=0.0
                        endif
      if (thetaapp(nnn,2).gt.0.00001) then
                 ycalc2=((summa(nnn,1)-summa(nnn,2))*
     *                  fxprob(j)*ffunct*asterm)
     *                  /thetaapp(nnn,2)
                        else
                        ycalc2=0.0
                        endif
                   endif
      ffSum=ffSum+ycalc
      fff=fff+(theta_int(nnn,2)-back_int(nnn,1))
      if(ialt.eq.2)then
      ff1=ff1+ycalc1
      ff2=ff2+ycalc2
      endif
 200  continue
      fx(j)=ffSum*thstep
      if(ialt.eq.2)then
      fapp(j,1)=ff1*thstep
      fapp(j,2)=ff2*thstep
      endif
      if(ialt.gt.0)then
      if(iknow.gt.0)then
      deltaper=(fxtrue(j)-fxfrag(j))*fx(j)
      if(deltaper.gt.0.0)then
      nright=nright+1
      sumright=sumright+abs(fxfrag(j)+fx(j)-fxtrue(j))
      sumfcright=sumfcright+fxtrue(j)
      sumtetright=sumtetright+TThet(j)
      else
      nwrong=nwrong+1
      sumwrong=sumwrong+abs(fxfrag(j)+fx(j)-fxtrue(j))
      sumfcwrong=sumfcwrong+fxtrue(j)
      sumtetwrong=sumtetwrong+TThet(j)
      endif
      fx(j)=(fxfrag(j)+fx(j)+fapp(j,1)+fapp(j,2))/3.0-fxfrag(j)
      if(ialt.eq.2)fxappo(j)=fx(j)
      fxfrag(j)=fxfrag(j)+fx(j)
      if(ialt.eq.2)fx(j)=fxfrag(j)
      endif
      endif
      if(ialt.eq.0.and.fx(j).lt.0.0)fx(j)=0.0
  100 continue
c     do  j=ncoun11(jjj),ncoun22(jjj)
c     theta_int(j,3)=0.0
c     enddo          
c     do j=nref11(jjj),nref22(jjj)
c     theta0=TThet(j)
c     rdeg = 0.5 * TThet(j) * dtor    
c     cdeg= cos(rdeg)
c     tdeg = sin(rdeg)/cos(rdeg)
c     tdeg2=tdeg**2
c     uvw2=phkl(j,5)
c     thminn=amax1(theta0-uvw2,thmin)
c     thmaxx=amin1(theta0+uvw2,thmax)
c     ranth=thminn-thmin
c     iniz = int ( ( thminn - thmin ) / thstep ) + 1
c     if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
c     ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
c     if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
c     if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
c     if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
c     if(ifin.lt.iniz) ifin=iniz         
c     do nnn=iniz,ifin
c     th = theta_int(nnn,7)
c     deltath=(th-theta0)
c     deltath2=deltath**2
c     if(nprof.eq.1)then
c     cc=(1.0+phkl(j,2)*deltath2)
c     ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
c     asnum=asym*(deltath**3)
c     asd1=deltath2
c     asd2=1.0/phkl(j,2)
c     asden=(asd1+asd2)**1.5
c     asterm=asnum/asden+1.0
c     elseif(nprof.eq.2)then
c     cc=-phkl(j,2)*deltath2
c     ffunct=phkl(j,1)*exp(cc)
c     asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
c     elseif(nprof.eq.3)then
c     cc=1.0+phkl(j,2)*deltath2
c     ffunct=phkl(j,1)/cc
c     asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
c     elseif(nprof.eq.4)then
c     eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2         
c     cc1=-phkl(j,2)*deltath2
c     ffunct1=phkl(j,1)*exp(cc1)
c     cc2=1.0+phkl(j,4)*deltath2
c     ffunct2=phkl(j,3)/cc2
c     ffunct=(1.0-eta)*ffunct1+eta*ffunct2
c     asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
c     endif
c     ffx=fx(j)
c     theta_int(nnn,3)=theta_int(nnn,3)+ffx*ffunct*asterm
c     enddo     
c     enddo    
ccc   if(i111.le.4)go to 111
      if(noback.eq.0.and.jjj.eq.nnt.
     &and.nbackg.eq.0.and.nvolte.eq.3.and.nfspace.gt.0) 
     &call indagine_back
      nbackg=nbackg+1
      if(ialt.eq.2)then
      sumo=0.0
      sumc=0.0
      do 451 j=ncoun11(jjj),ncoun22(jjj)
      sumo=sumo+theta_int(j,2)
      theta_int(j,3)=0.0
 451  continue
      do 511 j=nref11(jjj),nref22(jjj)
      theta0=TThet(j)
      rdeg = 0.5 * TThet(j) * dtor    
      cdeg= cos(rdeg)
      tdeg = sin(rdeg)/cos(rdeg)
      tdeg2=tdeg**2
      uvw2=phkl(j,5)
      thminn=amax1(theta0-uvw2,thmin)
      thmaxx=amin1(theta0+uvw2,thmax)
!corr
!corr      ranth=thminn-thmin
!corr      iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
!corr      ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
!corr      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
!corr      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
!corr      if(ifin.lt.iniz) ifin=iniz         
      iniz = clocate(theta_int(:npunti,7),thminn)
      ifin = clocate(theta_int(:npunti,7),thmaxx)
      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
      if(ifin.lt.iniz) ifin=iniz         
!corr
      do 611 nnn=iniz,ifin
      th = theta_int(nnn,7)
      deltath=(th-theta0)
      deltath2=deltath**2
      if(nprof.eq.1)then
      cc=(1.0+phkl(j,2)*deltath2)
      ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
      asnum=asym*(deltath**3)
      asd1=deltath2
      asd2=1.0/phkl(j,2)
      asden=(asd1+asd2)**1.5
      asterm=asnum/asden+1.0
      elseif(nprof.eq.2)then
      cc=-phkl(j,2)*deltath2
      ffunct=phkl(j,1)*exp(cc)
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.3)then
      cc=1.0+phkl(j,2)*deltath2
      ffunct=phkl(j,1)/cc
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.4)then
      eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2         
      cc1=-phkl(j,2)*deltath2
      ffunct1=phkl(j,1)*exp(cc1)
      cc2=1.0+phkl(j,4)*deltath2
      ffunct2=phkl(j,3)/cc2
      ffunct=(1.0-eta)*ffunct1+eta*ffunct2
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      endif
      ffx=fxappo(j)
      theta_int(nnn,3)=theta_int(nnn,3)+ffx*ffunct*asterm
      sumc=sumc+theta_int(nnn,3)
  611 continue
  511 continue
      scal=sumo/sumc
      scala(jjj)=scal
      if(nvolte.eq.1.and.kscreen.gt.0)then
         nlini=1
         nlfin=npunti  !!! corrado 0
         nlfin=0
         ipun=5
         iRef=1
         iStop=1
         iAction=0
         !call vedi(ipun,iAction)
         if (ispaceindexing.eq.0) call vedinew(4,nlini,nlfin)
         write(MsgB,161)
 161  format(' The difference profile has been visualized ')
         if (ispaceindexing.eq.0)call scrper(MsgB,0,-1,1)
      endif
      endif
      if(ialt.eq.2)then
      do 1000 i=ncoun11(jjj),ncoun22(jjj)
      theta_int(i,2)=summa(i,1)
      back_int(i,1)=summa(i,2)
      back_int(i,2)=summa(i,2)
 1000 continue
      endif
  452 continue
      do 450 j=ncoun11(jjj),ncoun22(jjj)
      theta_int(j,3)=0.0
 450  continue
      do 501 j=nref11(jjj),nref22(jjj)
      theta0=TThet(j)
      rdeg = 0.5 * TThet(j) * dtor    
      cdeg= cos(rdeg)
      tdeg = sin(rdeg)/cos(rdeg)
      tdeg2=tdeg**2
      uvw2=phkl(j,5)
      thminn=amax1(theta0-uvw2,thmin)
      thmaxx=amin1(theta0+uvw2,thmax)
!corr
!corr      ranth=thminn-thmin
!corr      iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
!corr      ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
!corr      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
!corr      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
!corr      if(ifin.lt.iniz) ifin=iniz         
      iniz = clocate(theta_int(:npunti,7),thminn)
      ifin = clocate(theta_int(:npunti,7),thmaxx)
      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
      if(ifin.lt.iniz) ifin=iniz         
!corr
      do 601 nnn=iniz,ifin
      th = theta_int(nnn,7)
      deltath=(th-theta0)
      deltath2=deltath**2
      if(nprof.eq.1)then
      cc=(1.0+phkl(j,2)*deltath2)
      ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
      asnum=asym*(deltath**3)
      asd1=deltath2
      asd2=1.0/phkl(j,2)
      asden=(asd1+asd2)**1.5
      asterm=asnum/asden+1.0
      elseif(nprof.eq.2)then
      cc=-phkl(j,2)*deltath2
      ffunct=phkl(j,1)*exp(cc)
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.3)then
      cc=1.0+phkl(j,2)*deltath2
      ffunct=phkl(j,1)/cc
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.4)then
      eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2         
      cc1=-phkl(j,2)*deltath2
      ffunct1=phkl(j,1)*exp(cc1)
      cc2=1.0+phkl(j,4)*deltath2
      ffunct2=phkl(j,3)/cc2
      ffunct=(1.0-eta)*ffunct1+eta*ffunct2
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      endif
      ffx=fx(j)
      theta_int(nnn,3)=theta_int(nnn,3)+ffx*ffunct*asterm
  601 continue
  501 continue
      ENDIF
  502 continue
      if(iknow.eq.1.and.ialt.gt.0)call erredif
      DEALLOCATE (summa,stat=ierr)
      DEALLOCATE (thetaapp,stat=ierr)
      if (ier4.lt.0) write(lo,*) ' Problemi nella allocazione'
      if (ierr.lt.0) then
      write(lo,*) ' Problemi nella deallocazione di profcalc'
      endif
      return
      end
ccccccc--------------------------
      SUBROUTINE GAUSSJOLD(A,N,NP,B,M,MP)
      PARAMETER (NMAX=3006)
C     PARAMETER (NMAX=50)
      DIMENSION A(NP,NP),B(NP,MP),IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                PAUSE 'Singular matrix'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) PAUSE 'Singular matrix.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine tosirp(nstop,nvolte,fileh,formt,ier)
      USE Riflessi
      USE xdataMod
      USE ExtraIndix
      USE General
      USE Symmetry
      USE extramodule, only: coef1,coef2
      USE nr, only: indexx
      USE reflection_type_util, only: rhof
!
      character space*16
      character*80 fileh,formt
      character fname9*80
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
!corr      common /indobs/coef1(3000),coef2(3000)   !,overl(3000)
!corr      common/bdata/ibig(124000)
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
!
      character*80 messa
      dimension ivat(3)
      dimension summ1(50),summ2(50),numm(50),pp1(50),pp2(50)
      dimension vett(14),ivett(14)
!corr      dimension rhoo(3000),tet(3000)
      real, dimension(nrefl)    :: rhoo,tet
      integer, dimension(nrefl) :: indov
!corr      dimension abig(72000),indov(3000)
!corr      equivalence (ibig(1),abig(1))
!corr      equivalence (vett,ivett)
      integer, dimension(nrefl) :: iorder
c
      indov(:) = 0
      fosog=-999999.0
      do i=1,79   
      fname9(i:i+1)='  '
      enddo
      fname9 = fname(BIN_FILE)(1:index(fname(BIN_FILE),'.')-1)//'.hkl'
      itype=0
      iform=1
      jop=jopen(jhost,fname9,itype,iform,ier)
      if (jop.lt.0) go to 9000
!corr      write(messa(5:80),50) (itle(i),i=1,19)
      messa(5:) = trim(jobname)
      messa(1:4) = '>   '
      write(jhost,'(a)') messa
      if(if92.ne.0)write(jhost,'(a)') messa
 50   format(20a4)
      sumofc=0.0
      sumofo=0.0
      do 508 j=nref11(nnt),nref22(nnt)
CCCCCCCCCCCCCCCCC
c      fx(j)=clp(j)*Mult(j)*(fxsav(j)**2)
CCCCCCCCCCCCCCCCC
      sumofc=sumofc+clp(j)*Mult(j)*(fxsav(j)**2)
      sumofo=sumofo+fx(j)
 508  continue
      if(iknow.gt.0)scalaf=sumofc/sumofo
      do 100 i=nref1(nnt),nref2(nnt)
      if(ialt.gt.0)fx(i)=fxfrag(i)
      if(fx(i).lt.0.0)fx(i)=0.0
      do 110 j=1,3
      ivat(j)=IndHKL(i,j)
110   continue
      IndHKL(i,4)=1
      rho=rhof(pp,ivat(1),ivat(2),ivat(3))
      rdeg = 0.5 * TThet(i) * dtor    
      cdeg= cos(rdeg)
      tdeg = sin(rdeg) / cos(rdeg)
      tdeg2 = tdeg * tdeg
      WHM(i) = phkl(i,6)
      rhoo(i)=rho
      ex(i)=fx(i)
      SetFob(i,4)=(fx(i)/(clp(i)*Mult(i)))
      if(ipror.eq.0)then
      fx(i)=sqrt(SetFob(i,4))
      if (fx(i).gt.fosog) fosog=fx(i)
      endif
  100 continue
!corr
      call indexx(TThet(:nrefl),iorder)
      IndHKL(:nrefl,1:5) = IndHKL(iorder,1:5)
      SetFob(:nrefl,1:5) = SetFob(iorder,1:5)
      TThet(:nrefl) = TThet(iorder)
      Mult(:nrefl) = Mult(iorder)
      WHM(:nrefl) = WHM(iorder)
      fxsav(:nrefl) = fxsav(iorder)
      fc(:nrefl) = SetFob(:nrefl,4)
      tet(:nrefl)=TThet(:nrefl) 
!corr
!corr      lind=138001
!corr      iblk=15
!corr      jump=11
!corr      izer=15*nrefl
!corr      do 502 i=1,izer
!corr 502    abig(i) = 0.0
!corr      do 691 i=1,nrefl
!corr       ibig(15*(i-1)+1)=IndHKL(i,1)
!corr       ibig(15*(i-1)+2)=IndHKL(i,2)
!corr       ibig(15*(i-1)+3)=IndHKL(i,3)
!corr       ibig(15*(i-1)+4)=IndHKL(i,4)
!corr       ibig(15*(i-1)+5)=IndHKL(i,5)
!corr       abig(15*(i-1)+6)=SetFob(i,1)
!corr       abig(15*(i-1)+7)=SetFob(i,2)
!corr       abig(15*(i-1)+8)=SetFob(i,3)
!corr       abig(15*(i-1)+9)=SetFob(i,4)
!corr       abig(15*(i-1)+10)=SetFob(i,5)
!corr       abig(15*(i-1)+11)=TThet(i)
!corr       ibig(15*(i-1)+12)=Mult(i)
!corr       abig(15*(i-1)+13)=WHM(i)
!corr       abig(15*(i-1)+14)=fxsav(i)
!corr       abig(15*(i-1)+15)=SetFob(i,4)
!corr  691 continue
!corr*     call sortz(lind,nrefl,iblk,jump)
!corr      idim = 72000
!corr      call sortz_dyn(abig,idim,1,nrefl,iblk,jump)
!corr      do 792 i=1,nrefl
!corr       IndHKL(i,1)=ibig(15*(i-1)+1)
!corr       IndHKL(i,2)=ibig(15*(i-1)+2)
!corr       IndHKL(i,3)=ibig(15*(i-1)+3)
!corr       IndHKL(i,4)=ibig(15*(i-1)+4)
!corr       IndHKL(i,5)=ibig(15*(i-1)+5)
!corr       SetFob(i,1)=abig(15*(i-1)+6)
!corr       SetFob(i,2)=abig(15*(i-1)+7)
!corr       SetFob(i,3)=abig(15*(i-1)+8)
!corr       SetFob(i,4)=abig(15*(i-1)+9)
!corr       SetFob(i,5)=abig(15*(i-1)+10)
!corr       TThet(i)=abig(15*(i-1)+11)
!corr       Mult(i)=ibig(15*(i-1)+12)
!corr       WHM(i)=abig(15*(i-1)+13)
!corr       fxsav(i)=abig(15*(i-1)+14)
!corr       fc(i)=abig(15*(i-1)+15)
!corr       tet(i)=TThet(i) 
!corr  792 continue
      if(ipror.eq.1)then
      write(lo,117)
 117  format(/,'    ***** Preferred orientation correction'
     *,' has been applied  *****   ',/)
      icall=2
!     call erre(nvolte,nnt,nstop,icall,erreprofA,indix)
      call erre(nvolte,nnt,nstop,icall,erreprofA)
      do 118 i=nref1(nnt),nref2(nnt)
      fx(i)=sqrt(SetFob(i,4))
      if (fx(i).gt.fosog) fosog=fx(i)
 118  continue
      endif
  300 format(3i4,3f15.4,i10)
  310 format(3i4,i8,f10.5,2f10.4,f10.0,f10.5,2f10.4)
  311 format(3i4,i8,f10.5,2f10.4,f10.0,f10.5,2f10.4,2x,i8)
  320 format(50x,f10.0)
      do 105 i=nref1(nnt),nref2(nnt)
      tetmin=9999999.0
      do 106 j=nref1(nnt),nref2(nnt)
      if(tet(j).le.tetmin)then
      tetmin=tet(j)
      jsav=j
      endif
 106  continue
      tet(jsav)=9999999.0
c     if(ialt.eq.0)then
      if(if92.eq.0)then
      if(iknow.eq.0)then
      write(jhost,300) (IndHKL(jsav,k),k=1,3),
     *WHM(jsav),SetFob(jsav,4)
      else
      write(jhost,300) (IndHKL(jsav,k),k=1,3),
     *WHM(jsav),SetFob(jsav,4),(fxsav(jsav)**2),
*    *phasav(jsav)
     *ipub(jsav)   ! gianluca 29/5/2008
      endif
                   else
      if(iknow.eq.0)then
      write(jhost,310) (IndHKL(jsav,k),k=1,3),Mult(jsav),rhoo(jsav),
     *TThet(jsav),WHM(jsav),SetFob(jsav,4)*100.,coef1(jsav),phkl(jsav,3)
     *,asym
      else
      write(jhost,311) (IndHKL(jsav,k),k=1,3),Mult(jsav),rhoo(jsav),
     *TThet(jsav),WHM(jsav),SetFob(jsav,4)*100.0,coef1(jsav),
     *phkl(jsav,3),asym,
*    *phasav(jsav)
     *ipub(jsav)   ! gianluca 29/5/2008
                   endif
                   endif
 105  continue
ccccccccccccccccccccccccccccccccccccccc
      scall=sum(fxsav(1:nrefl))/sum(sqrt(SetFob(1:nrefl,4)))
      do i=1,10
        kcod=1
        sogh=float(i)*0.1
        !!!!cor anna write(6,*)'             '
        if(iknow.gt.0)then
!anna          write(6,*)'             '
           call defovlex(kcod,sogh,indov,maxov)
        endif
        j=maxval(indov(1:nrefl))
        do k=1,j
        sum1=0.0
        sum2=0.0
        nsum=0
          do kk=1,nrefl
            if(indov(kk).eq.k)then
              sum1=sum1+abs(fxsav(kk)-scall*sqrt(SetFob(kk,4)))
              sum2=sum2+fxsav(kk)
              nsum=nsum+1
            endif
          enddo
!          if(sum2.gt.0)write(6,'(a,f8.3,i5,f8.3,i5)')'sogh',sogh,
!     *      k,sum1/sum2,nsum
        enddo
      enddo
ccccccccccccccccccccccccccccccccccccccc
      close(jhost)
ccccccccccccccccccccccccccccccccccccccc
!
      nmulttot = 0
      do j=1,nrefl
      nmulttot = nmulttot + mult(j)
      enddo
!     write(6,*) ' SOMMA MOLTEPLICITA, NUM. RIFLESSI =',nmulttot,nrefl
      ntotmult1 =nmulttot
      return
 9000 write(Msg,9010) ier,fname9
 9010 format('Open error, code =',i5,' file is ',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
      ier=-1
      return
      end
c-----------------------------------------------------------------
      subroutine profpa(nvolte,jjj,nstop)

      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE randofi
      use reflection_type_util, only: rhof
      common/try/itrysav,psav(12),nvoltemax
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common/uvwold/uvwtold(6)
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /backp2/ npol(10)
      common/savv/fwhsav,betasav,uvwtsav

      dimension ivat(3)
c------------------------------
      nstopsav=nstop
      nstop=iabs(nstop)
      zero=0.0000001
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
c-controllo
      do j=nref11(jjj),nref22(jjj)
        ivat(1)=IndHKL(j,1)
        ivat(2)=IndHKL(j,2)
        ivat(3)=IndHKL(j,3)
        rho=rhof(pp,ivat(1),ivat(2),ivat(3))
        rho2=rho*rho
        TThet(j)=ctheta(rho2)
        rdeg = 0.5 * TThet(j) * dtor    
        tdeg = sin(rdeg) / cos(rdeg)
        tdeg2 = tdeg * tdeg
        cdeg=cos(rdeg)
        if(nprof.eq.1)then
          uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
        elseif(nprof.eq.4)then
          uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
        elseif(nprof.eq.2)then
          uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
        else
          uvwqg=(uvwt(1)*tdeg+uvwt(2)/cdeg)**2
        endif
        uvwmin=(2.0*thstep)**2
        uvwmax=(2.0)**2
        if (uvwqg.lt.uvwmin.or.uvwqg.gt.uvwmax)then
          if(ipriort.eq.0)then
            uvwt(1)=uvwtold(1)
            uvwt(2)=uvwtold(2)
            uvwt(3) =uvwtold(3)
            go to 811
          else
            if(nvolte.eq.1)then
              uvwt(1)=abs(uvwtold(1))
              uvwt(2)=0.0
              uvwt(3) =0.0
              go to 811
            else
              uvwt(1)=uvwtold(1)
              uvwt(2)=uvwtold(2)
              uvwt(3) =uvwtold(3)
              go to 811
            endif
          endif
        endif
      enddo
 811  continue
      do j=nref11(jjj),nref22(jjj)
        ivat(1)=IndHKL(j,1)
        ivat(2)=IndHKL(j,2)
        ivat(3)=IndHKL(j,3)
        rho=rhof(pp,ivat(1),ivat(2),ivat(3))
        rho2=rho*rho
        TThet(j)=ctheta(rho2)
        rdeg = 0.5 * TThet(j) * dtor    
        tdeg = sin(rdeg) / cos(rdeg)
        tdeg2 = tdeg * tdeg
        cdeg=cos(rdeg)
        betamin=0.51            
        betamax=20.0            
        if(nprof.eq.1)then
          beta=uvwt(4)+uvwt(5)/TThet(j)+uvwt(6)/(TThet(j)**2)
        elseif(nprof.eq.4)then
          beta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2
        endif
          if(nprof.eq.1 .or. nprof.eq.4)then
          if (beta.lt.betamin.or.beta.gt.betamax)then
            if(ipriort.eq.0)then
              uvwt(4)=uvwtold(4)
              uvwt(5)=uvwtold(5)
              uvwt(6) =uvwtold(6)
              go to 911
            else
              if(nvolte.eq.1)then
                uvwt(4)=abs(uvwtold(4))
                uvwt(5)=0.0
                uvwt(6) =0.0
                go to 911
              else
                uvwt(4)=uvwtold(4)
                uvwt(5)=uvwtold(5)
                uvwt(6) =uvwtold(6)
                go to 911
              endif
            endif
          endif
          endif
      enddo
 911  continue
c
      if((nvolte.eq.1.and.jjj.eq.1).or.(nvolte.eq.1.and.itry.gt.0))then
      if(itry.gt.0)go to 13
      zeroprof=0.0
 13   continue
      endif
      if(nvolte.eq.1.and.jjj.eq.2.and.nstop.lt.3.
     *and.itry.eq.0.and.ipriort.gt.0)then
      j=nref1(jjj)
      rdeg = 0.5 * TThet(j) * dtor    
      tdeg = sin(rdeg) / cos(rdeg)
      tdeg2 = tdeg * tdeg
      cdeg=cos(rdeg)
      if(nprof.eq.1)then
      beta=uvwt(4)+uvwt(5)/TThet(j)+uvwt(6)/(TThet(j)**2)
      uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
      elseif(nprof.eq.4)then
      beta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2           
      uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
      elseif(nprof.eq.2)then
      beta=0.0
      uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
      else
      beta=0.0
      uvwqg=(uvwt(1)*tdeg+uvwt(2)/cdeg)**2
      endif
      if(nprof.eq.3)then
      fwhsav=sqrt(uvwqg)                 
      else
      fwhsav=uvwqg                      
      endif
      betasav=beta
      endif
      if(nvolte.eq.1.and.jjj.ne.1.and.jjj.ne.nnt.and.nstop.lt.3.
     *and.itry.eq.0.and.ipriort.eq.0)then
      if(jjj.ne.2.and.jjj.ne.nnt)asym=0.0
      if(nprof.ne.3) then
      uvwt(1)=fwhsav
      uvwt(2)=0.0   
      else
      rdeg = 0.5 * TThet(nref1(jjj-1)) * dtor    
      tdeg = sin(rdeg) / cos(rdeg)
      cdeg = cos(rdeg)
      uvwt(2)=fwhsav*cdeg
      uvwt(1)=0.0   
      endif
      uvwt(3)=0.0           
      uvwt(4)=betasav
      uvwt(5)=0.0
      uvwt(6)=0.0
      endif
      do 9 i=ncoun11(jjj),ncoun22(jjj)
      theta_int(i,7)=theta_int(i,1)-2.0*zeroprof
      if((jjj.ne.nnt.and.ipriort.eq.0).or.
     *(ialt.gt.0.and.nvolte.gt.1.and.ipriort.eq.0))then
      if(noback.eq.0)then
      if(ipriort.gt.0)thetamin=tmm(jjj)                        
      thet=theta_int(i,7)/thetamin - 1.0
        back_int(i,1)=bkg(1)
        if(npol(jjj).gt.1)then
        do 91 k=2,npol(jjj)
        ksp=real(k)-1.0
        back_int(i,1)=back_int(i,1)+bkg(k)*(thet**ksp)
 91     continue
        if((back_int(i,1).gt.theta_int(i,2)).and.ialt.eq.0)
     *  back_int(i,1)=theta_int(i,2)
        if(ipriort.gt.0)back_int(i,1)=back_int(i,1)+back_int(i,2)           
      endif
      endif
      else
      back_int(i,1)=back_int(i,2)
      endif
  9   continue
      do 11 j=nref11(jjj),nref22(jjj)
      ivat(1)=IndHKL(j,1)
      ivat(2)=IndHKL(j,2)
      ivat(3)=IndHKL(j,3)
      rho=rhof(pp,ivat(1),ivat(2),ivat(3))
      if(abs(rho*alambda).gt.1.0)then
      do 125 i=1,6
      pp(i)=psav(i)
 125  continue
      astar=psav(7)
      bstar=psav(8)
      cstar=psav(9)
      cosas=psav(10)
      cosbs=psav(11)
      coscs=psav(12)
      go to 12
      endif
 11   continue
 12   continue
      if(nvolte.gt.1)then
      ffmax=-9999999.0
      do 111 j=nref11(jjj),nref22(jjj)
      if(fx(j).gt.ffmax)ffmax=fx(j)
 111  continue
      endif
      do 10 j=nref11(jjj),nref22(jjj)
      ivat(1)=IndHKL(j,1)
      ivat(2)=IndHKL(j,2)
      ivat(3)=IndHKL(j,3)
      rho=rhof(pp,ivat(1),ivat(2),ivat(3))
      rho2=rho*rho
      TThet(j)=ctheta(rho2)
      if(nvolte.eq.1.and.nstop.ne.3)then
      if(iext.eq.0)then
       if(jjj.ne.nnt)then
       fx(j)=1.0              
       else
       fx(j)=ex(j)
       endif
      else
       if(jjj.ne.nnt)then
       fx(j)=fext(j)
       else
        if(itry.eq.0)then
        fx(j)=ex(j)
        else
        fx(j)=fext(j)
        endif
       endif
      endif
      endif
      rdeg = 0.5 * TThet(j) * dtor    
      tdeg = sin(rdeg) / cos(rdeg)
      tdeg2 = tdeg * tdeg
      cdeg=cos(rdeg)
      if(nprof.eq.1)then
      beta=uvwt(4)+uvwt(5)/TThet(j)+uvwt(6)/(TThet(j)**2)
      uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
      elseif(nprof.eq.4)then
      beta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2           
      uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
      elseif(nprof.eq.2)then
      beta=0.0
      uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
      else
      beta=0.0
      uvwqg=(uvwt(1)*tdeg+uvwt(2)/cdeg)**2
      endif
      uvwg = sqrt(uvwqg)
      if(neutro.eq.0.and.nsyn.eq.0) then
                 alp = 1.0 + 0.8*(cos(TThet(j)*dtor))**2
                     else
                 alp = 1.0
                   endif
      blp = sin(0.5*TThet(j)*dtor) * sin(TThet(j)*dtor)
      clp(j)=1.0
      if(abs(blp).gt.zero) clp(j)=alp/blp
c     if((nvolte.eq.1.or.ialt.gt.0))then
C     if((nvolte.eq.1.or.ialt.gt.0.or.
C    &(nstopsav.eq.-3.and.nvolte.eq.4)))then
C     uvw2=(uvwg*frac*0.5)
C     elseif(nvolte.gt.1.and.abs(ffmax).gt.0.0)then
C     uvw2=uvwg*frac*((1.0+(fx(j)/ffmax)))*0.5
C     elseif(nvolte.gt.1.and.abs(ffmax).le.0.0)then
C     uvw2=(uvwg*frac*0.5)
C     endif
C     uvw2=(uvwg*frac*0.5)
      uvw2=(uvwg*frac)
      if(uvw2.gt.3.0)uvw2=3.0
      if(nprof.eq.1)then
        const1=2.0*sqrt((2.0**(1.0/beta)-1.0)/pi)
        const2=4.0*((2.0**(1.0/beta))-1.0)
        phkl(j,1)=const1/uvwg
        phkl(j,2)=const2/uvwqg
        phkl(j,3)=beta    
        const3=GAMMAE(beta)
        beta2=beta-0.5
        const4=GAMMAE(beta2)
        phkl(j,4)=const3/const4
        phkl(j,5)=uvw2    
        phkl(j,6)=uvwg    
      elseif(nprof.eq.2)then
        const1=2.0*sqrt(alog(2.0)/pi)         
        const2=4.0*alog(2.0)         
        phkl(j,1)=const1/uvwg
        phkl(j,2)=const2/uvwqg
        phkl(j,3)=beta    
        const3=0.0         
        beta2=0.0         
        const4=0.0         
        phkl(j,4)=0.0          
        phkl(j,5)=uvw2    
        phkl(j,6)=uvwg    
      elseif(nprof.eq.3)then
        const1=2.0/pi                       
        const2=4.0
        phkl(j,1)=const1/uvwg
        phkl(j,2)=const2/uvwqg
        phkl(j,3)=beta    
        const3=0.0        
        beta2=0.0        
        const4=0.0         
        phkl(j,4)=0.0             
        phkl(j,5)=uvw2    
        phkl(j,6)=uvwg    
      elseif(nprof.eq.4)then
        const1=2.0*sqrt(alog(2.0)/pi)         
        const2=4.0*alog(2.0)         
        const3=2.0/pi                       
        const4=4.0
        phkl(j,1)=const3/uvwg
        phkl(j,2)=const4/uvwqg
        phkl(j,3)=const1/uvwg   
        phkl(j,4)=const2/uvwqg
        phkl(j,5)=uvw2    
        phkl(j,6)=uvwg    
        endif
  10  continue
      if(nprof.eq.3)then
      fwhsav=phkl(nref2(jjj),6)
      else
      fwhsav=phkl(nref2(jjj),6)**2
      endif
      betasav=beta
      return
      end
c-----------------------------------------------------------------------
      subroutine derpar(jjj)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE Deriv
      USE General
      USE Symmetry
      USE arrayutil
      use reflection_type_util, only: rhof
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      dimension ih(3)  
      double precision psi1,psi2,dbeta,dbeta2,MMPSI
c------------------------------
      call provajsys()
      eps = 1.E-10
      do 8 i=ncoun11(jjj),ncoun22(jjj)
      do 9 j=1,14
      derprof(i,j)=0.0
   9  continue
   8  continue
      do 10 j=nref11(jjj),nref22(jjj)
      ih(1)=IndHKL(j,1)
      ih(2)=IndHKL(j,2)
      ih(3)=IndHKL(j,3)
      uvw2=phkl(j,5)
      rdeg = 0.5 * TThet(j) * dtor    
      tdeg = sin(rdeg) / cos(rdeg)
      tdeg2 = tdeg * tdeg
      cdeg=cos(rdeg)
      sdeg=sin(rdeg)
      cdeg2=cdeg**2
      theta0=TThet(j)
      rho=rhof(pp,ih(1),ih(2),ih(3))
      dh=1.0/(2.0*rho)
      if(jsys.eq.6)then
      dra=2.0*astar*(ih(1)**2+ih(2)**2+ih(3)**2+
     *2.0*ih(1)*ih(2)*coscs+2.0*ih(1)*ih(3)*cosbs+2.0*ih(2)*ih(3)*cosas)
      drb=dra
      drc=dra
      elseif(jsys.eq.4.or.jsys.eq.5)then
      dra=2.0*astar*((ih(1)**2)+(ih(2)**2)+2.0*ih(1)*ih(2)*coscs)
     *+2.0*ih(3)*cstar*(ih(1)*cosbs+ih(2)*cosas)
      drb=dra
      drc=2.0*(ih(3)**2)*cstar+2.0*ih(1)*ih(3)*astar*cosbs+
     *2.0*ih(2)*ih(3)*astar*cosas
      else
      dra=2.0*(ih(1)**2)*astar+2.0*ih(1)*ih(2)*bstar*coscs
     *+2.0*ih(1)*ih(3)*cstar*cosbs
      drb=2.0*(ih(2)**2)*bstar+2.0*ih(1)*ih(2)*astar*coscs
     *+2.0*ih(2)*ih(3)*cstar*cosas
      drc=2.0*(ih(3)**2)*cstar+2.0*ih(1)*ih(3)*astar*cosbs
     *+2.0*ih(2)*ih(3)*bstar*cosas
      endif
      drastar=(alambda/(2.0*cdeg))*0.5*dh*dra
      drbstar=(alambda/(2.0*cdeg))*0.5*dh*drb
      drcstar=(alambda/(2.0*cdeg))*0.5*dh*drc
      dralphas=(alambda/(2.0*cdeg))*0.5*dh*(2.0*ih(2)*ih(3)
     **cstar*bstar)
      drbetas=(alambda/(2.0*cdeg))*0.5*dh*(2.0*ih(1)*ih(3)
     **astar*cstar)
      drgammas=(alambda/(2.0*cdeg))*0.5*dh*(2.0*ih(1)*ih(2)
     **astar*bstar)
      thminn=amax1(theta0-uvw2,thmin)
      thmaxx=amin1(theta0+uvw2,thmax)
!corr
!corr      ranth=thminn-thmin
!corr      iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
!corr      ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
!corr      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
!corr      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
!corr      if(ifin.lt.iniz) ifin=iniz         
      iniz = clocate(theta_int(:npunti,7),thminn)
      ifin = clocate(theta_int(:npunti,7),thmaxx)
      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
      if(ifin.lt.iniz) ifin=iniz         
!corr
      ffx = fx(j)
      if(nprof.eq.1)then
      beta=phkl(j,3)
      beta2=beta-0.5
      gam1=GAMMAE(beta)
      gam2=GAMMAE(beta2)
      dbeta=beta
      dbeta2=beta2
      ier=0
      psi1=MMPSI(dbeta,ier)
      psi2=MMPSI(dbeta2,ier)
      dergam1=psi1*gam1
      dergam2=psi2*gam2
      gamstar=(dergam1*gam2-dergam2*gam1)/(gam2**2)
      endif
      do 200 nnn=iniz,ifin
      th = theta_int(nnn,7)
      deltath=th-theta0
      deltath2=deltath**2
      deltath3=deltath**3
      if(nprof.eq.1)then
      cc=(1.0+phkl(j,2)*deltath2)
      pearson=phkl(j,4)*phkl(j,1)*(cc**(-beta))
      asnum=asym*(deltath**3)
      asd1=deltath2
      asd2=1.0/phkl(j,2)
      asd=asd1+asd2
      asden=asd**1.5
      asterm=asnum/asden+1.0
      asc=1.0/(phkl(j,6)*phkl(j,2))
      w1=pearson*0.5/phkl(j,6)
      alln=1.0/cc  
      aln=alog(cc)
      w2=2.0*phkl(j,2)*beta*deltath2*alln-1.0
      w3=asterm*w2/phkl(j,6)
      w4=-3.0*asc*asym*(deltath**3)/(asd**2.5)
      derprof(nnn,1)=derprof(nnn,1)+ffx*w1*(w3+w4) 
      derprof(nnn,2)=derprof(nnn,2)+ffx*tdeg*w1*(w3+w4) 
      derprof(nnn,3)=derprof(nnn,3)+ffx*tdeg2*w1*(w3+w4) 
      z0=pearson*deltath
      z1=4.0*phkl(j,2)*beta*asterm*alln
      z3=-6.0*asym*deltath/(asd**2)
      z4=(asd**0.5)-deltath2*(asd**(-0.5))
      z2=z3*z4                                   
      as1=(deltath**3)/(asd**1.5)
      derprof(nnn,5)=derprof(nnn,5)+ffx*z0*(z1+z2)
      derprof(nnn,6)=derprof(nnn,6)+ffx*pearson*as1
      d1=gamstar/phkl(j,4) 
      ddd=sqrt(2.0**(1.0/phkl(j,3))-1.0)*sqrt(pi)*2.0
      d2=2.0*alog(2.0)*(2.0**(1.0/phkl(j,3)))/
     *(ddd*(phkl(j,3)**2)*phkl(j,1)*phkl(j,6))
      d3=aln
      d4=4.0*alog(2.0)*deltath2*(2.0**(1.0/phkl(j,3)))*alln/
     *((phkl(j,6)**2)*beta)
      d0=asterm*(d1-d2-d3+d4)
      d6=-6.0*asym*alog(2.0)*(2.0**(1.0/phkl(j,3)))
      d7=1.0/((phkl(j,2)*phkl(j,6)*phkl(j,3))**2)
      d5=d6*d7*deltath3/(asd**2.5)
      derprof(nnn,4)=derprof(nnn,4)+ffx*pearson*
     *(d0+d5)
      derprof(nnn,7)=derprof(nnn,7)+ffx*pearson*
     *(d0+d5)/TThet(j)
      derprof(nnn,8)=derprof(nnn,8)+ffx*pearson*
     *(d0+d5)/(TThet(j)**2)
      c=(-2.0/(TThet(j)**2))*(uvwt(5)+uvwt(6)*2.0/TThet(j))
      d=(1.0/cdeg2)*(uvwt(2)+2.0*uvwt(3)*tdeg)
      dd=d/(2.0*phkl(j,6))
      ee=-2.0*alog(2.0)*(2.0**(1.0/phkl(j,3)))/((phkl(j,3)**2)*ddd)
      f=-4.0*alog(2.0)*(2.0**(1.0/phkl(j,3)))/(phkl(j,3)**2)
      g1=gamstar*c/phkl(j,4)
      g2=(1.0/(phkl(j,1)*phkl(j,6)))*(ee*c-phkl(j,1)*dd)
      g3=aln*c
      g4=-beta*alln*deltath/(phkl(j,6)**2)
      g5=deltath*(f*c-2.0*phkl(j,2)*phkl(j,6)*dd)
      g6=4.0*phkl(j,2)*(phkl(j,6)**2)
      dpth=pearson*(g1+g2-g3+g4*(g5-g6))    
      ga=-3.0*asym*deltath2
      gb=2.0*asd
      gc=0.5*deltath
      gd=(2.0*dd)/(phkl(j,6)*phkl(j,2))
      ge=-(f*c)/((phkl(j,2)*phkl(j,6))**2)
      gf=-4.0*deltath
      gg=gd+ge+gf
      dath=ga*(gb+gc*gg)
      derprof(nnn,9)=derprof(nnn,9)+ffx*
     *(asterm*dpth+pearson*dath)*drastar
      derprof(nnn,10)=derprof(nnn,10)+ffx*
     *(asterm*dpth+pearson*dath)*drbstar
      derprof(nnn,11)=derprof(nnn,11)+ffx*
     *(asterm*dpth+pearson*dath)*drcstar
      derprof(nnn,12)=derprof(nnn,12)+ffx*
     *(asterm*dpth+pearson*dath)*dralphas
      derprof(nnn,13)=derprof(nnn,13)+ffx*
     *(asterm*dpth+pearson*dath)*drbetas
      derprof(nnn,14)=derprof(nnn,14)+ffx*
     *(asterm*dpth+pearson*dath)*drgammas
      elseif(nprof.eq.4)then
      eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2         
      cc=(1.0+phkl(j,2)*deltath2)
      plor= eta*phkl(j,1)/cc
      pgau= (1.0-eta)*phkl(j,3)*exp(-phkl(j,4)*deltath2)
      pvoigt = plor + pgau
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      aa=(2.0*phkl(j,4)*deltath2)/(phkl(j,6)*cc)-(1.0/phkl(j,6))
      bb=((2.0*phkl(j,2)*deltath2)/phkl(j,6))-(1.0/phkl(j,6))
      derprof(nnn,1)=derprof(nnn,1)+ffx *asterm*
     *(aa*plor+bb*pgau)/(2.0*phkl(j,6))
      derprof(nnn,2)=derprof(nnn,2)+ffx * asterm*                      
     *(aa*plor+bb*pgau)*tdeg/(2.0*phkl(j,6))
      derprof(nnn,3)=derprof(nnn,3)+ffx *  asterm*                     
     *(aa*plor+bb*pgau)*tdeg2/(2.0*phkl(j,6))
      if(abs(1.0-eta).gt.eps)then
      derprof(nnn,4)=derprof(nnn,4)+ffx *  asterm*                     
     *(plor/eta-pgau/(1.0-eta))
      else
      derprof(nnn,4)=derprof(nnn,4)+ffx *  asterm*                     
     *(plor/eta)
      endif
      ald = 4.0*phkl(j,2)*deltath
      bld = 1.0/cc
      ga = 4.0*phkl(j,4)*deltath
      derprof(nnn,5)=derprof(nnn,5)+ffx *(asterm*
     *(plor*ald*bld+pgau*ga)+
     *(4.0*asym*sign(1.0,deltath)*deltath*pvoigt/tdeg))
      derprof(nnn,6)=derprof(nnn,6)+ffx*pvoigt*
     *(-1.0*sign(1.0,deltath)*deltath2/tdeg)
      if(abs(1.0-eta).gt.eps)then
      derprof(nnn,7)=derprof(nnn,7)+ffx *  asterm*                     
     *(plor/eta-pgau/(1.0-eta))*tdeg
      derprof(nnn,8)=derprof(nnn,8)+ffx *  asterm*                     
     *(plor/eta-pgau/(1.0-eta))*tdeg2
      else
      derprof(nnn,7)=derprof(nnn,7)+ffx *  asterm*                     
     *(plor/eta)*tdeg
      derprof(nnn,8)=derprof(nnn,8)+ffx *  asterm*                     
     *(plor/eta)*tdeg2
      endif
      drhg=1.0/(2.0*phkl(j,6)*cdeg2)*(uvwt(2)+2.0*uvwt(3)*tdeg)
      dr1=-plor*drhg/phkl(j,6)
      dra=(2.0*phkl(j,2)*deltath)
      drb=(1.0/phkl(j,6))*drhg*deltath+2.0
      dr2=plor*dra*drb/cc
      dr3=-drhg*pgau/phkl(j,6)
      draa=2.0*phkl(j,4)*deltath
      drbb=drhg*deltath/phkl(j,6)+2.0
      dr4=pgau*draa*drbb
      dr5=(uvwt(5)/cdeg2+2.0*uvwt(6)*tdeg/cdeg2)*(plor/eta)
      if(abs(1.0-eta).gt.eps)then
      dr6=-(uvwt(5)/cdeg2+2.0*uvwt(6)*tdeg/cdeg2)*(pgau/(1.0-eta))
      else
      dr6=0.0
      endif
      drprth=dr1+dr2+dr3+dr4+dr5+dr6  
      drasth=(asym*sign(1.0,deltath))*deltath*
     *(4.0/tdeg+(deltath/(cdeg2*tdeg2)))
      derprof(nnn,9)=derprof(nnn,9)+ffx
     **drastar*(asterm*drprth+pvoigt*drasth)
      derprof(nnn,10)=derprof(nnn,10)+ffx
     **drbstar*(asterm*drprth+pvoigt*drasth)
      derprof(nnn,11)=derprof(nnn,11)+ffx
     **drcstar*(asterm*drprth+pvoigt*drasth)
      derprof(nnn,12)=derprof(nnn,12)+ffx
     **dralphas*(asterm*drprth+pvoigt*drasth)
      derprof(nnn,13)=derprof(nnn,13)+ffx
     **drbetas*(asterm*drprth+pvoigt*drasth)
      derprof(nnn,14)=derprof(nnn,14)+ffx
     **drgammas*(asterm*drprth+pvoigt*drasth)
      elseif(nprof.eq.2)then
      pgau= phkl(j,1)*exp(-phkl(j,2)*deltath2)
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      bb=((2.0*phkl(j,2)*deltath2)/phkl(j,6))-(1.0/phkl(j,6))
      derprof(nnn,1)=derprof(nnn,1)+ffx *asterm*
     *bb*pgau/(2.0*phkl(j,6))
      derprof(nnn,2)=derprof(nnn,2)+ffx * asterm*                      
     *bb*pgau*tdeg/(2.0*phkl(j,6))
      derprof(nnn,3)=derprof(nnn,3)+ffx *  asterm*                     
     *bb*pgau*tdeg2/(2.0*phkl(j,6))
      derprof(nnn,4)=0.0
      ga = 4.0*phkl(j,2)*deltath
      derprof(nnn,5)=derprof(nnn,5)+ffx *(asterm*
     *(pgau*ga)+
     *(4.0*asym*sign(1.0,deltath)*deltath*pgau/tdeg))
      derprof(nnn,6)=derprof(nnn,6)+ffx*pgau*
     *(-1.0*sign(1.0,deltath)*deltath2/tdeg)
      derprof(nnn,7)=0.0
      derprof(nnn,8)=0.0
      drhg=1.0/(2.0*phkl(j,6)*cdeg2)*(uvwt(2)+2.0*uvwt(3)*tdeg)
      dr3=-drhg*pgau/phkl(j,6)
      draa=2.0*phkl(j,2)*deltath
      drbb=drhg*deltath/phkl(j,6)+2.0
      dr4=pgau*draa*drbb
      drprth=dr3+dr4
      drasth=(asym*sign(1.0,deltath))*deltath*
     *(4.0/tdeg+(deltath/(cdeg2*tdeg2)))
      derprof(nnn,9)=derprof(nnn,9)+ffx
     **drastar*(asterm*drprth+pgau*drasth)
      derprof(nnn,10)=derprof(nnn,10)+ffx
     **drbstar*(asterm*drprth+pgau*drasth)
      derprof(nnn,11)=derprof(nnn,11)+ffx
     **drcstar*(asterm*drprth+pgau*drasth)
      derprof(nnn,12)=derprof(nnn,12)+ffx
     **dralphas*(asterm*drprth+pgau*drasth)
      derprof(nnn,13)=derprof(nnn,13)+ffx
     **drbetas*(asterm*drprth+pgau*drasth)
      derprof(nnn,14)=derprof(nnn,14)+ffx
     **drgammas*(asterm*drprth+pgau*drasth)
      elseif(nprof.eq.3)then
      cc=(1.0+phkl(j,2)*deltath2)
      plor= phkl(j,1)/cc
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      aa=(2.0*phkl(j,2)*deltath2)/(phkl(j,6)*cc)-(1.0/phkl(j,6))
      derprof(nnn,1)=derprof(nnn,1)+ffx *asterm*
     *aa*plor*tdeg
      derprof(nnn,2)=derprof(nnn,2)+ffx * asterm*                      
     *aa*plor/cdeg
      derprof(nnn,3)=0.0      
      derprof(nnn,4)=0.0
      ald = 4.0*phkl(j,2)*deltath
      bld = 1.0/cc
      derprof(nnn,5)=derprof(nnn,5)+ffx *(asterm*
     *(plor*ald*bld)+
     *(4.0*asym*sign(1.0,deltath)*deltath*plor/tdeg))
      derprof(nnn,6)=derprof(nnn,6)+ffx*plor*
     *(-1.0*sign(1.0,deltath)*deltath2/tdeg)
      derprof(nnn,7)=0.0
      derprof(nnn,8)=0.0
      drhg=(1.0/cdeg2)*(uvwt(1)+uvwt(2)*sdeg)
      dr1=-plor*drhg/phkl(j,6)
      dra=(2.0*phkl(j,2)*deltath)
      drb=(1.0/phkl(j,6))*drhg*deltath+2.0
      dr2=plor*dra*drb/cc
      drprth=dr1+dr2
      drasth=(asym*sign(1.0,deltath))*deltath*
     *(4.0/tdeg+(deltath/(cdeg2*tdeg2)))
      derprof(nnn,9)=derprof(nnn,9)+ffx
     **drastar*(asterm*drprth+plor*drasth)
      derprof(nnn,10)=derprof(nnn,10)+ffx
     **drbstar*(asterm*drprth+plor*drasth)
      derprof(nnn,11)=derprof(nnn,11)+ffx
     **drcstar*(asterm*drprth+plor*drasth)
      derprof(nnn,12)=derprof(nnn,12)+ffx
     **dralphas*(asterm*drprth+plor*drasth)
      derprof(nnn,13)=derprof(nnn,13)+ffx
     **drbetas*(asterm*drprth+plor*drasth)
      derprof(nnn,14)=derprof(nnn,14)+ffx
     **drgammas*(asterm*drprth+plor*drasth)
      endif
  200 continue
  10  continue
      return
      end
c-----------------------------------------------------------------------
      subroutine shiftpar(ntime,jjj,pr_old,stdv)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE Deriv
      USE General
      USE Symmetry
!corr      include 'rando.fi'
      USE randofi
c
c
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /direx/ncycle,icycle,nosing,izero,zeroprof,asym,scaler,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /backp2/ npol(10)
      common/uvwold/uvwtold(6)
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      dimension shift(26)
      dimension dr(26),dfr(26),dr_part(26)
      dimension pr_old(32),stdv(32)
      double precision dr,dfr
c------------------------------
c
      mvolte=mod(ntime,2)
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
      if(ipriort.gt.0)then
      if(jjj.eq.nnt)then
      rid=0.5
      else
      rid=1.2
      endif
      else
      rid=1.0
      endif
      if(mvolte.ge.2.and.dumpp.le.0.2)then
      rdump=dumpp*3.0*rid
      rdumpb=dumpp*3.0*rid
      rdumpa=dumpp*3.0*rid
      rdumpz=dumpp*3.0*rid
      rdumpc=0.01*rid
      rdump1=0.005*rid
      else
      rdump=dumpp*rid
      rdumpb=dumpp*rid
      rdumpa=dumpp*rid
      rdumpz=dumpp*rid
      rdumpc=0.01*rid
      rdump1=0.005*rid
      endif
      do 200 k=1,26
      dfr(k)=0.0
      dr(k)=0.0
      shift(k)=0.0
      stdv(k)=0.0
      dr_part(k)=0.0
 200  continue
c
c-- accumulation l.s. 
c
      stdf=0.0
      do 1000 i=ncoun1(jjj),ncoun2(jjj)
      df=theta_int(i,2)-back_int(i,1)-scaler*theta_int(i,3)
      dr_part(1)=theta_int(i,3)
      dr_part(16)=1.0
      if(jjj.ne.nnt.or.ialt.gt.0)then
      angg=theta_int(i,7)/thetamin-1.0
      if(noback.eq.0)then
      derzb=((-bkg(2)-2.0*bkg(3)*angg
     *-3.0*bkg(4)*(angg**2)-4.0*bkg(5)*(angg**3)
     *-5.0*bkg(6)*(angg**4)
     *-6.0*bkg(7)*(angg**5)
     *-7.0*bkg(8)*(angg**6)
     *-8.0*bkg(9)*(angg**7)
     *-9.0*bkg(10)*(angg**8)
     *-10.0*bkg(11)*(angg**9))*(2.0/thetamin))
      else
      derzb=0.0
      endif
      dr_part(17)=angg
      dr_part(18)=(angg**2)
      dr_part(19)=(angg**3)
      dr_part(20)=(angg**4)
      dr_part(21)=(angg**5)
      dr_part(22)=(angg**6)
      dr_part(23)=(angg**7)
      dr_part(24)=(angg**8)
      dr_part(25)=(angg**9)
      dr_part(26)=(angg**10)
      else
      derzb=0.0
      endif
      dr_part(2)=(scaler*derprof(i,5)+derzb)
      dr_part(3)=(scaler*derprof(i,1))
      dr_part(6)=(scaler*derprof(i,6))
      dr_part(5)=(scaler*derprof(i,3))
      dr_part(7)=(scaler*derprof(i,4))
      dr_part(4)=(scaler*derprof(i,2))
      dr_part(8)=(scaler*derprof(i,7))
      dr_part(9)=(scaler*derprof(i,8))
      dr_part(10)=(scaler*derprof(i,9))
      dr_part(11)=(scaler*derprof(i,10))
      dr_part(12)=(scaler*derprof(i,11))
      dr_part(13)=(scaler*derprof(i,12))
      dr_part(14)=(scaler*derprof(i,13))
      dr_part(15)=(scaler*derprof(i,14))
c
      if(ialt.gt.0)npol(jjj)=11
      jcoun=15+npol(jjj)
      pesos=0.0
      if(ialt.eq.0)then
      if(abs(theta_int(i,2)).gt.0.0) pesos=1.0/abs(theta_int(i,2))
      else
      pesos=1.0
      endif
      stdf=stdf+pesos*(df**2)
      if(nprof.eq.1.or.nprof.eq.4)then
      do 1100 j=1,jcoun
      dfr(j)=dfr(j)+df*dr_part(j)*pesos             
      dr(j)=dr(j)+dr_part(j)*dr_part(j)*pesos             
 1100 continue
      elseif(nprof.eq.2)then
      do 1110 j=1,6
      dfr(j)=dfr(j)+df*dr_part(j)*pesos             
      dr(j)=dr(j)+dr_part(j)*dr_part(j)*pesos             
 1110 continue
      do 1120 j=10,jcoun
      dfr(j)=dfr(j)+df*dr_part(j)*pesos             
      dr(j)=dr(j)+dr_part(j)*dr_part(j)*pesos             
 1120 continue
      elseif(nprof.eq.3)then
      do 1115 j=1,4
      dfr(j)=dfr(j)+df*dr_part(j)*pesos             
      dr(j)=dr(j)+dr_part(j)*dr_part(j)*pesos             
 1115 continue
      dfr(6)=dfr(6)+df*dr_part(6)*pesos             
      dr(6)=dr(6)+dr_part(6)*dr_part(6)*pesos             
      do 1125 j=10,jcoun
      dfr(j)=dfr(j)+df*dr_part(j)*pesos             
      dr(j)=dr(j)+dr_part(j)*dr_part(j)*pesos             
 1125 continue
      endif
 1000 continue
c
      do 1113 j=1,jcoun          
      if(dr(j).gt.0.0) then
                         shift(j)=dfr(j)/dr(j)
                         stdv(j)=sqrt(stdf/dr(j))
                      endif
      if(abs(shift(j)).lt.1.E-20) shift(j)=0.0
 1113 continue
      if(ntime.eq.1)then
                  pr_old(1)=scaler
                  pr_old(2)=zeroprof   
                  pr_old(3)=uvwt(1)    
                  pr_old(4)=uvwt(2) 
                  pr_old(5)=uvwt(3)
                  pr_old(6)=asym          
                  pr_old(7)=uvwt(4)   
                  pr_old(8)=uvwt(5)
                  pr_old(9)=uvwt(6)    
                  pr_old(10)=astar  
                  pr_old(11)=bstar  
                  pr_old(12)=cstar      
                  pr_old(13)=cosas       
                  pr_old(14)=cosbs       
                  pr_old(15)=coscs     
                  pr_old(16)=bkg(1) 
                  pr_old(17)=bkg(2)
                  pr_old(18)=bkg(3)
                  pr_old(19)=bkg(4)
                  pr_old(20)=bkg(5)
                  pr_old(21)=bkg(6)
                  pr_old(22)=bkg(7)    
                  pr_old(23)=bkg(8)    
                  pr_old(24)=bkg(9)    
                  pr_old(25)=bkg(10)    
                  pr_old(26)=bkg(11)    
                  pr_old(27)=pp(1)       
                  pr_old(28)=pp(2)       
                  pr_old(29)=pp(3)       
                  pr_old(30)=pp(4)       
                  pr_old(31)=pp(5)       
                  pr_old(32)=pp(6)       
                  endif
      scaler=scaler+rdump*shift(1)     
      if((jjj.ne.nnt.or.ialt.gt.0).and.noback.eq.0)
     *bkg(1)=bkg(1)+rdump1*shift(16)     
      if(jjj.eq.1.and.noback.eq.0)bkg(2)=bkg(2)+rdump1*shift(17)     
      zeroprof=zeroprof+rdumpz*shift(2)     
      uvwtold(1)=uvwt(1)
      uvwtold(2)=uvwt(2)
      uvwtold(3)=uvwt(3)
      uvwtold(4)=uvwt(4)
      uvwtold(5)=uvwt(5)
      uvwtold(6)=uvwt(6)
      uvwt(1)=uvwt(1)+rdump*shift(3)     
      asym=asym+rdumpa*shift(6)     
      uvwt(3)=uvwt(3)+rdump*shift(5)     
      uvwt(4)=uvwt(4)+rdumpb*shift(7)     
      uvwt(2)=uvwt(2)+rdump*shift(4)     
      uvwt(5)=uvwt(5)+rdumpb*shift(8)     
      uvwt(6)=uvwt(6)+rdumpb*shift(9)     
      if(jjj.gt.1.and.noback.eq.0)then                               
      if(jjj.ne.nnt.or.ialt.gt.0)then
      if(npol(jjj).ge.3.and.noback.eq.0)bkg(3)=bkg(3)+rdump1*shift(18)     
      if(npol(jjj).ge.2.and.noback.eq.0)bkg(2)=bkg(2)+rdump1*shift(17)     
      if(npol(jjj).ge.4.and.noback.eq.0)bkg(4)=bkg(4)+rdump1*shift(19)     
      if(npol(jjj).ge.5.and.noback.eq.0)bkg(5)=bkg(5)+rdump1*shift(20)     
      if(npol(jjj).ge.6.and.noback.eq.0)bkg(6)=bkg(6)+rdump1*shift(21)     
      if(npol(jjj).ge.7.and.noback.eq.0)bkg(7)=bkg(7)+rdump1*shift(22)     
      if(npol(jjj).ge.8.and.noback.eq.0)bkg(8)=bkg(8)+rdump1*shift(23)     
      if(npol(jjj).ge.9.and.noback.eq.0)bkg(9)=bkg(9)+rdump1*shift(24)     
      if(npol(jjj).ge.10.and.noback.eq.0)
     *bkg(10)=bkg(10)+rdump1*shift(25)     
      if(npol(jjj).ge.11.and.noback.eq.0)
     *bkg(11)=bkg(11)+rdump1*shift(26)     
      endif
      if(nocell.eq.0)then
      astar=astar+rdumpc*shift(10)
      bstar=bstar+rdumpc*shift(11)
      cstar=cstar+rdumpc*shift(12)
      endif
      if(jsys.eq.1.and.nocell.eq.0)then
      cosas=cosas+rdumpc*shift(13)
      cosbs=cosbs+rdumpc*shift(14)
      coscs=coscs+rdumpc*shift(15)
      elseif(jsys.eq.2.and.nocell.eq.0)then
      cosbs=cosbs+rdumpc*shift(14)
      stdv(13)=0.0
      stdv(15)=0.0
      else
      stdv(13)=0.0
      stdv(14)=0.0
      stdv(15)=0.0
      endif
      else
      stdv(10)=0.0
      stdv(11)=0.0
      stdv(12)=0.0
      stdv(13)=0.0
      stdv(14)=0.0
      stdv(15)=0.0
      endif
      pp(1)=0.25*(astar**2)
      pp(2)=0.25*(bstar**2)
      pp(3)=0.25*(cstar**2)
      pp(4)=0.25*(2.0*astar*bstar*coscs )
      pp(5)=0.25*(2.0*astar*cstar*cosbs )
      pp(6)=0.25*(2.0*bstar*cstar*cosas )
      return
      end
c-----------------------------------------------------------------------
      subroutine erre(nvolte,jjj,nstop,icall
     *,erreprofA)                                            
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE ExtraIndix
      USE General
      USE messagemod
      USE randofi
      USE Molcom, only: jscreen
      character profile*11
!corr      common /save/var(3100),npolsav(10),refv(32,10),fwb(3000,2)
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common/try/itrysav,psav(12),nvoltemax
      common/errer/erreprof,erreprofw,erre_old,erref,errerif
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /profp/dumpp,nprof,ipol
      common /peak/xmax(200),ymax(200),fw(200),npk,asm(200)
      common /peak_noghost/noghost
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
      character*80 MsgB
c
corr         if (nvolte == 1)write(0,*)'ERRE=',sum(theta_int),sum(back_int)
      MsgB='             '
      if(nprof.eq.1)then
      profile='  Pearson  '
      elseif(nprof.eq.2)then
      profile='  Gaussian '
      elseif(nprof.eq.3)then
      profile=' Lorentzian '
      elseif(nprof.eq.4)then
      profile='  Pvoigt   '
      endif
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
      if(icall.eq.2)go to 1999
      mvolte=mod(nvolte,2)
      if(nvolte.eq.1.and.itry.gt.0.and.ialt.eq.0
     *.and.ipriort.eq.0)go to 99
      IF((MVOLTE.EQ.1.and.nstop.ne.3))THEN
      sumobs=0.0 
      sumcalc=0.0          
      do 8 i=ncoun1(jjj),ncoun2(jjj)
      if(ialt.gt.0)then
      if(abs(theta_int(i,3)).gt.0.0)then
      sumobs=sumobs+abs(theta_int(i,2)-back_int(i,1))
      sumcalc=sumcalc+abs(theta_int(i,3))
      endif
      else
      sumobs=sumobs+(theta_int(i,2)-back_int(i,1))
      sumcalc=sumcalc+theta_int(i,3)
      endif
  8   continue
      if(sumcalc.lt.-0.00000001.or.sumcalc.gt.0.000000001)then
      scal=sumobs/sumcalc
      else
      scal=0.0
      endif
                       endif
c calcolo R-profilo e Chi-quadro
99    continue
      sumdif=0.0
      sumobs=0.0
      sumdeltaw=0.0
      sumobsA=0.0
      if(jjj.ne.nnt)then
      nvolterif=int(nvoltemax/2)
      else
      nvolterif=int(nvoltemax/2)
      endif
      yyminsog=999999.0
      do i=ncoun1(jjj),ncoun2(jjj)
        if(theta_int(i,2).lt.yyminsog)yyminsog=theta_int(i,2)
      enddo
      do 10 i=ncoun1(jjj),ncoun2(jjj)
      if(jjj.eq.nnt)then
      thetarif=thet2(jjj)
      else
      thetarif=thet1(jjj+1)
      endif
      if(nvolte.gt.nvolterif.and.ialt.eq.0.and.
     *theta_int(i,7).lt.thetarif.and.iproff.eq.0)then
      sogg=float(nvolte-nvolterif+1)/float(nvoltemax-nvolterif+1)
      qsog=(1.2-sogg)*(1.2-sqrt(theta_int(i,7)/thmax))
      dnum=(theta_int(i,2)-scal*theta_int(i,3)-back_int(i,1))
      den=abs(scal*theta_int(i,3))
      if(den.gt.0.000001.and.indix(i).eq.0)then
      dnude=dnum/den
      if(dnude.gt.qsog)then
      prova=(qsog+1.0)*scal*theta_int(i,3)+back_int(i,1)
c     write(6,'(a,8f8.2)')'prova2',theta_int(i,7),theta_int(i,2),
c    *prova,scal*theta_int(i,3)+back_int(i,1),dnude,qsog
civan
      if(noghost==1) then
CORO    if(jjj==nnt) then
CORO       if(prova.ge.yyminsog) theta_int(i,2)=prova
CORO    end if
      else
c-modifica osservato
        if (ispaceindexing.eq.0) then
           if(prova.ge.yyminsog) theta_int(i,2)=prova
        endif
c-modifica osservato
c20febnoif(prova.ge.theta_int(i,2)) theta_int(i,2)=prova
      end if
civan      if(prova.ge.yyminsog) theta_int(i,2)=prova
      endif
      endif
      endif
      sumdif=sumdif+abs(theta_int(i,2)-scal*theta_int(i,3)
     *-back_int(i,1))
      if(abs(theta_int(i,2)).gt.0.0)
     *sumdeltaw=sumdeltaw+abs((theta_int(i,2)-scal*theta_int(i,3)
     *-back_int(i,1))**2)/abs(theta_int(i,2))
      sumobs=sumobs+abs(theta_int(i,2))
      sumobsA = sumobsA + abs(theta_int(i,2) - back_int(i,1))
  10  continue
      erreprofA=0.0
      if (sumobsA.gt.0.0) erreprofA = (sumdif/sumobsA)*100.0
      if(abs(sumobs).gt.0.0)then
      erreprof=(sumdif/sumobs)*100.0
      erreprofw=((sumdeltaw/sumobs)**0.5)*100.0
      else
      erreprof=0.0
      erreprofw=0.0
      endif
      if(nstop.eq.3)go to 1999
      if(nvolte.eq.1.or.ialt.gt.0)erre_old=erreprof
      if(icycle.eq.0.and.jjj.ne.nnt.and.ipriort.eq.0)then
      nvrif=int(nvoltemax/3)
      else
      nvrif=nvoltemax
      endif
      if(nvolte.gt.1.and.nvolte.le.nvrif)then
      ddelta=erreprof-erre_old
      erresog= 0.02*erre_old          
      erresog2= 100.0*erre_old          
      if(ddelta.gt.erresog) then
      if(nstop.eq.0)then
                   nstop=1
      elseif(nstop.eq.1)then
                   nstop=2
                   endif
      else
      nstop=0
      endif
      if(ddelta.gt.erresog2)nstop=2
      erre_old=erreprof
      else if(nvolte.gt.1.and.nvolte.gt.nvrif)then
      if(erreprof.gt.erre_old)nstop=2
      erre_old=erreprof
      endif
 1999 continue
      sumfo=0.0
      sumfc=0.0
      if(iknow.eq.1.and.jjj.gt.1)then
      do 2900 i=nref1(jjj),nref2(jjj)
      if(ialt.eq.0)then
      if(fx(i).lt.0.0)fx(i)=0.0
      sumfo=sumfo+sqrt(fx(i)/(clp(i)*Mult(i)))
      sumfc=sumfc+fxsav(i)
      else
      ft=fxfrag(i)
      if(ft.lt.0.0)ft=0.0
      sumfo=sumfo+sqrt(ft/(clp(i)*Mult(i)))
      sumfc=sumfc+fxsav(i)
      endif
 2900 continue
      if(abs(sumfo).gt.0.0)then
      sscl(jjj)=sumfc/sumfo
      else
      sscl(jjj)=1.0          
      endif
      sumdf=0.0
      do 3000 i=nref1(jjj),nref2(jjj)
      if(ialt.eq.0)then
      if(fx(i).gt.0.0)then
      fxos=sqrt(fx(i)/(clp(i)*Mult(i)))
      else
      fxos=0.0
      endif
      else
      ft=fxfrag(i)
      if(ft.gt.0.0)then
      fxos=sqrt(ft/(clp(i)*Mult(i)))
      else
      fxos=0.0
      endif
      endif
      sumdf=sumdf+abs(sscl(jjj)*fxos-fxsav(i))  
 3000 continue
      erref=(sumdf/sumfc)*100.0
      endif
      if (ispaceindexing==0 .and. jscreen > 0) then
          if (mod(nvolte,10) == 0 .or. nvolte == nvoltemax) then
          if (iknow == 1) then
              call setRowCountMesg(6,0)
          else
              call setRowCountMesg(5,0)
          endif
      if(jjj.eq.1)then
           if (nosing == 0) then
                 call write_message("Refine:Single peak",pos=2,kproc=0)
           else
                 call write_message("First interval",pos=2,kproc=0)
           endif
             call write_message("Rp':",rnum=erreprofA,pos=3,kproc=0)
             call write_message("Cycle:",inum=nvolte,pos=4,kproc=0)
             call write_message("Profile function:"//trim(profile),
     *                          pos=5,kproc=0)
      elseif(jjj.gt.1.and.jjj.lt.nnt)then
             if (iknow == 1) then
                call write_message("Interval:",inum=jjj-1,pos=2,kproc=0)
                call write_message("Rp':",rnum=erreprofA,pos=3,kproc=0)
                call write_message("Rf:",rnum=erref,pos=4,kproc=0)
                call write_message("Cycle:",inum=nvolte,pos=5,kproc=0)
                call write_message("Profile function:"//
     *          trim(adjustl(profile)),pos=6,kproc=0)
             else
                call write_message("Interval:",inum=jjj-1,pos=2,kproc=0)
                call write_message("Rp':",rnum=erreprofA,pos=3,kproc=0)
                call write_message("Cycle:",inum=nvolte,pos=4,kproc=0)
                call write_message("Profile function:"//
     *          trim(adjustl(profile)),pos=5,kproc=0)
             endif
      elseif(jjj.eq.nnt)then
             if (iknow == 1) then
                 if (ialt == 0) then
                 call write_message("Refine:Full pattern",pos=2,kproc=0)
                 call write_message("Rp':",rnum=erreprofA,pos=3,kproc=0)
                 call write_message("Rf:",rnum=erref,pos=4,kproc=0)
                 call write_message("Cycle:",inum=nvolte,pos=5,kproc=0)
                 call write_message("Profile function:"
     *           //trim(adjustl(profile)),pos=6,kproc=0)
                 endif
                 if (ialt > 0) then
                 call write_message("Difference pattern",pos=2,kproc=0)
                 call write_message("Rp':",rnum=erreprofA,pos=3,kproc=0)
                 call write_message("Rf:",rnum=erref,pos=4,kproc=0)
                 call write_message("Cycle:",inum=nvolte,pos=5,kproc=0)
                 call write_message("Profile function:"
     *           //trim(adjustl(profile)),pos=6,kproc=0)
                 endif
             else
                 call write_message("Refine:Full pattern",pos=2,kproc=0)
                 call write_message("Rp':",rnum=erreprofA,pos=3,kproc=0)
                 call write_message("Cycle:",inum=nvolte,pos=4,kproc=0)
                 call write_message("Profile function:"
     *           //trim(adjustl(profile)),pos=5,kproc=0)
             endif
      endif
          call scrper(' ',nvolte,nvoltemax,1)
          endif
      endif
   30 format(/,'     cycle  interval thetmin  thetmax    R-prof ')
   31 format(i8,i10,3f10.4,/)
   34 format('  **** Rf ****',f10.5)
   35 format(17hSingle peak  Rp'=,f8.2,' Cycle =',i3,a)
   36 format(19hFirst interval Rp'=,f8.2,' Cycle =',i3,a)
   37 format('Interval ',i3,6h  Rp'=,f8.2,' Cycle =',i3,a)
   47 format('Interval ',i3,6h  Rp'=,f8.2,' Rf =',f8.2,' Cycle =',
     *       i3,a)
   39 format(18hFull pattern  Rp'=,f8.2,' Cycle =',i3,a)
   69 format(24hDifference pattern  Rp'=,f8.2,' Cycle =',i3,a)
   49 format(18hFull pattern  Rp'=,f8.2,' Rf =',f8.2,' Cycle =',i3,a)
   59 format(24hDifference pattern  Rp'=,f8.2,' Rf =',f8.2,' Cycle =',i3
     *,a)
      return
      end
c-----------------------------------------------------------------------
      subroutine setint
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      dimension npun(10)
c------------------------------
 10   continue
      range=thmax-thmin
      if(nsetint.eq.0)then
      if(neutro.eq.1)then
      if(range.gt.40.0)then
      npoint=int(40.0/thstep)
                       else
                       npoint=npunti
                       endif
      elseif((neutro.eq.0.and.nsyn.eq.0))then
      if(range.gt.30.0)then
                       npoint=int(30.0/thstep)
                       else
                       npoint=npunti
                       endif
      elseif(neutro.eq.0.and.nsyn.eq.1)then
      ran=range/8.0
      if(ran.lt.20.0)then
      rang=20.0
      else
      rang=ran
      endif
      if(range.gt.rang)then
                       npoint=int(rang/thstep)
                       else
                       npoint=npunti
                       endif
                    endif
      else
      npoint=int(npunti/(nnt-1))
      endif
      nresto=mod(npunti,npoint)
      nrapp=int(npunti/npoint)
      if(nresto.eq.0.or.nresto.le.int(npoint/2.0))then
      nnt=nrapp+1
      else
      if(nresto.gt.int(npoint/2.0))nnt=nrapp+2
      endif
      nover=int(2.0/thstep)
      if(nnt.eq.2)then
      npun(2)=npunti
      ncoun1(2)=1
      ncoun2(2)=npunti
      go to 202
      endif
      do 200 i=2,nnt
      if(i.eq.2)then
      npun(i)=npoint
      ncoun1(i)=1
      ncoun2(i)=npoint
      else if(i.lt.nnt)then
      npun(i)=npoint+nover
      ncoun1(i)=ncoun2(i-1)-nover
      ncoun2(i)=ncoun1(i)+npun(i)       
      else if(i.eq.nnt)then
      if(nresto.eq.0)then
      npun(i)=npoint+nover
      ncoun1(i)=ncoun2(i-1)-nover
      ncoun2(i)=npunti
      else if(nresto.gt.int(npoint/2.0)) then
      npun(i)=nresto+nover
      ncoun1(i)=ncoun2(i-1)-nover
      ncoun2(i)=npunti
      else if(nresto.le.npoint/2.0) then
      npun(i)=npoint+nover+nresto-1
      ncoun1(i)=ncoun2(i-1)-nover
      ncoun2(i)=npunti
      endif
      endif
 200  continue
 202  continue
      do 205 i=2,nnt
      dismin=99999999.0
      dismin2=99999999.0
      do 201 j=1,nrefl
      diss=abs(theta_int(ncoun1(i),1)-TThet(j))
      diss2=abs(theta_int(ncoun2(i),1)-TThet(j))
      if(diss.lt.dismin)then
      dismin=diss
!corr      jmi=int((TThet(j)-thmin)/thstep)
      jmi = clocate(theta_int(:npunti,7),TThet(j))
      endif
      if(diss2.lt.dismin2)then
      dismin2=diss2
!corr      jmi2=int((TThet(j)-thmin)/thstep)
      jmi2 = clocate(theta_int(:npunti,7),TThet(j))
      endif
 201  continue
      if(neutro.eq.1)then
      iv1=15    
      else
      iv1=30    
      endif
      iv=2*iv1
      if(i.ne.2)then
      pmin=999999999.0
      do 203 j=0,iv
      jmirif=jmi-iv1+j
      if(theta_int(jmirif,2).le.pmin.and.jmirif.lt.ncoun2(i-1))then
      ncoun1(i)=jmi-iv1+j                   
      pmin=theta_int(jmi-iv1+j,2)
      endif
 203  continue
      endif
      if(i.ne.nnt)then
      pmin2=999999999.0
      do 204 j=0,iv
      if(theta_int(jmi2-iv1+j,2).le.pmin2)then
      ncoun2(i)=jmi2-iv1+j                   
      pmin2=theta_int(jmi2-iv1+j,2)
      endif
 204  continue
      endif
      npun(i)=ncoun2(i)-ncoun1(i)
!corr      thet1(i)=thmin+(ncoun1(i)-1)*thstep
!corr      thet2(i)=thmin+(ncoun2(i)-1)*thstep
      thet1(i)=theta_int(ncoun1(i),7)
      thet2(i)=theta_int(ncoun2(i),7)
 205  continue
      nrf1=2
      if(nosing.eq.1)then
      nrf1=1
      thet1(1)=thet1(2)
      thet2(1)=thet2(2)
      ncoun1(1)=ncoun1(2)
      ncoun2(1)=ncoun2(2)
      endif
      do 300 i=0,nnt-nrf1
      do 400 j=1,nrefl
      if(TThet(j).ge.thet1(nnt-i))then 
      nref1(nnt-i)=j
      go to 450
      endif
 400  continue
 450  continue
 300  continue
      do 600 i=nrf1,nnt
      do 700 j=0,nrefl-1
      if(TThet(nrefl-j).le.thet2(i))then 
      nref2(i)=nrefl-j
      go to 750
      endif
 700  continue
 750  continue
 600  continue
      do 1000 i=1,nnt
      ymx(i)=-9999999
      do 1100 j=1,npunti
      if(theta_int(j,1).ge.thet1(i).and.theta_int(j,1).le.thet2(i)
     *.and.theta_int(j,2).gt.ymx(i))ymx(i)=theta_int(j,2)
1100  continue
1000  continue
CATT  sover=3.0
      sover=1.0
      do 2000 i=2,nnt
      if(i.eq.2.and.nnt.ne.2)then
      thet11(i)=thet1(i)
      thet22(i)=thet2(i)+sover
      ncoun11(i)=ncoun1(i) 
!corr      ncoun22(i)=ncoun2(i)+int(sover/thstep)+1
      ncoun22(i) = clocate(theta_int(:npunti,7),thet22(i))
      else if(i.eq.nnt.and.nnt.ne.2) then
      thet11(i)=thet1(i)-sover
      thet22(i)=thet2(i)
!corr      ncoun11(i)=ncoun1(i)-int(sover/thstep)-1
      ncoun11(i) = clocate(theta_int(:npunti,7),thet11(i))
      ncoun22(i)=ncoun2(i)
      else if(i.eq.2.and.nnt.eq.2) then
      thet11(i)=thet1(i)
      thet22(i)=thet2(i)
      ncoun11(i)=ncoun1(i)
      ncoun22(i)=ncoun2(i)
      else
      thet11(i)=thet1(i)-sover
      thet22(i)=thet2(i)+sover
!corr      ncoun11(i)=ncoun1(i)-int(sover/thstep)-1
!corr      ncoun22(i)=ncoun2(i)+int(sover/thstep)+1
      ncoun11(i) = clocate(theta_int(:npunti,7),thet11(i))
      ncoun22(i) = clocate(theta_int(:npunti,7),thet22(i))
      endif
      if(ncoun22(i).le.0)ncoun22(i)=ncoun2(i)
      if(ncoun11(i).le.0)ncoun11(i)=ncoun2(i)
 2000 continue
      nrf1=2
      if(nosing.eq.1)then
      nrf1=1
      thet11(1)=thet11(2)
      thet22(1)=thet22(2)
      ncoun11(1)=ncoun11(2)
      ncoun22(1)=ncoun22(2)
      endif
      do 1300 i=0,nnt-nrf1
      do 1400 j=1,nrefl
      if(TThet(j).ge.thet11(nnt-i))then 
      nref11(nnt-i)=j
      go to 1450
      endif
1400  continue
1450  continue
1300  continue
      do 1600 i=nrf1,nnt
      do 1700 j=0,nrefl-1
      if(TThet(nrefl-j).le.thet22(i))then 
      nref22(i)=nrefl-j
      go to 1750
      endif
1700  continue
1750  continue
1600  continue
      nnt=nnt+1
      thet1(nnt)=thet1(2)
      thet11(nnt)=thet11(2)
      thet2(nnt)=thet2(nnt-1)
      thet22(nnt)=thet22(nnt-1)
      nref1(nnt)=nref1(2)
      nref11(nnt)=nref11(2)
      nref2(nnt)=nref2(nnt-1)
      nref22(nnt)=nref22(nnt-1)
      ncoun1(nnt)=ncoun1(2)
      ncoun11(nnt)=ncoun11(2)
      ncoun2(nnt)=ncoun2(nnt-1)
      ncoun22(nnt)=ncoun22(nnt-1)
      do 1601 i=1,nnt
      if(nref1(i).gt.nref2(i))then
      write(Msg,1604)
      call MsgWinErr('Warning',Msg,ERR_WINDOW,nExitCode)        
      nnt=2
      nsetint=1
      go to 10
      endif
 1601 continue
 1604 format('Since large range in your pattern is without '
     *,'reflections','no subdivision into intervals is made')
      return
      end
c--------------------------------------------
      subroutine setback(wrange,ier)
      USE Riflessi, only: TThet
      USE xdataMod, only: tt,countmi,weig,tth,conth
      USE Conteggi, only: theta_int,back_int,bkg
      USE General, only: nrefl,iprin,lo
      use arrayutil
c
      implicit none
      real :: wrange
      integer :: ier
c
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      integer :: ncycle,icycle,nosing,izero,noint,ialt,if92,nocell
      real :: zeroprof,asym,scal,frac,sigma
      common/genob/irho,thetamin
      integer :: irho
      real :: thetamin
      common/genob2/thmin,thmax,thstep
      real :: thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      real :: thet1,thet2,ymmx,thet11,thet22,sscl,scala,ymx
      integer :: ncoun1,ncoun2,nref1,nref2,nnt,ncoun11,ncoun22
      integer :: nref11,nref22
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      integer :: nback,ifcamb,noback,ntyp
      real :: backp,bkk,tmm
      common /pesob/weigb(10000),nsmoothb
      integer :: nsmoothb
      real :: weigb
      common /backp2/ npol(10)
      integer :: npol
      real, dimension(300) :: tmin,tmax
      real, dimension(300) :: ttmin,ttmax
      !real, dimension(300) :: alm1,alm2
      real, dimension(:),allocatable :: alm1,alm2
      integer, parameter :: alm_start_size=300
      real, dimension(nrefl) :: distth
      real :: a,a1,a2,b,b1,b2,back,countmax,countmin,range
      real :: countmimed,delta,deltt,detden,detnum1,detnum2,df
      real :: df2,difmax,difmax2,distmax,dmedio,dst,dtt,dis
      real :: thet,thhmin,ttt,zero
      integer :: i,j,k,jjj,jsav,jsav2,imem,imem2,itime,jcall
      integer :: kk,kkmin,kksav,ksp,mrange,ndom,nrange,ntime
      integer :: ntimemax,num,nvol,kkdif
c
c-- calcolo dei coefficienti di background
c
      call new_array(alm1,alm_start_size)
      call new_array(alm2,alm_start_size)
      nback=0
      do 1100 jjj=1,nnt-1
         range = thet2(jjj) - thet1(jjj)
         countmin=999999999.0
         countmax=-999999999.0
         zero=0.00000001
         nrange=11       
         mrange=11       
         ntimemax=30
         if((jjj.ne.1.and.range.gt.4.0.and.npol(jjj).gt.1).or
     *   .(jjj.eq.1.and.nosing.eq.1))then
            tmin(1)=theta_int(ncoun1(jjj),1)
!corr            tmax(1)=theta_int(ncoun1(jjj),1)+2.0*thstep
            tmax(1)=theta_int(ncoun1(jjj)+2,1)
!corr            tmin(nrange)=theta_int(ncoun2(jjj),1)-2.0*thstep
            tmin(nrange) = theta_int(ncoun2(jjj)-2,1)
            tmax(nrange)=theta_int(ncoun2(jjj),1)
            nrange=nrange-2
            do i=1,nrange
               countmi(i+1)=99999999.9
               delta=(tmin(nrange+2)-tmax(i))/(nrange-i+1)
               tmin(i+1)=tmax(i)
               ttmin(i+1)=tmin(i+1)
               tmax(i+1)=tmin(i+1)+delta
               ttmax(i+1)=tmin(i+1)+delta
               do j=0,nref2(jjj)-nref1(jjj)
                  if(TThet(nref2(jjj)-j).le.tmax(i+1)
     *            .and.TThet(nref2(jjj)-j).ge.
     *            tmin(i+1).and.TThet(nref2(jjj)-j).le.tmax(i+1))then
                     tmax(i+1)=TThet(nref2(jjj)-j)
                     go to 17
                  endif
               enddo
               tmax(i+1)=ttmax(i+1)
 17            continue
               dtt=tmax(i+1)-tmin(i+1)
               if(dtt.lt.zero)tmax(i+1)=ttmax(i+1)
            enddo
!corr         9  continue
            countmi(1)=999999999.0
            countmi(nrange+2)=999999999.0
            nrange=nrange+2
         endif
         if((jjj.ne.1.and.range.gt.4.0.and.npol(jjj).gt.1).or.
     *   (jjj.eq.1.and.nosing.eq.1))then
            do 200 i=2,nrange-1
               num=0
               distmax=-99999999.0
               do j=nref1(jjj),nref2(jjj)-1
                  if(TThet(j).ge.tmin(i).and.TThet(j).le.tmax(i).and
     *            .TThet(j+1).ge.tmin(i).and.TThet(j+1).le.tmax(i))then
                     distth(j)=TThet(j+1)-TThet(j)
                     if(distth(j).gt.distmax.and.distth(j)
     *               .gt.(2.0*thstep))then
                        num=num+1
                        distmax=distth(j)
                        jsav=j
                     endif
                  endif
               enddo
!corr          250  continue
               do j=nref1(jjj),nref2(jjj)
                  if(TThet(j).ge.tmin(i).and.TThet(j).le.tmax(i))then
                  dst=TThet(j)-tmin(i)
                     jsav2=j
                     !go to 275
                     exit
                  endif
               enddo      
!corr          270  continue
!corr           275  continue
               if(num.gt.0)then
                  if(distth(jsav).ge.dst)then
                     tmin(i)=TThet(jsav)
                     tmax(i)=TThet(jsav+1)
                  else
                     tmax(i)=TThet(jsav2)
                  endif
               else
                  do j=nref1(jjj),nref2(jjj)
                     if(TThet(j).ge.tmin(i).and.TThet(j).le.tmax(i))then
                        tmin(i)=TThet(j)
                        tmax(i)=ttmax(i)
                     endif
                  enddo
!corr             260   continue
               endif
 200        continue
         else
            nrange=1
            tmin(nrange)=thet1(jjj)
            tmax(nrange)=thet2(jjj)
            countmi(nrange)=999999999.0
         endif
c
         if((jjj.ne.1.and.range.gt.4.0.and.npol(jjj).gt.1).or
     *   .(jjj.eq.1.and.nosing.eq.1))then
            do i=1,nrange
               deltt=tmax(i)-tmin(i)
               if(deltt.lt.thstep)then
                  tmin(i)=tmax(i-1)
                  tmax(i)=tmin(i+1)
               endif
            enddo
!corr    12      continue
         endif
         do 10 i=ncoun1(jjj),ncoun2(jjj)
            back_int(i,1)=0.0
            a=theta_int(i,2)
            b=theta_int(i,1)
            do 2 j=1,nrange
               if(b.ge.tmin(j).and.b.le.tmax(j)
     *         .and.a.le.countmi(j)) then
                  countmi(j)=a       
                  tt(j)=b
!corr                  go to 20
                  exit
               endif
   2        continue
!corr     20     continue
            if(a.lt.countmin) then
               countmin=a       
               thetamin=b
            endif
 10      continue
         if((jjj.ne.1.and.range.gt.4.0.and.npol(jjj).gt.1).or
     *   .(jjj.eq.1.and.nosing.eq.1))then
c
           countmimed=0.0
           do k=1,nrange
             countmimed=countmimed+countmi(k)
           enddo
           countmimed=countmimed/float(nrange)
           do k=1,nrange
             if(countmi(k).lt.0.3*countmimed)then
               kkmin=9999999
               do kk=1,nrange
                 if(countmi(kk).gt.0.3*countmimed)then
                   kkdif=iabs(k-kk)
                   if(kkdif.lt.kkmin)then
                     kksav=kk
                     kkmin=kkdif
                   endif
                 endif
               enddo
               countmi(k)=countmi(kksav)
             endif
           enddo
c
           if(countmi(1).gt.(1.3*countmi(2)))countmi(1)=countmi(2)
           if(countmi(nrange).gt.(1.3*countmi(nrange-1)))
     *     countmi(nrange)=countmi(nrange-1)
           nrange=npol(jjj)
         endif
         ntime=0
         itime=0
 1000    continue
         ntime=ntime+1
         if((jjj.ne.1.and.range.gt.4.0.and.npol(jjj).gt.1).or
     *   .(jjj.eq.1.and.nosing.eq.1))then
           if(itime.eq.0)then
              call corr(mrange)
           else
              itime=0
              do 7 i=1,mrange
                 thhmin=99999999.0
                 do 8 j=1,mrange
                    if(tt(j).le.thhmin)then
                    thhmin=tt(j)
                    jsav=j
                    endif
 8               continue
                 tth(i)=tt(jsav)
                 conth(i)=countmi(jsav)
                 tt(jsav)=99999999.0
 7            continue
              do i=1,mrange
                 tt(i)=tth(i)
                 countmi(i)=conth(i)
              enddo
           endif
           jcall=1
           call lsqback(mrange,nrange,jcall,jjj,ier)
           if(ier.lt.0)return
           if(ntime.lt.ntimemax)then
              imem=0
              imem2=0
              difmax=-99999999.0
              difmax2=-99999999.0
              nvol=0
              ndom=0
              do 7200 i=ncoun1(jjj),ncoun2(jjj)
                 thet=theta_int(i,1)/thetamin - 1.0
                 back_int(i,1)=bkg(1)
                 do k=2,npol(jjj)
                    ksp=real(k)-1.0
                    back_int(i,1)=back_int(i,1)+bkg(k)*(thet**ksp)
                 enddo
!corr            7201 continue
                 if(back_int(i,1).gt.1.02*theta_int(i,2))then
                    if(nvol.eq.0)then
                       ndom=ndom+1
                       if (ndom > size(alm1)) then
                           call resize_array(alm1,ndom+alm_start_size)
                           call resize_array(alm2,ndom+alm_start_size)
                       endif
                       alm1(ndom)=theta_int(i,1)
                       alm2(ndom)=theta_int(i,1)
                       nvol=1
                    else
                       alm2(ndom)=theta_int(i,1)
                    endif
                 else
                    nvol=0
                 endif
                 if(countmin.gt.back_int(i,1))then
                    df2=countmin-back_int(i,1)        
                    if(df2.gt.0.001*countmin.and.df2.gt.difmax2)then
                       difmax2=df2
                       imem2=i
                    endif
                 endif
7200          continue
              if(ndom.ne.0)then
                 dmedio=0.0
                 do 7205 j=1,ndom
                    difmax=-999999999.0
                    do 7206 i=ncoun1(jjj),ncoun2(jjj)
                       if(theta_int(i,1).ge.alm1(j).and.
     *                 theta_int(i,1).le.alm2(j))then
                          df=back_int(i,1)-theta_int(i,2)
                          if(df.gt.difmax)then
                             difmax=df
                             imem=i
                          endif
                       endif
7206                continue
                    dmedio=dmedio+difmax
                    if(imem.ne.0)then
                       do 9001 k=1,mrange
                          dis=abs(tt(k)-theta_int(imem,1))
                          if(dis.lt.0.5*thstep)go to 9002
9001                   continue
                       mrange=mrange+1
                       tt(mrange)=theta_int(imem,1)
                       countmi(mrange)=theta_int(imem,2)
                       itime=1
9002                   continue
                    endif
7205             continue
                 dmedio=dmedio/ndom
              endif
              if(imem2.ne.0)then
                 do 9003 k=1,mrange
                    dis=abs(tt(k)-theta_int(imem2,1))
                    if(dis.lt.thstep)go to 9004
9003             continue
                 mrange=mrange+1
                 tt(mrange)=theta_int(imem2,1)
                 countmi(mrange)=countmin           
                 itime=1
9004             continue
              endif
              if(itime.gt.0.and.ntime.le.30)go to 1000
           endif
         else
            if(jjj.eq.1.and.nosing.eq.0)then
               a1=theta_int(ncoun1(1),1)/thetamin-1.0
               a2=theta_int(ncoun2(1),1)/thetamin-1.0
               b1=theta_int(ncoun1(1),2)
               b2=theta_int(ncoun2(1),2)
               detden=a2-a1
               detnum1=b1*a2-b2*a1
               detnum2=b2-b1
               bkg(1)=detnum1/detden
               bkg(2)=detnum2/detden
               mrange=0
            else
               bkg(1)=countmin
               bkg(2)=0.0
               mrange=1
            endif
         endif
         if((jjj.gt.1.and.range.gt.4.0.and.npol(jjj).gt.1).or
     *   .(jjj.eq.1.and.nosing.eq.1))then
            call corr2(mrange,jjj,wrange,ier)
            if(ier.lt.0)return
            call varprofile(mrange,nrange,jjj)
            if(iprin.gt.0.and.noback.eq.0)write(lo,7000) jjj-1,bkg
 7000   format(/,9x,'*** The background polynomial coefficients',
     *  ' for the interval ***',/,16x,
     *  '*** number ',i3,'  are automatically calculated ***'
     *  ,/,/,5x,3f20.5,/,5x,3f20.5,/,5x,3f20.5,/,5x,2f20.5,/,/,9x,
     *  '***  The following interpolation points have been used  ***',/)
            if (iprin.ne.0) write(lo,22) 
            do 19 i=1,mrange
               ttt=(tt(i)/thetamin-1.0)
               back=bkg(1)
               if(jjj.gt.1)then
                  do 21 k=2,npol(jjj)
                     ksp=real(k)-1.0
                     back=back+bkg(k)*(ttt**ksp)
 21               continue
               endif
               if (iprin.ne.0) write(lo,7100)(ttt+1.0)*thetamin,
     *         countmi(i),weig(i),back
   19       continue
 7100       format(11x,4f12.3)
   22       format(18x,'Theta     Countmin      Weight    Backcalc')
         endif
         if(jjj.ne.1.or.(jjj.eq.1.and.nosing.eq.1))then
            do j=1,mrange
               backp(nback+j,1)=tt(j)
               backp(nback+j,2) =countmi(j)
               ntyp(nback+j)=jjj
               weigb(nback+j)=weig(j)
               write(71,*)'BACKP: ',backp(nback+j,1),backp(nback+j,2)
            enddo
         endif
         tmm(jjj)=thetamin
         do j=1,npol(jjj)
            bkk(j,jjj)=bkg(j)
         enddo
!corr    1520 continue
         if(jjj.ne.1.or.(jjj.eq.1.and.nosing.eq.1))nback=nback+mrange
 1100 continue
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE LUDCMP(A,N,NP,INDX,D,ier)
!
      USE General
      PARAMETER (NMAX=800,TINY=1.0E-20)
      DIMENSION A(NP,NP),INDX(N),VV(NMAX)

c     write(6,*) 'PALLE0',a(:np,:np)
      ier=0
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
CANG    IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        IF (AAMAX.EQ.0.) then                    
        write(Msg,999) 
  999   format('Singular least squares matrix ')
        call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
        ier=-1
        return
                         endif
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        DO 14 I=1,J-1
          SUM=A(I,J)
          DO 13 K=1,I-1
            SUM=SUM-A(I,K)*A(K,J)
13        CONTINUE
          A(I,J)=SUM
14      CONTINUE
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          DO 15 K=1,J-1
            SUM=SUM-A(I,K)*A(K,J)
15        CONTINUE
          A(I,J)=SUM
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
c         write(6,*) 'PALLE',i,j,dum,imax,a(i,j),aamax
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(A(J,J).EQ.0.)A(J,J)=TINY
        IF(J.NE.N)THEN
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      DIMENSION A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        DO 13 J=I+1,N
          SUM=SUM-A(I,J)*B(J)
13      CONTINUE
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine senti
      USE General
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      do 10 i=1,3
   10 ang(i)=ang(i)*dtor
      a1=cos(ang(1))
      a2=cos(ang(2))
      a3=cos(ang(3))
      s1=sin(ang(1))
      s2=sin(ang(2))
      s3=sin(ang(3))
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
      v=abc(1)*abc(2)*abc(3)*sqrt(arg)
      astar=abc(2)*abc(3)*s1         /v
      bstar=abc(1)*abc(3)*s2         /v
      cstar=abc(1)*abc(2)*s3         /v
      cosas=(a2*a3-a1)/(s2*s3                 )
      cosbs=(a1*a3-a2)/(s1*s3                 )
      coscs=(a1*a2-a3)/(s1*s2                 )
      return
      end
c-----------------------------------------------------------------------
      subroutine setsingPrimaDelleModifiche 
     *               (fracout,uvwtsav,fracsing,ibecare)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
!corr      include 'rando.fi'
      USE randofi
      common/uvwold/uvwtold(6)
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /peak/xmax(200),ymax(200),fw(200),npk,asm(200)
      dimension ind(20),dm(20),xm(20),ym(20),peso1(20),peso2(20),
     *peso3(20),peso0(20),fww(20)
c------------------------------
      ibecare=0
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
c
      call sfl39
c
      npkk=min0(20,npk)
      do 30 i=1,npkk
      fww(i)=fw(i)
      if(izero.gt.0)xmax(i)=xmax(i)-zeroprof
 30   continue
      do 35 i=1,npkk
      fwmin=9999999999.0
      do 36 j=1,npkk
      if(fww(j).lt.fwmin)then
      jsav=j
      fwmin=fww(j)
      endif
 36   continue
      peso0(jsav)=(float(npkk-i+1))
      fww(jsav)=9999.0
 35   continue
      do 100 i=1,npkk
      peso1(i)=float(npkk-i+1)
      distmin=9999999999.0
      do 200 j=1,nrefl
      dista=abs(xmax(i)-TThet(j))
      if(dista.lt.distmin)then
      jsav=j
      distmin=dista
      endif
 200  continue
CNUOVO
      if(jsav.gt.2)then
      xlim1=TThet(jsav-2)
      else
      xlim1=thmin
      endif
      if(jsav.le.(nrefl-2))then
      xlim2=TThet(jsav+2)
      else
      xlim2=thmax
      endif
      if(xlim1.lt.thmin)xlim1=thmin
      if(xlim2.gt.thmax)xlim2=thmax
      ini1 = clocate(theta_int(:npunti,7),xlim1)
      ini2 = clocate(theta_int(:npunti,7),xlim2)
      ymin=999999999.0
      do 50 j=ini1,ini2
      if(theta_int(j,2).lt.ymin)ymin=theta_int(j,2)
  50  continue
      if(jsav.gt.1)then
      xlim1=TThet(jsav-1)
      else
      xlim1=thmin
      endif
      if(jsav.le.nrefl)then
      xlim2=TThet(jsav+1)
      else
      xlim2=thmax
      endif
      ini0 = clocate(theta_int(:npunti,7),xmax(i))
      ini1 = clocate(theta_int(:npunti,7),xlim1)
      ini2 = clocate(theta_int(:npunti,7),xlim2)
      do 110 j=ini1,ini0
      if(theta_int(j,2).lt.2.0*ymin)go to 111
 110  continue
      peso1(i)=0.0
      go to 114
 111  continue
      do 113 j=ini0,ini2
      if(theta_int(j,2).lt.2.0*ymin)go to 114
 113  continue
      peso1(i)=0.0
 114  continue
CNUOVO
      ind(i)=jsav
      if(jsav.gt.1)then
      dist1=TThet(jsav)-TThet(jsav-1)
      else
      dist1=TThet(jsav)-thmin
      endif
      if(jsav.lt.nrefl)then
      dist2=TThet(jsav+1)-TThet(jsav)
      else
      dist2=thmax-TThet(jsav)
      endif
      dm(i)=amin1(dist1,dist2)
      if (distmin.gt.0.5)dm(i)=0.0
      thminn=amax1(TThet(ind(i)),thmin)
!corr
!corr      ini = int ( ( thminn - thmin ) / thstep ) + 1
      ini = clocate(theta_int(:npunti,7),thminn)
!corr
c     write(6,*)i,xmax(i),ind(i),TTHet(ind(i)),dm(i),ymax(i)
c    *,theta_int(ini,2)
      do 102 k=1,i-1
      if(ind(i).eq.ind(k))then
      dm(k)=0.0
      dm(i)=0.0
      endif
 102  continue
 100  continue
      pesomax=-999999999.0
      do 300 i=1,npkk
      dmax=-9999999.0
      do 400 j=1,npkk
      if(dm(j).gt.dmax)then
      dmax=dm(j)
      jsa=j
      endif
 400  continue
      peso2(jsa)=(float(npkk-i+1))
      peso3(jsa)=(peso0(jsa)**2)*(peso1(jsa))*(peso2(jsa)**2)
      dm(jsa)=0.0
      if(peso3(jsa).gt.pesomax)then
      pesomax=peso3(jsa)
      jsavv=jsa
      endif
 300  continue
      if(nosing.eq.1)then
      uvwtsav=10.0*thstep
      uvwt(1)=uvwtsav**2
      uvwt(2)=0.0           
      uvwt(3)=0.0           
      if(nprof.eq.4)then 
      uvwt(4)=0.5
      elseif(nprof.ne.2.and.nprof.ne.3)then
      if(neutro.eq.1)then
      uvwt(4)=1.6        
      else
      uvwt(4)=0.8
      endif
      endif
      uvwt(5)=0.0
      uvwt(6)=0.0
      frac=7.0                        
      zeroprof=0.0
      return
      endif
      jrif=jsavv
      irif=ind(jsavv)
      thminn=amax1(TThet(irif),thmin)
!corr
!corr      ini = int ( ( thminn - thmin ) / thstep ) + 1
      ini = clocate(theta_int(:npunti,7),thminn)
!corr
      tsog1=10.0*fw(jrif)
      tsog2=fw(jrif)
      zeroprof=(xmax(jrif)-TThet(irif))*0.5
      if(irif.eq.1)then
        t1=amin1(tsog1,(TThet(irif)-thmin))      
        do ii=irif+1,nrefl
          ttt=TThet(ii)-TThet(irif)
          if(ttt.gt.tsog2)then
            t2=amin1(tsog1,(TThet(ii)-TThet(irif))*0.9)
            go to 222
          endif
        enddo
222     continue
      elseif(irif.eq.nrefl)then
      t2=amin1(tsog1,(thmax-TThet(irif)))
        do ii=irif-1,1,-1
          ttt=TThet(irif)-TThet(ii)
          if(ttt.gt.tsog2)then
            t1=amin1(tsog1,(TThet(irif)-TThet(ii))*0.9)      
            go to 322
          endif
        enddo
322     continue
      else
        do ii=irif-1,1,-1
          ttt=TThet(irif)-TThet(ii)
          if(ttt.gt.tsog2)then
            t1=amin1(tsog1,(TThet(irif)-TThet(ii))*0.9)      
            go to 422
          endif
        enddo
422     continue
        do ii=irif+1,nrefl
          ttt=TThet(ii)-TThet(irif)
          if(ttt.gt.tsog2)then
            t2=amin1(tsog1,(TThet(ii)-TThet(irif))*0.9)
            go to 522
          endif
        enddo
522     continue
      endif
      th1=TThet(irif)-t1
      th2=TThet(irif)+t2
      thminn=amax1(th1,thmin)
      thmaxx=amin1(xmax(jrif),thmax)
      thmaxxx=amin1(th2,thmax)
!corr
!corr      iniz1 = int ( ( thminn - thmin ) / thstep ) + 1
!corr      ifin1 = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      ifin2 = int ( ( thmaxxx - thmin ) / thstep ) + 1
      iniz1 = clocate(theta_int(:npunti,7),thminn)
      ifin1 = clocate(theta_int(:npunti,7),thmaxx)
      ifin2 = clocate(theta_int(:npunti,7),thmaxxx)
      if(ifin1.lt.iniz1) ifin1=iniz1         
      if(ifin2.lt.iniz1) ifin2=iniz1         
!corr
      yrif=-999999999.0
      do 910 i=iniz1,ifin2
      if(theta_int(i,2).gt.yrif)yrif=theta_int(i,2)
 910  continue
      ymin=999999999.0
      do 1000 i=iniz1,ifin1
      if(theta_int(i,2).lt.ymin)then             
      ymin=theta_int(i,2)
      isav=i
      endif
 1000 continue
      iniz1=isav
      dymin=99999999.0
      do 1010 i=iniz1,ifin1
      yyy=theta_int(i,2)-ymin
      yys=(yrif-ymin)*0.5
      dys=abs(yyy-yys)
      if(dys.lt.dymin)then             
      iisav=i
      dymin=dys
      endif
 1010 continue
      x1=theta_int(iisav,1)
 1020 continue
      nref1(1)=irif    
      nref11(1)=irif    
      nref2(1)=irif    
      nref22(1)=irif    
      thet1(1)=theta_int(isav,1)       
      thet11(1)=theta_int(isav,1)       
      ncoun1(1)=isav
      ncoun11(1)=isav
      thmaxx=amin1(th2,thmax)
      thminn=amax1(xmax(jrif),thmin)
!corr
!corr      iniz1 = nint ( ( thminn - thmin ) / thstep ) + 1
!corr      ifin1 = nint ( ( thmaxx - thmin ) / thstep ) + 1
      iniz1 = clocate(theta_int(:npunti,7),thminn)
      ifin1 = clocate(theta_int(:npunti,7),thmaxx)
!corr
      if(ifin1.lt.iniz1) ifin1=iniz1         
      ymin=999999999.0
      do 1200 i=iniz1,ifin1
      if(theta_int(i,2).lt.ymin)then             
      ymin=theta_int(i,2)
      isav=i
      endif
 1200 continue
      ifin1=isav
      dymin=99999999.0
      do 1210 i=iniz1,ifin1
      yyy=theta_int(i,2)-ymin
      yys=(yrif-ymin)*0.5
      dys=abs(yyy-yys)
      if(dys.lt.dymin)then             
      iisav=i
      dymin=dys
      endif
 1210 continue
      x2=theta_int(iisav,1)
 1220 continue
      thet2(1)=theta_int(isav,1)         
      thet2(1)=theta_int(isav,1)         
      thet22(1)=theta_int(isav,1)         
      ncoun2(1)=isav
      ncoun22(1)=isav
      cmax=-999999.0
      do 501 i=ncoun1(1),ncoun2(1)
      if(theta_int(i,2).ge.cmax)then
      cmax=theta_int(i,2)
      isavv=i
      endif
 501  continue
      if(iabs(isavv-ncoun1(1)).le.3
     *.or.iabs(isavv-ncoun2(1)).le.3)ibecare=1
      if(x2.gt.x1)fw(jrif)=x2-x1
      uvwtsav=fw(jrif)
      uvwt(1)=uvwtsav**2
      uvwt(2)=0.0           
      uvwt(3)=0.0           
      if(nprof.eq.4)then 
      uvwt(4)=0.5
      else
      if(neutro.eq.1)then
      uvwt(4)=1.6        
      else
      uvwt(4)=0.8
      endif
      endif
      uvwt(5)=0.0
      uvwt(6)=0.0
      frac=(thet2(1)-thet1(1))/fw(jrif)
      if(frac.gt.15.0)frac=15.0
c     if(frac.gt.7.0)frac=7.0
      if(frac.lt.2.0)frac=2.0
      if(fracout.gt.0.0)frac=fracout
      fracsing = frac
      uvwtold(1)=uvwt(1)
      uvwtold(2)=uvwt(2)
      uvwtold(3)=uvwt(3)
      uvwtold(4)=uvwt(4)
      uvwtold(5)=uvwt(5)
      uvwtold(6)=uvwt(6)
      return
      end
c-----------------------------------------------------------------------
      subroutine setsing (fracout,uvwtsav,fracsing,ibecare)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
!corr      include 'rando.fi'
      USE randofi
      common/uvwold/uvwtold(6)
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /peak/xmax(200),ymax(200),fw(200),npk,asm(200)
      dimension ind(20),dm(20),xm(20),ym(20),peso1(20),peso2(20),
     *peso3(20),peso0(20),fww(20)
c------------------------------
      ibecare=0
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
c
      call sfl39
!      write(0,*) 'PEAKSEARCH:'
!      do i=1,npk
!       write(0,*) xmax(i),ymax(i),fw(i)
!      end do
c
      npkk=min0(20,npk)
      do 30 i=1,npkk
      fww(i)=fw(i)
      if(izero.gt.0)xmax(i)=xmax(i)-zeroprof
 30   continue
      do 35 i=1,npkk
      fwmin=9999999999.0
      do 36 j=1,npkk
      if(fww(j).lt.fwmin)then
      jsav=j
      fwmin=fww(j)
      endif
 36   continue
      peso0(jsav)=(float(npkk-i+1))
      fww(jsav)=9999.0
 35   continue
      do 100 i=1,npkk
      peso1(i)=float(npkk-i+1)
      distmin=9999999999.0
      do 200 j=1,nrefl
      dista=abs(xmax(i)-TThet(j))
      if(dista.lt.distmin)then
      jsav=j
      distmin=dista
      endif
 200  continue
CNUOVO
      if(jsav.gt.2)then
      xlim1=TThet(jsav-2)
      else
      xlim1=thmin
      endif
      if(jsav.le.(nrefl-2))then
      xlim2=TThet(jsav+2)
      else
      xlim2=thmax
      endif
      if(xlim1.lt.thmin)xlim1=thmin
      if(xlim2.gt.thmax)xlim2=thmax
      ini1 = clocate(theta_int(:npunti,7),xlim1)
      ini2 = clocate(theta_int(:npunti,7),xlim2)
!corr
      ymin=999999999.0
      do 50 j=ini1,ini2
      if(theta_int(j,2).lt.ymin)ymin=theta_int(j,2)
  50  continue
      if(jsav.gt.1)then
      xlim1=TThet(jsav-1)
      else
      xlim1=thmin
      endif
!corr-      if(jsav.le.nrefl)then  !for seg.fault if jsav=nrefl
      if(jsav.lt.nrefl)then
      xlim2=TThet(jsav+1)
      else
      xlim2=thmax
      endif
      ini0 = clocate(theta_int(:npunti,7),xmax(i))
      ini1 = clocate(theta_int(:npunti,7),xlim1)
      ini2 = clocate(theta_int(:npunti,7),xlim2)
!corr
      do 110 j=ini1,ini0
      if(theta_int(j,2).lt.2.0*ymin)go to 111
 110  continue
      peso1(i)=0.0
      go to 114
 111  continue
      do 113 j=ini0,ini2
      if(theta_int(j,2).lt.2.0*ymin)go to 114
 113  continue
      peso1(i)=0.0
 114  continue
CNUOVO
      ind(i)=jsav
      if(jsav.gt.1)then
      dist1=TThet(jsav)-TThet(jsav-1)
      else
      dist1=TThet(jsav)-thmin
      endif
      if(jsav.lt.nrefl)then
      dist2=TThet(jsav+1)-TThet(jsav)
      else
      dist2=thmax-TThet(jsav)
      endif
      dm(i)=amin1(dist1,dist2)
      if(distmin.gt.0.5)dm(i)=0.0
      thminn=amax1(TThet(ind(i)),thmin)
!corr
!corr      ini = int ( ( thminn - thmin ) / thstep ) + 1
      ini = clocate(theta_int(:npunti,7),thminn)
!corr
      do 102 k=1,i-1
      if(ind(i).eq.ind(k))then
      dm(k)=0.0
      dm(i)=0.0
      endif
 102  continue
 100  continue
      pesomax=-999999999.0
      do 300 i=1,npkk
      dmax=-9999999.0
      do 400 j=1,npkk
      if(dm(j).gt.dmax)then
      dmax=dm(j)
      jsa=j
      endif
 400  continue
      peso2(jsa)=(float(npkk-i+1))
      peso3(jsa)=(peso0(jsa)**2)*(peso1(jsa))*(peso2(jsa)**2)
      dm(jsa)=0.0
      if(peso3(jsa).gt.pesomax)then
      pesomax=peso3(jsa)
      jsavv=jsa
      endif
 300  continue
      if(nosing.eq.1)then
      uvwtsav=10.0*thstep
      uvwt(1)=uvwtsav**2
      uvwt(2)=0.0           
      uvwt(3)=0.0           
      if(nprof.eq.4)then 
      uvwt(4)=0.5
      elseif(nprof.ne.2.and.nprof.ne.3)then
      if(neutro.eq.1)then
      uvwt(4)=1.6        
      else
      uvwt(4)=0.8
      endif
      endif
      uvwt(5)=0.0
      uvwt(6)=0.0
      frac=7.0                        
      zeroprof=0.0
      return
      endif
      jrif=jsavv
      irif=ind(jsavv)
      thminn=amax1(TThet(irif),thmin)
!corr
!corr      ini = int ( ( thminn - thmin ) / thstep ) + 1
      ini = clocate(theta_int(:npunti,7),thminn)
!corr
      tsog1=10.0*fw(jrif)
      tsog2=fw(jrif)
      zeroprof=(xmax(jrif)-TThet(irif))*0.5
      if(irif.eq.1)then
        t1=amin1(tsog1,(TThet(irif)-thmin))      
        do ii=irif+1,nrefl
          ttt=TThet(ii)-TThet(irif)
          if(ttt.gt.tsog2)then
            t2=amin1(tsog1,(TThet(ii)-TThet(irif))*0.9)
            go to 222
          endif
        enddo
222     continue
      elseif(irif.eq.nrefl)then
      t2=amin1(tsog1,(thmax-TThet(irif)))
        do ii=irif-1,1,-1
          ttt=TThet(irif)-TThet(ii)
          if(ttt.gt.tsog2)then
            t1=amin1(tsog1,(TThet(irif)-TThet(ii))*0.9)      
            go to 322
          endif
        enddo
322     continue
      else
        do ii=irif-1,1,-1
          ttt=TThet(irif)-TThet(ii)
          if(ttt.gt.tsog2)then
            t1=amin1(tsog1,(TThet(irif)-TThet(ii))*0.9)      
            go to 422
          endif
        enddo
422     continue
        do ii=irif+1,nrefl
          ttt=TThet(ii)-TThet(irif)
          if(ttt.gt.tsog2)then
            t2=amin1(tsog1,(TThet(ii)-TThet(irif))*0.9)
            go to 522
          endif
        enddo
522     continue
      endif
      th1=TThet(irif)-t1
      th2=TThet(irif)+t2
      thminn=amax1(xmax(jrif)-tsog2,thmin)
      thmaxx=amin1(xmax(jrif)+tsog2,thmax)
!corr
!corr      iniz1 = int ( ( thminn - thmin ) / thstep ) + 1
!corr      ifin1 = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      if(ifin1.lt.iniz1) ifin1=iniz1
      iniz1 = clocate(theta_int(:npunti,7),thminn)
      ifin1 = clocate(theta_int(:npunti,7),thmaxx)
      if(ifin1.lt.iniz1) ifin1=iniz1
!corr
      yrif=-999999999.0
      do 910 i=iniz1,ifin1
      if(theta_int(i,2).gt.yrif)yrif=theta_int(i,2)
 910  continue
      thminn=amax1(th1,thmin)
      thmaxx=amin1(xmax(jrif),thmax)
      thmaxxx=amin1(th2,thmax)
!corr
!corr      iniz1 = int ( ( thminn - thmin ) / thstep ) + 1
!corr      ifin1 = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      ifin2 = int ( ( thmaxxx - thmin ) / thstep ) + 1
      iniz1 = clocate(theta_int(:npunti,7),thminn)
      ifin1 = clocate(theta_int(:npunti,7),thmaxx)
      ifin2 = clocate(theta_int(:npunti,7),thmaxxx)
!corr
      if(ifin1.lt.iniz1) ifin1=iniz1         
      if(ifin2.lt.iniz1) ifin2=iniz1         
c     yrif=-999999999.0
c     do 910 i=iniz1,ifin2
c     if(theta_int(i,2).gt.yrif)yrif=theta_int(i,2)
c910  continue
      ymin=999999999.0
      do 1000 i=iniz1,ifin1
      if(theta_int(i,2).lt.ymin)then             
      ymin=theta_int(i,2)
      isav=i
      endif
 1000 continue
      iniz1=isav
      dymin=99999999.0
      do 1010 i=iniz1,ifin1
      yyy=theta_int(i,2)-ymin
      yys=(yrif-ymin)*0.5
      dys=abs(yyy-yys)
      if(dys.lt.dymin)then             
      iisav=i
      dymin=dys
      endif
 1010 continue
      x1=theta_int(iisav,1)
 1020 continue
      nref1(1)=irif    
      nref11(1)=irif    
      nref2(1)=irif    
      nref22(1)=irif    
      thet1(1)=theta_int(isav,1)       
      thet11(1)=theta_int(isav,1)       
      ncoun1(1)=isav
      ncoun11(1)=isav
      thmaxx=amin1(th2,thmax)
      thminn=amax1(xmax(jrif),thmin)
!corr
!corr      iniz1 = nint ( ( thminn - thmin ) / thstep ) + 1
!corr      ifin1 = nint ( ( thmaxx - thmin ) / thstep ) + 1
!corr      if(ifin1.lt.iniz1) ifin1=iniz1         
      iniz1 = clocate(theta_int(:npunti,7),thminn)
      ifin1 = clocate(theta_int(:npunti,7),thmaxx)
      if(ifin1.lt.iniz1) ifin1=iniz1         
!corr
      ymin=999999999.0
      do 1200 i=iniz1,ifin1
      if(theta_int(i,2).lt.ymin)then             
      ymin=theta_int(i,2)
      isav=i
      endif
 1200 continue
      ifin1=isav
      dymin=99999999.0
      do 1210 i=iniz1,ifin1
      yyy=theta_int(i,2)-ymin
      yys=(yrif-ymin)*0.5
      dys=abs(yyy-yys)
      if(dys.lt.dymin)then             
      iisav=i
      dymin=dys
      endif
 1210 continue
      x2=theta_int(iisav,1)
 1220 continue
      thet2(1)=theta_int(isav,1)         
      thet2(1)=theta_int(isav,1)         
      thet22(1)=theta_int(isav,1)         
      ncoun2(1)=isav
      ncoun22(1)=isav
      cmax=-999999.0
      do 501 i=ncoun1(1),ncoun2(1)
      if(theta_int(i,2).ge.cmax)then
      cmax=theta_int(i,2)
      isavv=i
      endif
 501  continue
      if(iabs(isavv-ncoun1(1)).le.3
     *.or.iabs(isavv-ncoun2(1)).le.3)ibecare=1
      if(x2.gt.x1)fw(jrif)=x2-x1
      uvwtsav=fw(jrif)
      uvwt(1)=uvwtsav**2
      uvwt(2)=0.0           
      uvwt(3)=0.0           
      if(nprof.eq.4)then 
      uvwt(4)=0.5
      else
      if(neutro.eq.1)then
      uvwt(4)=1.6        
      else
      uvwt(4)=0.8
      endif
      endif
      uvwt(5)=0.0
      uvwt(6)=0.0
      frac=(thet2(1)-thet1(1))/fw(jrif)
      if(frac.gt.15.0)frac=15.0
c     if(frac.gt.7.0)frac=7.0
      if(frac.lt.2.0)frac=2.0
      if(fracout.gt.0.0)frac=fracout
      fracsing = frac
      uvwtold(1)=uvwt(1)
      uvwtold(2)=uvwt(2)
      uvwtold(3)=uvwt(3)
      uvwtold(4)=uvwt(4)
      uvwtold(5)=uvwt(5)
      uvwtold(6)=uvwt(6)
      return
      end
c-----------------------------------------------------------------------
******subroutine corr(npoint,jjj)
      subroutine corr(npoint)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
c
      zero=0.0000001
      do 7 i=1,npoint
      thhmin=99999999.0
      do 8 j=1,npoint
      if(tt(j).le.thhmin)then
      thhmin=tt(j)
      jsav=j
      endif
 8    continue
      xxh(i)=tt(jsav)
      yyh(i)=countmi(jsav)
      tt(jsav)=99999999.0
 7    continue
      do 29 i=1,npoint
      tt(i)=xxh(i)
      countmi(i)=yyh(i)
 29   continue
      xxh(1)=tt(1)
      yyh(1)=countmi(1)
      do 600 i=1,npoint-1
      xxh(3*(i-1)+1)=tt(i)
      yyh(3*(i-1)+1)=countmi(i)
      yymn=9999999.0
      nnn=0
      do 700 j=1,npunti
      if(theta_int(j,1).gt.tt(i).and.theta_int(j,1).lt.tt(i+1))then
      nnn=1
      if(theta_int(j,2).le.yymn)then
      yymn=theta_int(j,2)
      xxh(3*(i-1)+2)=theta_int(j,1)
      yyh(3*(i-1)+2)=yymn
      endif
      endif
 700  continue
      if(nnn.eq.0)then
      xxh(3*(i-1)+2)=-9999999.0    
      yyh(3*(i-1)+2)=0.0  
      endif
      dstmin1=xxh(3*(i-1)+2)-tt(i)
      dstmin2=tt(i+1)-xxh(3*(i-1)+2)
      if(dstmin1.lt.dstmin2)then
      almin1=xxh(3*(i-1)+2)
      almin2=tt(i+1)
      else
      almin2=xxh(3*(i-1)+2)
      almin1=tt(i)
      endif
      yymn=9999999.0
      nnn1=0
      do 900 j=1,npunti
      if(theta_int(j,1).gt.almin1.and.theta_int(j,1).lt.almin2)then
      nnn1=1
      if(theta_int(j,2).le.yymn)then
      yymn=theta_int(j,2)
      xxh(3*(i-1)+3)=theta_int(j,1)
      yyh(3*(i-1)+3)=yymn
      endif
      endif
 900  continue
      if(nnn1.eq.0)then
      xxh(3*(i-1)+3)=-99999999.0    
      yyh(3*(i-1)+3)=0.0  
      endif
 600  continue
      xxh(3*(npoint-1)+1)=tt(npoint)
      yyh(3*(npoint-1)+1)=countmi(npoint)
      npoint=(npoint-1)*3+1
      npunt=0
      do 500 i=1,npoint 
      if(xxh(i).gt.zero)then
      npunt=npunt+1
      tt(npunt)=xxh(i)
      countmi(npunt)=yyh(i)
      endif
 500  continue
      npoint=npunt
      do 701 i=1,npoint
      thhmin=99999999.0
      do 801 j=1,npoint
      if(tt(j).le.thhmin)then
      thhmin=tt(j)
      jsav=j
      endif
801   continue
      xxh(i)=tt(jsav)
      yyh(i)=countmi(jsav)
      tt(jsav)=99999999.0
701   continue
CORIG npunt=1
***** if (jjj.eq.2) then
*****     npunt=1
*****  else    
          npunt=0
***** endif
      do 829 i=1,npoint
      if(i.ne.1.and.i.ne.npoint)then
      countsog=amin1(2.5*countmi(npunt),2.5*yyh(i+1))
      xsog=xxh(i)-tt(npunt)
      if(yyh(i).lt.countsog.and.xsog.ge.thstep)then       
      npunt=npunt+1
      tt(npunt)=xxh(i)
      countmi(npunt)=yyh(i)
      endif
      else
      npunt=npunt+1
      tt(npunt)=xxh(i)
      countmi(npunt)=yyh(i)
      endif
 829  continue
c-
***** if (jjj.eq.2) then
*****     xx(1)=xx(2)-4.0
*****     yy(1)=yy(2)
***** elseif (jjj.eq.nnn-t) then
*****     npoint=npunt+1
*****     xx(npoint)=xx(npoint-1)+4.0
*****     yy(npoint)=yy(npoint-1)
***** endif
c-
      npoint=npunt
      return
      end 
c-----------------------------------------------------------------
      subroutine lsqback(mrange,nrange,jcall,jjj,ier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
c
c-- read counts from card input
c
      common /backp2/ npol(10)
      common /profp/dumpp,nprof,ipol
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /save/npolsav(10),refv(32,10)   !,fwb(3000,2)
!corr      common /savev/var(3100)
      dimension dmat(11),amat(11,11),INDX(11),amt(11)
      dimension tta(10000),countmia(10000)
c
      if(ipol.eq.1)then
      nrangemin=npol(jjj)
      nrangemax=npol(jjj)
      elseif(ipol.eq.0.and.npolsav(jjj).ne.npol(jjj))then
      nrangemin=npol(jjj)
      nrangemax=npol(jjj)
      else
      nrangemin=5
      nrangemax=11
      endif
      nvolt=nrangemax-nrangemin+1
      do 55 ijk=1,nvolt
      nrange=nrangemin+ijk-1
      do 10 i=1,nrange
      dmat(i)=0.0
      amt(i)=0.0
      do 11 j=1,nrange
      amat(i,j)=0.0
 11   continue
 10   continue
c     it=0
      mmrange=0
      do 4 i=1,mrange
corrado run-time error
C     if(i.gt.1.and.(countmi(i).gt.2.5*countmi(i-1)).and.jcall.ne.4)
C    *go to 4       
      if(i.gt.1.and.jcall.ne.4) then
         if(countmi(i).gt.2.5*countmi(i-1)) go to 4
      endif
      mmrange=mmrange+1
      tta(mmrange)=tt(i)
      countmia(mmrange)=countmi(i)
  4   continue
      mrange=mmrange
      do 44 i=1,mrange
      tt(i)=tta(i)
      countmi(i)=countmia(i)
 44   continue
      do 5 i=1,mmrange
      if(jcall.eq.1)then
      weig(i)=1.0      
      if(i.ne.1.and.i.ne.mrange)then
      if(countmi(i).lt.countmi(i-1).and.countmi(i).lt.countmi(i+1))
     *weig(i)=sqrt(2.0)
      if(countmi(i).gt.countmi(i-1).and.countmi(i).gt.countmi(i+1))
     *weig(i)=1.0/sqrt(2.0)
      if((countmi(i).gt.countmi(i-1).and.countmi(i).lt.countmi(i+1)).or.   
     *(countmi(i).lt.countmi(i-1).and.countmi(i).gt.countmi(i+1)))
     *weig(i)=1.0
      else
      weig(i)=2.5
      endif
      endif
      pesos=weig(i)
      amt(1)=1.0
      amt(2)=(tt(i)/thetamin-1.0)
      amt(3)=amt(2)**2
      amt(4)=amt(2)**3
      amt(5)=amt(2)**4
      amt(6)=amt(2)**5
      amt(7)=amt(2)**6
      amt(8)=amt(2)**7
      amt(9)=amt(2)**8
      amt(10)=amt(2)**9
      amt(11)=amt(2)**10
      do 13 k=1,nrange
      dmat(k)=dmat(k)+(countmi(i)*amt(k))*pesos
      do 25 kk=1,nrange
      amat(k,kk)=amat(k,kk)+amt(k)*amt(kk)*pesos
 25   continue
 13   continue
   5  continue
      N=nrange
      NPP=11
      M=1
      MP=1
      call LUDCMP(amat,N,NPP,INDX,D,ier)
      if(ier.lt.0)return
      call LUBKSB(amat,N,NPP,INDX,dmat)
      do 100 i=1,mrange
      ttt=(tt(i)/thetamin-1.0)
      countmic(i)=dmat(1)
      if(nrange.gt.1)then
      do 21 k=2,nrange  
      ksp=real(k)-1.0
      countmic(i)=countmic(i)+dmat(k)*(ttt**ksp)
 21   continue
      endif
100   continue
      sumbo=0.0
      sumbc=0.0
      do 200 i=1,mrange
      sumbo=sumbo+countmi(i)
      sumbc=sumbc+countmic(i)
 200  continue
      scalb=sumbo/sumbc
      sumdb=0.0
      do 300 i=1,mrange
      sumdb=sumdb+abs(countmi(i)-scalb*countmic(i))
 300  continue
      erreb=sumdb/sumbo
      if(ijk.eq.1)erremn=erreb
      if(erreb.le.erremn)then
      erremn=erreb
      do 15 i=1,nrange
      bkg(i)=dmat(i)
 15   continue
      if(nrange.lt.11)then
      do 16 i=nrange+1,11
      bkg(i)=0.0    
 16   continue
      endif
      npol(jjj)=nrange
      npolsav(jjj)=nrange
      endif
 55   continue
      return
      end 
c------------------------------------------
      subroutine corr2(npoint,jjj,wrange,ier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
!corr      common /profp/phkl(3000,6),dumpp,nprof,ipol
      common /backp2/ npol(10)
      real, allocatable :: y(:)
c
      IF (.NOT.ALLOCATED(y))
     *   ALLOCATE (y(npunti), stat=ier4)
      if(jjj.eq.1)return
      npo=0
      uvw2=wrange
      uvw3=0.5*sqrt(uvwt(1))*1.2
      if(uvw3.lt.12.0*thstep)uvw3=wrange       
      alm1=thet1(jjj)    
      alm2=TThet(nref1(jjj))-uvw2
!corr
!corr      ranth=alm1-thmin
!corr      ini= int ( ranth/ thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)ini=ini+1
!corr      if(ini.lt.1)ini=1
!corr      ranth=alm2-thmin
!corr      ifi= int ( ranth/ thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)ifi=ifi+1
      ini = clocate(theta_int(:npunti,7),alm1)
      ifi = clocate(theta_int(:npunti,7),alm2)
!corr
      alm3=TThet(nref1(jjj))-uvw3
!corr      ranth=alm3-thmin
!corr      ifii= int ( ranth/ thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)ifii=ifii+1
!corr      if(ifii.gt.npunti)ifii=npunti
      ifii = clocate(theta_int(:npunti,7),alm3)
!corr
      if(ifii.gt.ini.and.ini.ge.1)then
      npnt=0
      do 441 i=ini,ifii
      npnt=npnt+1
      y(npnt)=theta_int(i,2)
 441  continue
      if(npnt.gt.3)then
      ppts=3.0
      else
      ppts=real(npnt)
      endif
      call smooft(y,npnt,ppts)
      npnt=0
      do 442 i=ini,ifii
      npnt=npnt+1
      theta_int(i,2)=y(npnt)
 442  continue
      endif
      nmed=0
      if(ifi.gt.ini)then
      idifi=ifi-ini
      if(ini.lt.1)ini=1
      if(ifi.gt.npunti)ifi=npunti
      ndiffi=ifi-ini 
      if(ndiffi.gt.40)then
      nsalt=20
      ndifi=int((ifi-ini)/nsalt)
      elseif(ndiffi.ge.10.and.ndiffi.le.40)then
      nsalt=5
      ndifi=int((ifi-ini)/nsalt)
      else
      nsalt=1
      ndifi=ndiffi
      endif
      ifiii=ini
      do 119 kk=1,nsalt
      iniii=ifiii
      ifiii=ifiii+ndifi
      cmax=-999999999.0
      cmin=999999999.0
      summed = 0.0
      nmedd=0
      do 120 k=iniii,ifiii
      nmedd=nmedd+1
      if(theta_int(k,2).gt.cmax)cmax=theta_int(k,2)
      if(theta_int(k,2).lt.cmin)cmin=theta_int(k,2)
      summed=summed+theta_int(k,2)
 120  continue
      counmed=summed/nmedd
      nmed=nmed+1
      thht=theta_int(iniii,1)+
     *(theta_int(ifiii,1)-theta_int(iniii,1))*0.5
!corr      nind=nint((thht-thmin)/thstep)
      nind = clocate(theta_int(:npunti,7),thht)
      if (nind.eq.0) nind=1
      tt(npoint+npo+nmed)=theta_int(nind,1)
      countmi(npoint+npo+nmed)=counmed        
      weig(npoint+npo+nmed)=5.0     
 119  continue
      do 190 j=1,npoint
      if(tt(j).gt.alm1.and.tt(j).lt.alm2)then
      tt(j)=9999.0
      countmi(j)=counmed
      weig(j)=0.0
      endif
  190 continue
      endif
      npo=npo+nmed
      do 100 i=nref1(jjj),nref2(jjj)-1
      uvw2=wrange                 
      alm1=TThet(i)+uvw2
      alm2=TThet(i+1)-uvw2
      ini = clocate(theta_int(:npunti,7),alm1)
      ifi = clocate(theta_int(:npunti,7),alm2)
      alm3=TThet(i)+uvw3
      alm4=TThet(i+1)-uvw3
      inii = clocate(theta_int(:npunti,7),alm3)
      ifii = clocate(theta_int(:npunti,7),alm4)
      if(ifii.gt.inii.and.inii.ge.1)then
      npnt=0
      do 443 j=inii,ifii
      npnt=npnt+1
      y(npnt)=theta_int(j,2)
 443  continue
      if(npnt.gt.3)then
      ppts=3.0
      else
      ppts=real(npnt)
      endif
      call smooft(y,npnt,ppts)
      npnt=0
      do 444 j=inii,ifii
      npnt=npnt+1
      theta_int(j,2)=y(npnt)
 444  continue
      endif
      nmed=0
      if(ifi.gt.ini)then
      idifi=ifi-ini
      if(ini.lt.1)ini=1
      if(ifi.gt.npunti)ifi=npunti
      ndiffi=ifi-ini 
      if(ndiffi.gt.40)then
      nsalt=20
      ndifi=int((ifi-ini)/nsalt)
      elseif(ndiffi.ge.10.and.ndiffi.le.40)then
      nsalt=5
      ndifi=int((ifi-ini)/nsalt)
      else
      nsalt=1
      ndifi=ndiffi
      endif
      ifiii=ini
      nmed=0
      do 149 kk=1,nsalt
      iniii=ifiii
      ifiii=ifiii+ndifi
      cmax=-999999999.0
      cmin=999999999.0
      summed = 0.0
      nmedd=0
      do 150 k=iniii,ifiii
      nmedd=nmedd+1
      if(theta_int(k,2).gt.cmax)cmax=theta_int(k,2)
      if(theta_int(k,2).lt.cmin)cmin=theta_int(k,2)
      summed=summed+theta_int(k,2)
 150  continue
      counmed=summed/nmedd
      nmed=nmed+1
      thht=theta_int(iniii,1)+
     *(theta_int(ifiii,1)-theta_int(iniii,1))*0.5
!corr      nind=nint((thht-thmin)/thstep)
      nind = clocate(theta_int(:npunti,7),thht)
      tt(npoint+npo+nmed)=theta_int(nind,1)
      countmi(npoint+npo+nmed)=counmed        
      weig(npoint+npo+nmed)=5.0     
 149  continue
      do 200 j=1,npoint
      if(tt(j).gt.alm1.and.tt(j).lt.alm2)then
      tt(j)=9999.0
      countmi(j)=counmed
      weig(j)=0.0
      endif
  200 continue
      endif
      npo=npo+nmed
  100 continue
      uvw2=wrange                 
      alm1=TThet(nref2(jjj))+uvw2
      alm2=thet2(jjj)      
!corr
!corr      ranth=alm1-thmin
!corr      ini= int ( ranth/ thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)ini=ini+1
!corr      ranth=alm2-thmin
!corr      ifi= int ( ranth/ thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)ifi=ifi+1
      ini = clocate(theta_int(:npunti,7),alm1)
      ifi = clocate(theta_int(:npunti,7),alm2)
!corr
      alm3=TThet(nref2(jjj))+uvw3
!corr      ranth=alm3-thmin
!corr      inii= int ( ranth/ thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)inii=inii+1
!corr      if(inii.lt.1)inii=1
!corr      if(ifi.gt.npunti)ifi=npunti
      inii = clocate(theta_int(:npunti,7),alm3)
      if(ifi.gt.inii)then
      npnt=0
      do 445 i=inii,ifi 
      npnt=npnt+1
      y(npnt)=theta_int(i,2)
 445  continue
      if(npnt.gt.3)then
      ppts=3.0
      else
      ppts=real(npnt)
      endif
!corr-old code      ppts=real(npnt)
      call smooft(y,npnt,ppts)
      npnt=0
      do 446 i=inii,ifi 
      npnt=npnt+1
      theta_int(i,2)=y(npnt)
 446  continue
      endif
      nmed=0
      if(ifi.gt.ini)then
      idifi=ifi-ini
      if(ini.lt.1)ini=1
      if(ifi.gt.npunti)ifi=npunti
      ndiffi=ifi-ini 
      if(ndiffi.gt.40)then
      nsalt=20
      ndifi=int((ifi-ini)/nsalt)
      elseif(ndiffi.ge.10.and.ndiffi.le.40)then
      nsalt=5
      ndifi=int((ifi-ini)/nsalt)
      else
      nsalt=1
      ndifi=ndiffi
      endif
      ifiii=ini
      do 169 kk=1,nsalt
      iniii=ifiii
      ifiii=ifiii+ndifi
      cmax=-999999999.0
      cmin=999999999.0
      summed = 0.0
      nmedd=0
      do 170 k=iniii,ifiii
      nmedd=nmedd+1
      if(theta_int(k,2).gt.cmax)cmax=theta_int(k,2)
      if(theta_int(k,2).lt.cmin)cmin=theta_int(k,2)
      summed=summed+theta_int(k,2)
 170  continue
      counmed=summed/nmedd
      nmed=nmed+1
      thht=theta_int(iniii,1)+
     *(theta_int(ifiii,1)-theta_int(iniii,1))*0.5
!corr      nind=nint((thht-thmin)/thstep)
      nind = clocate(theta_int(:npunti,7),thht)
      tt(npoint+npo+nmed)=theta_int(nind,1)
      countmi(npoint+npo+nmed)=counmed        
      weig(npoint+npo+nmed)=5.0     
 169  continue
      do 220 j=1,npoint
      if(tt(j).gt.alm1.and.tt(j).lt.alm2)then
      tt(j)=9999.0
      countmi(j)=counmed
      weig(j)=0.0
      endif
  220 continue
      endif
      npo=npo+nmed
      if(npo.ne.0)then
      npoint=npoint+npo
      npo=0
      do 500 i=1,npoint
      thhmin=99999999.0
      do 600 j=1,npoint
      if(tt(j).le.thhmin)then
      thhmin=tt(j)
      jsav=j
      endif
 600  continue
      xxh(i)=tt(jsav)
      yyh(i)=countmi(jsav)
      weigh(i)=weig(jsav)
      tt(jsav)=999999999.0
500   continue
      do 700 i=1,npoint
      if(xxh(i).lt.1000.0)then
      npo=npo+1
      tt(i)=xxh(i)
      countmi(i)=yyh(i)
      weig(i)=weigh(i)
      endif
 700  continue
      jcall=2
      nvari=npol(jjj)
      npoint=npo
      call lsqback(npoint,nvari,jcall,jjj,ier)
      if(ier.lt.0)return
      endif
      DEALLOCATE (y,stat=ierr)
      if (ier4.lt.0) write(lo,*) ' Problemi nella allocazione'
      if (ierr.lt.0) then
      write(lo,*) ' Problemi nella deallocazione di profcalc'
      endif
      return
      end
c------------------------------
      SUBROUTINE SMOOFT(Y,N,PTS)
      USE Conteggi, only:npunti
CNEW  PARAMETER(MMAX=1024)
c     PARAMETER(MMAX=20000)
!!!corrado: errrore y in input ha dimensione diversa dall dummy argum.  DIMENSION Y(npunti)
      DIMENSION Y(*)
      mmax=npunti
      M=2
      NMIN=N+2.*PTS
1     IF(M.LT.NMIN)THEN
        M=2*M
      GO TO 1
      ENDIF
      IF(M.GT.MMAX) PAUSE 'MMAX too small'
      CONST=(PTS/M)**2
      Y1=Y(1)
      YN=Y(N)
      RN1=1./(N-1.)
      DO 11 J=1,N
        Y(J)=Y(J)-RN1*(Y1*(N-J)+YN*(J-1))
11    CONTINUE
      DO 12 J=N+1,M
        Y(J)=0.
12    CONTINUE
      MO2=M/2
      CALL REALFT(Y,MO2,1)
      Y(1)=Y(1)/MO2
      FAC=1.
      DO 13 J=1,MO2-1
        K=2*J+1
        IF(FAC.NE.0.)THEN
          FAC=AMAX1(0.,(1.-CONST*J**2)/MO2)
          Y(K)=FAC*Y(K)
          Y(K+1)=FAC*Y(K+1)
        ELSE
          Y(K)=0.
          Y(K+1)=0.
        ENDIF
13    CONTINUE
      FAC=AMAX1(0.,(1.-0.25*PTS**2)/MO2)
      Y(2)=FAC*Y(2)
      CALL REALFT(Y,MO2,-1)
      DO 14 J=1,N
        Y(J)=RN1*(Y1*(N-J)+YN*(J-1))+Y(J)
14    CONTINUE
      RETURN
      END
ccccccccccccccccccccccc
      SUBROUTINE REALFT(DATA,N,ISIGN)
      REAL*8 WR,WI,WPR,WPI,WTEMP,THETA
      DIMENSION DATA(*)
      THETA=3.141592653589793D0/DBLE(N)
      C1=0.5
      IF (ISIGN.EQ.1) THEN
        C2=-0.5
        CALL FOUR1(DATA,N,+1)
      ELSE
        C2=0.5
        THETA=-THETA
      ENDIF
      WPR=-2.0D0*DSIN(0.5D0*THETA)**2
      WPI=DSIN(THETA)
      WR=1.0D0+WPR
      WI=WPI
      N2P3=2*N+3
      DO 11 I=2,N/2
        I1=2*I-1
        I2=I1+1
        I3=N2P3-I2
        I4=I3+1
        WRS=SNGL(WR)
        WIS=SNGL(WI)
        H1R=C1*(DATA(I1)+DATA(I3))
        H1I=C1*(DATA(I2)-DATA(I4))
        H2R=-C2*(DATA(I2)+DATA(I4))
        H2I=C2*(DATA(I1)-DATA(I3))
        DATA(I1)=H1R+WRS*H2R-WIS*H2I
        DATA(I2)=H1I+WRS*H2I+WIS*H2R
        DATA(I3)=H1R-WRS*H2R+WIS*H2I
        DATA(I4)=-H1I+WRS*H2I+WIS*H2R
        WTEMP=WR
        WR=WR*WPR-WI*WPI+WR
        WI=WI*WPR+WTEMP*WPI+WI
11    CONTINUE
      IF (ISIGN.EQ.1) THEN
        H1R=DATA(1)
        DATA(1)=H1R+DATA(2)
        DATA(2)=H1R-DATA(2)
      ELSE
        H1R=DATA(1)
        DATA(1)=C1*(H1R+DATA(2))
        DATA(2)=C1*(H1R-DATA(2))
        CALL FOUR1(DATA,N,-1)
      ENDIF
      RETURN
      END
      SUBROUTINE FOUR1(DATA,NN,ISIGN)
      REAL*8 WR,WI,WPR,WPI,WTEMP,THETA
      DIMENSION DATA(*)
      N=2*NN
      J=1
      DO 11 I=1,N,2
        IF(J.GT.I)THEN
          TEMPR=DATA(J)
          TEMPI=DATA(J+1)
          DATA(J)=DATA(I)
          DATA(J+1)=DATA(I+1)
          DATA(I)=TEMPR
          DATA(I+1)=TEMPI
        ENDIF
        M=N/2
1       IF ((M.GE.2).AND.(J.GT.M)) THEN
          J=J-M
          M=M/2
        GO TO 1
        ENDIF
        J=J+M
11    CONTINUE
      MMAX=2
2     IF (N.GT.MMAX) THEN
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/(ISIGN*MMAX)
        WPR=-2.D0*DSIN(0.5D0*THETA)**2
        WPI=DSIN(THETA)
        WR=1.D0
        WI=0.D0
        DO 13 M=1,MMAX,2
          DO 12 I=M,N,ISTEP
            J=I+MMAX
            TEMPR=SNGL(WR)*DATA(J)-SNGL(WI)*DATA(J+1)
            TEMPI=SNGL(WR)*DATA(J+1)+SNGL(WI)*DATA(J)
            DATA(J)=DATA(I)-TEMPR
            DATA(J+1)=DATA(I+1)-TEMPI
            DATA(I)=DATA(I)+TEMPR
            DATA(I+1)=DATA(I+1)+TEMPI
12        CONTINUE
          WTEMP=WR
          WR=WR*WPR-WI*WPI+WR
          WI=WI*WPR+WTEMP*WPI+WI
13      CONTINUE
        MMAX=ISTEP
      GO TO 2
      ENDIF
      RETURN
      END
c-----------------------------------------------------------------------
      subroutine modint(inoref,kwrong)
      USE Riflessi
      USE xdataMod
      USE Conteggi, only:npunti,theta_int
      USE General
      USE arrayutil
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
c------------
      do 100 i=1,nnt-1
      nref1(i)=0
      nref11(i)=0
      nref2(i)=0
      nref22(i)=0
      thet1(i)=theta_int(ncoun1(i),7)
      thet11(i)=theta_int(ncoun1(i),7)
      thet2(i)=theta_int(ncoun2(i),7)
      thet22(i)=theta_int(ncoun2(i),7)
      ncoun11(i)=ncoun1(i)
      ncoun22(i)=ncoun2(i)
      sover=3.0
      do 400 k=1,nrefl
      if(TThet(k).ge.thet1(i))then 
      nref1(i)=k
      go to 450
      endif
 400  continue
 450  continue
      do 700 k=0,nrefl-1
      if(TThet(nrefl-k).le.thet2(i))then 
      nref2(i)=nrefl-k
      go to 750
      endif
 700  continue
 750  continue
      if(nref1(i).gt.nref2(i))then
      inoref=1
      kwrong=i-1
      endif
      if(nnt.ne.3)then
      if(i.eq.2.or.(i.eq.1.and.nosing.gt.0))then
      thet11(i)=thet1(i)
      thet22(i)=thet2(i)+sover
      ncoun11(i)=ncoun1(i) 
!corr      ncoun22(i)=ncoun2(i)+int(sover/thstep)+1
      ncoun22(i) = clocate(theta_int(:npunti,7),thet22(i))
      if(thet22(i).gt.thmax)thet22(i)=thet2(i)
      if(ncoun22(i).gt.npunti)ncoun22(i)=ncoun2(i)
      elseif(i.eq.(nnt-1))then
      thet11(i)=thet1(i)-sover
      thet22(i)=thet2(i)
!corr      ncoun11(i)=ncoun1(i)-int(sover/thstep)+1
      ncoun11(i) = clocate(theta_int(:npunti,7),thet11(i))
      ncoun22(i)=ncoun2(i)
      if(thet11(i).lt.1)thet11(i)=thet1(i)
      if(ncoun11(i).lt.1)ncoun11(i)=ncoun1(i)
      else
      thet11(i)=thet1(i)-sover
      thet22(i)=thet2(i)+sover
!corr      ncoun11(i)=ncoun1(i)-int(sover/thstep)-1
!corr      ncoun22(i)=ncoun2(i)+int(sover/thstep)+1
      ncoun11(i) = clocate(theta_int(:npunti,7),thet11(i))
      ncoun22(i) = clocate(theta_int(:npunti,7),thet22(i))
      if(thet11(i).lt.1)thet11(i)=thet1(i)
      if(ncoun11(i).lt.1)ncoun11(i)=ncoun1(i)
      if(thet22(i).gt.thmax)thet22(i)=thet2(i)
      if(ncoun22(i).gt.npunti)ncoun22(i)=ncoun2(i)
      endif
      endif
      do 800 k=1,nrefl
      if(TThet(k).ge.thet11(i))then 
      nref11(i)=k
      go to 850
      endif
 800  continue
 850  continue
      do 900 k=0,nrefl-1
      if(TThet(nrefl-k).le.thet22(i))then 
      nref22(i)=nrefl-k
      go to 950
      endif
 900  continue
 950  continue
 100  continue
      thet1(nnt)=thet1(2)
      thet11(nnt)=thet11(2)
      thet2(nnt)=thet2(nnt-1)
      thet22(nnt)=thet22(nnt-1)
      nref1(nnt)=nref1(2)
      nref11(nnt)=nref11(2)
      nref2(nnt)=nref2(nnt-1)
      nref22(nnt)=nref22(nnt-1)
      ncoun1(nnt)=ncoun1(2)
      ncoun11(nnt)=ncoun11(2)
      ncoun2(nnt)=ncoun2(nnt-1)
      ncoun22(nnt)=ncoun22(nnt-1)
      return
      end
c-----------------------------------------------------------------------
      subroutine extf(fileh,formt,ityp,ier)
      USE Riflessi
      USE xdataMod
c
c-- read counts from card input
c
      USE General
      USE Molcom
c
      character*80 fileh,formt
      character*80 testo
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
c
c--
c
      if(ialt.gt.0)formt(1:16)='(3i4,18x,3f15.4)'
      testo(1:5)='(a80)'
      if (jfile.lt.0) go to 7034
      if (jfile.ne.ln) then
         itype=2
         iform=1
         if (jopen(jfile,fileh,itype,iform,ios).lt.0) go to 9000
      endif
 7034 continue
      if (jfile.eq.ln) go to 6000
      jfile=iabs(jfile)
      if(iext.eq.1)read(jfile,testo,end=60,err=8000,iostat=ios)
      if(iext.le.2)read(jfile,testo,end=60,err=8000,iostat=ios)
!corr      nnn=0
   10 continue
      if(ialt.eq.0)then
      read(jfile,formt,end=60,err=8000,iostat=ios)ih,ik,il,fobs
      else
      read(jfile,formt,end=60,err=8000,iostat=ios)ih,ik,il,sumN,rap,fobs
      endif
!corr      nnn=nnn+1
!corr      if(nnn.gt.3000) go to 5000
      do 100 i=1,nrefl
      if(ih.eq.IndHKL(i,1).and.ik.eq.IndHKL(i,2)
     *.and.il.eq.IndHKL(i,3))then
      if(ityp.eq.0)then
      fext(i)=fobs
c     fext(i)=fobs**2
      else
      fext(i)=fobs**2
      endif
      if(ialt.gt.0)then
      sumfn(i)=sumN
      rapp(i)=rap
      endif
      go to 10
      endif
 100  continue
      go to 10
  60  continue
      if (jfile.ne.ln) close(jfile)
      sumfext=0.0
      sumfo=0.0
      return
 5000 continue
      ier=-1
      write(lo,5010)
 5010 format(/,' *** warning ***  too many fsquared supplied ')
      go to 9040
 6000 continue
      ier=-1
      write(lo,6010)
 6010 format(/,' *** warning ***  no fsquared supplied')
      go to 9040
!corr 8000 if(kprog.lt.10.and.ios.eq.6101)go to 60
 8000 if(ios > 0) go to 60
      write(Msg,8010) jfile,ios
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
 8010 format('Read error on channel ',i2,' code =',i5)
      go to 9020
 9000 write(Msg,9010) ios,fileh
 9010 format('Open error, code =',i5,' file is ',a)
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
 9020 write(lo,9030)
 9030 format(  '                fsquared expected')
      ier=-1
 9040 return
      end
c-----------------------------------------------------------------------
      subroutine setfinal(ier)
      USE Riflessi
      USE xdataMod
      USE General
      use reflection_type_util, only: rhof
c
c-- read counts from card input
c
      common/uvwold/uvwtold(6)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /backp2/ npol(10)
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /save/npolsav(10),refv(32,10)    !,fwb(3000,2)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common/savv/fwhsav,betasav,uvwtsav
      dimension dmat(11),amat(11,11),INDX(11),amt(11)
      dimension sumsum(12),ivat(3)
c
      nnegp=0
      sumzero=0.0
      sumasy=0.0
      do 10 i=1,11
      dmat(i)=0.0
      amt(i)=0.0
      do 11 j=1,11
      amat(i,j)=0.0
 11   continue
 10   continue
      do 50 i=1,12
      sumsum(i)=0.0
 50   continue
      do 100 jjj=2,nnt-1
      sumzero=sumzero+refv(2,jjj)
      sumasy=sumasy+refv(6,jjj)
      do 200 j=1,6
      sumsum(j)=sumsum(j)+refv(9+j,jjj)
 200  continue
      do 300 j=7,12
      sumsum(j)=sumsum(j)+refv(20+j,jjj)
 300  continue
 100  continue
      zeroprof=sumzero/(nnt-2)
      asym=sumasy/(nnt-2)
      astar=sumsum(1)/(nnt-2)
      bstar=sumsum(2)/(nnt-2)
      cstar=sumsum(3)/(nnt-2)
      cosas=sumsum(4)/(nnt-2)
      cosbs=sumsum(5)/(nnt-2)
      coscs=sumsum(6)/(nnt-2)
      pp(1)=sumsum(7)/(nnt-2)
      pp(2)=sumsum(8)/(nnt-2)
      pp(3)=sumsum(9)/(nnt-2)
      pp(4)=sumsum(10)/(nnt-2)
      pp(5)=sumsum(11)/(nnt-2)
      pp(6)=sumsum(12)/(nnt-2)
      if(nrefl.eq.1)return
      sumuvw=0.0
      sumbeta=0.0
      nntu=0
      nntb=0
      sumfwb1=0.0
      sumfwb2=0.0
      do 400 j=nref1(2),nref2(nnt-1)
      do 401 jjj=2,nnt-1
      if(j.ge.nref1(jjj).and.j.le.nref2(jjj))then
      if (nref2(jjj).gt.nref1(jjj)) then
      pesos=1.0/(nref2(jjj)-nref1(jjj))
      else
      pesos=1.0
      endif
      go to 402
      endif
 401  continue
 402  continue
      ivat(1)=IndHKL(j,1)
      ivat(2)=IndHKL(j,2)
      ivat(3)=IndHKL(j,3)
      rho=rhof(pp,ivat(1),ivat(2),ivat(3))
      rho2=rho*rho
      TThet(j)=ctheta(rho2)
      rdeg = 0.5 * TThet(j) * dtor    
      cdeg= cos(rdeg)
      tdeg = sin(rdeg) / cos(rdeg)
c     sumuvw=sumuvw+fwb(j,1)**2
      if(fwb(j,1).gt.0.0)then
        nntu=nntu+1
        sumuvw=sumuvw+fwb(j,1)**2
      endif
      sumbeta=sumbeta+fwb(j,2)
      if(fwb(j,1).gt.0.0)nntu=nntu+1
      if(abs(fwb(j,2)).gt.0.0)nntb=nntb+1
      if(fwb(j,2).lt.0.0)nnegp=1     
      if(iproff.ne.3)then
      if(nprof.ne.3)then
      amt(1)=1.0
      amt(2)=tdeg                
      amt(3)=amt(2)**2
      else
      amt(1)=tdeg
      amt(2)=1.0/cdeg            
      endif
      do 13 k=1,3
      if(nprof.ne.3)then
      dmat(k)=dmat(k)+amt(k)*(fwb(j,1)**2)*pesos
      else
      dmat(k)=dmat(k)+amt(k)*fwb(j,1)*pesos
      endif
      do 25 kk=1,3
      amat(k,kk)=amat(k,kk)+amt(k)*amt(kk)*pesos
 25   continue
 13   continue
      endif
 400  continue
      if(iproff.ne.3)then
      if(nprof.ne.3)then
      N=3
      else
      N=2
      endif
      NPP=11
      M=1
      MP=1
      call LUDCMP(amat,N,NPP,INDX,D,ier)
      if(ier.lt.0)return
      call LUBKSB(amat,N,NPP,INDX,dmat)
      if(nprof.ne.3)then
      uvwt(1)=dmat(1)
      uvwt(2)=dmat(2)
      uvwt(3)=dmat(3)
      else
      uvwt(1)=dmat(1)
      uvwt(2)=dmat(2)
      uvwt(3)=0.0     
      endif
      if(nntb.ne.0)then
      uvwt(4)=sumbeta/nntb     
      uvwt(5)=0.0     
      uvwt(6)=0.0     
      else
      uvwt(4)=betasav          
      uvwt(5)=0.0     
      uvwt(6)=0.0     
      endif
      else
      if(nntu.ne.0)then
      uvwt(1)=sumuvw/nntu        
      uvwt(2)=0.0     
      uvwt(3)=0.0     
      else
      uvwt(1)=fwhsav             
      uvwt(2)=0.0     
      uvwt(3)=0.0     
      endif
      if(nntb.ne.0)then
      uvwt(4)=sumbeta/nntb     
      uvwt(5)=0.0     
      uvwt(6)=0.0     
      else
      uvwt(4)=betasav          
      uvwt(5)=0.0     
      uvwt(6)=0.0     
      endif
      endif
      if(nprof.eq.2.or.nprof.eq.3)then 
      uvwt(4)=0.0              
      uvwt(5)=0.0     
      uvwt(6)=0.0     
      endif
      if(nprof.eq.4)then
      if(nnegp.eq.1)uvwt(4)=1.0
      if(asym.lt.-1.0)asym=0.0
      endif
c-controllo
      sumdifuvw=0.0
      summuvw=0.0
      do j=nref1(2),nref2(nnt-1)
        rdeg = 0.5 * TThet(j) * dtor    
        tdeg = sin(rdeg) / cos(rdeg)
        tdeg2 = tdeg * tdeg
        cdeg=cos(rdeg)
        if(nprof.eq.1)then
          uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
        elseif(nprof.eq.4)then
          uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
        elseif(nprof.eq.2)then
          uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
        else
          uvwqg=(uvwt(1)*tdeg+uvwt(2)/cdeg)**2
        endif
        if(uvwqg.lt.0.0)then
          if(nntu.ne.0)then
            uvwt(1)=sumuvw/nntu        
            uvwt(2)=0.0     
            uvwt(3)=0.0     
          else
            uvwt(1)=fwhsav             
            uvwt(2)=0.0     
            uvwt(3)=0.0     
          endif
          go to 999
        endif         
        sumdifuvw=sumdifuvw+abs(fwb(j,1)-sqrt(uvwqg))
        summuvw=summuvw+fwb(j,1)
      enddo
      if((sumdifuvw/summuvw).gt.0.1)then
        if(nntu.ne.0)then
          uvwt(1)=sumuvw/nntu        
          uvwt(2)=0.0     
          uvwt(3)=0.0     
        else
          uvwt(1)=fwhsav             
          uvwt(2)=0.0     
          uvwt(3)=0.0     
        endif
      endif
c
 999  continue
      uvwtold(1)=uvwt(1)
      uvwtold(2)=uvwt(2)
      uvwtold(3)=uvwt(3)
      uvwtold(4)=uvwt(4)
      uvwtold(5)=uvwt(5)
      uvwtold(6)=uvwt(6)
      return
      end 
c------------------------
      subroutine modsing (uvwtsav)
      USE Riflessi
      USE xdataMod
      USE Conteggi
c
      USE General
c
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
c------------------------------
      ymax=-9999999999.0
      ymin=9999999999.0
      ncoun11(1)=ncoun1(1)
      ncoun22(1)=ncoun2(1)
      do 100 i=ncoun1(1),ncoun2(1)
      if(theta_int(i,2).gt.ymax)then
      ymax=theta_int(i,2)
      xmax=theta_int(i,1)
      endif
      if(theta_int(i,2).lt.ymin)then
      ymin=theta_int(i,2)
      endif
  100 continue
      zeroprof=0.5*(xmax-TThet(nref1(1)))
      ysog=(ymax-ymin)*0.5
      ydif1=99999999999.0
      ydif2=99999999999.0
      do 200 i=ncoun1(1),ncoun2(1)
      ydiff=abs(theta_int(i,2)-ymin-ysog)
      if(ydiff.lt.ydif1.and.theta_int(i,1).lt.xmax)then
      ydif1=ydiff
      xth1=theta_int(i,1)
      elseif(ydiff.lt.ydif2.and.theta_int(i,1).gt.xmax)then
      ydif2=ydiff
      xth2=theta_int(i,1)
      endif
 200  continue
      uvwtsav=xth2-xth1 
      uvwt(1)=uvwtsav**2
      uvwt(2)=0.0           
      uvwt(3)=0.0           
      if(nprof.eq.4)then 
      uvwt(4)=0.5
      else
      if(neutro.eq.1)then
      uvwt(4)=1.6        
      else
      uvwt(4)=0.8
      endif
      endif
      uvwt(5)=0.0
      uvwt(6)=0.0
      frac=(thet2(1)-thet1(1))/uvwtsav  
      return
      end
c------------------------------------------------------------
      subroutine indref
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE extramodule, only: coef1, coef2
!corr      include 'rando.fi'
      USE randofi
      interface
         subroutine calcextr(iniz,ifin,theta1,theta2)
         integer, dimension(:), intent(out) :: iniz,ifin
         real, dimension(:), intent(out)    :: theta1,theta2
         end subroutine calcextr

         subroutine calcindobs(thetaov,iniz,ifin,theta1,theta2)
         real, dimension(:), intent(inout) :: thetaov
         integer, dimension(:), intent(in) :: iniz,ifin
         real, dimension(:), intent(in)    :: theta1,theta2
         end subroutine calcindobs
      end interface
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
!corr      common /indobs/coef1(3000),coef2(3000)  !,overl(3000)
      common /bbbb/ oscalef,ggpror,natso
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
      integer, dimension(nrefl) :: iniz,ifin
      real, dimension(nrefl) :: theta1,theta2
      real, allocatable :: thetaov(:)
!
c-
c---Prova
       dimension errewf(10),sumfc(10),sumfo(10),numref(10),scalafc(10)
c---Prova
      call calcextr(iniz,ifin,theta1,theta2)
      IF (.NOT.ALLOCATED(thetaov))ALLOCATE (thetaov(npunti), stat=ier4)
      thetaov(1) = thmin
      do 150 ii = 2,npunti
!corr        thetaov(ii) = thetaov(ii-1) + thstep
        !if(ii<100)write(0,*)'count=',thetaov(ii),theta_int(ii,1)
        thetaov(ii) = theta_int(ii,1)
 150  continue
c-------------  
      call calcindobs(thetaov,iniz,ifin,theta1,theta2)
c-------------
        if(iknow.eq.0)go to 1000
C---riscalo gli f**2 veri
        sum0= 0.0
        sum00= 0.0
        sum4= 0.0
        sum40= 0.0
c---Prova
        do 2 i=1,10
          errewf(i)=0.0
          sumfc(i)=0.0
          sumfo(i)=0.0
          numref(i)=0
          scalafc(i)=0.0
    2   continue
        do 3 i=1,nrefl
              do 4 j=1,10
               if (coef1(i).lt.(j*0.1).and.coef1(i).ge.(j-1)*0.1) then
                   numref(j)= numref(j) + 1
                   sumfc(j)= sumfc(j) + fxsav(i)
                   sumfo(j)= sumfo(j) + sqrt(SetFob(i,4))
               endif
    4         continue
    3   continue
        do 6 j = 1,10
              if (abs(sumfc(j)).gt.0.) scalafc(j)=sumfo(j)/sumfc(j)
    6   continue
        do 310 i=1,nrefl
              do 7 j=1,10
               if (coef1(i).lt.(j*0.1).and.coef1(i).ge.(j-1)*0.1) then
                  fverc=scalafc(j)*fxsav(i)
                  errewf(j)=errewf(j) + abs(sqrt(SetFob(i,4)) - fverc)
               endif
    7         continue
 310    continue
              do 8 j=1,10
                if(sumfo(j).gt.0.) errewf(j)=errewf(j)/sumfo(j) 
c         write(lo,1015)(j-1)*0.1,j*0.1,numref(j),errewf(j)
    8         continue
1000    sumc1=0.0
        do 1010 i=1,nrefl
        sumc1= sumc1+ coef1(i)
 1010   continue
        iprio = max0(ipriorp,ipriors)
        if (iprio.eq.1.or.iprio.eq.2) return
        if (ispaceindexing==0) write(lo,1030) 
        if (ispaceindexing==0) write(lo,1025)
        if (ispaceindexing==0) write(lo,1020) int(sumc1+0.5)
        if (ispaceindexing==0) write(lo,1021)(sumc1/nrefl)*100.
        if (ispaceindexing==0) write(lo,1030) 
 1015   format(/,f6.2,'  -',f6.2,2h  ,i8,f10.5)
 1020   format(18x,'Number of independent observations = ',i7,/)
 1021   format(18x,'Independent reflections percentage = ',f7.2,'%')
 1025   format(18x,'Independent observations calculation routine',/)
 1030   format(/,16x ,48('*'),/)
      DEALLOCATE (thetaov,stat=ierr)
      if (ier4.lt.0) write(lo,*) ' Problemi nella allocazione'
      if (ierr.lt.0) then
      write(lo,*) ' Problemi nella deallocazione '
      endif
      return
      end
c-----------------------------------------------------
      subroutine calcextr(iniz,ifin,theta1,theta2)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
c
c-- Calcola gli angoli estremi del picco associato all'i-esimo
c-- riflesso
c
      integer, dimension(:), intent(out) :: iniz,ifin
      real, dimension(:), intent(out)    :: theta1,theta2
!corr      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
!corr      common /bbbb/ oscalef,ggpror,natso
c-------
c---  Si memorizzano in theta1 e theta2 gli angoli estremi del picco assoc. al rifl. i-esimo
c-------
      do 250 i =1,nrefl
!corr-moved in calcextr                 iover(i) = 1 
         SetFob(i,3)= fx(i)/Mult(i)
         SetFob(i,4)= fx(i)/(clp(i)*Mult(i))

c        write(20,'(3i4,f10.4)')(IndHKL(i,ji),ji=1,3),uvwg
c        uvw2max=2.0
         uvw2min=2.0*thstep
c        uvw2=  phkl(i,5) 
         uvw2=  phkl(i,6)*0.5
c        if(uvw2.gt.uvw2max) uvw2=uvw2max
c
         theta0 = TThet(i)
!bug-to avoid undefined iniz and ifin         if (theta0.gt.thmax) cycle
         thmin0=amax1(theta0-uvw2,thmin)
         thmax0=amin1(theta0+uvw2,thmax)
!corr        ranth=thmin0-thmin
!corr        iniz(i) = int ( ( thmin0 - thmin ) / thstep ) + 1
!corr        if(amod(ranth,thstep).gt.0.0) then
!corr                        iniz(i)=iniz(i)+1
!corr                 endif
!corr        if(iniz(i).gt.npunti) iniz(i) = npunti
!corr        ifin(i) = int ( ( thmax0 - thmin ) / thstep ) + 1
!corr        ranth0=thmax0-thmin
!corr        if(amod(ranth0,thstep).gt.0.0) then
!corr                        ifin(i)=ifin(i)+1
!corr                 endif
!corr        if(ifin(i).gt.npunti) ifin(i) = npunti
         iniz(i) = clocate(theta_int(:npunti,1),thmin0)
         ifin(i) = clocate(theta_int(:npunti,1),thmax0)
!
         theta1(i)=theta0-uvw2
         theta2(i)=theta0+uvw2
         if (theta2(i).gt.thmax) theta2(i) = thmax
         if (theta1(i).lt.thmin) theta1(i) = thmin
!corr         if(ifin(i).lt.iniz(i)) go to 250
c-------
c        write(6,'(i4,1h),3f10.4)')i,theta1(i),theta2(i),uvw2
!g!      write(6,*) 'ce',i, SetFob(i,4), fx(i),clp(i)*Mult(i)
  250 continue
      return
      end
c-----------------------------------------------------
      subroutine calcindobs(thetaov,iniz,ifin,theta1,theta2)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE extramodule, only: coef1,coef2
c
c----- Calcola il numero di osservazioni indipendenti presenti
c----- in uno spettro di polveri.
c
      real, dimension(:), intent(inout) :: thetaov
      integer, dimension(:), intent(in) :: iniz,ifin
      real, dimension(:), intent(in)    :: theta1,theta2
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /profp/dumpp,nprof,ipol
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
!corr      common /indobs/coef1(3000),coef2(3000)  !,overl(3000)
      integer, dimension(nrefl) :: iover
      real, dimension(nrefl) :: overl
      common /bbbb/ oscalef,ggpror,natso
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
!corr      double precision theta_intov(1000),theta_intovnew(1000),ffunct,
!corr     *                  funct
      double precision theta_intov(npunti),theta_intovnew(npunti),ffunct
     *                 ,funct
C-------
c--- In coef2(i) e' memorizzata la superficie associata all'i-simo riflesso
C-------
      iover(:) = 1
        eps=1.0E-10      
        do 299 j = 1, nrefl
          rdeg = 0.5 * TThet(j) * dtor
          cdeg= cos(rdeg)
          tdeg = sin(rdeg) / cos(rdeg)
          tdeg2=tdeg**2
          theta0 = TThet(j)
          coef2(j) = 0.0
          coef1(j) = 0.0
          if (TThet(j).gt.thmax) goto 299
          ffx = fx(j)
          if (iniz(j).eq.0.or.ifin(j).eq.0) go to 299
        do 200 nnn=iniz(j),ifin(j)
             if (thetaov(nnn).gt.thmax) thetaov(nnn) = thmax
             if (thetaov(nnn).lt.thmin) thetaov(nnn) = thmin
             th = thetaov(nnn)
             deltath=th-theta0
             deltath2=deltath**2
             if(nprof.eq.1)then
             cc=(1.0+phkl(j,2)*deltath2)
             ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
             asnum=asym*(deltath**3)
             asd1=deltath2
             asd2=1.0/phkl(j,2)
             asden=(asd1+asd2)**1.5
             asterm=asnum/asden+1.0
             elseif(nprof.eq.2)then
             cc=-phkl(j,2)*deltath2
             ffunct=phkl(j,1)*exp(cc)
             asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
             elseif(nprof.eq.3)then
             cc=1.0+phkl(j,2)*deltath2
             ffunct=phkl(j,1)/cc
             asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
             elseif(nprof.eq.4)then
             cc1=-phkl(j,2)*deltath2
             ffunct1=phkl(j,1)*exp(cc1)
             cc2=1.0+phkl(j,4)*deltath2
             ffunct2=phkl(j,3)/cc2
             eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2
             ffunct=(1.0-eta)*ffunct1+eta*ffunct2
             asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
             endif
             n0 = nnn - iniz(j) + 1
             n0 = min0(n0,npunti)
             if (n0.eq.0) goto 200
             theta_intov(n0)=ffx*ffunct*asterm
             theta_intovnew(n0) =  theta_intov(n0)
             coef2(j) = coef2(j) + theta_intov(n0)*thstep
  200   continue
              if (j.eq.nrefl) goto 343
               do 340 ii = j + 1,nrefl
c------ si confronta il picco j-esimo con i successivi del gruppo in over.
                  diff = theta2(j) - theta1(ii)
                   if (diff.lt.eps) goto 340
                   rdeg = 0.5 * TThet(ii) * dtor
                   cdeg= cos(rdeg)
                   tdeg = sin(rdeg) / cos(rdeg)
                   tdeg2=tdeg**2
                   iover(j) = iover(j) +1
                   n1 = iniz(ii) - iniz(j) + 1
                   n2 = n1 + ifin(j) - iniz(ii)
cccccccccc
c        if (n1.le.0) write(6,*)'ATTENZ. n1< = 0,j,ii,n1',j,ii,n1
cccccccccc
                    if (n1.le.0) then
                               n1=1
                               irif =min0(ifin(j),ifin(ii))
                               n2=n1 +irif - iniz(j)
                    endif
                    theta0 = TThet(ii)
                    ffx = fx(ii)
              if (n2.lt.n1) goto 333
                    do 350 jj = n1,n2
                     th = thetaov(jj + iniz(j) -1)
                     deltath=th-theta0
                     deltath2=deltath**2
                     if(nprof.eq.1)then
                     cc=(1.0+phkl(ii,2)*deltath2)
                     ffunct=phkl(ii,4)*phkl(ii,1)*(cc**(-phkl(ii,3)))
                     asnum=asym*(deltath**3)
                     asd1=deltath2
                     asd2=1.0/phkl(ii,2)
                     asden=(asd1+asd2)**1.5
                     asterm=asnum/asden+1.0
                     elseif(nprof.eq.2)then
                     cc=-phkl(ii,2)*deltath2
                     ffunct=phkl(ii,1)*exp(cc)
                     asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
                     elseif(nprof.eq.3)then
                     cc=1.0+phkl(ii,2)*deltath2
                     ffunct=phkl(ii,1)/cc
                     asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
                     elseif(nprof.eq.4)then
                     cc1=-phkl(ii,2)*deltath2
                     ffunct1=phkl(ii,1)*exp(cc1)
                     cc2=1.0+phkl(ii,4)*deltath2
                     ffunct2=phkl(ii,3)/cc2
                     eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2
                     ffunct=(1.0-eta)*ffunct1+eta*ffunct2
                     asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
                     endif
                     funct= ffx*ffunct*asterm
                     if(theta_intov(jj).le.funct) then
                              theta_intovnew(jj) = 0.0
                     endif
  350               continue
  333            continue
  340          continue
  343            continue
c------
c------ si confronta il picco j-esimo con i precedenti jj -simi
c------
                 if (j.eq.1) goto 353
                  do 360 jj = j - 1,1,-1
                   diff = theta2(jj) - theta1(j)
                   if (diff.lt.eps) goto 360
                   rdeg = 0.5 * TThet(jj) * dtor
                   tdeg = sin(rdeg) / cos(rdeg)
                   cdeg= cos(rdeg)
                   tdeg2=tdeg**2
                   iover(j) = iover(j) +1
                   n1 = iniz(j) - iniz(jj) + 1
                   n2 = n1 + ifin(jj) - iniz(j)
cccccccccc
c        if (n1.le.0) write(6,*)'ATTENZ. n1<0,j,jj,n1',j,jj,n1
cccccccccc
                   if (n1.le.0) then
                         n1=1
                         irif =min0(ifin(j),ifin(jj))
                         n2=n1 +irif - iniz(jj)
                   endif
                   theta0 = TThet(jj)
                   ffx = fx(jj)
              if (n2.lt.n1) goto 323
                   do 370 kk = n1,n2
                      th = thetaov(kk + iniz(jj) -1)
                      deltath=th-theta0
                      deltath2=deltath**2
                      if(nprof.eq.1)then
                      cc=(1.0+phkl(jj,2)*deltath2)
                      ffunct=phkl(jj,4)*phkl(j,1)*(cc**(-phkl(jj,3)))
                      asnum=asym*(deltath**3)
                      asd1=deltath2
                      asd2=1.0/phkl(jj,2)
                      asden=(asd1+asd2)**1.5
                      asterm=asnum/asden+1.0
                      elseif(nprof.eq.2)then
                      cc=-phkl(jj,2)*deltath2
                      ffunct=phkl(jj,1)*exp(cc)
                      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
                      elseif(nprof.eq.3)then
                      cc=1.0+phkl(jj,2)*deltath2
                      ffunct=phkl(jj,1)/cc
                      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
                      elseif(nprof.eq.4)then
                      cc1=-phkl(jj,2)*deltath2
                      ffunct1=phkl(jj,1)*exp(cc1)
                      cc2=1.0+phkl(jj,4)*deltath2
                      ffunct2=phkl(jj,3)/cc2
                      eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2
                      ffunct=(1.0-eta)*ffunct1+eta*ffunct2
                      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
                      endif
                      funct= ffx*ffunct*asterm
C                  if (n1.gt.0) then
                      if(theta_intov(kk-n1+1).lt.funct)then
                             theta_intovnew(kk-n1 +1) = 0.0
                      endif
C                  else
C                     if(theta_intov(kk+iniz(jj)-iniz(j)).lt.funct) then
C                            theta_intovnew(kk+iniz(jj)-iniz(j)) = 0.0
C                     endif
C                  endif
  370              continue
  323           continue
  360             continue
  353           continue
                   if (iover(j).ne.1) then
                     npuntj = ifin(j) - iniz(j) + 1
                     if (npuntj.eq.0) go to 299
!corr                     do ij = 1,npuntj
!corr                      coef1(j) = coef1(j) + theta_intovnew(ij)*thstep
!corr                     enddo
                     do ij = 1,npuntj-1
                        ipp = iniz(j) + ij - 1
                      coef1(j) = coef1(j) + theta_intovnew(ij)*
     *                      (theta_int(ipp+1,7)-theta_int(ipp,7))
                     enddo
!corr
                     if (coef2(j).gt.eps) coef1(j)=coef1(j)/coef2(j)
                   else
                     coef1(j) = 1.0
                   endif
                   overl(j) = coef1(j)
  299   continue
         do 222 j=1,nrefl
          if (TThet(j).gt.thmax) goto 222
              iok1 = 0
           if (coef2(j).lt.eps.and.iover(j).ne.1) then
              if (j.eq.nrefl) goto 232
                do 221 ij=j+1,j+iover(j)-1
                   if(ij.gt.nrefl) goto 232
         if (coef2(ij).gt.eps.and.((theta2(j)-theta1(ij)).gt.eps)) then
                    iok1 = 1
                  goto 222
           endif
         if ((theta2(j)-theta1(ij)).lt.eps) goto 221
  221       continue
  232      continue
              if (j.eq.1) goto 242
              if (j-iover(j)+1.le.0) goto 242
           do 220 ij=j-1,j-iover(j)+1,-1
                   if(ij.gt.nrefl) goto 242
         if (coef2(ij).gt.eps.and.((theta2(ij)-theta1(j)).gt.eps)) then
                           iok1 = 1
                           goto 222
             endif
         if ((theta2(ij)-theta1(j)).lt.eps) goto 220
  220       continue
  242       continue
          if (iok1.eq.0) coef1(j) = 1.0
          endif
              overl(j) = coef1(j)
  222       continue
         do 219 j=1,nrefl-1
               do 216 jj=j+1,nrefl
               if (TThet(jj).gt.thmax) goto 216
               difset=abs(SetFob(j,4)-SetFob(jj,4))
               diftet1=abs(theta1(j)-theta1(jj))
               diftet2=abs(theta2(j)-theta2(jj))
               if (difset.lt.eps.and.diftet1.lt.eps.
     *             and.diftet2.lt.eps) then
                    overl(j) = 0.0
                    overl(jj) = 0.0
                endif
  216          continue
  219     continue
      return
      end
c-----------------------------------------------------------------------
      subroutine erredif
      USE Riflessi
      USE xdataMod
      USE General
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      real, dimension(nrefl) :: fxx,exx
      sumfc2=0.0
      sumfp2=0.0
      sumd2=0.0
      sumdef=0.0
      sumfc=0.0
      do 100 i=nref1(nnt),nref2(nnt)
      sumfc2=sumfc2+(fxsav(i)**2)
      sumfc=sumfc+fxsav(i)
      sumfp2=sumfp2+fxfrag(i)/(clp(i)*Mult(i))
      sumd2=sumd2+fx(i)/(clp(i)*Mult(i))
      sumdef=sumdef+ex(i)/(clp(i)*Mult(i))
 100  continue
      scala1=sumfc2/sumfp2
      scala2=sumfc2/sumd2
      scala3=sumfc2/sumdef
c     write(6,*)'  h  k  l  2theta   F2 framm.   delta F2   F2+delta'
c    *,'   F2calc   F2def'
      sumdif2=0.0
      sumdif=0.0
      do 200 i=nref1(nnt),nref2(nnt)
      fxfra(i)=scala1*sigma*fxfrag(i)/(clp(i)*Mult(i))
      fxx(i)=scala2*(1.0-sigma)*fx(i)/(clp(i)*Mult(i))
      exx(i)=scala3*ex(i)/(clp(i)*Mult(i))
      sumdif2=sumdif2+abs(fxfra(i)+fxx(i)-fxsav(i)**2)
      if(fxfra(i)+fxx(i).gt.0.0)
     *sumdif=sumdif+abs(sqrt(fxfra(i)+fxx(i))-fxsav(i))
      erre1=sumdif2/sumfc2
      erre2=sumdif/sumfc
 200  continue
      return
      end
c-----------------------------------------------------------------------
!corr      subroutine staterre
!corr      USE Riflessi
!corr      USE xdataMod
!corr      USE General
!corr      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
!corr     *              ,noint,ialt,sigma,if92,nocell
!corr      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
!corr     *,nref1(10),nref2(10),ymx(10),nnt
!corr     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
!corr     *,nref11(10),nref22(10),sscl(10),scala(10)
!corr      dimension fxapp(3000),fxsavapp(3000),nrf(20),nrif(3000)
!corr      dimension ivett(3),rover(3000),dnover(3000),ddover(3000),
!corr     *indov(3000),fpero(3000)
!corrc
!corr      kcod=0
!corr      sogh=0.1
!corr      call defovlex(kcod,sogh,indov,maxov)
!corr      scalaa=sscl(nnt)
!corr      do 1000 i=1,nrefl
!corr      if(ialt.eq.0)then
!corr      fxapp(i)=scalaa*sqrt(fx(i)/(clp(i)*Mult(i)))
!corr      else
!corr      if(fxfrag(i).lt.0.0)fxfrag(i)=0.0
!corr      fxapp(i)=scalaa*sqrt(fxfrag(i)/(clp(i)*Mult(i)))
!corr      endif  
!corr      fxsavapp(i)=fxsav(i)
!corr 1000 continue
!corr      do 1002 i=1,nrefl
!corr      if(indov(i).eq.0)then
!corr      go to 1002
!corr      else
!corr      do 1001 k=i,i+indov(i)-1
!corr      fpero(k)=fxapp(k)/indov(i)
!corr 1001 continue
!corr      endif
!corr 1002 continue
!corr      fxmax=-999999.0
!corr      fxmin=999999.0
!corr      novermax=-999999999 
!corr      do 2100 j=1,nrefl
!corr      if(indov(j).gt.novermax)novermax=indov(j)
!corr      if(fpero(j).gt.fxmax) fxmax=fpero(j)
!corr      if(fpero(j).lt.fxmin) fxmin=fpero(j)
!corr 2100 continue
!corr      do 2110 j=1,novermax
!corr      dnover(j)=0.0
!corr      ddover(j)=0.0
!corr      rover(j)=0.0
!corr      nrif(j)=0
!corr 2110 continue
!corr      smfo=0.0
!corr      smdf=0.0
!corr      fint=(fxmax-fxmin)/5.0            
!corr      write(lo,*)'                '
!corr      write(lo,*)'*****************************************************'
!corr      write(lo,'(30x,a,5x,a,7x,a,4x,a,4x,a,2x,a,2x,a)')
!corr     *'Fmin','Fmax','Rf','Rfcum','nr','NR','ov(medio)'
!corr      write(lo,*)'*****************************************************'
!corr      write(lo,*)'                '
!corrCANG  do 2300 j=1,20
!corr      do 2300 j=1,5
!corr      sumdf=0.0
!corr      ere=0.0
!corr      flim2=fxmax-(j-1)*fint
!corr      flim1=flim2-fint
!corr      if(flim2.ge.(fxmax-0.1).and.flim2.le.(fxmax+0.1))
!corr     *flim2=fxmax+0.1
!corr      sumfc=0.0
!corr      sumdf=0.0
!corr      numbb=0
!corr      novr=0
!corr      nov=0
!corr      do 2400 k=1,nrefl
!corr      if(fpero(k).ge.flim1.and.fpero(k).lt.flim2)then
!corr      if(indov(k).ne.0)then
!corr      novr=novr+indov(k)
!corr      nov=nov+1
!corr      else
!corr      do 2490 kk=1,k-1
!corr      if(indov(k-kk).ne.0)then
!corr      novr=novr+indov(k-kk)
!corr      nov=nov+1
!corr      go to 2495
!corr      endif
!corr 2490 continue
!corr 2495 continue
!corr      endif
!corr      numbb=numbb+1
!corr      sumdf=sumdf+abs(fxapp(k)-fxsavapp(k))
!corr      sumfc=sumfc+fxsavapp(k)
!corr      smdf=smdf+abs(fxapp(k)-fxsavapp(k))
!corr      smfo=smfo+fxsavapp(k)
!corr      ksav=k
!corr      endif
!corr 2400 continue    
!corr      if(j.gt.1)then
!corr      nrf(j)=numbb+nrf(j-1)
!corr      else
!corr      nrf(j)=numbb
!corr      endif
!corr      if(numbb.eq.0)go to 2300
!corr      if(sumfc.gt.0.0)ere=(sumdf/sumfc)*100.0
!corr      if(smfo.gt.0.0)rr=(smdf/smfo)*100.0
!corr      ovr=float(novr)/float(nov)
!corr      if(numbb.gt.1)then
!corr      write(lo,'(a,4f10.4,2i5,f4.1)')'Rf-analysis vs.intensity',
!corr     *flim1,flim2,ere,rr,numbb,nrf(j),ovr
!corr      else
!corr      write(lo,'(a,4f10.4,2i5,f4.1,f10.4)')'Rf-analysis vs.intensity',
!corr     *flim1,flim2,ere,rr,numbb,nrf(j),ovr,TThet(ksav)
!corr      endif
!corr 2300 continue
!corr      write(lo,*)'                '
!corr      write(lo,*)'*****************************************************'
!corr      write(lo,'(28x,a,6x,a,4x,a,4x,a,2x,a)')
!corr     *'OV','Rf','Rfcum','nr','NR'
!corr      write(lo,*)'*****************************************************'
!corr      write(lo,*)'                '
!corr      do 2450 k=1,nrefl
!corr      nind=indov(k)
!corr      do 2460 kk=k,k+nind-1
!corr      nrif(nind)=nrif(nind)+1
!corr      dnover(nind)=dnover(nind)+abs(fxapp(kk)-fxsavapp(kk))
!corr      ddover(nind)=ddover(nind)+fxsavapp(kk)
!corr 2460 continue    
!corr 2450 continue    
!corr      ncum=0
!corr      do 2470 k=1,novermax
!corr      smfo=0.0
!corr      smdf=0.0
!corr      do 2471 kk=1,k
!corr      smdf=smdf+dnover(kk)
!corr      smfo=smfo+ddover(kk)
!corr 2471 continue
!corr      ncum=ncum+nrif(k)
!corr      if(ddover(k).gt.0.0)rover(k)=(dnover(k)/ddover(k))*100.0
!corr      if(smfo.gt.0.0)rr=(smdf/smfo)*100.0
!corr      if(nrif(k).gt.0)write(lo,'(a,i4,2f10.4,2i5)')
!corr     *'Rf-analysis vs.overlapping',k,rover(k),rr,nrif(k),ncum
!corr 2470 continue
!corr      write(lo,*)'                '
!corr      call correl(fxapp,fxsavapp,nrefl,res)
!corr      write(lo,'(a,f10.4)')'Correl. between calculated and true values',
!corr     *res
!corr      return
!corr      end
c--------------------------------------------------------------
      subroutine ancora(kgo)
      USE General
      USE Molcom      
c ---
      kgo = 0
      if (kscreen.eq.0) return
c     call scrper(' ',0,-1)
      write(Inte,100)
      write(Msg,101)
  100 format(' GO ON                 ')
  101 format('Do you want to continue the refinement',
     *' on the same range?')
!     iTipo =3
      iExCode = 0
      call MsgWinErr(Inte,Msg,QUEST_WINDOW_YES_NO,iExCode)
      if (iExCode .eq. 1) kgo=1
c
      return
      end
c-----------------------------------------------------------------------
      subroutine varprofile(ny,ndeg,jjj)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
c
      common /backp2/ npol(10)
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      real, allocatable :: yapp(:)
      real, allocatable :: ies(:)
      real, allocatable :: rappo(:)
      real, dimension(10000) :: countmih
c
      var=0.0
      IF (.NOT.ALLOCATED(yapp))
     *   ALLOCATE (yapp(npunti), stat=ier4)
      IF (.NOT.ALLOCATED(ies))
     *   ALLOCATE (ies(npunti), stat=ier4)
      IF (.NOT.ALLOCATED(rappo))
     *   ALLOCATE (rappo(npunti), stat=ier4)
      do 90 i=ncoun11(jjj),ncoun22(jjj)
      ies(i)=0
!corr      if(i.gt.1)rappo(i)=(theta_int(i,2)-theta_int(i-1,2))/thstep
      if(i.gt.1)rappo(i)=(theta_int(i,2)-theta_int(i-1,2))/
     *                   (theta_int(i,7)-theta_int(i-1,7))
  90  continue
      rappo(ncoun11(jjj))=rappo(ncoun11(jjj)+1)
      np=ncoun2(jjj)-ncoun1(jjj)
      do 190 i=ncoun11(jjj),ncoun22(jjj)-1
      if(i.gt.1.and.rappo(i).lt.0.0.and.rappo(i+1).gt.0.0)
     *ies(i)=1                           
 190  continue
      ndp=int(10.0/thstep)
      nt=np/ndp
      nr=mod(np,ndp)
      do 20 j=1,nt
      nmin=ncoun1(jjj)+(j-1)*ndp
      nmax=ncoun1(jjj)+j*ndp
      if(j.eq.nt)namx=ncoun2(jjj)
      if(nmin.lt.ncoun1(jjj))nmin=ncoun1(jjj)
      if(nmax.gt.ncoun2(jjj))nmax=ncoun2(jjj)
      profmed=0.0
      nmed=0
      do 10 i=nmin,nmax
      if(ies(i).eq.0)go to 10
      ies(i)=1
      profmed=profmed+theta_int(i,2)
      nmed=nmed+1
 10   continue
      profmed=profmed/nmed
      natt=1
 50   continue
      profmed2=0.0
      nmed2=0
      do 100 i=nmin,nmax
      if(ies(i).eq.0)go to 100
      ies(i)=1
      yapp(i)=theta_int(i,2)
      if(yapp(i).lt.profmed)then
      ies(i)=2
      profmed2=profmed2+yapp(i)
      nmed2=nmed2+1
      endif
 100  continue
      if(nmed2.eq.0)go to 20
      profmed2=profmed2/nmed2
      var2=0.0
      do 200 i=nmin,nmax
      if(ies(i).eq.0)go to 200
      if(yapp(i).lt.profmed)then
      ies(i)=2
      var2=var2+(yapp(i)-profmed2)**2
      endif
 200  continue
      if(nmed2.gt.1)then
      var2=var2/(nmed2-1)
      else
      var2=var2
      endif
      if((natt.gt.1.and.(var-var2).gt.0.5*var.and.var2.ge.1.0).
     *or.natt.eq.1)then
      profmed=profmed2
      natt=natt+1
      var=var2
      go to 50
      else
      ndeg=11
      do 400 i=nmin,nmax
      if(ies(i).eq.2)then
      ny=ny+1
      tt(ny)=theta_int(i,1)
      countmi(ny)=theta_int(i,2)
      weig(ny)=1.0
      nies=0
      endif
 400  continue
      endif
  20  continue
      do 500 i=1,ny
      thhmin=99999999.0
      do 600 j=1,ny
      if(tt(j).le.thhmin)then
      thhmin=tt(j)
      jsav=j
      endif
 600  continue
      tth(i)=tt(jsav)
      countmih(i)=countmi(jsav)
      weigh(i)=weig(jsav)
      tt(jsav)=999999999.0
500   continue
      nyy=0
      do 700 i=1,ny
corrado: run-time error      if(i.eq.1.or.((tth(i)-tt(nyy)).ge.thstep))then
      if(i.eq.1)then
         nyy=nyy+1
         tt(nyy)=tth(i)
         countmi(nyy)=countmih(i)
         weig(nyy)=weigh(i)
      else if(((tth(i)-tt(nyy)).ge.thstep))then
         nyy=nyy+1
         tt(nyy)=tth(i)
         countmi(nyy)=countmih(i)
         weig(nyy)=weigh(i)
      endif
  700 continue
      jcall=2
      ny=nyy
c-----
      do i=1,ny
        tth(i)=tt(i)
        countmih(i)=countmi(i)
        weigh(i)=weig(i)
      enddo
      if (jjj.eq.2) then
         do i=1,ny
            tt(i+1)=tth(i)
            countmi(i+1)=countmih(i)
            weig(i+1)=weigh(i)
         enddo
         tt(1)=theta_int(ncoun1(jjj),1)-4.0
         countmi(1)=theta_int(ncoun1(jjj),2)
         weig(1)=weig(2)
         ny=ny+1
      endif
      if (jjj.eq.nnt-1) then
          ny=ny+1
          tt(ny)=theta_int(ncoun2(jjj),1)+4.0
          countmi(ny)=theta_int(ncoun2(jjj),2)
          weig(ny)=weig(ny-1)
      endif
c-----
ccccccccccccccc
        countmimed=0.0
        do k=1,ny
          countmimed=countmimed+countmi(k)
        enddo
        countmimed=countmimed/float(ny)
        do k=1,ny
          if(countmi(k).lt.0.3*countmimed)then
            kkmin=9999999
            do kk=1,ny
              if(countmi(kk).gt.0.3*countmimed)then
                kkdif=iabs(k-kk)
                if(kkdif.lt.kkmin)then
                  kksav=kk
                  kkmin=kkdif
                endif
              endif
            enddo
            countmi(k)=countmi(kksav)
          endif
        enddo
ccccccccccccccc
      call lsqback(ny,ndeg,jcall,jjj,ier)
      DEALLOCATE (yapp,stat=ierr)
      DEALLOCATE (ies,stat=ierr)
      DEALLOCATE (rappo,stat=ierr)
      if (ier4.lt.0) write(lo,*) ' Problemi nella allocazione'
      if (ierr.lt.0) then
      write(lo,*) ' Problemi nella deallocazione di profcalc'
      endif
      return
      end
c------------------------------------------------------------
c     define overlapping            
      subroutine defovlex(kcod,sogh,indov,maxov)
      USE Riflessi
      USE xdataMod
      USE General
      dimension ies(nrefl),indov(nrefl)
C
C --- Construct of overlapping groups of reflections;
C
      THG    = sogh 
      jr     = nrefl
      DO 229 JS=1,JR
      indov(JS) = 1
      ies(js)=1
 229  CONTINUE
      DO 230 JS=1,JR-1
         if(kcod.eq.0)then
         If(indov(JS).EQ.0) GO TO 225
         else
         If(ies(JS).EQ.0) GO TO 225
         endif
            indov(JS) = 1
            DO 220 JG=JS+1,JR
               IFL = 0
               if(kcod.eq.0)then
               fwrif=phkl(JG-1,6)
               else
               fwrif=WHM(JG-1)
               endif
               IF(ABS(Tthet(JG)-Tthet(JG-1)).LE.THG*fwrif) THEN
                  indov(JS) = indov(JS)+1
                  if(kcod.eq.0)then
                  indov(JG) = 0          
                  else
                  do 260 jk=js+1,jg
                  indov(jk)=indov(js)
 260              continue
                  ies(jg)=0
                  endif
                  IFL = 1
               END IF
               IF(IFL.EQ.0) GO TO 225
 220        CONTINUE
 225        CONTINUE
 230  CONTINUE
 295  continue
      maxov=-99999
      do 5000 i=1,nrefl
      if(indov(i).gt.maxov)maxov=indov(i)
 5000 continue
      return
      end
!corrc--------------------------------------------------------------------
!corr      subroutine correl(x,y,nt,res)
!corrc
!corrc-----------------------------------------------------
!corrc-  Calcola la correlazione tra i vettori x e y
!corrc-----------------------------------------------------
!corrc
!corr      dimension x(3000), y(3000)
!corr
!corr      y1=0.0
!corr      x1=0.0
!corr      do 10 i=1,nt
!corr            y1=y1+y(i)
!corr            x1=x1+x(i)
!corr 10   continue
!corr      y1=y1/nt
!corr      x1=x1/nt
!corr      rnum1=0.0
!corr      rden1=0.0
!corr      rden2=0.0
!corr      sumnum=0.0
!corr      sumden=0.0
!corr      do 20 i=1,nt
!corr            rnum1=rnum1 + (x(i)-x1)*(y(i)-y1) 
!corr            rden1=rden1 + (x(i)-x1)**2
!corr            rden2=rden2 + (y(i)-y1)**2
!corr            sumnum=sumnum+abs(x(i)-y(i))
!corr            sumden=sumden+y(i)
!corr 20   continue
!corr      erre=sumnum/sumden
!corrc     write(6,*)'ERREPROVA',erre
!corr      res=rnum1/(sqrt(rden1)*sqrt(rden2))
!corr      return
!corr      end
c-----------------------------------------------------------------------
      subroutine randomf(jjj,nvolte)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE CalcProfile
      USE General
      USE Molcom
      USE extramodule, only: inizc,ifinc,indovr
!corr      include 'rando.fi'
      USE randofi
      common/anna1/sumobs,sumobsnobac
!corr      common/anna2/inizc(3000),ifinc(3000)
!corr      common/intervalli/fxinte(3000),fleb(3000),fint(3000)
      common /limiti/ nlini, nlfin
      common/try/itrysav,psav(12),nvoltemax
      common /backp2/ npol(10)
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common/errer/erreprof,erreprofw,erre_old,erref,errerif
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      dimension ivat(3)
      common/anna/ncounmax
!corr      dimension xran(3000),ino(3000),fmem(3000)
      dimension xran(nrefl),ino(nrefl),fmem(nrefl)
c-----f90
      real, allocatable :: summa(:,:)
c------------------------------
      IF (.NOT.ALLOCATED(summa))
     *   ALLOCATE (summa(npunti,2), stat=ier4)
      nb=nref22(jjj)-nref11(jjj)
      if(nb.eq.0)return
      if(iesrandom.eq.0)return
      ncounmax=npunti             
      sumofc=0.0
      sumofo=0.0
      do 508 j=nref11(jjj),nref22(jjj)
      ino(j)=0
      fmem(j)=fx(j)
      sumofc=sumofc+clp(j)*Mult(j)*(fxsav(j)**2)
      sumofo=sumofo+fx(j)
 508  continue
      if(iknow.gt.0)scalaf=sumofo/sumofc
      do 100 j=ncoun11(jjj),ncoun22(jjj)
      summa(j,1)=theta_int(j,3)
 100  continue
      call AllocaCalcprofile(1)
      call CalcProff(jjj,ier)
      do 600 k=1,nov
      ilap=0
      ilapp=0
      nrandom=0
      do 601 ihh=isav1(k),isav2(k)
      if(indovr(ihh).gt.1)then
      ilap=ilap+1
      ilapp=ilapp+indovr(ihh)
      endif
 601  continue
      ilapp=int(ilapp/2)
      kkmax=10*ilapp                   
!!!TOFIX: Corr. kkmax is limit on reflections number?
!corr      if(kkmax.gt.3000)kkmax=3000
      if(ilapp.eq.0)go to 600
      sumo1=0.0
      sumc=0.0
      do 101 jj=ncoun11(jjj),ncoun22(jjj)
      sumo1=sumo1+(theta_int(jj,2)-back_int(jj,1))
      sumc=sumc+summa(jj,1)
 101  continue
      sumdd=0.0
      if(sumc.gt.0.0001)then
      scalaa=sumo1/sumc
      else
      scalaa=0.0             
      endif
      sumo2=0.0
      sumo3=0.0
      sumdif2=0.0
      do 200 jj=inizsav(k),ifinsav(k)
      sumo2=sumo2+theta_int(jj,2)
      if(theta_int(jj,2).gt.0.0)then
      pesos=1.0/(theta_int(jj,2))
      else
      pesos=0.0
      endif
      pesos=1.0
      sumo3=sumo3+pesos*(theta_int(jj,2)**2)
      dif=theta_int(jj,2)-back_int(jj,1)-scalaa*summa(jj,1)
      sumdif2=sumdif2+((dif)**2)*pesos
      sumdd=sumdd+pesos*(abs(dif)**2)
 200  continue
      if(sumo3.gt.0.0)then
      errerif=(sumdd/sumo3)
      else
      errerif=0.0
      endif
      chi2rif=sumdif2
      if(errerif.ge.-0.000001.and.errerif.le.0.000001)go to 600
      igood=0
      do 500 kk=1,kkmax
      do 650 i=isav1(k),isav2(k)
      ino(i)=0
 650  continue
      do 700 j=isav1(k),isav2(k)
      if(indovr(j).eq.1)go to 700
      if(ino(j).gt.0)go to 700
      xra=0.0
      yra=0.0
      do 604 k0=1,indovr(j)
      call SirRandom(iix,iiy,yfl)
      iix=iiy
      xran(k0)=yfl
      xra=xra+xran(k0)
      yra=yra+fx(j+k0-1)
      ino(j+k0-1)=1
 604  continue
      do 701 k0=1,indovr(j)
      nrandom=nrandom+1
      fmem(j+k0-1)=xran(k0)*yra/xra
 701  continue
 700  continue
 707  format(a,4i4,4f10.3)
      do 450 jj=ncoun11(jjj),ncoun22(jjj)
      theta_int(jj,3)=0.0
 450  continue
      sumc=0.0
      do 501 jj=nref11(jjj),nref22(jjj)
      iniz = inizc(jj)
      ifin = ifinc(jj)
      ffx=fmem(jj)
      do 311 nnn=iniz,ifin
      theta_int(nnn,3)=theta_int(nnn,3)+ffx*profcalc(jj,nnn-iniz+1)
  311 continue
  501 continue
      do 1000 jj=ncoun11(jjj),ncoun22(jjj)
      sumc=sumc+theta_int(jj,3)
 1000 continue
      if(sumc.gt.0.0001)then
      scalaa=sumo1/sumc
      else
      scalaa=0.0
      endif
      sumdd=0.0
      sumdd2=0.0
      do 800 jj=inizsav(k),ifinsav(k)
      if(theta_int(jj,2).gt.0.0)then
      pesos=1.0/(theta_int(jj,2))
      else
      pesos=0.0
      endif
      pesos=1.0
      dif=theta_int(jj,2)-back_int(jj,1)-scalaa*theta_int(jj,3)
      sumdd=sumdd+((dif)**2)*pesos
      sumdd2=sumdd2+((dif)**2)*pesos
 800  continue
      errep=(sumdd/sumo3)
      chi2=sumdd2
      if(igood.eq.0)then
      erresog=0.99*errerif
      chisog=0.99*chi2rif
      else
      erresog=errerif
      chisog=chi2rif
      endif
      if(chi2.le.chisog)then
      errerif=errep
      chi2rif=chi2
      igood=1
      do 900 kkk=isav1(k),isav2(k)
      fx(kkk)=fmem(kkk)
 900  continue
      endif
 500  continue
 600  continue
      do 550 j=ncoun11(jjj),ncoun22(jjj)
      theta_int(j,3)=0.0
 550  continue
      do 901 jj=nref11(jjj),nref22(jjj)
      iniz = inizc(jj)
      ifin = ifinc(jj)
      ffx=fx(jj)
      do 911 nnn=iniz,ifin
      theta_int(nnn,3)=theta_int(nnn,3)+ffx*profcalc(jj,nnn-iniz+1)
  911 continue
  901 continue
      call AllocaCalcProfile(2)
      DEALLOCATE (summa,stat=ierr)
      if (ier4.lt.0) write(lo,*) ' Problemi nella allocazione'
      if (ierr.lt.0) then
      write(lo,*) ' Problemi nella deallocazione di profcalc'
      endif
      return
      end
c------------------------------------------------------------
c     define overlapping            
      subroutine defovlra(jjj,nvolte,sog)                           
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
      USE extramodule, only: indovr
!corr      include 'rando.fi'
      USE randofi
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      dimension iss(nrefl)
C
C --- Construct of overlapping groups of reflections;
C
      DO 229 JS=nref11(jjj),nref22(jjj)
      indovr(JS) = 1
      iss(js)=1
 229  CONTINUE
      DO 230 JS=nref11(jjj),nref22(jjj)-1
         If(iss(JS).EQ.0) GO TO 225
            indovr(JS) = 1
!corr            ranth=TThet(js)-thmin
!corr            in = int ( ranth/ thstep ) + 1
            in = clocate(theta_int(:npunti,7),TThet(js))
            if(in.lt.ncoun11(jjj))in=ncoun11(jjj)
            if(in.gt.ncoun22(jjj))in=ncoun22(jjj)
!corr            rif=back_int(in,1)*thstep
!corr            rif0=theta_int(in,2)*thstep
            DO 220 JG=JS+1,nref22(jjj)
               IFL = 0
               fwrif=phkl(JG-1,6)
               IF(ABS(Tthet(JG)-Tthet(JG-1)).LE.sog*fwrif) THEN
               flim1=0.5*fx(jg-1)
               flim2=1.5*fx(jg-1)
                  indovr(JS) = indovr(JS)+1
                  do 260 jk=js+1,jg
                  indovr(jk)=indovr(js)
 260              continue
                  iss(jg)=0
                  IFL = 1
               END IF
               IF(IFL.EQ.0) GO TO 225
 220        CONTINUE
 225        CONTINUE
 230  CONTINUE
 295  continue
      return
      end
c--------------------------------------------------------------------
!     subroutine prerandom(jjj,nvolte)
      subroutine prerandom(nvolte)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE Molcom
      USE PatternRef
      USE arrayutil
      USE extramodule, only: indovr
      USE nr, only: indexx
!corr      include 'rando.fi'
      USE randofi
!corr      common/intervalli/fxinte(3000),fleb(3000),fint(3000)
      common /limiti/ nlini, nlfin
      common/try/itrysav,psav(12),nvoltemax
      common /backp2/ npol(10)
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common/errer/erreprof,erreprofw,erre_old,erref,errerif
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
!corr      common/bdata/ibig(124000)
      common/genob/irho,thetamin
!corr      common/genob2/thmin,thmax,thstep
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
!corr      common /profp/phkl(3000,6),dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      dimension ivat(3)
!corr      dimension xran(3000),ino(3000),fmem(3000)
      dimension ino(nrefl)
      dimension isavsav1(nrefl),isavsav2(nrefl),inizsavsav(nrefl),
     *ifinsavsav(nrefl)
      integer, dimension(nrefl) :: iorder
!corr      dimension tdel1(3000),tdel2(3000)
!corr      dimension abig(72000)
!corr      equivalence (ibig(1),abig(1))
c
      nb=nref22(jjj)-nref11(jjj)
      if(nb.eq.0)return
      if(jjj.eq.2)then
      write(lo,14)
   14 format(/,10x,'***      Random Intensity Decomposition         ***'
     &       /,10x,'***                  in Extra                   ***'
     &       ,/)
      write(lo,'(2a,f8.2,/)')'  The parameter used in the overlapping',
     &' definition is',sograndom
      endif
!corr
      call indexx(TThet(:nrefl),iorder)
      IndHKL(:nrefl,1:5) = IndHKL(iorder,1:5)
      SetFob(:nrefl,1:5) = SetFob(iorder,1:5)
      TThet(:nrefl) = TThet(iorder)
      Mult(:nrefl) = Mult(iorder)
      WHM(:nrefl) = WHM(iorder)
      fxsav(:nrefl) = fxsav(iorder)
      fc(:nrefl) = SetFob(:nrefl,4)
!FIXED: wrong sort
!corr      lind=138001
!corr      iblk=15
!corr      jump=11
!corr      izer=15*nrefl
!corr      do 502 i=1,izer
!corr 502    abig(i) = 0.0
!corr      do 691 i=1,nrefl
!corr       ibig(15*(i-1)+1)=IndHKL(i,1)
!corr       ibig(15*(i-1)+2)=IndHKL(i,2)
!corr       ibig(15*(i-1)+3)=IndHKL(i,3)
!corr       ibig(15*(i-1)+4)=IndHKL(i,4)
!corr       ibig(15*(i-1)+5)=IndHKL(i,5)
!corr       abig(15*(i-1)+6)=SetFob(i,1)
!corr       abig(15*(i-1)+7)=SetFob(i,2)
!corr       abig(15*(i-1)+8)=SetFob(i,3)
!corr       abig(15*(i-1)+9)=SetFob(i,4)
!corr       abig(15*(i-1)+10)=SetFob(i,5)
!corr       abig(15*(i-1)+11)=TThet(i)
!corr       ibig(15*(i-1)+12)=Mult(i)
!corr       abig(15*(i-1)+13)=WHM(i)
!corr       abig(15*(i-1)+14)=fxsav(i)
!corr       abig(15*(i-1)+15)=SetFob(i,4)
!corr  691 continue
!corr      call sortz(lind,nrefl,iblk,jump)
!corr      do 792 i=1,nrefl
!corr       IndHKL(i,1)=ibig(15*(i-1)+1)
!corr       IndHKL(i,2)=ibig(15*(i-1)+2)
!corr       IndHKL(i,3)=ibig(15*(i-1)+3)
!corr       IndHKL(i,4)=ibig(15*(i-1)+4)
!corr       IndHKL(i,5)=ibig(15*(i-1)+5)
!corr       SetFob(i,1)=abig(15*(i-1)+6)
!corr       SetFob(i,2)=abig(15*(i-1)+7)
!corr       SetFob(i,3)=abig(15*(i-1)+8)
!corr       SetFob(i,4)=abig(15*(i-1)+9)
!corr       SetFob(i,5)=abig(15*(i-1)+10)
!corr       TThet(i)=abig(15*(i-1)+11)
!corr       Mult(i)=ibig(15*(i-1)+12)
!corr       WHM(i)=abig(15*(i-1)+13)
!corr       fxsav(i)=abig(15*(i-1)+14)
!corr       fc(i)=abig(15*(i-1)+15)
!corr  792 continue
      sog=sograndom
      if(sog.gt.1.0)sog=1.0
      wid=0.8
      call defovlra(jjj,nvolte,sog)
      iesrandom=0
      do 508 j=nref11(jjj),nref22(jjj)
      if(indovr(j).gt.1)iesrandom=1
      ino(j)=0
 508  continue
      if(iesrandom.eq.0)return
      nov=0
      do 400 j=nref11(jjj),nref22(jjj)
      if(indovr(j).eq.1)go to 400
      if(ino(j).eq.1)go to 400
      if(nov.eq.0)then
      nov=nov+1
      theta0=TThet(j)
      uvw2=phkl(j,5)
      uvw2=uvw2*wid  
      thminn=amax1(theta0-uvw2,thmin)
!corr      ranth=thminn-thmin
!corr      iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
      iniz = clocate(theta_int(:npunti,7),thminn)
!corr
      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
      ini=iniz
      inizsav(nov)=ini        
      isav1(nov)=j
      ik=inizsav(nov)
      if(theta_int(ik,2).gt.1.1*back_int(ik,1).and.nov.gt.1)then
      do 863 jh=ik-1,ifinsav(nov-1),-1
      if(theta_int(jh,2).le.1.1*back_int(jh,1))then
      inizsav(nov)=jh        
      go to 866
      endif
 863  continue 
 866  continue 
      endif
      do 885 il=nref11(jjj),j-1    
      if(TThet(il).ge.theta_int(inizsav(nov),1))then
      isav1(nov)=il
      go to 884
      endif
 885  continue
 884  continue
      else
      theta0=TThet(j)
      uvw2=phkl(j,5)
      uvw2=uvw2*wid  
      thminn=amax1(theta0-uvw2,thmin)
!corr      ranth=thminn-thmin
!corr      iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
      iniz = clocate(theta_int(:npunti,7),thminn)
!corr
      if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
      if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
      ini=iniz
      iniz1=ini        
      if(iniz1.ge.ifinsav(nov).or.j.eq.(nref22(jjj)))then
      nov=nov+1
      inizsav(nov)=iniz1      
      isav1(nov)=j   
      ik=inizsav(nov)
      if(theta_int(ik,2).gt.1.1*back_int(ik,1).and.nov.gt.1)then
      do 663 jh=ik-1,ifinsav(nov-1),-1
      if(theta_int(jh,2).le.1.1*back_int(jh,1))then
      inizsav(nov)=jh        
      go to 666
      endif
 663  continue 
 666  continue 
      endif
      do 875 il=nref11(jjj),j-1  
      if(TThet(il).ge.theta_int(inizsav(nov),1))then
      isav1(nov)=il
      go to 874
      endif
 875  continue
 874  continue
      endif
      endif
      k=indovr(j)
      if((j+k-1).ge.nref22(jjj))k=nref22(jjj)-j+1
 999  continue
      isav2(nov)=j+k-1
      theta0=TThet(j+k-1)
      uvw2=phkl(j+k-1,5)
      uvw2=uvw2*wid  
      thmaxx=amin1(theta0+uvw2,thmax)
!corr
!corr      ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
      ifin = clocate(theta_int(:npunti,7),thmaxx)
!corr
      if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
      ifi=ifin
      ifinsav(nov)=ifi    
      ik=ifinsav(nov)
      if(theta_int(ik,2).gt.1.1*back_int(ik,1).
     *and.ik.lt.ncoun22(jjj))then
      do 673 jh=ik+1,ncoun22(jjj)
      if(theta_int(jh,2).le.1.1*back_int(jh,1))then
      ifinsav(nov)=jh        
      go to 676
      endif
 673  continue 
 676  continue 
      endif
      do 865 il=nref22(jjj),j+k,-1
      if(TThet(il).le.theta_int(ifinsav(nov),1))then
      isav2(nov)=il
      go to 864
      endif
 865  continue
 864  continue
      do 855 ii=isav1(nov),isav2(nov)
      ino(ii)=1
 855  continue
 400  continue
      do 1100 k=1,nov
      isavsav1(k)=isav1(k)
      isavsav2(k)=isav2(k)
      inizsavsav(k)=inizsav(k)
      ifinsavsav(k)=ifinsav(k)
 1100 continue
      novv=0
      if(jjj.eq.2)then
      write(lo,'(2a,/)')'   The following clumps of',
     *' reflections are considered:'
      write(lo,'(2a)')'   2th-min   2th-max  nr. refl.',
     *'  nr. overlapped refl.'                     
      endif
      do 1200 k=1,nov
      if(k.eq.1)then
      novv=novv+1
      isav1(novv)=isavsav1(k)
      isav2(novv)=isavsav2(k)
      inizsav(novv)=inizsavsav(k)
      ifinsav(novv)=ifinsavsav(k)
      else
      if(inizsavsav(k).gt.inizsav(novv))then
      novv=novv+1
      isav1(novv)=isavsav1(k)
      isav2(novv)=isavsav2(k)
      inizsav(novv)=inizsavsav(k)
      ifinsav(novv)=ifinsavsav(k)
      else
      isav2(novv)=isavsav2(k)
      ifinsav(novv)=ifinsavsav(k)
      endif
      endif
 1200 continue
      nov=novv
      do 1300 k=1,nov
      n1=isav1(k)
      n2=isav2(k)
      call defovlrr(n1,n2,jjj,nvolte,sog,nmod)
      write(lo,'(2f10.3,i6,8x,i10)')theta_int(inizsav(k),1),
     *theta_int(ifinsav(k),1),isav2(k)-isav1(k)+1,nmod
 1300 continue
      if(jjj.eq.(nnt-1))then
      write(lo,19)
   19 format(/,10x,'***                                             ***'
     &       ,/)
      endif
      return
      end
c------------------------------------------------------------
      subroutine CalcProff(jjj,ier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE CalcProfile
      USE General
      USE arrayutil
      USE extramodule, only: inizc,ifinc
c-
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /profp/dumpp,nprof,ipol
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
c-
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common/anna/ncounmax
      common/anna1/sumobs,sumobsnobac
!corr      common/anna2/inizc(3000),ifinc(3000)
      dimension vat(12),ivat(12)
      equivalence (vat(1)  ,ivat(1)  )
c---------------------------------------------------
      do 5 i=1,nrefl
      do 5 j=1,ncounmax
          profcalc(i,j) = 0.0
 5    continue
      do 10 j=nref11(jjj),nref22(jjj)
          theta0=TThet(j)
          rdeg = 0.5 * TThet(j) * dtor
          cdeg= cos(rdeg)
          tdeg = sin(rdeg) / cos(rdeg)
          tdeg2=tdeg**2
          uvw2=phkl(j,5)
          thminn=amax1(theta0-uvw2,thmin)
          thmaxx=amin1(theta0+uvw2,thmax)
!corr
!corr          ranth=thminn-thmin
!corr          iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr          if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
!corr          ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr          if(iniz.lt.1) iniz = 1
          iniz = clocate(theta_int(:npunti,7),thminn)
          ifin = clocate(theta_int(:npunti,7),thmaxx)
!corr
          if(iniz.lt.ncoun11(jjj)) iniz = ncoun11(jjj)
          if(iniz.gt.ncoun22(jjj)) iniz = ncoun22(jjj)
          if(ifin.gt.ncoun22(jjj)) ifin = ncoun22(jjj)
          if(ifin.lt.iniz) ifin=iniz
          inizc(j) = iniz
          ifinc(j) = ifin
          uvw2=phkl(j,5)*0.3
          thminn=amax1(theta0-uvw2,thmin)
          thmaxx=amin1(theta0+uvw2,thmax)
!corr
!corr          ranth=thminn-thmin
!corr          iniz1 = int ( ( thminn - thmin ) / thstep ) + 1
!corr          if(amod(ranth,thstep).gt.0.0)iniz1=iniz1+1
!corr          ifin1 = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr          if(iniz1.lt.1) iniz1 = 1
          iniz1 = clocate(theta_int(:npunti,7),thminn)
          ifin1 = clocate(theta_int(:npunti,7),thmaxx)
!corr
          if(iniz1.lt.ncoun11(jjj)) iniz1 = ncoun11(jjj)
          if(iniz1.gt.ncoun22(jjj)) iniz1 = ncoun22(jjj)
          if(ifin1.gt.ncoun22(jjj)) ifin1 = ncoun22(jjj)
          do 20 nnn=iniz,ifin
             th = theta_int(nnn,7)
             deltath=(th-theta0)
             deltath2=deltath**2
             if(nprof.eq.1)then
               cc=(1.0+phkl(j,2)*deltath2)
               ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
               asnum=asym*(deltath**3)
               asd1=deltath2
               asd2=1.0/phkl(j,2)
               asden=(asd1+asd2)**1.5
               asterm=asnum/asden+1.0
             elseif(nprof.eq.2)then
               cc=-phkl(j,2)*deltath2
               ffunct=phkl(j,1)*exp(cc)
               asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
             elseif(nprof.eq.3)then
               cc=1.0+phkl(j,2)*deltath2
               ffunct=phkl(j,1)/cc
               asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
             elseif(nprof.eq.4)then
               cc1=-phkl(j,2)*deltath2
               ffunct1=phkl(j,1)*exp(cc1)
               cc2=1.0+phkl(j,4)*deltath2
               ffunct2=phkl(j,3)/cc2
               eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2
               ffunct=(1.0-eta)*ffunct1+eta*ffunct2
               asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
             endif
               profcalc(j,nnn-iniz+1) = ffunct*asterm
   20 continue
   10 continue
      return
      end
c------------------------------------------------------------
c     define overlapping            
      subroutine defovlrr(n1,n2,jjj,nvolte,sog,nmod)    
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
      USE extramodule, only: indovr
!corr      include 'rando.fi'
      USE randofi
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
!corr      common /profp/phkl(3000,6),dumpp,nprof,ipol
      dimension iss(nrefl)
C
C --- Construct of overlapping groups of reflections;
C
      DO 229 JS=n1,n2           
      indovr(JS) = 1
      iss(js)=1
 229  CONTINUE
      nmod=0
      DO 230 JS=n1,n2-1
         If(iss(JS).EQ.0) GO TO 225
            indovr(JS) = 1
!corr            ranth=TThet(js)-thmin
!corr            in = int ( ranth/ thstep ) + 1
            in = clocate(theta_int(:npunti,7),TThet(js))
!corr
            if(in.lt.ncoun11(jjj))in=ncoun11(jjj)
            if(in.gt.ncoun22(jjj))in=ncoun22(jjj)
!corr            rif=back_int(in,1)*thstep
!corr            rif0=theta_int(in,2)*thstep
            DO 220 JG=JS+1,n2                
               IFL = 0
               fwrif=phkl(JG-1,6)
               flim1=0.5*fx(jg-1)
               flim2=1.5*fx(jg-1)
               flim1=0.5*fx(jg-1)
               flim2=1.5*fx(jg-1)
               IF((ABS(Tthet(JG)-Tthet(JG-1)).LE.sog*fwrif)
     *         .and.(fx(jg).ge.flim1.and.fx(jg).le.flim2)) THEN
                  indovr(JS) = indovr(JS)+1
                  do 260 jk=js+1,jg
                  indovr(jk)=indovr(js)
 260              continue
                  iss(jg)=0
                  IFL = 1
               END IF
               IF(IFL.EQ.0) GO TO 225
 220        CONTINUE
 225        CONTINUE
 230  CONTINUE
 295  continue
      DO 239 JS=n1,n2           
      if(indovr(js).ne.1)nmod=nmod+1
 239  CONTINUE
      return
      end
c--------------------------------------------------------------------
      subroutine modback(icontrollo,ier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE PatternRef
      common/genob/irho,thetamin
!corr      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common /pesob/weigb(10000),nsmoothb
c------------
      npb=0
      zero=0.000000001
      if(icontrollo.eq.0)then
        npbb=0
        do i=1,nback
          if(ntyp(i).eq.jjj)then
            npbb=npbb+1
            xb(npbb)=backp(i,1)
            yb(npbb)=backp(i,2)
            tt(npbb)=backp(i,1)
            countmi(npbb)=backp(i,2)
            weig(npbb)= weigb(i)
          endif
        enddo
         bkg(1:11)=bkk(1:11,jjj)         
         go to 1200
       ! go to 1100
      endif
      do 100 i=1,nback
      if(ntyp(i).eq.jjj.and.backp(i,1).gt.0.0)then
      npb=npb+1
      xb(npb)=backp(i,1)
      yb(npb)=backp(i,2)
      weig(npb)=weigb(i)
      endif
 100  continue
!corr      if(jjj.eq.3.and.iprin.gt.0) write(0,*) npb
      jcall=3
      nvari=11
      do 500 i=1,npb
      thhmin=99999999.0
      do 600 j=1,npb
      if(xb(j).le.thhmin)then
      thhmin=xb(j)
      jsav=j
      endif
 600  continue
      xxh(i)=xb(jsav)
      yyh(i)=yb(jsav)
      weigh(i)=weig(jsav)
      xb(jsav)=999999999.0
500   continue
      npbb=0
      do 700 i=1,npb
      if(weigh(i).lt.zero)then
      do 701 j=i+1,npunti
      if(weigh(j).gt.zero)then
      if(i.ge.1)then
      wmin=amin1(weigh(j),weigh(i-1))
      else
      wmin=weigh(j)
      endif
      go to 702
      endif
 701  continue
 702  continue
      weigh(i)=wmin
      endif
      if(xxh(i).gt.0.0)then
      if(npbb.eq.0)then
      npbb=npbb+1
      xb(npbb)=xxh(i)
      yb(npbb)=yyh(i)
      weig(npbb)=weigh(i)
      else
      if(xxh(i).lt.(xb(npbb)-0.00001).or.xxh(i).gt.
     *(xb(npbb)+0.00001))then
      npbb=npbb+1
      xb(npbb)=xxh(i)
      yb(npbb)=yyh(i)
      weig(npbb)=weigh(i)
      endif
      endif
      endif
 700  continue
 1100 continue
      do i=1,npbb
            tt(i)=xb(i)              
            countmi(i)=yb(i)               
      enddo
      call lsqback(npbb,nvari,jcall,jjj,ier)
      if(ier.lt.0)return
      if(iprin.gt.0)then
      write(lo,7000) jjj-1,bkg
 7000 format(/,' *** The background polynomial coefficients',
     *' for the interval number ',i4,'are calculated *** '
     *,/,11f12.3,/,
     *'     The automatic interpolation points have been modified ',
     *' or the polynomial order has been changed ',/)
      write(lo,22)
      endif
 1200 continue
      do 19 i=1,npbb
      thetamin=tmm(jjj)
      ttt=(xb(i)/thetamin-1.0)
      back=bkg(1)
      do 21 k=2,11
      iesp=k-1
      back=back+bkg(k)*(ttt**iesp)
 21   continue
      if(iprin.gt.0)write(lo,7100)(ttt+1.0)*thetamin,
     *yb(i),weig(i),back
   19 continue
 7100 format(4f12.3)
   22 format('       Theta      Countmin      Weight      Backcalc')
c     nback=npbb
      return
      end
c---------------------------------------------------
      subroutine corrmatrix
      USE Riflessi
      USE xdataMod
      USE CalcProfile
      USE Correlazione
      USE Conteggi
      USE General
      USE extramodule, only: inizc,ifinc
!
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
!corr      common /profp/phkl(3000,6),dumpp,nprof,ipol
      common/anna1/sumobs,sumobsnobac
!corr      common/anna2/inizc(3000),ifinc(3000)
      dimension a(nrefl,nrefl),y(nrefl,nrefl),indx(nrefl)
c-
      call AllocaCalcprofile(1)
      call AllocaCorrelazione(1)
      jjj=nnt
      call CalcProff(jjj,ier)
      do 10 i=1,nrefl
      do 20 j=1,nrefl
      correl(i,j)=0.0
 20   continue
 10   continue
      do 100 i=1,nrefl                       
      iniz1 = inizc(i)
      ifin1 = ifinc(i)
      do 200 j=i,nrefl
      iniz2 = inizc(j)
      ifin2 = ifinc(j)
      summo=0.0
      iniz=iniz1
      ifin=ifin2
      w1=0.0
      do 300 nnn=iniz,ifin
      p1=0.0
      p2=0.0
      if(theta_int(nnn,2).gt.0.00001) w1=1.0/theta_int(nnn,2)
      if(nnn.ge.iniz1.and.nnn.le.ifin1) p1=profcalc(i,nnn-iniz1+1)
      if(nnn.ge.iniz2.and.nnn.le.ifin2) p2=profcalc(j,nnn-iniz2+1)
      summo=summo+(scala(nnt)**2)*p1*p2*w1
  300 continue
      correl(i,j)=summo*thstep
      correl(j,i)=summo*thstep
  200 continue
  100 continue
c     do 500 i=1,nrefl
c     write(6,'(3x,3000(i6))')(j,j=1,nrefl)
c     write(6,'(i3,3000(f6.3))')i,(correl(i,j),j=1,nrefl)
c500  continue
      do 510 i=1,nrefl
      do 520 j=1,nrefl
      correlation(i,j)=correl(i,j)/sqrt(correl(i,i)*correl(j,j))
      a(i,j)=correl(i,j)
 520  continue
c     write(6,*)i,(correlation(i,j),j=1,nrefl)
 510  continue
c     do 550 i=1,nrefl
c     do 560 j=1,nrefl
c     y(i,j)=0.0
c560  continue
c     y(i,i)=1.0
c550  continue
c     n=nrefl
c     np=nrefl
c     call ludcmp(a,n,np,indx,d)
c     do 570 j=1,nrefl
c     call lubksb(a,n,np,indx,y(1,j))
c570  continue
c     do 580 i=1,nrefl
c     do 590 j=1,nrefl
c     variance(i,j)=y(i,j)
c590  continue
c     write(6,*)i,(variance(i,j),j=1,nrefl)
c580  continue
      do 700 i=1,nrefl
      if(abs(fx(i)).gt.0.000001)then
c     stand(i)=variance(i,i)
      stand(i)=1.0/correl(i,i)
      else
      stand(i)=0.0
      endif
      if(stand(i).gt.0.000001)then
c     weight(i)=1.0/sqrt(stand(i))
      weight(i)=1.0/(stand(i))
      else
      weight(i)=0.0               
      endif
 700  continue
      if(iknow.gt.0)then
      smfo=0.0
      smfc=0.0
      do 1000 i=1,nrefl
      fcc=(fxsav(i)**2)*mult(i)*clp(i)
      smfo=smfo+fx(i)
      smfc=smfc+fcc
 1000 continue
      scall=smfc/smfo
      smdf=0.0
      smdfw=0.0
      n1=0
      n2=0
      do 1100 i=1,nrefl
c     if(weight(i).gt.0.5)then
c     weight(i)=1.0
c     n1=n1+1
c     else
c     weight(i)=0.0
c     n2=n2+1
c     endif
      fcc=(fxsav(i)**2)*mult(i)*clp(i)
      smdf=smdf+abs(fcc-scall*fx(i))
      smdfw=smdfw+abs(fcc-scall*fx(i))*weight(i)
      write(6,*)i,stand(i),weight(i),fcc,scall*fx(i),
     *abs(fcc-scall*fx(i))/fcc
 1100 continue
c     write(6,*)'ERRE',smdf/smfc,smdfw/smfc,n1,n2
      endif
      call AllocaCalcprofile(2)
      call AllocaCorrelazione(2)
      return
      end
c----------------------------------------------------
      subroutine smoothbkg(wrange)     
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE ProfileApp
      USE General
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      call AllocaProfileApp(1)
      do 100 i=1,npunti
      theta_app(i,2)=theta_int(i,2)
 100  continue
      thetamed=0.0
      thetamin=9999999.0
      do 200 i=1,npunti
      thetamed=thetamed+theta_app(i,2)
      if(theta_app(i,2).lt.thetamin)thetamin=theta_app(i,2)
 200  continue
      thetamed=thetamed/float(npunti)
      thetasog=thetamed+2.0*(thetamed-thetamin)
      do 300 i=1,npunti
      if(theta_app(i,2).gt.thetasog)theta_app(i,2)=thetasog
 300  continue
      nn=int(wrange/thstep)
      nvolte=25
      do 350 k=1,nvolte
      do 400 i=1,npunti
      thmed=0.0
      i0=0
      do 500 j=i-nn,i+nn
      if(j.le.0)go to 500
      if(j.gt.npunti)go to 500
      i0=i0+1
      thmed=thmed+theta_app(j,2)
 500  continue
      thmed=thmed/float(i0)
      if(thmed.lt.theta_app(i,2))theta_app(i,2)=thmed
 550  continue
 400  continue
 350  continue
      do 600 i=1,npunti
      if(theta_app(i,2).lt.theta_int(i,2))then
      back_int(i,1)=theta_app(i,2)
      else
      back_int(i,1)=theta_int(i,2)
      endif
 600  continue
      call AllocaProfileApp(2)
      noback=1
      return
      end
c--------------------------------------------------------------
      subroutine extrainit
c     routine for initializing some variable values
      USE Conteggi
      USE ProfileApp
      USE Deriv
      USE ExtraIndix
      USE General
      USE PatternRef
!!!!corrado      include 'extrainc.fi'
      common/stamp/pr_string(32),proff(10),profile,fileh,formt,timet
      character pr_string*8,proff*11
      character*80 fileh,formt,timet
      character profile*11
      common/superandom/iix,iiy,ntrial,irandom,sograndom
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
      common /pesob/weigb(10000),nsmoothb
corrado
*      common/rc/pp(6),cell(9),nrefl,nbWils,rhomax,mm,en,mz,er,th,rhomin
c
      Msg='          '
      iera=0
      ierb=0
      iiy=67543
      iix=iiy
      mxbg  = 30000
      do 50 i=1,45000
      sint(i)=sin(dtor*float(i-1)/100.)
   50 continue
      do 49 i=1,5000
      weigb(i)=1.0
 49   continue
      asym=0.0
      zeroprof=0.0
      scal=1.0
      frac=0.0
      fracout=0.0
      iflag=0
      itype=1
      iform=2
      pr_string( 1)=' Scale  '
      pr_string( 2)=' Zero   '
      pr_string( 3)=' Fwhm   '
      pr_string( 4)=' Fwhm   '
      pr_string( 5)=' Fwhm   '
      pr_string( 6)=' Asym   '
      pr_string( 7)=' Mix.par'
      pr_string( 8)=' Mix.par'
      pr_string( 9)=' Mix.par'
      pr_string(10)=' Astar  '
      pr_string(11)=' Bstar  '
      pr_string(12)=' Cstar  '
      pr_string(13)=' Alphas '
      pr_string(14)=' Betas  '
      pr_string(15)=' Gammas '
      pr_string(16)=' Back-1 '
      pr_string(17)=' Back-2 '
      pr_string(18)=' Back-3 '
      pr_string(19)=' Back-4 '
      pr_string(20)=' Back-5 '
      pr_string(21)=' Back-6 '
      pr_string(22)=' Back-7 '
      pr_string(23)=' Back-8 '
      pr_string(24)=' Back-9 '
      pr_string(25)=' Back-10'
      pr_string(26)=' Back-11'
      pr_string(27)=' pp(1)   '
      pr_string(28)=' pp(2)   '
      pr_string(29)=' pp(3)   '
      pr_string(30)=' pp(4)   '
      pr_string(31)=' pp(5)   '
      pr_string(32)=' pp(6)   '
      return
      end
c----------------------------------------------------------
      subroutine priorinf(nfspace)
c     routine for setting prior information
      USE Conteggi
      USE ProfileApp
      USE Deriv
      USE ExtraIndix
      USE General
      USE RandomStaff, only:iprandom
      USE PatternRef
!!!!corrado      include 'extrainc.fi'
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /scmess/MessH,Messages
      character *80 MessH,Messages(200)
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/stima/nstima,ncodecyc
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /pref/ nplane,jplane(3),gmax,ipref,sogg,iusep,sogpse
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
!!!!corrado
      character cff
c
!corr   10 format(///,a1,78('+'),//,
!corr     1 43h expo2005 : Intensities eXtraction routine ,22x,
!corr     214hRelease  02.01,/,/,20x,20a4,/,1h ,78('+'),//)
CORO
      if(ipriort.ne.0) go to 1
CORO
      if(iext.ne.3.and.npseu.ne.1.and.iprandom.ne.1.and.ialt.ne.2)then
         ipriort=0
         ipriorp=0
         ipriors=0
         ipriopa=0
         ipriofr=0
         iprioro=0
         ipref = 0
      endif
 1    continue
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
      iprio = max0(ipriorp,ipriors)
      if (ipriorp.gt.0)  ipriosta = 2
      if (ipriors.gt.0) then
          ncodecyc = 2
          ipriosta = ncodecyc
      endif
      if ((iprio.eq.0.or.iprio.eq.ipriosta).and.nfspace.eq.0) then
          call write_inte_routine('Intensities eXtraction')
      endif
      if (ipriopa.eq.1.and.ipriofr.eq.0.and.nfspace.eq.0) write(lo,15)
      if (ipriorp.eq.2.and.ipriofr.eq.0.and.nfspace.eq.0) write(lo,16)
      if (ipriors.eq.2.and.ipriofr.eq.0.and.nfspace.eq.0) write(lo,17)
      if (ipriofr.eq.1.and.nfspace.eq.0) write(lo,18) 
   15 format(/,10x,'***   Modified Patterson map has been used as   ***'
     &       /,10x,'***           prior information in Extra        ***'
     &       ,/)
   16 format(/,10x,'***   pseudotranslational symmetry has been used as'
     &,'   ***',/,10x,'***            prior information in Extra      ',
     & '       ***',/)
!corr   17 format(/,10x,'***   Probabilistic |E|',2h's,
   17 format(/,10x,"***   Probabilistic |E|'s",
     &       ' estimation has been used as   ***',
     &       /,10x,'***            prior information in Extra',
     & '               ***',/)
   18 format(/,10x,'***   Structural fragment has been used as   ***',
     &       /,10x,'***         prior information in Extra    ',
     & '   ***',/)
      izz = 32
      if (ipriorp.gt.0) then
          write(Messages(icomat)(1:izz),19)
      endif  
      if (ipriors.gt.0) then
          write(Messages(icomat)(1:izz),20)
      endif  
      if (ipriopa.gt.0) then
          write(Messages(icomat)(1:izz),21)
      endif  
      if (iprandom.gt.0) then
          write(Messages(icomat)(1:izz),23)
      endif  
      if (ipriofr.gt.0) then
          write(Messages(icomat)(1:izz),22)
      endif  
c
   19 format('  Pseudo symmetry actively used ')
   20 format(' Prob. estimation actively used ')
   21 format(' Patt. information actively used')
   22 format(' Frag. information actively used')
   23 format(' Random procedure used')
      return
      end
c----------------------------------------------------
      subroutine extra1(kscreen,nrun,nfspace,fracsing,ksmoo,ier)
c     routine for setting prior information
      USE Conteggi
      USE ProfileApp
      USE Deriv
      USE ExtraIndix
      USE VIEW
      USE General
      USE RandomStaff, only:iprandom
      USE PatternRef
      USE messagemod

      common/stamp/pr_string(32),proff(10),profile,fileh,formt,timet
      character pr_string*8,proff*11
      character*80 fileh,formt,timet
      character profile*11
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/genob/irho,thetamin
!corr      common/genob2/thmin,thmax,thstep
      common /backp2/ npol(10)
      common /profp/dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common /limiti/ nlini, nlfin
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/try/itrysav,psav(12),nvolte
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common /celsav/cellas(6),porig(6)
      common/nmmn/ nmm1(10),nmm2(10),nmm11(10),nmm22(10)
      common/good/ fwhgood(4),betagood(4),fracgood(4),asymgood(4),
     *zerogood(4),pr_oldgood(26),p_good(12,4),nprofgood,nosingsav
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
      common/savv/fwhsav,betasav,uvwtsav
      character*100 MsgB
!
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
!
c
      call extrainit
      iln=37
      call srlin (iln,lsn,lix37,ljxx,lkxx,llxx)
      if (lix37.gt.0) then
          call ysfl37(npunti)
        else
          write(Msg,8)
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          ier=-1
          return
  8       format('No counts in direct acces file')
      endif
      call AllocaExtraIndix(1)
      call AllocaConteggi(1)
      call AllocaDeriv(1)
!corr      call dirext(fileh,formt,nrun,ityp,fracout,ioptim,
!corr     *   nridb,nfspace,ksmoo,ier)
      call dirext(fileh,formt,nrun,ityp,nridb,nfspace,ksmoo,ier)
CATTENZ
c     noint=2
CATTENZ
      if(iprandom.gt.0)asym=0.0
      if(ialt.gt.0.and.nfspace.eq.0)write(lo,1088)
 1088    format(/,18x,'***   Difference Plot Procedure  ***'
     &          ,/)
      if(neutro.eq.1)then
       sogran=19.0
      else
       if(nsyn.eq.0)then
         sogran=8.0
        else
         sogran=4.0
        endif
      endif
      ipriort=ipriorp+ipriors+ipriopa+ipriofr
      if(thmax-thmin.le.sogran.and.itry.eq.0)then
       ipol=1
       do 888 i=1,10
       npol(i)=2
 888   continue
      endif
      if(fracout.gt.0.0)frac=fracout
      call reflin(ier)
      if (ier.lt.0) return                  
      if (nrefl.le.0) then
          write(Msg,448)
          ier=-1
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          return
      endif
  448    format('No reflections supplied')
c
      call priorinf(nfspace)
      if(iext.ne.0.and.iext.le.2)call extf(fileh,formt,ityp,ier)
      if (ier.lt.0) return             
      npoint=npunti
      call profin(npoint,nridb,nfspace,ier)
         call ysfr37(npunti)
      call AllocaProfileApp(1)
      do 7777 i=1,npunti
      theta_app(i,1)=theta_int(i,1)
      theta_app(i,2)=theta_int(i,2)
      theta_app(i,3)=theta_int(i,3)
      theta_app(i,4)=theta_int(i,4)
      theta_app(i,5)=theta_int(i,5)
      theta_app(i,6)=theta_int(i,6)
      theta_app(i,7)=theta_int(i,7)
      back_app(i,1)=back_int(i,1)
      back_app(i,2)=back_int(i,2)
 7777 continue
      call AllocaConteggi(2)
      npunti=npoint
      call AllocaConteggi(1)
      do 7778 i=1,npunti
      theta_int(i,1)=theta_app(i,1)
      theta_int(i,2)=theta_app(i,2)
      theta_int(i,3)=theta_app(i,3)
      theta_int(i,4)=theta_app(i,4)
      theta_int(i,5)=theta_app(i,5)
      theta_int(i,6)=theta_app(i,6)
      theta_int(i,7)=theta_app(i,7)
      back_int(i,1)=back_app(i,1)
      back_int(i,2)=back_app(i,2)
 7778 continue
      call AllocaProfileApp(2)
      if(itry.eq.0.and.ipriort.eq.0)then
       do 441 i=1,npunti
       theta_int(i,4)=theta_int(i,1)
       theta_int(i,5)=theta_int(i,2)
 441   continue
      endif
      if (npunti.le.0) then
          write(Msg,449)
          ier=-1
          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
          return
      endif
  449 format('No counts supplied')
      if(itry.ne.0.or.ipriort.ne.0)then
       do 3 i=1,3
       abc(i)=cell(i)
       ang(i)=cell(i+3)
   3   continue
      else
       do 4 i=1,3
       abc(i)=cellas(i)
       ang(i)=cellas(i+3)
   4   continue
      endif
      if(itry.eq.0)call senti
      pp(1)=0.25*(astar**2)
      pp(2)=0.25*(bstar**2)
      pp(3)=0.25*(cstar**2)
      pp(4)=0.25*(2.0*astar*bstar*coscs )
      pp(5)=0.25*(2.0*astar*cstar*cosbs )
      pp(6)=0.25*(2.0*bstar*cstar*cosas )
      do 125 i=1,6
      psav(i)=pp(i)
 125  continue
      psav(7)=astar
      psav(8)=bstar
      psav(9)=cstar
      psav(10)=cosas
      psav(11)=cosbs
      psav(12)=coscs
c------
      fwhsav=0.0
      betasav=0.0
      zero=0.00000001
      zerosav=zeroprof
      if (itry.eq.0)then
          nosingsav=nosing
          if(ipriort.eq.0)then
           call setsing(fracout,uvwtsav,fracsing,ibecare)
            if (ibecare.eq.1) then
            if (ispaceindexing.eq.0) then
                write(Msg,447)
                call MsgWinErr('Warning',Msg,WARN_WINDOW,nExitCode)        
            endif
  447       format('Be careful: the automatic selection of the single ',
     *      'peak can be wrong')
           endif
          endif
          if(izero.ne.0)zeroprof=zerosav*0.5
          zerowrite=zeroprof
          if (abs(zeroprof).gt.zero) then
              do 8000 i=1,npunti
              theta_int(i,1)=theta_int(i,1)-2.0*zeroprof
              theta_int(i,7)=theta_int(i,7)-2.0*zeroprof
 8000         continue
              thmin=theta_int(1,1)
              thmax=theta_int(npunti,1)
              thet1(1)=thet1(1)-2.0*zeroprof
              thet11(1)=thet1(1)
              thet2(1)=thet2(1)-2.0*zeroprof
              thet22(1)=thet2(1)
              thet22(1)=thet2(1)
          endif
      endif
      zeroprof=0.0
      if(itry.eq.0.and.ipriort.eq.0)call setint
      imodint=0
      if(itry.gt.0)go to 444
      if(kscreen.gt.0.and.ipriort.eq.0)then
 598   continue
       nlini=1
       nlfin=npunti
!corr       ipun=2
       jjj=200
       if(noint.eq.1)then
       iStop = 0
      else
       iStop = 1
      endif
!corr      iAction = 2
!corr      thminsav=thmin
!corr      thmaxsav=thmax
      if (ispaceindexing == 0) then
!corr         call SetRowCountMesg(3)
         write(MsgB,162)nnt-2
 162     format('The pattern has been divided into ',i0,' intervals ')
             call write_message(MsgB,pos=2,kproc=0)
             call scrper(' ',0,-1,1)
         call vedinew(2,1,npunti)
         MsgB = 'Press "Pattern>>Intervals" to modify predefined' 
     *             //' intervals or'
     *            //' "Next" to go on'
             call write_message(MsgB,pos=3,kproc=0)
             call scrper(' ',0,-1,1)
      endif
!corr      thmin=thminsav
!corr      thmax=thmaxsav
      endif                      ! chiudi if su kscreen
  444 continue
      thetsav1=thet1(1)
      thetsav2=thet2(1)
      ncounsav1=ncoun1(1)
      ncounsav2=ncoun2(1)
      if (iprio.eq.0.or.iprio.eq.ipriosta)  then
          if(iprin.gt.0.and.nfspace.eq.0) then
             zzero = 2.0 * zeroprof
             write(lo,7999) nnt-2
             write(lo,7998) zerowrite
             if(nosing.eq.0) then
                write(lo,7997) thetsav1,thetsav2
                write(lo,7996) fracsing
              else
                write(lo,7995) frac
             endif
          endif
      endif
 7999 format(3x,'The pattern has been divided in ',i4,' intervals ',/)
 7998 format(3x,'Profile has been corrected by a zero shift = ',f6.3,/)
 7997 format(3x,'Standard peak from',f9.4,' to',f9.4,/)
 7996 format(3x,'Initial peak width    = ',f8.2,' * fwhm ',/)
 7995 format(3x,'Peak width            = ',f8.2,' * fwhm ',/)
      return
      end
c----------------------------------------------------
      subroutine changeint(ier)
c     routine for setting prior information
      USE Conteggi
      USE ProfileApp
      USE Deriv
      USE ExtraIndix
      USE General
      USE Molcom      
      USE PatternRef
      common/genob/irho,thetamin
!corr      common/genob2/thmin,thmax,thstep
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/nmmn/ nmm1(10),nmm2(10),nmm11(10),nmm22(10)
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
      common/savv/fwhsav,betasav,uvwtsav

      imodint = 0                      !mr 290711
      if(neutro.eq.1)then
       sogran=19.0
      else
       if(nsyn.eq.0)then
          sogran=8.0
       else
          sogran=4.0
       endif
      endif
      do 201 j=2,nnt-1
         if(nmm1(j).ne.ncoun1(j).or.nmm2(j).ne.ncoun2(j)) imodint=1      
            dfthet=theta_int(ncoun2(j),7)-theta_int(ncoun1(j),7)
            if(dfthet.le.sogran.and.thmax-thmin.gt.sogran)then
            imodint=4
            jwrong=j-1
            go to 203
         endif
201   continue
      if(nmm1(1).ne.ncoun1(1).or.nmm2(1).ne.ncoun2(1)) then
         dtheta=theta_int(ncoun2(1),1)-theta_int(ncoun1(1),1)
         if (neutro.eq.0) then
             dthetsog=3.0
         else
             dthetsog=4.0
         endif
         if (dtheta.gt.dthetsog.and.nosing.eq.0) then  !Picco singolo troppo grande
             write(Msg,443)dthetsog
             call MsgWinErr('Warning',Msg,WARN_WINDOW,nExitCode)        
             ncoun1(1)=nmm1(1)
             ncoun2(1)=nmm2(1)
             ncoun11(1)=nmm11(1)
             ncoun22(1)=nmm22(1)
             theta_left(1) = thet1(1)
             theta_right(1) = thet2(1)
             ier = -1
             return
          endif
          imodint=2
      endif
203   continue
      if(imodint.eq.4)then                             ! Intervallo troppo grande
         write(Msg,264)jwrong,sogran
         call MsgWinErr('warning',Msg,WARN_WINDOW,nExitCode)        
         ncoun1(jwrong+1)=nmm1(jwrong+1)
         ncoun2(jwrong+1)=nmm2(jwrong+1)
         ncoun11(jwrong+1)=nmm11(jwrong+1)
         ncoun22(jwrong+1)=nmm22(jwrong+1)
         theta_left(jwrong+1) = thet1(jwrong+1)
         theta_right(jwrong+1) = thet2(jwrong+1)
         imodint=0
         ier = -1
         return
      endif
      inoref=0
      if(imodint.gt.0)call modint(inoref,kwrong)
      if(inoref.gt.0)then                              ! Non ci sono riflessi
         if(kwrong.gt.0)then
            write(Msg,206)kwrong                       ! nell'intervallo  
         else
            write(Msg,207)                             ! nel picco singolo  
         endif
         call MsgWinErr('warning',Msg,WARN_WINDOW,nExitCode)        
         ncoun1(kwrong+1)=nmm1(kwrong+1)
         ncoun2(kwrong+1)=nmm2(kwrong+1)
         ncoun11(kwrong+1)=nmm11(kwrong+1)
         ncoun22(kwrong+1)=nmm22(kwrong+1)
         inoref=0
         call modint(inoref,kwrong)
         theta_left(kwrong+1) = thet1(kwrong+1)
         theta_right(kwrong+1) = thet2(kwrong+1)
         imodint=0
         ier = -1
         return
      endif
      if(imodint.eq.2.and.nosing.eq.0)call modsing(uvwtsav)
      do j=2,nnt-1
         if(ncoun2(j).lt.ncoun1(j+1))then                 ! Intervalli non in sovrapposizione
            write(Msg,205)j-1,j
            call MsgWinErr('warning',Msg,WARN_WINDOW,nExitCode)        
            ncoun1(j)=nmm1(j)
            ncoun2(j)=nmm2(j)
            ncoun11(j)=nmm11(j)
            ncoun22(j)=nmm22(j)
            ncoun1(j+1)=nmm1(j+1)
            ncoun2(j+1)=nmm2(j+1)
            ncoun11(j+1)=nmm11(j+1)
            ncoun22(j+1)=nmm22(j+1)
            inoref=0
            call modint(inoref,kwrong)
            theta_left(j) = thet1(j)
            theta_right(j) = thet2(j)
            theta_left(j+1) = thet1(j+1)
            theta_right(j+1) = thet2(j+1)
            imodint=0
            ier = -1
            return
         endif
      enddo
      thetsav1=thet1(1)
      thetsav2=thet2(1)
      ncounsav1=ncoun1(1)
      ncounsav2=ncoun2(1)
!
  443 format('You selected a single peak whose range is ',
     *'greater than',f6.3,' degrees :','try again to modify it')
  264 format('You have selected the interval ',i3,
     *' whose range is less than',f8.2,' degrees : modify again')
  206 format('You have selected the interval ',i3,
     *' without reflections:try again to modify it')
  207 format('You have selected the single peak interval '
     *,' without reflections:try again to modify it')
  205 format('The selected intervals',2i3,' are not in overlapping :',
     *'try again to modify them')           
!
      return
      end
c-------------------------------------------------
      subroutine extra2(nrun,nfspace,fracsing,ksmoo,ier)
      USE Conteggi
      USE ProfileApp
      USE Deriv
      USE ExtraIndix
      USE ssmoothing
      USE VIEW
      USE nrtype
      USE Molcom
      USE General
      USE PatternRef
      USE messagemod
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common /limiti/ nlini, nlfin
      common /pesob/weigb(10000),nsmoothb
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
      character*100 MsgB
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
!!!!corrado
      dimension ysm(3*npunti)
      integer oder,opol
      integer(I4B)        :: nleft
c
      if(ipriort.eq.0.and.noback.eq.0.and.nsmoothb.eq.0)then
        call AllocaProfileApp(1)
c
         do i=1,npunti
           theta_app(i,4)=theta_int(i,2)
         enddo
        if(ksmoo.eq.1)then
          do i=1,npunti
             ysm(i)=theta_int(i,2)
          enddo
          pts =4.
          npunti0=npunti
          call smooft(ysm,npunti0,pts)
          do i=1,npunti
             theta_int(i,2)=ysm(i)
          enddo
c       else
c        nleft=1
c        nright=1
c        oder=0
c        opol=2
c        theta_int(:,2)=
c    *  savgol_smooth(theta_int(:,2),nleft,nright,oder,opol)
       endif
        do i=1,npunti
          theta_app(i,6)=theta_int(i,1)
          theta_app(i,7)=theta_int(i,2)
        enddo
        wrange=0.5*frac*sqrt(uvwt(1))
        call setback(wrange,ier)
        if(ier.lt.0)return
        do i=1,npunti
          theta_int(i,1)=theta_app(i,6)
          theta_int(i,2)=theta_app(i,7)
        enddo
c
        call treatforback
c
         do i=1,npunti
           theta_int(i,2)=theta_app(i,4)
         enddo
c
        call AllocaProfileApp(2)
      endif
      if(ipriort.eq.0.and.nsmoothb.gt.0)then
         wrange=0.5*frac*sqrt(uvwt(1))
         call smoothbkg(wrange)
      endif
      if (kscreen > 0) then
        if(noint.eq.1)then
        iStop = 0
        else
        iStop = 1
        endif
        if (ispaceindexing.eq.0) then
            call vedinew(3,1,npunti)
            MsgB = 'Press "Pattern>>Background" to modify the default '
     *               //'background or "Next" to go on'
                call write_message(MsgB,pos=3)
        endif
      endif
      return
      end
c-------------------------------------------------
      subroutine setpara(nvar,var)  
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE ProfileApp
      USE Deriv
      USE ExtraIndix
      USE General
      USE PatternRef
      integer, intent(in) :: nvar
      real, dimension(:), intent(in) :: var
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /profp/dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /save/npolsav(10),refv(32,10)   !,fwb(3000,2)
      !common /savev/var(3100)
c
!corr      common/bdata/ibig(124000)
c
      if(jjj.gt.2)then
        do 585 kk=1,32
        refv(kk,jjj-1)=var(nvar+kk)
 585    continue
        if(jjj.gt.3)then
          krif=nref1(jjj-1)-1
          fwrif1=fwb(krif,1)
          fwrif2=fwb(krif,2)
          do 1085 k=nref1(jjj-1),nref2(jjj-1)
            if(phkl(k,6).gt.fwrif1)then
            go to 1085
            else
            go to 1087
            endif
1085      continue
          fwcor=phkl(nref1(jjj-1),6)-fwrif1
          do 1086 k=nref1(jjj-1),nref2(jjj-1)
          phkl(k,6)=phkl(k,6)-fwcor 
1086      continue
1087      continue
          do 1095 k=nref1(jjj-1),nref2(jjj-1)
            if(phkl(k,6).lt.fwrif1)then
            go to 1095
            else
            go to 1097
            endif
1095      continue
          fwcor=fwrif1-phkl(nref1(jjj-1),6)
          do 1096 k=nref1(jjj-1),nref2(jjj-1)
          phkl(k,6)=phkl(k,6)+fwcor
1096      continue
1097      continue
        endif
        do 685 kk=nref1(jjj-1),nref2(jjj-1)
          fwb(kk,1)=phkl(kk,6)
          if(nprof.ne.4)then
          fwb(kk,2)=phkl(kk,3)
          else
          rdeg = 0.5 * TThet(kk) * dtor
          tdeg = sin(rdeg) / cos(rdeg)
          tdeg2 = tdeg * tdeg
          fwb(kk,2)=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2
          endif
          if(jjj.gt.3.and.kk.ge.nref1(jjj-1).and.kk.le.nref2(jjj-2))then
          ex(kk)=(ex(kk)+fx(kk))*0.5
          else
          ex(kk)=fx(kk)
          endif
 685    continue
      endif
      return
      end
c-------------------------------------------------
      subroutine extra3(nrun,nfspace,fracsing,ier)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE ProfileApp
      USE Deriv
      USE ExtraIndix
      USE VIEW, only : vedinew
      USE Molcom
      USE General
      USE PatternRef
      USE arrayutil
      USE messagemod
      USE enable_amb
      USE proginterface
      USE variables, only:ref,cryst
      USE unit_cell
      USE extramodule, only: icare
      USE nr, only: indexx
      USE randofi
      use reflection_type_util, only: rhof
      interface
        subroutine setpara(nvar,var)
        integer, intent(in)            :: nvar
        real, dimension(:), intent(in) :: var
        end subroutine setpara
      end interface
      common/stamp/pr_string(32),proff(10),profile,fileh,formt,timet
      character pr_string*8,proff*11
      character*80 fileh,formt,timet
      character profile*11
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/genob/irho,thetamin
      common/errer/erreprof,erreprofw,erre_old,erref,errerif
      common /backp2/ npol(10)
      common /profp/dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      real, dimension(:), allocatable :: var
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/try/itrysav,psav(12),nvolte
      common/pri/ pr_old(32),stdv(32),rprof(100),rprofw(100),rproff(10),
     *rprofwf(10),reffe(100),reffef(100),rprofA(100),rproffA(100)
      common/good/ fwhgood(4),betagood(4),fracgood(4),asymgood(4),
     *zerogood(4),pr_oldgood(26),p_good(12,4),nprofgood,nosingsav
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
      common/savv/fwhsav,betasav,uvwtsav
      dimension ivett(3),cel(6) 
      common/anna/ncounmax
      common /peak/xxmax(200),yymax(200),fw(200),npk,asm(200)
      common /peak_noghost/noghost
      dimension ffw(nrefl)
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
!bug-corr      integer, dimension(nrefl) :: iorder
      integer, dimension(:), allocatable :: iorder
c
      kgo_refine = 0
      call new_array(var,nrefl+100)
!
      call provajsys()
 1    iera=0
      iStop=0
      kgo=0
      iinit=1
      iiend=60
      if(istep_extra.lt.0)then
         if (kgo_refine == CYCLE_EVENT) then
             kgo = 1
         else
             kgo = 0
         endif
         if(kgo.eq.1)then
            ioptim=1
            jjjsav=iabs(istep_extra)
            jinit=jjjsav
            jiend=nnt
            istep_extra=3
            iinit=2
            nstop=0
            go to 499
         else
            jjjsav=iabs(istep_extra)
            if(jjjsav.lt.nnt)then
               jinit=jjjsav+1
               jiend=nnt
               istep_extra=3
               go to 499
            else
               istep_extra=3
               go to 199
            endif
         endif
         jjjsav=iabs(istep_extra)
         jinit=jjjsav+1
         jiend=nnt
         istep_extra=3
         go to 499
      endif
      nprofgood=nprof
      do 485 j=1,4
      fracgood(j)=frac
      p_good(1,j)=pp(1)
      p_good(2,j)=pp(2)
      p_good(3,j)=pp(3)
      p_good(4,j)=pp(4)
      p_good(5,j)=pp(5)
      p_good(6,j)=pp(6)
      p_good(7,j)=astar
      p_good(8,j)=bstar
      p_good(9,j)=cstar
      p_good(10,j)=cosas
      p_good(11,j)=cosbs
      p_good(12,j)=coscs
 485  continue
      if(itry.eq.0)then
        if(ipriort.eq.0)then
        jinit=1
        else
        jinit=2
        endif
      else
        jinit=nnt
      endif
      jiend=nnt
 499  continue
corrado
!      if (ispaceindexing==0) call scrper(' ',0,0)
      if (ispaceindexing==0) call progress_bar_init()
corrado
      do 185 jjj=jinit,jiend
      if(noghost.eq.1) then
       if(jjj.eq.(nnt)) then
         do i=1,nrefl
           ffw(i)=phkl(i,6)
         end do
         call ghost_extra(ffw)
       endif
      endif
      if(kgo.eq.1)then
      iinit=2
      iiend=nvolte
      nstop=0
      go to 288
      else
      iinit=1
      iiend=nvolte
      endif
      if(itry.gt.0)go to 688
      call setpara(nvar,var)
 688  nstop=0
      if(iproff.eq.1)then
      jjjrif=1
      elseif(iproff.eq.2)then
      jjjrif=2
      else
      jjjrif=jjj
      endif
      if(iproff.gt.0.and.jjj.le.jjjrif)then
             nprob=4
             else
             nprob=1
      endif
 288  continue
      do 188 ijk=1,nprob
      if(kgo.gt.0)go to 154
      if(nprob.ne.1)then
           if(jjj.eq.1)then
           thet1(jjj)=thetsav1
           thet2(jjj)=thetsav2 
           thet11(jjj)=thetsav1 
           thet22(jjj)=thetsav2   
           ncoun1(jjj)=ncounsav1        
           ncoun2(jjj)=ncounsav2      
           ncoun11(jjj)=ncounsav1       
           ncoun22(jjj)=ncounsav2      
           endif
           nprof=ijk
             if(iprin.gt.0.and.nfspace.eq.0)then
               if(nprof.eq.1)then
               write(lo,195)
               elseif(nprof.eq.2)then
               write(lo,196)
               elseif(nprof.eq.3)then
               write(lo,197)
               elseif(nprof.eq.4)then
               write(lo,198)
  195          format(/,22x,'A Pearson function will be used')
  196          format(/,22x,'A Gaussian function will be used')
  197          format(/,22x,'A Lorentzian function will be used')
  198          format(/,22x,'A Pvoigt function will be used')
  295          format(/,20x,'A Pearson function has been selected')
  296          format(/,20x,'A Gaussian function has been selected')
  297          format(/,20x,'A Lorentzian function has been selected')
  298          format(/,20x,'A Pvoigt function has been selected')
               endif
             endif
           if(jjj.gt.1.and.itry.eq.0)then
           fwhsav=fwhgood(ijk)
           betasav=betagood(ijk)
           asym=asymgood(ijk)
           zeroprof=zerogood(ijk)
           pp(1)=p_good(1,ijk)
           pp(2)=p_good(2,ijk)
           pp(3)=p_good(3,ijk)
           pp(4)=p_good(4,ijk)
           pp(5)=p_good(5,ijk)
           pp(6)=p_good(6,ijk)
           astar=p_good(7,ijk)
           bstar=p_good(8,ijk)
           cstar=p_good(9,ijk)
           cosas=p_good(10,ijk)
           cosbs=p_good(11,ijk)
           coscs=p_good(12,ijk)
           endif
           frac=fracgood(ijk)
      else
           nprof=nprofgood
           if(iprin.gt.0.and.nfspace.eq.0)then
             if(nprof.eq.1)then
               if(iproff.gt.0)then
               write(lo,295)
               else
               write(lo,195)
               endif
             elseif(nprof.eq.2)then
               if(iproff.gt.0)then
               write(lo,296)
               else
               write(lo,196)
               endif
             elseif(nprof.eq.3)then
               if(iproff.gt.0)then
               write(lo,297)
               else
               write(lo,197)
               endif
             elseif(nprof.eq.4)then
               if(iproff.gt.0)then
               write(lo,298)
               else
               write(lo,198)
               endif
             endif
           endif
           if(iproff.gt.0.and.nstop.lt.3)then
           fwhsav=fwhgood(nprof)
           betasav=betagood(nprof)
           asym=asymgood(nprof)
           zeroprof=zerogood(nprof)
           pp(1)=p_good(1,nprof)
           pp(2)=p_good(2,nprof)
           pp(3)=p_good(3,nprof)
           pp(4)=p_good(4,nprof)
           pp(5)=p_good(5,nprof)
           pp(6)=p_good(6,nprof)
           astar=p_good(7,nprof)
           bstar=p_good(8,nprof)
           cstar=p_good(9,nprof)
           cosas=p_good(10,nprof)
           cosbs=p_good(11,nprof)
           coscs=p_good(12,nprof)
           endif
           if(iproff.gt.0)frac=fracgood(nprof)
      endif
      if(nstop.eq.3)go to 387
      thetamin=tmm(jjj)
      do 187 j=1,npol(jjj)
      bkg(j)=bkk(j,jjj)
187   continue
 387  continue
      if (iprio.eq.0.or.iprio.eq.ipriosta)  then
        if(jjj.eq.1.and.iprin.gt.0.and.nfspace.eq.0)then
          if(nosing.eq.0)then
          write(lo,186)
 186   format(/,14x,'***** Profile fitting for the standard peak *****')
          else
            if(nosing.eq.nosingsav)then
            write(lo,284)
 284        format(/,18x,'***** No standard peak fit required *****'
     *      ,//,15x,'***** Profile fitting for reference range *****')
            endif
          endif
        elseif(jjj.ne.nnt.and.iprin.gt.0.and.nfspace.eq.0)then
        write(lo,189)jjj-1
 189    format(/,10x,'***** Profile fitting for the interval number'
     *  ,i3,' *****   ',/)
        if(noback.gt.0)write(lo,389)npol(jjj)-1
 389    format(/,10x,'***** The background polynomial is of order'
     *  ,i5,' *****   ',/)
        elseif(jjj.eq.nnt.and.iprin.gt.0.and.ialt.gt.0.
     *  and.nfspace.eq.0)then
        write(lo,299)
 299    format(/,10x,'***** Profile fitting for the full input'
     *  ,' pattern  *****   ',/)
        endif
      endif
      if(nstop.eq.3)go to 487
      if(jjj.eq.nnt.and.itry.eq.0)call setfinal(ier)
      if (ier.lt.0) go to 900
 487  continue
      if(jjj.eq.nnt)then
              if(icycle.eq.0)then
                  if(itry.eq.0)then
                  !!!!!!!!!!!!!!!!nvolte=8
                  nvolte=8
                  if(ipriort.gt.0)nvolte=4
                  else
                   if(ialt.eq.0.or.ialt.eq.2)then
                   nvolte=20
                   else
                   nvolte=6
                   endif
                  endif
              else
                if(itry.eq.0)then
                nvolte=max0(int(ncycle/3),1)
                else
                  if(ialt.eq.0)then
                  nvolte=ncycle
                  else
                  nvolte=ncycle
                  endif
                endif
              endif
      else
              if(icycle.eq.0)then
              nvolte=60
              if(ipriort.gt.0)nvolte=20
              else
              nvolte=ncycle
              endif
      endif
      iinit=1 
      iiend=nvolte
  154 continue
      nstopsave=0
      do 155 ii=iinit,iiend
      if(ii.eq.(nvolte-1).and.jjj.eq.1.and.nosing.eq.0)then
                      cminc1=0.00001     
                      cminc2=0.00001     
                      do 2000 k=ncoun1(jjj),ncoun2(jjj)
                      if(theta_int(k,3).gt.cminc1.
     *                and.theta_int(k,1).lt.TThet(nref1(jjj)))then
                      xxx1=theta_int(k,1)
                      go to 2100
                      endif
 2000                 continue
                      xxx1=thet1(jjj)
 2100                 continue
                      do 2200 k=ncoun1(jjj),ncoun2(jjj)
                      if(theta_int(k,3).lt.cminc2.
     *                and.theta_int(k,1).gt.TThet(nref1(jjj)))then
                      xxx2=theta_int(k,1)
                      go to 2300
                      endif
 2200                 continue
                      xxx2=thet2(jjj)
 2300                 continue
!corr                      nc1=nint((xxx1-thmin)/thstep)+2
!corr                      nc2=nint((xxx2-thmin)/thstep)
                      nc1 = clocate(theta_int(:npunti,7),xxx1)+1
                      nc2 = clocate(theta_int(:npunti,7),xxx2)-1
                      if(nc2.gt.nc1)then
!corr                      ncoun1(jjj)=nint((xxx1-thmin)/thstep)+2
!corr                      ncoun11(jjj)=nint((xxx1-thmin)/thstep)+2
!corr                      ncoun2(jjj)=nint((xxx2-thmin)/thstep)
!corr                      ncoun22(jjj)=nint((xxx2-thmin)/thstep)
!corr                      thet1(jjj)=thmin+(ncoun1(jjj)-1)*thstep
!corr                      thet11(jjj)=thmin+(ncoun1(jjj)-1)*thstep
!corr                      thet2(jjj)=thmin+(ncoun2(jjj)-1)*thstep
!corr                      thet22(jjj)=thmin+(ncoun2(jjj)-1)*thstep

                      ncoun1(jjj)=clocate(theta_int(:npunti,7),xxx1)
                      ncoun11(jjj) = ncoun1(jjj)
                      ncoun2(jjj)=clocate(theta_int(:npunti,7),xxx2)
                      ncoun22(jjj) = ncoun2(jjj)
                      thet1(jjj)=theta_int(ncoun1(jjj),7)
                      thet11(jjj)=theta_int(ncoun1(jjj),7)
                      thet2(jjj)=theta_int(ncoun2(jjj),7)
                      thet22(jjj)=theta_int(ncoun2(jjj),7)
                      endif
      endif
      if(nstop.eq.2)then
        nvar=0
        do 411 k=nref11(jjj),nref22(jjj)
        nvar=nvar+1
        fx(k)=var(nvar)
411     continue
        scal=var(nvar+1)
        zeroprof=var(nvar+2)
        uvwt(1)=var(nvar+3)
        uvwt(2)=var(nvar+4)
        uvwt(3) =var(nvar+5)
        asym  =var(nvar+6)
        uvwt(4) =var(nvar+7)
        uvwt(5) =var(nvar+8)
        uvwt(6) =var(nvar+9)
        astar   =var(nvar+10)
        bstar   =var(nvar+11)
        cstar   =var(nvar+12)
        cosas   =var(nvar+13)
        cosbs   =var(nvar+14)
        coscs  =var(nvar+15)
        bkg(1) =var(nvar+16)
        bkg(2) =var(nvar+17)
        bkg(3) =var(nvar+18)
        bkg(4) =var(nvar+19)
        bkg(5) =var(nvar+20)
        bkg(6) =var(nvar+21)
        bkg(7) =var(nvar+22)
        bkg(8) =var(nvar+23)
        bkg(9) =var(nvar+24)
        bkg(10) =var(nvar+25)
        bkg(11) =var(nvar+26)
        pp(1)    =var(nvar+27)
        pp(2)    =var(nvar+28)
        pp(3)    =var(nvar+29)
        pp(4)    =var(nvar+30)
        pp(5)    =var(nvar+31)
        pp(6)    =var(nvar+32)
        do 99 jk=1,26
        stdv(jk)=var(nvar+32+jk)
  99    continue
c       nstop=3   
        nstop=-3   
                     endif
      call profpa(ii,jjj,nstop)
      if (ier.lt.0) go to 900
      call lebail(ii,nstop,nfspace,ier)
      if(ier.lt.0)return
      icall=1
      call erre(ii,jjj,nstop,icall,erreprofA)
      if(nstop.eq.2)nstopsave=nstop
      if(ialt.eq.2) ialt=0
      rprofA(ii)=erreprofA
      rprof(ii)=erreprof
      rprofw(ii)=erreprofw
      reffe(ii)=erref
      if(nstop.lt.1.or.nstop.eq.3)then
        nvar=0
        do 412 k=nref11(jjj),nref22(jjj)
        nvar=nvar+1
        var(nvar)=fx(k)
412     continue
        var(nvar+1)=scal
        var(nvar+2)=zeroprof
        var(nvar+3)=uvwt(1)
        var(nvar+4)=uvwt(2)  
        var(nvar+5)=uvwt(3) 
        var(nvar+6)=asym    
        var(nvar+7)=uvwt(4) 
        var(nvar+8)=uvwt(5) 
        var(nvar+9)=uvwt(6) 
        var(nvar+10)=astar   
        var(nvar+11)=bstar   
        var(nvar+12)=cstar   
        var(nvar+13)=cosas   
        var(nvar+14)=cosbs   
        var(nvar+15)=coscs  
        var(nvar+16)=bkg(1) 
        var(nvar+17)=bkg(2) 
        var(nvar+18)=bkg(3)  
        var(nvar+19)=bkg(4) 
        var(nvar+20)=bkg(5) 
        var(nvar+21)=bkg(6) 
        var(nvar+22)=bkg(7) 
        var(nvar+23)=bkg(8) 
        var(nvar+24)=bkg(9) 
        var(nvar+25)=bkg(10) 
        var(nvar+26)=bkg(11) 
        var(nvar+27)=pp(1) 
        var(nvar+28)=pp(2) 
        var(nvar+29)=pp(3) 
        var(nvar+30)=pp(4) 
        var(nvar+31)=pp(5) 
        var(nvar+32)=pp(6) 
        do 998 jk=1,26
        var(nvar+32+jk)=stdv(jk)
 998    continue
                 endif
CATT  if((ii.eq.nvolte.or.ii.eq.1.or.nstop.eq.3).or.ialt.gt.0)then
      if(kscreen.gt.0)then
      scala(jjj)=scal
      if(jjj.eq.1.and.nosing.eq.1)scala(jjj+1)=scal
      if(jjj.eq.3.and.nnt.eq.3)scala(jjj-1)=scal
      if(itry.gt.0)then
      do 999 kkk=1,nnt
      scala(kkk)=scal
 999  continue
      endif
      iRef=1
      ipun=5
      if((ii.eq.nvolte.or.nstop.eq.3).or.ialt.gt.0)then
      if(jjj.ne.nnt)then
        if(noint.eq.2)then
          iStop=1
        else
          iStop=0
        endif
      else
        if(nprob.eq.1)then
          iStop=1
          if(noint.eq.1)iStop=0
        else
          if(noint.eq.2)then
            iStop=1
          else
            iStop=0
          endif
        endif
      endif
      elseif(ii.eq.1)then
      iStop=0
      endif
      iAction = 0
      thminsav=thmin
      thmaxsav=thmax
      !call vedi(ipun,iAction)
      if (ii.eq.nvolte.or.ii.eq.1.or.nstop.eq.3.or.mod(ii,10).eq.0) then
        if (ispaceindexing.eq.0) call vedinew(4,ncoun1(jjj),ncoun2(jjj))
      endif
      if(((ii.eq.nvolte.and.nprob.eq.1).or.nstop.eq.3).
     &and.ioptim.eq.1)iStop=1
c    &and.ioptim.eq.1.and.kgo.ne.2)iStop=1
c     if(((ii.eq.nvolte.and.nprob.eq.1).or.nstop.eq.3).
c    &and.ioptim.eq.1.and.kgo.eq.2.and.jjj.eq.nnt)iStop=0
      if(ioptim.eq.1.and.kgo.gt.0)kgo=0
c     if(iStop.eq.1.and.jjj.lt.nnt)then
CATT  if((iStop.eq.1.and.jjj.lt.nnt).or.
CATT &(iStop.eq.1.and.ioptim.eq.1))then
CATT  istep_extra=-jjj
CATT  return
CATT  endif
 898  continue
c     if((ii.eq.nvolte.and.nprob.eq.1).or.nstop.eq.3)then
c     kgo=0
c     if(ioptim.eq.1)then
CATTENcall ancora(kgo)
c     kgo=1
c     if(kgo.eq.1) then
c     iinit=2
c     nstop=0
c     go to 156
c     endif
c     endif
c     endif
      if((jjj.eq.nnt).and.((ii.eq.nvolte.and.nprob.eq.1)
     *.or.nstop.eq.3))then
CORO  if(iStop.eq.-1)iera=1111
      go to 5000
      else
CORO  if (iStop.eq.-1) then
CORO      ier = 1111
CORO      return
CORO  endif
      endif
5000  continue  
      thmin=thminsav
      thmax=thmaxsav
      call xdump
      endif
 599  continue
      if((ii.eq.nvolte.or.nstop.eq.3))then
      rproff(jjj)=erreprof
      rproffA(jjj)=erreprofA
      rprofwf(jjj)=erreprofw
      reffef(jjj)=erref
      if(nprof.eq.1)then
      profile='  Pearson  '
      elseif(nprof.eq.2)then
      profile='  Gaussian '
      elseif(nprof.eq.3)then
      profile=' Lorentzian '
      elseif(nprof.eq.4)then
      profile='  Pvoigt   '
      endif
      if(nprofgood.eq.1)then
      proff(jjj)='  Pearson  '
      elseif(nprofgood.eq.2)then
      proff(jjj)='  Gaussian '
      elseif(nprofgood.eq.3)then
      proff(jjj)=' Lorentzian '
      elseif(nprofgood.eq.4)then
      proff(jjj)='  Pvoigt   '
      endif
      if(iprin.gt.0)then
      nrighe=ii/5
      if(mod(ii,5).gt.0)nrighe=nrighe+1
      if(mod(ii,5).gt.0)then
      nresto=mod(ii,5)
      else
      nresto=5
      endif
      do 1109 k=1,nrighe
      if(k.ne.nrighe)then
      kfinal=5
      else
      kfinal=nresto
      endif
      if(nfspace.eq.0)write(lo,1110)((k-1)*5+iii,iii=1,kfinal)
      if(nfspace.eq.0)write(lo,1111)(rprof((k-1)*5+iii),iii=1,kfinal)
      if(nfspace.eq.0)write(lo,1121)(rprofA((k-1)*5+iii),iii=1,kfinal)
      if(nfspace.eq.0)write(lo,1112)(rprofw((k-1)*5+iii),iii=1,kfinal)
      if(iknow.gt.0.and.jjj.gt.1.and.nfspace.eq.0)write(lo,1113)
     *(reffe((k-1)*5+iii),iii=1,kfinal)
1109  continue
      endif
1110  format(/,'  Cycle   ',5x,5(2x,i8,2x))
1111  format(/,'  R-prof  ',5x,5(f10.3,2x))
1112  format(/,'  R-profw ',5x,5(f10.3,2x))
1113  format(/,'  R-effe  ',5x,5(f10.3,2x))
1121  format(/,"  R-prof' ",5x,10(f10.3,2x))
      if(jjj.gt.1.and.jjj.ne.nnt.and.iprin.gt.0.and.nfspace.eq.0)then
      write(lo,1010)jjj-1,erreprof,erreprofw
1010  format(/,'  *** The profile fitting for the interval number',
     *i4,' has been completed  ***',/,26x,'R-profile = ',f6.2,
     */,26x,'RW-profile = ',f6.2,/)
      elseif(jjj.eq.1.and.iprin.gt.0.and.nfspace.eq.0)then
      write(lo,1011)erreprof,erreprofw
1011  format(/,'  *** The profile fitting for the standard peak',
     *' has been completed  ***',/,26x,'R-profile = ',f6.2,
     */,26x,'RW-profile = ',f6.2,/)
      elseif(jjj.eq.nnt.and.iprin.gt.0.and.nfspace.eq.0)then
      if(ialt.eq.0)then
      write(lo,1012)erreprof,erreprofw
1012  format(/,'  *** The profile fitting for the full pattern',
     *' has been completed  ***',/,26x,'R-profile = ',f6.2,
     */,26x,'RW-profile = ',f6.2,/)
      endif
      endif
      if(iprin.eq.0.and.jjj.eq.nnt.and.nprob.eq.1)then
      npol(1)=2
      if(iproff.gt.0)then
      if(iproff.eq.1)then
      proff(1)=proff(2)
      else
      proff(1)='     -     '
      endif
      endif
      if ((iprio.eq.0.or.iprio.eq.ipriosta).and.nfspace.eq.0)  then
      if(itry.eq.0)then
                 if(ipriort.eq.0)then
                 if(nosing.eq.0)then
                 write(lo,1210)(iii-1,iii=2,nnt-1)
                 else
                 write(lo,1231)(iii-1,iii=2,nnt-1)
                 endif
                                else
                 write(lo,1232)(iii-1,iii=2,nnt-1)
                                endif
                 if(ipriort.eq.0)then
                 write(lo,1207)proff(nnt),proff(1),
     *          (proff(iii),iii=2,nnt-1)
                 write(lo,1206)npol(1)-1,(npol(iii)-1,iii=2,nnt-1)
      write(lo,1211)rproff(nnt),(rproff(iii),iii=1,nnt-1)
      write(lo,1217)rproffA(nnt),(rproffA(iii),iii=1,nnt-1)
      write(lo,1212)rprofwf(nnt),(rprofwf(iii),iii=1,nnt-1)
                                 else
                 write(lo,1207)proff(nnt),
     *          (proff(iii),iii=2,nnt-1)
                 write(lo,1206)(npol(iii)-1,iii=2,nnt-1)
      write(lo,1211)rproff(nnt),(rproff(iii),iii=2,nnt-1)
      write(lo,1217)rproffA(nnt),(rproffA(iii),iii=2,nnt-1)
      write(lo,1212)rprofwf(nnt),(rprofwf(iii),iii=2,nnt-1)
                                 endif
                   else
                 write(lo,1209)
                 write(lo,1208)proff(nnt)
      write(lo,1215)rproff(nnt)
      write(lo,1218)rproffA(nnt)
      write(lo,1216)rprofwf(nnt)
                   endif
      if(iknow.gt.0.and.itry.eq.0.and.ipriort.eq.0.and.nfspace.eq.0)
     *write(lo,1213)reffef(nnt),
     *(reffef(iii),iii=2,nnt-1)
      if(iknow.gt.0.and.itry.eq.0.and.ipriort.gt.0.and.nfspace.eq.0)
     *write(lo,1233)reffef(nnt),
     *(reffef(iii),iii=2,nnt-1)
      if(iknow.gt.0.and.itry.gt.0.and.nfspace.eq.0)
     *write(lo,1214)reffef(nnt)
1210  format(/,'  Interval',5x,'Full pattern ','  Stand. Peak',
     *i6,1x,8(2x,i8,2x))
1232  format(/,'  Interval',5x,'Full pattern ',
     *i6,1x,8(2x,i8,2x))
1231  format(/,'  Interval',5x,'Full pattern ',' Stand. Inte.',
     *i6,1x,8(2x,i8,2x))
1209  format(/,'  Full pattern')
1211  format(/,'  R-prof  ',5x,10(f10.3,2x))
1217  format(/,'  R-prof  ',5x,10(f10.3,2x))
1212  format(/,'  R-profw ',5x,10(f10.3,2x))
1207  format(/,'  Function',6x,10(a10,2x))
1206  format(/,'  Back. Degree',6x,'-',4x,i10,2x,8(i10,2x))
1215  format(/,'  R-prof  ',5x,(f10.3,2x))
1218  format(/,'  R-profNobg',3x,(f10.3,2x))
1216  format(/,'  R-profw ',5x,(f10.3,2x))
1208  format(/,'  Function',6x,(a10,2x))
1213  format(/,'  R-effe  ',5x,f10.3,9x,'-',4x,9(f10.3,2x))
1233  format(/,'  R-effe  ',5x,f10.3,2x,9(f10.3,2x))
1214  format(/,'  R-effe  ',5x,(f10.3,2x))
      endif
      endif
      if(jjj.eq.1)then
      if(nosing.eq.0)then
      if(nprof.ne.3)then
      frac=(thet2(jjj)-thet1(jjj))/(sqrt(fwhsav))
      else
      frac=(thet2(jjj)-thet1(jjj))/(fwhsav)
      endif
c     if(frac.gt.10.0.and.nsyn.eq.0)frac=10.0
      if(frac.gt.15.0)frac=15.0
c     if(frac.gt.7.0.and.nsyn.eq.1)frac=7.0
      if(fracout.gt.0.0) frac=fracout
      endif
      if (iprio.eq.0.or.iprio.eq.ipriosta)  then
        if (iprin.eq.0.and.iproff.eq.0)  then
           if(nfspace.eq.0)write(lo,8012) nnt-2
           zzero = 2.0 * zeroprof
           if (nosing.eq.0) then
               if(nfspace.eq.0)write(lo,8013) zzero
               if(nfspace.eq.0)write(lo,8014) thetsav1,thetsav2
               if(nfspace.eq.0)write(lo,8015) fracsing
            else
               if(izero.ne.0.and.nfspace.eq.0) write(lo,8013) zzero
               if(nfspace.eq.0)write(lo,8016) frac
           endif
        endif
      endif
 8012 format(3x,75('*'),/,3x,1h*,73x,1h*,/,
     *       3x,1h*,6x,'Number of intervals   =   ',i3,
     *       38x,1h*,/,3x,1h*,73x,1h*)
 8013 format(3x,1h*,6x,'Zero correction       =    ',f6.3,34x,1h*,
     *     /,3x,1h*,73x,1h*)
 8014 format(3x,1h*,6x,'Standard peak from',f9.4,' to',f9.4,28x,1h*,
     *     /,3x,1h*,73x,1h*)
 8015 format(3x,1h*,6x,'Initial peak width    = ',f8.2,' * fwhm ',
     * 27x,1h*,/,3x,1h*,73x,1h*)
 8016 format(3x,1h*,6x,'Peak width            = ',f8.2,' * fwhm ',
     * 27x,1h*,/,3x,1h*,73x,1h*)
         if (iprio.eq.0.or.iprio.eq.ipriosta)  then
           if(iprin.eq.0) then
             if(nosing.eq.0.and.iproff.eq.0.and.nfspace.eq.0)
     *                       write(lo,608) frac,profile
             if(nosing.eq.0.and.iproff.gt.0.and.nfspace.eq.0)
     *                       write(lo,609) frac,profile
             if(nosing.eq.1.and.iproff.eq.0.and.nfspace.eq.0) 
     *       write(lo,607) profile
          endif
      endif
 607  format(3x,1h*,6x,'Used function :',a,41x,
     *1h*,/,3x,1h*,73x,1h*,/,3x,75('*'),/,3x,1h*,73x,1h*)
 608  format(3x,1h*,6x,'Refined peak width    = ',f8.2,' * fwhm',
     *28x,1h*,/,3x,1h*,73x,1h*,/,3x,1h*,6x,'Used function :',a,41x,
     *1h*,/,3x,1h*,73x,1h*,/,3x,75('*'),/,3x,1h*,73x,1h*)
 609  format(3x,'Refined peak width    = ',f8.2,' * fwhm',
     */,/,3x,'Used function :',a,/)
c
      if (iprio.eq.0.or.iprio.eq.ipriosta)  then
         if(iprin.gt.0.and.nfspace.eq.0) write(lo,1119)
         if(iprin.eq.0.and.iproff.gt.0.and.nfspace.eq.0) write(lo,1119)
          if(nfspace.eq.0)write(lo,1603)
          if(nfspace.eq.0)then
          do 1900 i=2,nnt-1
          write(lo,1604)i-1,thet1(i),thet2(i),ncoun1(i),ncoun2(i),
     *                  nref1(i),nref2(i)
 1900     continue
          write(lo,1116)
          endif
      endif
 1119 format(3x,75('*'),/,3x,1h*,73x,1h*)
 1603 format(3x,1h*,18x,'***     Intervals informa',
     *  'tion     ***',18x,1h*,/,3x,1h*,73x,1h*,/,3x,1h*,6x,
     *'I   2Th-Min   2Th-Max  Count-Min  Count-Max  Nref-Min  Nref-Max'
     *  ,4x,1h*,/,3x,1h*,73x,1h*)
 1604 format(3x,1h*,3x,i4,1x,f8.2,2x,f8.2,1x,i8,3x,i8,2x,i8,2x,i8,7x,
     *      1h*)
 1116 format(3x,1h*,73x,1h*,/,3x,75('*'))
c
      if(nosing.eq.1)then
      iamax=15+npol(jjj)
      else
      iamax=17
      endif
      elseif(jjj.eq.nnt.and.ialt.eq.0)then
      iamax=15
      else
      iamax=15+npol(jjj)
      if(ipriort.gt.0.or.noback.gt.0)iamax=15
      endif
      if ((iprio.eq.0.or.iprio.eq.ipriosta).and.nfspace.eq.0)  then
      if(itry.eq.0)then
      if(ialt.eq.0)then
      if(iprin.gt.0.or.jjj.eq.nnt.and.nprob.eq.1)write(lo,'(/,6x,a/)')
     * ' Ref. Parameter             old               new'
      if (iprin.ne.0.or.jjj.eq.nnt.and.nprob.eq.1) then
        do 1003 ia=1,iamax
        if(ia.ne.2)then
        write(lo,1004) pr_string(ia),pr_old(ia),var(nvar+ia)
        else
        write(lo,1004) pr_string(ia),-2.0*pr_old(ia),-2.0*var(nvar+ia)
        endif
 1003   continue
      endif
      endif
      endif
      endif
 1004 format(10x,a8,2f20.5)
      nstop=0
 158  continue
      go to 156
      endif
CATT  endif
      if(nstop.eq.2)go to 159
      if(ialt.eq.1)go to 159
      call derpar(jjj)
      call shiftpar(ii,jjj,pr_old,stdv)
 159  continue
 155  continue
 156  continue
      if(kgo.gt.0.and.kscreen.gt.0)go to 154
      if(nprob.ne.1)then
      fwhgood(ijk)=fwhsav
      betagood(ijk)=betasav
      asymgood(ijk)=asym
      zerogood(ijk)=zeroprof
      fracgood(ijk)=frac
      p_good(1,ijk)=pp(1)
      p_good(2,ijk)=pp(2)
      p_good(3,ijk)=pp(3)
      p_good(4,ijk)=pp(4)
      p_good(5,ijk)=pp(5)
      p_good(6,ijk)=pp(6)
      p_good(7,ijk)=astar
      p_good(8,ijk)=bstar
      p_good(9,ijk)=cstar
      p_good(10,ijk)=cosas
      p_good(11,ijk)=cosbs
      p_good(12,ijk)=coscs
      else
      fwhgood(nprof)=fwhsav
      betagood(nprof)=betasav
      asymgood(nprof)=asym
      zerogood(nprof)=zeroprof
      fracgood(nprof)=frac
      p_good(1,nprof)=pp(1)
      p_good(2,nprof)=pp(2)
      p_good(3,nprof)=pp(3)
      p_good(4,nprof)=pp(4)
      p_good(5,nprof)=pp(5)
      p_good(6,nprof)=pp(6)
      p_good(7,nprof)=astar
      p_good(8,nprof)=bstar
      p_good(9,nprof)=cstar
      p_good(10,nprof)=cosas
      p_good(11,nprof)=cosbs
      p_good(12,nprof)=coscs
      endif
      if(jjj.ne.1)then
      scala(jjj)=scal
      do 157 i=ncoun1(jjj),ncoun2(jjj)
      if(jjj.gt.2.and.jjj.ne.nnt)then
      if(i.ge.ncoun1(jjj).and.i.le.ncoun2(jjj-1))then
      back_int(i,2)=(back_int(i,2)+back_int(i,1))*0.5
      else
      back_int(i,2)=back_int(i,1)
      endif
                  else
      back_int(i,2)=back_int(i,1)
                 endif
 157  continue
      endif
c     if (iproff.ne.3.and.nfspace.eq.0) then
c         if (jjj.ne.1.and.jjj.ne.nnt) then
c             if (ipriort.eq.0.and.itry.eq.0)
c    *        call ToRiet(jjj,zerowrite,zeroprof,asym)
c          endif
c     endif
      if(nprob.eq.1)then
                    errerif=erreprof
                    else
                    if(ijk.eq.1)errerif=erreprof
                    if(erreprof.le.errerif)then
                    errerif=erreprof
                    nprofgood=nprof
                    do 489 k=1,nvar+58
                    vargood(k)=var(k)
  489 continue                  
                    do 589 k=1,26
                    pr_oldgood(k)=pr_old(k)
  589 continue                  
                         endif
                    endif
  188 continue
      if(jjj.gt.1.and.iproff.gt.0.and.nprob.ne.1)then
      nprob=1
      nstop = 3
        nvar=0
        do 711 k=nref11(jjj),nref22(jjj)
        nvar=nvar+1
        fx(k)=vargood(nvar)
711     continue
        scal=vargood(nvar+1)
        zeroprof=vargood(nvar+2)
        uvwt(1)=vargood(nvar+3)
        uvwt(2)=vargood(nvar+4)
        uvwt(3) =vargood(nvar+5)
        asym  =vargood(nvar+6)
        uvwt(4) =vargood(nvar+7)
        uvwt(5) =vargood(nvar+8)
        uvwt(6) =vargood(nvar+9)
        astar   =vargood(nvar+10)
        bstar   =vargood(nvar+11)
        cstar   =vargood(nvar+12)
        cosas   =vargood(nvar+13)
        cosbs   =vargood(nvar+14)
        coscs  =vargood(nvar+15)
        bkg(1) =vargood(nvar+16)
        bkg(2) =vargood(nvar+17)
        bkg(3) =vargood(nvar+18)
        bkg(4) =vargood(nvar+19)
        bkg(5) =vargood(nvar+20)
        bkg(6) =vargood(nvar+21)
        bkg(7) =vargood(nvar+22)
        bkg(8) =vargood(nvar+23)
        bkg(9) =vargood(nvar+24)
        bkg(10) =vargood(nvar+25)
        bkg(11) =vargood(nvar+26)
        pp(1)    =vargood(nvar+27)
        pp(2)    =vargood(nvar+28)
        pp(3)    =vargood(nvar+29)
        pp(4)    =vargood(nvar+30)
        pp(5)    =vargood(nvar+31)
        pp(6)    =vargood(nvar+32)
        do 997 jk=1,26
        stdv(jk)=vargood(nvar+32+jk)
 997    continue
        do 812 k=1,26
        pr_old(k)=pr_oldgood(k)
 812    continue
      go to 288
      endif
CCCCCCCCCCC
!corr      if(nfspace.eq.0.and.kscreen.eq.1)call attiva_tasto(2)
!corr      if(nfspace.eq.0.and.kscreen.eq.1)
!corr     *   call toolbar_set_state('Cycle'//char(0),1)
      if(kscreen > 0)then
         if((iStop.eq.1.and.jjj.lt.nnt).or.(iStop.eq.1))then
             istep_extra=-jjj
!corr             if(nstopsave.eq.2.and.jjj.ne.1)then
!corr         if(nfspace.eq.0.and.kscreen.eq.1)
!corr     *      call attiva_tasto(1)
!corr     *      call toolbar_set_state('Cycle'//char(0),2)
!corr             endif
             if (ispaceindexing == 0) then
!corr            riempire setfob(4) e avere export dei riflessi da file>export
                 do i=nref1(nnt),nref2(nnt)
                    SetFob(i,4)=(fx(i)/(clp(i)*Mult(i)))
                 enddo
                 call fillref(ref)  ! For Info > HKL list
!corr
                 if (nfspace == 0) then
!qt                     call toolbar_set_state('Cycle'//char(0),1)
                     call abilita_tasti(CycleAction,1)
                 endif
                 call scrper(' ',0,-1,1)
                 call write_message
     *           ('Press "Next" to continue or "File>>Exit"',pos=6)
                 call abilita_tasti('pattern')
                 kprofile_type = PROFILE_EXTRA
                 call abilita_tasti(ProfileAction,1)
                 call stop_fortran() 
!qt                 call gestione_eventi(kgo_refine)
                 kgo_refine = event_from_gui()
                 call abilita_tasti(ProfileAction,0)
             endif
             if (kexitrun == 1) return        ! ho premuto il tasto 'exit'
             if (kgo_refine == STOP_EVENT) then
                 kexitrun = 1
                 return
             endif
             go to 1
         endif
      endif
CCCCCCCCCCC
  185 continue
  199 continue
      nrefl=nref2(nnt)
c     if(jjj.eq.nnt.and.iknow.gt.0.and.nfspace.eq.0)call staterre
C     if(jjj.eq.nnt.and.ialt.eq.0.and.nfspace.eq.0)call indref
c     if(jjj.eq.nnt.and.ialt.eq.0.and.nfspace.eq.0)call corrmatrix
C     if(jjj.eq.nnt)call tosirp(nstop,nvolte,
C    &fileh,formt,ier)
          if(ialt.eq.0.and.nfspace.eq.0)call indref
! richiamo calcolo riflessi indipendenti anche quando fa findspace con n-treor
          if(ialt.eq.0.and.ispaceindexing.eq.1)call indref
      icare(1:nrefl)=0
      if(nfspace.gt.0)call variance2
      call tosirp(nstop,nvolte,fileh,formt,ier)
      if(nfspace.eq.0)itry=itrysav+1
      do i=1,nrefl
         ivett(1)=IndHKL(i,1)
         ivett(2)=IndHKL(i,2)
         ivett(3)=IndHKL(i,3)
         rho=rhof(pp,ivett(1),ivett(2),ivett(3))
         rho2=rho*rho
         twot=ctheta(rho2)
         TThet (i)   = twot     
         fc(i) = SetFob(i,4)
      enddo
!corr
      call new_array(iorder,nrefl)
      call indexx(TThet(:nrefl),iorder)
      IndHKL(:nrefl,1:5) = IndHKL(iorder,1:5)
      SetFob(:nrefl,1:5) = SetFob(iorder,1:5)
      TThet(:nrefl) = TThet(iorder)
      Mult(:nrefl) = Mult(iorder)
      WHM(:nrefl) = WHM(iorder)
      fxsav(:nrefl) = fxsav(iorder)
      fc(:nrefl) = fc(iorder)
      do i=1,nrefl
         if (TThet(i).gt.theta_int(npunti,1)) then
            nrefl = i -1
            goto 193
         endif
         if (TThet(i).gt.theta_int(npunti,7)) then
            nrefl = i -1
            goto 193
         endif
      enddo
!corr
!corr      lind=138001
!corr      iblk=15
!corr      jump=11
!corr      izer=15*nrefl
!corr      do 402 i=1,izer
!corr 402    abig(i) = 0.0
!corr      do 191 i=1,nrefl
!corr       ibig(15*(i-1)+1)=IndHKL(i,1)
!corr       ibig(15*(i-1)+2)=IndHKL(i,2)
!corr       ibig(15*(i-1)+3)=IndHKL(i,3)
!corr       ibig(15*(i-1)+4)=IndHKL(i,4)
!corr       ibig(15*(i-1)+5)=IndHKL(i,5)
!corr       abig(15*(i-1)+6)=SetFob(i,1)
!corr       abig(15*(i-1)+7)=SetFob(i,2)
!corr       abig(15*(i-1)+8)=SetFob(i,3)
!corr       abig(15*(i-1)+9)=SetFob(i,4)
!corr       abig(15*(i-1)+10)=SetFob(i,5)
!corr       abig(15*(i-1)+11)=TThet(i)
!corr       ibig(15*(i-1)+12)=Mult(i)
!corr       abig(15*(i-1)+13)=WHM(i)
!corr       abig(15*(i-1)+14)=fxsav(i)
!corr       abig(15*(i-1)+15)=fc(i)
!corr  191 continue
!corr*     call sortz(lind,nrefl,iblk,jump)
!corr      idim = 72000
!corr      call sortz_dyn(abig,idim,1,nrefl,iblk,jump)
!corr      do 192 i=1,nrefl
!corr       if (TThet(i).gt.theta_int(npunti,1)) then
!corr          nrefl = i -1
!corr          goto 193
!corr       endif
!corr       if (TThet(i).gt.theta_int(npunti,7)) then
!corr          nrefl = i -1
!corr          goto 193
!corr       endif
!corr       IndHKL(i,1)=ibig(15*(i-1)+1)
!corr       IndHKL(i,2)=ibig(15*(i-1)+2)
!corr       IndHKL(i,3)=ibig(15*(i-1)+3)
!corr       IndHKL(i,4)=ibig(15*(i-1)+4)
!corr       IndHKL(i,5)=ibig(15*(i-1)+5)
!corr       SetFob(i,1)=abig(15*(i-1)+6)
!corr       SetFob(i,2)=abig(15*(i-1)+7)
!corr       SetFob(i,3)=abig(15*(i-1)+8)
!corr       SetFob(i,4)=abig(15*(i-1)+9)
!corr       SetFob(i,5)=abig(15*(i-1)+10)
!corr       TThet(i)=abig(15*(i-1)+11)
!corr       Mult(i)=ibig(15*(i-1)+12)
!corr       WHM(i)=abig(15*(i-1)+13)
!corr       fxsav(i)=abig(15*(i-1)+14)
!corr       fc(i)=abig(15*(i-1)+15)
!corr  192 continue
  193 continue
!!!!!corr-reallocare array a nrefl per evitare crash (es. in asserefn su vethkl durante spacegroup)
!!!!!va sistemato meglio
      call resize_array(tthet,nrefl)
!!!!!corr
      do i=1,nnt
        if(nref2(i).gt.nrefl)nref2(i)=nrefl
        if(nref22(i).gt.nrefl)nref22(i)=nrefl
      enddo
CSPA  if(nfspace.eq.0)call defovl
      call defovl
CSPA  if (kequirip.eq.1.and.nfspace.eq.0) call noequi
      if (kequirip.eq.1) call noequi
      if ((iprio.eq.0.or.iprio.eq.ipriosta).and.nfspace.eq.0)  then
!corr         if(kit.ne.1)then
         if(kequirip.eq.1.and.ialt.eq.0) write(lo,368)
         if(kequirip.eq.0.and.ialt.eq.0) write(lo,369)
  368 format(//,'    The overall intensity for each group of',
     *' overlapping reflections',/,
     *'    is equipartitioned ')
  369 format(//,'    The overall intensity for each group of',
     *' overlapping reflections',/,
     *'    is not equipartitioned      ')
         endif
!corr      endif
CSPA  if(nfspace.eq.0)call PreparaRiflessiOrdinati
      ncounmax=-99999999
      do j=1,nrefl
         theta0 =  TThet(j)
         rdeg = 0.5 * TThet(j) * dtor
         tdeg = sin(rdeg) / cos(rdeg)
         tdeg2 = tdeg * tdeg
         cdeg=cos(rdeg)
         if (nprof.eq.1) then
             uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
         elseif (nprof.eq.4) then
             uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
         elseif (nprof.eq.2) then
             uvwqg = uvwt(3) * tdeg2 + uvwt(2) * tdeg + uvwt(1)
          else
             uvwqg=(uvwt(1)*tdeg+uvwt(2)/cdeg)**2
         endif
         if (uvwqg.le.0.000001)then
             uvwg=2.0*thstep
             uvwqg=uvwg**2
         else
             uvwg = sqrt(uvwqg)
         endif
         uvw2max=2.0
         uvw2min=2.0*thstep
         if(uvwg.gt.uvw2max) then
           uvwg=uvw2max
           uvwqg=uvwg**2
         endif
         if(uvwg.lt.uvw2min) then
           uvwg=uvw2min
           uvwqg=uvwg**2
         endif
         uvw2=(uvwg*frac)
         if(uvw2.gt.3.0)uvw2=3.0
         thminn=amax1(theta0-uvw2,thmin)
         thmaxx=amin1(theta0+uvw2,thmax)
         iniz = clocate(theta_int(:npunti,7),thminn)
         ifin = clocate(theta_int(:npunti,7),thmaxx)
         if(ifin.lt.iniz) ifin=iniz
         nagg=ifin-iniz+1
         if (nagg.gt.ncounmax) ncounmax=nagg
      enddo
      call PreparaRiflessiOrdinati
      npseud=0
      do 541 i=1,npunti
      theta_int(i,1)=theta_int(i,4)
      if(nfspace.gt.0)theta_int(i,2)=theta_int(i,5)
 541  continue
      if(nfspace.eq.1)then
      thmin=theta_int(1,1)
      thmax=theta_int(npunti,1)
      asym=0
      endif
      iy = 67543
!corr      machkl=0
CSPA  if(ialt.eq.0.and.nfspace.eq.0)call CreaListaRiflessiOrdinati(iy)
      if(ialt.eq.0)call CreaListaRiflessiOrdinati(iy)
CSPA  if(nfspace.eq.0)call ysfr06(fc)
!     call ysfr06(fc)
!     call CreaListaRiflessi(fc)
      do i=1, nrefl
         fcvet(i) = fc(i)
         worko(i) = fx(i)
         fx(i) = fx(i)**2
!g ???   SetFob(i,4) = fx(i)
         SetFob(i,5) = 0.0
      enddo
      call CreaListaRiflessi
      fx(1:nrefl) = worko(1:nrefl)
      if(ialt.eq.0.and.nfspace.eq.0)call ysfr37(npunti)
c     if(nfspace.eq.0)call ToRiet0(zerowrite)
c     if(nfspace.eq.0)call cp1339
      pp(1)=0.25*(astar**2)
      pp(2)=0.25*(bstar**2)
      pp(3)=0.25*(cstar**2)
      pp(4)=0.25*(2.0*astar*bstar*coscs )
      pp(5)=0.25*(2.0*astar*cstar*cosbs )
      pp(6)=0.25*(2.0*bstar*cstar*cosas )
      abc(1)=astar
      abc(2)=bstar
      abc(3)=cstar
      ang(1)=acos(cosas)*rtod     
      ang(2)=acos(cosbs)*rtod
      ang(3)=acos(coscs)*rtod
      call senti
      cosas=acos(cosas)*rtod     
      cosbs=acos(cosbs)*rtod
      coscs=acos(coscs)*rtod
      cel(1)=astar
      cel(2)=bstar
      cel(3)=cstar
      cel(4)=cosas
      cel(5)=cosbs
      cel(6)=coscs
      cell(1)=astar
      cell(2)=bstar
      cell(3)=cstar
      cell(4)=cosas
      cell(5)=cosbs
      cell(6)=coscs
      cell(7)=sin(cosas*dtor)
      cell(8)=sin(coscs*dtor)
      cell(9)=sin(coscs*dtor)
      if (nfspace.eq.0) then
          call frm01( (/(cel(i),i=1,6),(0.0,i=7,13)/) )
          call cryst(1)%set_unit_cell(set_cell_type(cel))
      endif
      if(ialt.eq.0)then
      if ((iprio.eq.0.or.iprio.eq.ipriosta).and.nfspace.eq.0)  
     *write(lo,9000)astar,bstar,cstar,cosas,cosbs,coscs
      endif
 9000 format(/,'     Refined cell   ',6f8.3)
      if(iera.gt.0)then
      ier=1111
      return
      endif
      if(iera.gt.0)then
      ier=1111
      return
      endif
  900 continue
corrado-se deallochi non funziona lo zoom      call AllocaConteggi(2)
      call AllocaDeriv(2)
      call AllocaExtraIndix(2)
      return
      end
c-----------------------------------------------------------------------
      subroutine CalcoBacExt(icontrollo)
      USE Conteggi
      USE General
      USE PatternRef
      common/genob/irho,thetamin
!corr      common/genob2/thmin,thmax,thstep
      common /backp2/ npol(10)
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
!!!!corrado
c
      thetamin=tmm(jjj)
      call modback(icontrollo,ier)
      if(ier.lt.0)return
      do 283 i=ncoun1(jjj),ncoun2(jjj)
         if(jjj.eq.2.and.i.le.ncoun2(jjj))then
            thet=theta_int(i,1)/thetamin - 1.0
            back_int(i,1)=bkg(1)
            do 286 k=2,npol(jjj)
               ksp=real(k)-1.0
               back_int(i,1)=back_int(i,1)+bkg(k)*(thet**ksp)
 286        continue
         else
            if(i.gt.ncoun2(jjj-1))then
               thet=theta_int(i,1)/thetamin - 1.0
               back_int(i,1)=bkg(1)
               do 287 k=2,npol(jjj)
                  ksp=real(k)-1.0
                  back_int(i,1)=back_int(i,1)+bkg(k)*(thet**ksp)
 287           continue
            endif
         endif
 283  continue
      do 285 j=1,11
         bkk(j,jjj)=bkg(j)
 285  continue
c ---
      return
      end
c-----------------------------------------------------------------------
      subroutine extranew(nrun,nfspace,exit_code,ier)
      USE Molcom
      USE PatternRef
      USE messagemod
      USE enable_amb
      USE proginterface
      USE variables, only:ref,cryst
      USE General, only:is_extraction,nrefl,is_extra_active
      USE extramodule, only: allocate_extra
      USE randofi
      implicit none
      integer              :: nrun,nfspace
      integer, intent(out) :: ier,exit_code
      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
     *,ncounsav1,ncounsav2,fracout,ioptim
      integer :: ipriort,iprio,ipriosta,ncounsav1,ncounsav2,ioptim
      real :: sogran,thetsav1,thetsav2,fracout
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      integer :: iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
      integer :: ispaceindexing,ntotmult1,ntotmult2
      real    :: fspaceindex,percind,errespac
      common /limiti/ nlini, nlfin
      integer :: nlini, nlfin
      character*20 lauecell
      real :: fracsing, shiftzero
      integer :: ksmoo
!!!!!!CHECK declaration integer-real
!
      ier = 0
      exit_code = 0
      is_extra_active = .true.
!
      call abilita_tasti(ExtraAction)
      if (jscreen > 0 .and. ispaceindexing == 0) 
     *    call stop_fortran_visible(1)
!
!     Peak search for single peak
      call fillcounts()
      call back_for_peaksearch(.true.)
      call peaksearch(shiftzero,ier)  
      if (ier /= 0) return
!
      call allocate_extra(nrefl)
!
      if (ispaceindexing == 0 .and. jscreen > 0) then
          !call clear_messages()
          call SetRowCountMesg(3,1)
          call write_message('Extraction command',pos=1)
      endif
!
      call extra1(kscreen,nrun,nfspace,fracsing,ksmoo,ier)
      if (ier.lt.0) go to 10
!
      if (ipriort == 0) then
          if (ispaceindexing == 0 .and. jscreen > 0) then
!qt              call abilita_tasti('pattern')
              call abilita_tasti(IntervalsAction,1)
!qt              call wmenu_set_state('Intervals'//char(0),1)
              call stop_fortran()
              call abilita_tasti(IntervalsAction,0)
!qt              call wmenu_set_state('Intervals'//char(0),0)
!qt              if (kexitrun == 1) go to 10        ! ho premuto il tasto 'exit'
              if (event_from_gui() == STOP_EVENT) then
                  exit_code = STOP_EVENT
!qt                  kexitrun = 1
                  go to 10
              endif
          endif
      endif
!
      call extra2(nrun,nfspace,fracsing,ksmoo,ier)
      if (ier.lt.0) go to 10
!
      if (ipriort == 0 .and. jscreen > 0) then
!qt          call abilita_tasti('pattern')
!qt          call wmenu_set_state('Background Settings'//char(0),1)
!qt          call wmenu_set_state('Background'//char(0),2)
          call toolbar_set_state('pointmode'//char(0),1)
          call abilita_tasti(ExtraBackgroundAction,1)
          if (ispaceindexing == 0) call stop_fortran()
          call abilita_tasti(ExtraBackgroundAction,0)
!qt          call wmenu_set_state('Background Settings'//char(0),2)
!qt          call wmenu_set_state('Background'//char(0),0)
          call toolbar_set_state('pointmode'//char(0),0)
!qt          if (kexitrun == 1) go to 10        ! ho premuto il tasto 'exit'
          if (event_from_gui() == STOP_EVENT) then
              exit_code = STOP_EVENT
!qt              kexitrun = 1
              go to 10
          endif
      endif
!
      call extra3(nrun,nfspace,fracsing,ier)
      if (nfspace == 0 .and. jscreen > 0) 
     *    call abilita_tasti(CycleAction,0)
      if (ier.lt.0) go to 10
      if (kexitrun == 1) go to 10            ! ho premuto il tasto 'exit'
!
      is_extraction = .true.
!  
!     Nascondi il tasto 'Next' se non stai facendo il gruppo spaziale
!qt10    if (jscreen > 0 .and. nfspace == 0) 
!qt     *    call toolbar_set_state('continue'//char(0),2)
!qt 10    if (jscreen > 0 .and. nfspace == 0) then
10    if (jscreen > 0) then
          if (nfspace == 0) call stop_fortran_visible(0)
          call abilita_tasti(PatternAction)
      endif
!qt      call abilita_tasti(RestoreAction)
      call fillref(ref)
      call cryst(1)%set_reflections(ref)
      is_extra_active = .false.
!
      return
      end
c-----------------------------------------------------------
      subroutine make_extra(ier)
      implicit none
      integer, intent(out) :: ier
      integer :: nrun, nfspace
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      integer :: ncycl,nroset,nundset,nsec,jback,itry,kequirip
      real :: uvwt, pfwhm
      integer :: exit_code
      ier=0
      nrun=1
      itry=0
      nfspace=0
                           !!!call ysfr37(npunti)
      call extranew(nrun,nfspace,exit_code,ier)
      end subroutine make_extra
c-----------------------------------------------------------
      subroutine generate_points(interval,npoints)
      USE General, only: alambda
      USE Conteggi, only: theta_int
      USE Background
      USE xdataMod, only: tt,countmi,weig
      implicit none
      integer, intent(in)  :: interval
      integer, intent(out) :: npoints
      type(point_type), dimension(:), allocatable :: points
      integer                                     :: i
!      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
!     *,nback,ifcamb(10),noback
!      real :: backp, bkk, tmm
!      integer :: ntyp, nback, ifcamb, noback
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      real :: thet1, thet2, ymx, thet11, thet22, sscl, scala
      integer :: ncoun1, ncoun2, nref1, nref2, nnt
      integer :: ncoun11, ncoun22, nref11, nref22
      integer :: nc1, nc2
   
      nc1 = ncoun1(interval)
      nc2 = ncoun2(interval)
      call piazza_punti(theta_int(nc1:nc2,1),theta_int(nc1:nc2,2),
     *                  npoints,points,alambda)
      do i=1,npoints
         tt(i) = points(i)%x
         countmi(i) = points(i)%y
         weig(1) = 1.0
      enddo
!      nback = npoints
!      do i=1,nback
!         backp(i,1) = points(i)%x
!         backp(i,2) = points(i)%y
!      enddo
!     Print list of points
      write(70,'(A,i0)') 'Generated points for interval ',interval, 
     *                  ' of ',nnt
      do i=1,npoints
         write(70,'(2F10.4)') points(i)%x,points(i)%y
      enddo

      end subroutine generate_points
c-----------------------------------------------------------
      subroutine treatforback
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE ProfileApp
      USE General
      USE arrayutil
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /backp2/ npol(10)
      common /profp/dumpp,nprof,ipol
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /save/npolsav(10),refv(32,10)    !,fwb(3000,2)
!corr      common /savev/var(3100)
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      common /pesob/weigb(10000),nsmoothb
      common /peak/xmax(200),ymax(200),fw(200),npk,asm(200)
c
      dimension dmat(11),amat(11,11),INDX(11),amt(11)
c
      npuntisav=npunti
      yymax=maxval(theta_int(1:npunti,2))
      nback=0
      nntt=1
 1500 nntt=nntt+1
CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      ymin=9999999.0
      npunti=0
      do i=ncoun11(nntt),ncoun22(nntt)
         npunti=npunti+1
         theta_app(npunti,1)=theta_int(i,1)
         theta_app(npunti,2)=theta_int(i,2)
         if(theta_app(npunti,2).lt.ymin)ymin=theta_app(npunti,2)
      enddo
      yymin=9999999.0
      do i=1,npunti
         theta_app(i,2)=theta_app(i,2)-ymin
         theta_app(i,2)=-theta_app(i,2)
         if(theta_app(i,2).lt.yymin)yymin=theta_app(i,2)
      enddo
      yminn=-yymin
      do i=1,npunti
         theta_app(i,2)=theta_app(i,2)+yminn
      enddo
      do i=1,npunti
         theta_int(i,1)=theta_app(i,1)
         theta_int(i,2)=theta_app(i,2)
      enddo
      call searchmax(ier)
      do j=1,5
      mrange=0
      sogs=0.3+float(j-1)*0.05
      do i=1,npk
!!!!!!!!12 settembre 2008 questo if e' nuovo
        if((-ymax(i)+ymin+yminn).le.sogs*yymax.and.
     *    (-ymax(i)+ymin+yminn).ge.0.0)then
          mrange=mrange+1
          tt(mrange)=xmax(i)
          countmi(mrange)=-ymax(i)+ymin+yminn
        endif
      enddo
      if(mrange.gt.npk/2)exit
      enddo
      if(mrange.eq.0)sogs=1.0
      mrange=0
      do i=1,npk
!!!!!!!!12 settembre 2008 questo if e' nuovo
        if((-ymax(i)+ymin+yminn).le.sogs*yymax)then
        mrange=mrange+1
        tt(mrange)=xmax(i)
        countmi(mrange)=-ymax(i)+ymin+yminn
        endif
      enddo
      npunti=npuntisav
      do i=1,npunti
        theta_int(i,1)=theta_app(i,6)
        theta_int(i,2)=theta_app(i,7)
      enddo
      thmin=theta_int(1,1)
      thmax=theta_int(npunti,1)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      mmrange=mrange
      mrange=0
      csog=1.1
      do j=1,mmrange                                                 
corrado: run-time error
c       if(j.gt.1.and.j.lt.mmrange        !!!!.and.
!!!! *    countmi(j).le.csog*countmi(j-1)
c    *    .and.countmi(j).le.csog*countmi(j+1))then
c         if (countmi(j).le.csog*countmi(j-1)) then
c         mrange=mrange+1
c         tx(mrange)=tt(j)
c         ty(mrange)=countmi(j)                         
c         weigc(mrange)=1.0     
c         endif
c       elseif(j.eq.1.or.j.eq.mmrange)then
c         mrange=mrange+1
c         tx(mrange)=tt(j)
c         ty(mrange)=countmi(j)                         
c         weigc(mrange)=1.0     
c       else
c         mrange=mrange+1
c         tx(mrange)=tt(j)
c         ty(mrange)=countmi(j)                         
c         weigc(mrange)=0.1                
c       endif
        if(j.gt.1.and.j.lt.mmrange        
     *    .and.countmi(j).le.csog*countmi(j+1))then
          if (countmi(j).le.csog*countmi(j-1)) then
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=1.0
          else
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=0.1
          endif
        elseif(j.eq.1.or.j.eq.mmrange)then
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=1.0
        else
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=0.1
        endif
      enddo
      do j=1,mrange                                                 
        tt(j)=tx(j)
        countmi(j)=ty(j)
        weig(j)=weigc(j)
      enddo
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      do j=1,mrange                                                 
        ttapp(j)=tt(j)
        countmiapp(j)=countmi(j)
        weigapp(j)=weig(j)
      enddo
      thetamin=tmm(nntt)
      do j=1,mrange                                                 
        xminn=99999999.0
        do jj=1,mrange
          if(ttapp(jj).lt.xminn)then
            xminn=ttapp(jj)            
            jsav=jj
          endif
        enddo
        tt(j)=ttapp(jsav)
        countmi(j)=countmiapp(jsav)
        weig(j)=weigapp(jsav)
        ttapp(jsav)=999999999.0
      enddo
      if(ipol.eq.1)then
        nrangemin=npol(nntt)
        nrangemax=npol(nntt)
      elseif(ipol.eq.0.and.npolsav(nntt).ne.npol(nntt))then
        nrangemin=npol(nntt)
        nrangemax=npol(nntt)
      else
        nrangemin=5
        nrangemax=11
      endif
      nvolt=nrangemax-nrangemin+1
      do ijk=1,nvolt
        nrange=nrangemin+ijk-1
        do i=1,nrange
          dmat(i)=0.0
          amt(i)=0.0
          do j=1,nrange
            amat(i,j)=0.0
          enddo          
        enddo          
        do i=1,mrange
          pesos=weig(i)     
          amt(1)=1.0
          amt(2)=(tt(i)/thetamin-1.0)
          amt(3)=amt(2)**2
          amt(4)=amt(2)**3
          amt(5)=amt(2)**4
          amt(6)=amt(2)**5
          amt(7)=amt(2)**6
          amt(8)=amt(2)**7
          amt(9)=amt(2)**8
          amt(10)=amt(2)**9
          amt(11)=amt(2)**10
          do k=1,nrange
             dmat(k)=dmat(k)+(countmi(i)*amt(k))*pesos
             do kk=1,nrange
               amat(k,kk)=amat(k,kk)+amt(k)*amt(kk)*pesos
             enddo 
          enddo
        enddo  
        N=nrange
        NPP=11
        M=1
        MP=1
        call LUDCMP(amat,N,NPP,INDX,D,ier)
        if(ier.lt.0)return
        call LUBKSB(amat,N,NPP,INDX,dmat)
        do i=1,mrange
          ttt=(tt(i)/thetamin-1.0)
          countmic(i)=dmat(1)
          if(nrange.gt.1)then
            do k=2,nrange  
              ksp=real(k)-1.0
              countmic(i)=countmic(i)+dmat(k)*(ttt**ksp)
            enddo   
          endif
        enddo    
        sumbo=0.0
        sumbc=0.0
        do i=1,mrange
          sumbo=sumbo+countmi(i)
          sumbc=sumbc+countmic(i)
        enddo    
        scalb=sumbo/sumbc
        sumdb=0.0
        do i=1,mrange
          sumdb=sumdb+abs(countmi(i)-scalb*countmic(i))
        enddo   
        erreb=sumdb/sumbo
        if(ijk.eq.1)erremn=erreb
        if(erreb.le.erremn)then
          erremn=erreb
          nrangesav=nrange
          do i=1,nrange
            bkg(i)=dmat(i)
          enddo    
          if(nrange.lt.11)then
            do i=nrange+1,11
              bkg(i)=0.0    
            enddo    
          endif
        endif
      enddo    
      nrange=nrangesav
      do i=ncoun11(nntt),ncoun22(nntt)
        thet=theta_int(i,1)/thetamin - 1.0
        back_int(i,1)=bkg(1)
        if(nrange.gt.1)then
          do k=2,nrange     
            ksp=real(k)-1.0
            back_int(i,1)=back_int(i,1)+bkg(k)*(thet**ksp)
          enddo     
        endif
      enddo
      kattemax=50
      katte=0
 4010 continue
      katte=katte+1
      ieskatte=0
      mmrange=0
      varmed=0.0
      nnnn=0
      do i=1,mrange                             
!corr          ranth=tt(i)-thmin
!corr          in = int ( ranth / thstep ) + 1
          in = clocate(theta_int(:npunti,7),tt(i))
          if(countmi(i).ge.back_int(in,1))then
            varmed=varmed+((countmi(i)-back_int(in,1))
     *                  /back_int(in,1))
            nnnn=nnnn+1
          endif
      enddo
      varmed=varmed/float(nnnn)
      varm=0.0
      countmini=999999.0
      do i=1,mrange                             
!corr          ranth=tt(i)-thmin
!corr          in = int ( ranth / thstep ) + 1
          in = clocate(theta_int(:npunti,7),tt(i))
          if(countmi(i).ge.back_int(in,1))then
            varm=varm+(((countmi(i)-back_int(in,1))/back_int(in,1))
     *           -varmed)**2                                  
          endif
      enddo
      varm=varm/float(nnnn-1)
      varm=sqrt(varm)
      varmsog=0.01
      if(varm.lt.varmsog)go to 1313
      varsog=0.5+0.05*float(katte-1)
      do i=1,mrange                             
!corr          ranth=tt(i)-thmin
!corr          in = int ( ranth / thstep ) + 1
          in = clocate(theta_int(:npunti,7),tt(i))
          vara=((countmi(i)-back_int(in,1))/back_int(in,1))-varmed    
          if(countmi(i).le.back_int(in,1).or.vara.lt.varsog*varm)then
            mmrange=mmrange+1
            tx(mmrange)=tt(i)
            ty(mmrange)=countmi(i)                         
            weigc(mmrange)=weig(i)
          else
             ieskatte=1
          endif
 1111     continue
      enddo
      mrange=0           
      do j=1,mmrange
        mrange=mrange+1
        tt(mrange)=tx(j)
        countmi(mrange)=ty(j)
        weig(mrange)=weigc(j)
      enddo
 1313 continue
      if(ipol.eq.1)then
        nrangemin=npol(nntt)
        nrangemax=npol(nntt)
      elseif(ipol.eq.0.and.npolsav(nntt).ne.npol(nntt))then
        nrangemin=npol(nntt)
        nrangemax=npol(nntt)
      else
        nrangemin=5
        nrangemax=11
      endif
      nvolt=nrangemax-nrangemin+1
!!!!!!!!!!!!!!!!! corrado
      !call generate_points(nnt, mrange)
!!!!!!!!!!!!!!!!!
      do ijk=1,nvolt
        nrange=nrangemin+ijk-1
        do ii=1,nrange
          dmat(ii)=0.0
          amt(ii)=0.0
          do j=1,nrange
            amat(ii,j)=0.0
          enddo          
        enddo          
        do ii=1,mrange
          pesos=weig(ii)         
          amt(1)=1.0
          amt(2)=(tt(ii)/thetamin-1.0)
          amt(3)=amt(2)**2
          amt(4)=amt(2)**3
          amt(5)=amt(2)**4
          amt(6)=amt(2)**5
          amt(7)=amt(2)**6
          amt(8)=amt(2)**7
          amt(9)=amt(2)**8
          amt(10)=amt(2)**9
          amt(11)=amt(2)**10
          do k=1,nrange
           dmat(k)=dmat(k)+(countmi(ii)*amt(k))*pesos
             do kk=1,nrange
               amat(k,kk)=amat(k,kk)+amt(k)*amt(kk)*pesos
             enddo 
          enddo
        enddo  
        N=nrange
        NPP=11
        M=1
        MP=1
        call LUDCMP(amat,N,NPP,INDX,D,ier)
        if(ier.lt.0)return
        call LUBKSB(amat,N,NPP,INDX,dmat)
        do ii=1,mrange
          ttt=(tt(ii)/thetamin-1.0)
          countmic(ii)=dmat(1)
          if(nrange.gt.1)then
            do k=2,nrange  
              ksp=real(k)-1.0
              countmic(ii)=countmic(ii)+dmat(k)*(ttt**ksp)
            enddo   
          endif
        enddo    
        sumbo=0.0
        sumbc=0.0
        do ii=1,mrange
          sumbo=sumbo+countmi(ii)
          sumbc=sumbc+countmic(ii)
        enddo    
        scalb=sumbo/sumbc
        sumdb=0.0
        do ii=1,mrange
          sumdb=sumdb+abs(countmi(ii)-scalb*countmic(ii))
        enddo   
        erreb=sumdb/sumbo
        if(ijk.eq.1)erremn=erreb
        if(erreb.le.erremn)then
          erremn=erreb
          nrangesav=nrange
          do ii=1,nrange
            bkg(ii)=dmat(ii)
          enddo    
          if(nrange.lt.11)then
            do ii=nrange+1,11
              bkg(ii)=0.0    
            enddo    
          endif
        endif
      enddo    
      nrange=nrangesav
      do i=ncoun11(nntt),ncoun22(nntt)
        thet=theta_int(i,1)/thetamin - 1.0
        back_int(i,1)=bkg(1)
        if(nrange.gt.1)then
          do k=2,nrange     
            ksp=real(k)-1.0
            back_int(i,1)=back_int(i,1)+bkg(k)*(thet**ksp)
          enddo     
        endif
      enddo
      if(katte.lt.kattemax.and.ieskatte.gt.0)go to 4010
CCCCCCCCCCCCCCCCCCCCCC
      mmrange=mrange
      mrange=0
      do j=1,mmrange                                                 
corrado: run-time error
        if(j.gt.1.and.j.lt.mmrange        !!!!.and.
!!!! *    countmi(j).le.csog*countmi(j-1)
     *    .and.countmi(j).le.csog*countmi(j+1))then
          if (countmi(j).le.csog*countmi(j-1)) then
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=1.0
          else
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=0.5
          endif
        elseif(j.eq.1.or.j.eq.mmrange)then
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=1.0
        else
          mrange=mrange+1
          tx(mrange)=tt(j)
          ty(mrange)=countmi(j)
          weigc(mrange)=0.5
        endif
      enddo
      do j=1,mrange                                                 
        tt(j)=tx(j)
        countmi(j)=ty(j)
        weig(j)=weigc(j)
      enddo
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      ccsog=1.05
      mmrange=0
      rang=50*thstep
      if(rang.lt.0.5)rang=0.5
      if(rang.gt.2.0)rang=2.0
      if((tt(1)-thet11(nntt)).gt.5.0*thstep)then
!corr        ranth1=thet11(nntt)-thmin
!corr        in1=int(ranth1/thstep)+1 
!corr        ranth2=tt(1)-thmin
!corr        in2=int(ranth2/thstep)+1 
        in1 = clocate(theta_int(:npunti,7),thet11(nntt))
        in2 = clocate(theta_int(:npunti,7),tt(1))
        insav=0
        ymnn=countmi(1)
        do j=in1,in2-2 
          if(theta_int(j,2).le.ccsog*ymnn)then
            ymn=theta_int(j,2)
            xmn=theta_int(j,1)
            insav=j
            go to 1233
          endif
        enddo
 1233   continue
        if(insav.gt.0)then
          mmrange=mmrange+1
          tx(mmrange)=xmn      
          ty(mmrange)=ymn           
          weigc(mmrange)=1.0                         
        else
          mmrange=mmrange+1
          tx(mmrange)=thet11(nntt)
          ty(mmrange)=countmi(1)*ccsog
          weigc(mmrange)=1.0                         
        endif
      endif
      if(mmrange.gt.0)then
        if((tx(mmrange)-thet11(nntt)).gt.5.0*thstep)then
          mmrange=mmrange+1
          tx(mmrange)=thet11(nntt)
          ty(mmrange)=countmi(1)*ccsog
          weigc(mmrange)=1.0                         
        endif
      endif
 1310 continue
      do j=1,mrange
        mmrange=mmrange+1
        tx(mmrange)=tt(j)               
        ty(mmrange)=countmi(j)         
        weigc(mmrange)=weig(j)                     
      enddo
      if((thet22(nntt)-tx(mmrange)).gt.5.0*thstep)then
!corr        ranth1=tx(mmrange)-thmin
!corr        in1=int(ranth1/thstep)+1 
!corr        ranth2=thet22(nntt)-thmin
!corr        in2=int(ranth2/thstep)+1 
        in1 = clocate(theta_int(:npunti,7),tx(mmrange))
        in2 = clocate(theta_int(:npunti,7),thet22(nntt))
!corr
        insav=0
        ymnn=ty(mmrange)              
        do j=in2,in1-2,-1
          if(theta_int(j,2).le.ccsog*ymnn)then
            ymn=theta_int(j,2)
            xmn=theta_int(j,1)
            insav=j
            go to 1333
          endif
        enddo
 1333   continue
        if(insav.gt.0)then
          mmrange=mmrange+1
          tx(mmrange)=xmn      
          ty(mmrange)=ymn           
          weigc(mmrange)=1.0                           
        else
          mmrange=mmrange+1
          tx(mmrange)=thet22(nntt)
          ty(mmrange)=ty(mmrange-1)*ccsog
          weigc(mmrange)=1.0                           
        endif
      endif
      if((thet22(nntt)-tx(mmrange)).gt.5.0*thstep)then
          mmrange=mmrange+1
          tx(mmrange)=thet22(nntt)
          ty(mmrange)=ty(mmrange-1)
          weigc(mmrange)=1.0                           
      endif
      mrange=mmrange
      do j=1,mrange
        tt(j)=tx(j)
        countmi(j)=ty(j)
        weig(j)=weigc(j)
      enddo
      do j=1,mrange                                                 
        ttapp(j)=tt(j)
        countmiapp(j)=countmi(j)
        weigapp(j)=weig(j)
      enddo
      do j=1,mrange                                                 
        xminn=99999999.0
        do jj=1,mrange
          if(ttapp(jj).lt.xminn)then
            xminn=ttapp(jj)            
            jsav=jj
          endif
        enddo
        tt(j)=ttapp(jsav)
        countmi(j)=countmiapp(jsav)
        weig(j)=weigapp(jsav)
        ttapp(jsav)=999999999.0
      enddo
      mmrange=1                 
      tx(mmrange)=tt(1)
      ty(mmrange)=countmi(1)
      weigc(mmrange)=weig(1)
      do j=2,mrange
       if(tt(j).gt.tx(mmrange))then
         if((tt(j)-tx(mmrange)).gt.rang)then     
           delta=(tt(j)-tx(mmrange))/rang
           knk=int(delta)
           coef=(countmi(j)-countmi(j-1))/(tt(j)-tt(j-1))
           do kk=1,knk
             txx=tx(mmrange)+rang
!corr             ranth=txx-thmin
!corr             rmod=amod(ranth,thstep)
!corr             if(rmod.gt.0.0)then
!corr               in=int(ranth/thstep)+1 
!corr             else
!corr               in=int(ranth/thstep) 
!corr             endif
             in = clocate(theta_int(:npunti,7),txx)
               mmrange=mmrange+1
               tx(mmrange)=txx                        
               yx=countmi(j-1)+coef*(tx(mmrange)-tt(j-1))
               if(theta_int(in,2).ge.yx)then
                 ty(mmrange)=yx
               else
                 ty(mmrange)=theta_int(in,2)
               endif
               weigc(mmrange)=weig(j-1)
           enddo
           mmrange=mmrange+1
           tx(mmrange)=tt(j)
           ty(mmrange)=countmi(j)
           weigc(mmrange)=weig(j)
         else
           mmrange=mmrange+1
           tx(mmrange)=tt(j)
           ty(mmrange)=countmi(j)
           weigc(mmrange)=weig(j)
         endif
       endif
      enddo
      mrange=mmrange
      do j=1,mrange
        tt(j)=tx(j)
        countmi(j)=ty(j)
        weig(j)=weigc(j)
      enddo
      do j=1,mrange                                                 
        ttapp(j)=tt(j)
        countmiapp(j)=countmi(j)
        weigapp(j)=weig(j)
      enddo
      do j=1,mrange                                                 
        xminn=99999999.0
        do jj=1,mrange
          if(ttapp(jj).lt.xminn)then
            xminn=ttapp(jj)            
            jsav=jj
          endif
        enddo
        tt(j)=ttapp(jsav)
        countmi(j)=countmiapp(jsav)
        weig(j)=weigapp(jsav)
        ttapp(jsav)=999999999.0
      enddo
      if(ipol.eq.1)then
        nrangemin=npol(nntt)
        nrangemax=npol(nntt)
      elseif(ipol.eq.0.and.npolsav(nntt).ne.npol(nntt))then
        nrangemin=npol(nntt)
        nrangemax=npol(nntt)
      else
        nrangemin=5
        nrangemax=11
      endif
      nvolt=nrangemax-nrangemin+1
      do ijk=1,nvolt
        nrange=nrangemin+ijk-1
        do ii=1,nrange
          dmat(ii)=0.0
          amt(ii)=0.0
          do j=1,nrange
            amat(ii,j)=0.0
          enddo          
        enddo          
        do ii=1,mrange
          pesos=weig(ii)
          amt(1)=1.0
          amt(2)=(tt(ii)/thetamin-1.0)
          amt(3)=amt(2)**2
          amt(4)=amt(2)**3
          amt(5)=amt(2)**4
          amt(6)=amt(2)**5
          amt(7)=amt(2)**6
          amt(8)=amt(2)**7
          amt(9)=amt(2)**8
          amt(10)=amt(2)**9
          amt(11)=amt(2)**10
          do k=1,nrange
           dmat(k)=dmat(k)+(countmi(ii)*amt(k))*pesos
             do kk=1,nrange
               amat(k,kk)=amat(k,kk)+amt(k)*amt(kk)*pesos
             enddo 
          enddo
        enddo  
        N=nrange
        NPP=11
        M=1
        MP=1
        call LUDCMP(amat,N,NPP,INDX,D,ier)
        if(ier.lt.0)return
        call LUBKSB(amat,N,NPP,INDX,dmat)
        do ii=1,mrange
          ttt=(tt(ii)/thetamin-1.0)
          countmic(ii)=dmat(1)
          if(nrange.gt.1)then
            do k=2,nrange  
              ksp=real(k)-1.0
              countmic(ii)=countmic(ii)+dmat(k)*(ttt**ksp)
            enddo   
          endif
        enddo    
        sumbo=0.0
        sumbc=0.0
        do ii=1,mrange
          sumbo=sumbo+countmi(ii)
          sumbc=sumbc+countmic(ii)
        enddo    
        scalb=sumbo/sumbc
        sumdb=0.0
        do ii=1,mrange
          sumdb=sumdb+abs(countmi(ii)-scalb*countmic(ii))
        enddo   
        erreb=sumdb/sumbo
        if(ijk.eq.1)erremn=erreb
        if(erreb.le.erremn)then
          erremn=erreb
          nrangesav=nrange
          do ii=1,nrange
            bkg(ii)=dmat(ii)
          enddo    
          if(nrange.lt.11)then
            do ii=nrange+1,11
              bkg(ii)=0.0    
            enddo    
          endif
        endif
      enddo    
      nrange=nrangesav
CCCCCCCCCCCCCCCCCCCCCC
      if(nntt.eq.2)then
        rapsog1=0.05
        rapsog2=0.08
        rapsogg1=1.01
        rapsogg2=1.1
      else
        rapsog1=0.05
        rapsog2=0.07
        rapsogg1=1.00
        rapsogg2=1.1
      endif
cmodifica 22aprile2005 (lefebvre non andava bene)
      nbackmeno=0
cmodifica 22aprile2005 (lefebvre non andava bene)
      n6100=0
6100  continue
      n6100=n6100+1
!     write(6,*) ' BACKGROUND EXTRA'
      do i=ncoun11(nntt),ncoun22(nntt)
        thet=theta_int(i,1)/thetamin - 1.0
        back_int(i,1)=bkg(1)
        if(nrange.gt.1)then
          do k=2,nrange     
            ksp=real(k)-1.0
            back_int(i,1)=back_int(i,1)+bkg(k)*(thet**ksp)
          enddo     
        endif
!       write(6,'(i6,1h),f10.2)') i,back_int(i,1)
      enddo
      npos=0
      nposatt=0
      tposatt=0.0
      ntot=ncoun2(nntt)-ncoun1(nntt)+1
cmodifica 22aprile2005 (lefebvre non andava bene)
      bmed=0.0
      do k=1,mrange
        bmed=bmed+countmi(k)
      enddo
      bmed=bmed/float(mrange)
      menob=0
      do k=1,mrange
         if(countmi(k).lt.bmed)then
           if((bmed-countmi(k)).gt.0.95*bmed)menob=1
         endif
      enddo
cmodifica 22aprile2005 (lefebvre non andava bene)
      do i=ncoun1(nntt),ncoun2(nntt)
        if(back_int(i,1).gt.rapsogg1*theta_int(i,2))npos=npos+1
        if(back_int(i,1).gt.rapsogg2*theta_int(i,2))then
          nposatt=nposatt+1
          tposatt=tposatt+theta_int(i,1)
        endif
      enddo
      rap=float(npos)/float(ntot)
      rapatt=float(nposatt)/float(ntot)
      if(nposatt.gt.0)tposatt=tposatt/float(nposatt)
      if(rapatt.gt.0.02.and.(tposatt-thmin).lt.2.0)rapatt=0.01
      if(rapatt.gt.0.02.and.(thmax-tposatt).lt.2.0)rapatt=0.01
cmodifica 22aprile2005 (lefebvre non andava bene)
c     if(rap.gt.rapsog2.or.rapatt.gt.0.02)then
cmodifica 22aprile2005 (lefebvre non andava bene)
      if(menob.eq.0.or.nbackmeno.le.3)then
        if((rap.gt.rapsog2.or.rapatt.gt.0.02))then
          do k=1,nrange
            bkg(k)=bkg(k)*0.98
          enddo
          nbackmeno=nbackmeno+1
          if(n6100<50) go to 6100
        endif
      endif
      if(rapatt.gt.0.01)go to 6000
      if(rap.lt.rapsog1)then
        do k=1,nrange
          bkg(k)=bkg(k)*1.003
        enddo
        if(n6100<50) go to 6100
      endif
6000  continue
      jjj=nntt          
      npol(jjj)=nrange
      npolsav(jjj)=nrange
      tmm(jjj)=thetamin
      do j=1,npol(jjj)
        bkk(j,jjj)=bkg(j)
      enddo     
      do i=1,mrange
        nback=nback+1
        backp(nback,1)=tt(i)
        backp(nback,2) =countmi(i)
        ntyp(nback)=nntt
        weigb(nback)=weig(i)  
      enddo
      if(nntt.lt.(nnt-1))go to 1500
      return
      end
c-----------------------------------------------------------
c-----------------------------------------------------------
      subroutine searchmax(ier)
      USE Conteggi
      USE ProfileApp
      USE General
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/genob2/thmin,thmax,thstep
      common /peak/xmax(200),ymax(200),fw(200),npk,asm(200)
!corr-non modificare sogi nel common
!corr      common /searchcond/ths11,ths22,sogii,sogd,iesdirsear
!corr      common /searchcond/ths1,ths2,sogi,sogd,iesdirsear
      dimension xmx(200),ymx(200),dx(200),fww(200),asmm(200)
      dimension iflagg(200)
      real :: ths1,ths2,sogi
c-----
      thmin=theta_int(1,1)
      thmax=theta_int(npunti,1)
      ths1=thmin
      ths2=thmax
c----
      npk = 100
      npsog= 100
      sogi=10.0
c------
      npeakk=0
      npun=0
      do 50 i=1,200
      fw(i)=0.5
 50   continue
      yminn=99999999.0
      ymaxx=-999999999.0
      if(npk.eq.0)npk=50
      do 150 i=1,npunti
      theta_app(i,5)=0.0
      if(theta_int(i,1).le.ths2.and.theta_int(i,1).ge.ths1)then
      if(theta_int(i,2).lt.yminn)yminn=theta_int(i,2)
      endif
  150 continue
      npun=npunti
      do 180 i=1,npunti
      if(theta_int(i,1).le.ths2.and.theta_int(i,1).ge.ths1)then
      theta_app(i,5)=theta_int(i,2)-yminn
      else
      theta_app(i,5)=0.0 
      endif
 180  continue
      yminas = yminn
      ysog=15.0*yminn     
      do 200 i=1,npun
c     ymaxx=-9999999.0
      ymaxx=0.0               
      nvolte=0
      do 300 j=1,npun
CCCCCCCCCCCC
      if(j.eq.1.or.j.eq.npun)go to 300
      if(theta_app(j,5).gt.ymaxx.and.theta_int(j,2).ge.theta_int(j-1,2)
     *.and.theta_int(j,2).ge.theta_int(j+1,2))then
      ymaxx=theta_app(j,5)
      xmaxx=theta_int(j,1)
      jmax=j
      nvolte=1
      endif
 300  continue
      if(nvolte.eq.0)go to 500
      npeakk=npeakk+1
      if(npeakk.gt.npsog)then
      npeakk=npeakk-1
      go to 500
      endif
      xmax(npeakk)=xmaxx
      ymax(npeakk)=theta_int(jmax,2)
      ss=sin(xmaxx*0.5*dtor)
      cc=cos(xmaxx*0.5*dtor)
      tt=ss/cc
      y0=ymaxx
      fwmed=0.0
      nmed=0
      named=0
      asmed=0.0
      nnm=nint(0.05/thstep)
      if(nnm.lt.3)nnm=3
      do 7000 j=-nnm,nnm
      k=jmax+j
      if(k.ge.1.and.k.le.npunti.and.k.ne.jmax)then
      nmed=nmed+1
      kk=iabs(k-jmax)
      y00=theta_app(k,5)
      if(y00.gt.0.0.and.y00.lt.y0)then
      al1=alog(y0/y00)
      al2=alog(2.0)
      fwmed=fwmed+sqrt(4.0*(kk**2)*al2*(thstep**2)/al1)
      endif
      if(j.lt.0)then
      named=named+1
      y1=theta_app(k,5)
      ifi=min0(npun,iabs(j)+jmax)
      y2=theta_app(ifi,5)
      if(abs(y1+y2).gt.0.0)then
      div1=(y1-y2)/(y1+y2)
      div2=((kk*thstep)**2)/tt
      asmed=asmed+div1/div2
      endif
      endif
      endif
 7000 continue
      fw(npeakk)=fwmed/nmed
      asm(npeakk)=asmed/named
      if(fw(npeakk).lt.3.0*thstep) fw(npeakk)=3.0*thstep
      if(fw(npeakk).gt.3.0) fw(npeakk)=3.0
      nstep=int((2.0*fw(npeakk))/thstep)
      iniz=max0(1,jmax-nstep)
      ifin=min0(npun,jmax+nstep)
      const=-4.0*alog(2.0)/((fw(npeakk))**2)
      do 600 j=iniz,ifin
      dth=theta_int(j,1)-xmaxx
      funct=exp(const*(dth**2))
      dth2=dth**2
      fasy=1.0-(asm(npeakk)*sign(1.0,dth)*dth2)/tt
CORIG theta_int(j,5)=theta_int(j,5)-ymaxx*funct*fasy
      yycalc = ymaxx*funct*fasy
CSAL
      if (yycalc.lt.0.0) then
          yycalc = 0.0
      endif
CSAL
      theta_app(j,5)=theta_app(j,5)-yycalc
      if(theta_app(j,5).lt.0.0)theta_app(j,5)=0.0
 600  continue
 200  continue
 500  continue
      do 1000 i=1,npeakk
      iflagg(i)=1
      yrif=-999999999.0   
      do 1100 j=1,npeakk
      if(ymax(j).gt.yrif)then
      xmx(i)=xmax(j)
      ymx(i)=ymax(j)
      fww(i)=fw(j)
      asmm(i)=asm(j)
      yrif=ymax(j)
      jsav=j
      endif
1100  continue
      ymax(jsav)=-9999999.0
1000  continue
      npeak=0
      do 2000 i=1,npeakk
      if(iflagg(i).eq.0)go to 2000
      do 2150 j=i+1,npeakk
      dx(j)=xmx(j)-xmx(i)
      if(abs(dx(j)).le.0.5*fww(i))then
         iflagg(j)=0
      endif
 2150 continue
 2000 continue
c-------
      do i=1,npeakk
         xmax(i) = xmx(i)
         ymax(i) = ymx(i)
      enddo
c-------
      do 2500 i=1,npeakk
      if(iflagg(i).gt.0)then
      npeak=npeak+1
      if(npeak.gt.npk)then
      npeak=npeak-1
      go to 2550
      endif
      xmax(npeak)=xmx(i)
      ymax(npeak)=ymx(i)
      fw(npeak)=fww(i)
      asm(npeak)=asmm(i)
      endif
 2500 continue
 2550 continue
      yymay=-99999.0
      do 3500 i=1,npeak
      xmx(i)=xmax(i)
      ymx(i)=ymax(i)
      asmm(i)=asm(i)
      fww(i)=fw(i)
      if(ymx(i).gt.yymay)yymay=ymx(i)
 3500 continue
c---new
      npk=0
      do 4000 i=1,npeak
      thminn=9999.0
      do 5000 j=1,npeak
      if(xmx(j).lt.thminn)then
      thminn=xmx(j)
      jsav=j
      endif
 5000 continue
      yr=100.0*ymx(jsav)/yymay
      if(yr.gt.sogi)then
      npk=npk+1
      xmax(npk)=xmx(jsav)
      ymax(npk)=ymx(jsav)
      asm(npk)=asmm(jsav)
      fw(npk)=fww(jsav)
      d=alambda/(2.0*sin(0.5*xmx(jsav)*dtor))
      endif
      xmx(jsav)=99999.0
 4000 continue
      return
      end
c-----------------------------------------------------------
      subroutine ghost_extra(fw)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil
      USE nr, only: indexx
!corr      common/bdata/ibig(124000)
      common /peak/xmax(200),ymax(200),ffw(200),npk,asm(200)
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      dimension xxmax(nrefl),yymax(nrefl),afwxmax(nrefl)
      dimension fw(nrefl),itrov(100),TThetap(nrefl)
      integer, dimension(nrefl) :: iorder
!corr      dimension abig(72000)
!corr      equivalence (ibig(1),abig(1))
c
c     do i=1,nrefl
c      write(6,*) 'REFL_iniz',i,TThet(i),fw(i)
c     end do
      call sfl39
!corr
      call indexx(TThet(:nrefl),iorder)
      TThetap(:nrefl) = TThet(iorder)
      fw(:nrefl) = fw(iorder)
!FIXED: wrong sort
!corr      lind=138001
!corr      iblk=15
!corr      jump=11
!corr      izer=15*nrefl
!corr      do 502 i=1,izer
!corr 502    abig(i) = 0.0
!corr      do 691 i=1,nrefl
!corr       ibig(15*(i-1)+1)=IndHKL(i,1)
!corr       ibig(15*(i-1)+2)=IndHKL(i,2)
!corr       ibig(15*(i-1)+3)=IndHKL(i,3)
!corr       ibig(15*(i-1)+4)=IndHKL(i,4)
!corr       ibig(15*(i-1)+5)=IndHKL(i,5)
!corr       abig(15*(i-1)+6)=SetFob(i,1)
!corr       abig(15*(i-1)+7)=SetFob(i,2)
!corr       abig(15*(i-1)+8)=SetFob(i,3)
!corr       abig(15*(i-1)+9)=SetFob(i,4)
!corr       abig(15*(i-1)+10)=SetFob(i,5)
!corr       abig(15*(i-1)+11)=TThet(i)
!corr       ibig(15*(i-1)+12)=Mult(i)
!corr       abig(15*(i-1)+13)=fw(i)
!corr       abig(15*(i-1)+14)=fxsav(i)
!corr       abig(15*(i-1)+15)=SetFob(i,4)
!corr  691 continue
!corr      call sortz(lind,nrefl,iblk,jump)
!corrc     write(50,*) 'REFLEXIONES'
!corr      do 792 i=1,nrefl
!corr       TThetap(i)=abig(15*(i-1)+11)
!corr       fw(i)=abig(15*(i-1)+13)
!corr       write(50,*) i,tthetap(i),fw(i)
!corr  792 continue
      do i=1,nrefl
         xxmax(i)=0.0
         yymax(i)=0.0
         afwxmax(i)=0.0
c      write(6,*) 'REFL',i,TThetap(i),fw(i)
      end do

c     do i=1,npunti
c      write(6,*) 'PICCHI',i,theta_int(i,7),theta_int(i,2)
c     end do

cccc
!      if(fw(i)<0.1) then
!        sog=0.35
!      else
      sog=0.5
!      end if
      npk_extra=0
      ii=0
      do i=1,npk
c       write(6,*) 'SEARCH',i,xmax(i)
        drmin=99999999.0
        do j=1,nrefl
          drx=abs(xmax(i)-TThetap(j))
c         write(6,*) 'TETA',j,TThetap(j),drx
          if(drx.lt.drmin)then
            drmin=drx
            ijsav=j
          endif
 200    enddo
c       write(6,*) 'DRMIN',i,drmin
c        if(drmin.gt.sog)then
        if(drmin.gt.fw(ijsav)) then

          ii=ii+1
          itrov(ii)=ijsav
c         write(6,*) 'SEARCH1',i,ii,xmax(i),ijsav,itrov(ii)
          npk_extra=npk_extra+1
          xxmax(npk_extra)=xmax(i)
          yymax(npk_extra)=ymax(i)
          afwxmax(npk_extra)=ffw(i)

          write(lo,501) xxmax(npk_extra),afwxmax(npk_extra)
        endif
      enddo
cccc
      do i=1,nrefl-1
        do l=1,ii
          if(itrov(l).eq.i.or.itrov(l).eq.(i+1)) go to 1
        end do
        drfwhm=0.5*(fw(i)+fw(i+1))
        drx=TThetap(i+1)-TThetap(i)
c        if(drx.gt.drfwhm) then
        if(drx.gt.drfwhm.and.drx.lt.1.3) then

c        write(6,*) 'DIST',i,TThetap(i),TThetap(i+1),fw(i),fw(i+1)

          if(fw(i).lt.0.1.or.fw(i+1).lt.0.1) then
            ranthp=(TThetap(i)+(0.9*fw(i)))  !!!corr-theta_int(1,7)
            ranth1p=(TThetap(i+1)-(0.9*fw(i+1)))    !!!corr-theta_int(1,7)
          else
            ranthp=(TThetap(i)+(0.5*fw(i)))      !!!!corr  -theta_int(1,7)
            ranth1p=(TThetap(i+1)-(0.5*fw(i+1)))      !!!!corr  -theta_int(1,7)
          endif

!corr          ranth=TThetap(i)-theta_int(1,7)
!corr          ranth1=TThetap(i+1)-theta_int(1,7)
          
 
c          write(48,*) i,theta_int(1,7),thstep,tthetap(i),tthetap(i+1)

c         if(fw(i).lt.0.1.or.fw(i+1).lt.0.1) then
!corr            irani=anint(ranthp/thstep)+1
!corr            iranf=anint(ranth1p/thstep)+1
            irani = clocate(theta_int(:npunti,7),ranthp)
            iranf = clocate(theta_int(:npunti,7),ranth1p)
!corr            in1=anint(ranth/thstep)+1  !antes, 2
!corr            in11=anint(ranth1/thstep)+1  !antes, 2
            in1 = clocate(theta_int(:npunti,7),TThetap(i))
            in11 = clocate(theta_int(:npunti,7),TThetap(i+1))
c         else
c           irani=anint(ranthp/thstep)+1  !antes, 2
c           iranf=anint(ranth1p/thstep)+1  !antes, 2
c           in1=anint(ranth/thstep)+1
c           in11=anint(ranth1/thstep)+1
c         endif

          aymax=-9999999.0
          if(in11>npunti) in11=npunti
          do l=in1,in11
            if(theta_int(l,2).gt.aymax) then
              aymax=theta_int(l,2)
              ijsav=l
            endif 
          end do

          if(fw(i).lt.0.1.or.fw(i+1).lt.0.1) then
            if(abs(theta_int(ijsav,7)-TThetap(i))<0.45*fw(i)) goto 1
            if(abs(theta_int(ijsav,7)-TThetap(i+1))<0.45*fw(i+1)) goto 1
          else
            if(abs(theta_int(ijsav,7)-TThetap(i))<0.25*fw(i)) goto 1
            if(abs(theta_int(ijsav,7)-TThetap(i+1))<0.25*fw(i+1)) goto 1
          endif

c            xxxmax=ijsav*thstep+thmin-thstep
          xxxmax=theta_int(ijsav,7)
c         write(6,*)'INF.PICCO',xxxmax,aymax,drfwhm
c         write(6,*)'RANGEPICCO',irani,iranf
c         write(6,*)'INF.ESTRLAV',theta_int(irani,7),theta_int(iranf,7) 
c         write(6,*)'INT.ESTRLAV',theta_int(irani,2),theta_int(iranf,2)
c         write(6,*)'INF.ESTREMIveri',theta_int(in1,7),theta_int(in11,7) 
c    *              ,theta_int(in1,2),theta_int(in11,2),in1,in11
c
          perci=0.05*theta_int(in1,2)
          percf=0.05*theta_int(in11,2)
c          perci=1.0
c          percf=1.0
          do j=irani,iranf
c           write(6,*) 'THETAPICCO',j,theta_int(j,7),theta_int(j,2)
c            if(theta_int(j,2).gt.theta_int(in1,2).and.
c    *         theta_int(j,2).gt.theta_int(in11,2)) then
            if(theta_int(j,2).ge.(perci+theta_int(in1,2)).and.
     *        theta_int(j,2).ge.(percf+theta_int(in11,2))) then

c             write(6,*) 'SCELTOPICCO',j,theta_int(j,1),theta_int(j,2)

              npk_extra=npk_extra+1
              xxmax(npk_extra)=xxxmax
              yymax(npk_extra)=aymax
              afwxmax(npk_extra)=drfwhm

c             write(6,*)'LUI',i,npk_extra,xxmax(npk_extra)
c    *                    ,afwxmax(npk_extra),yymax(npk_extra)
              write(lo,500) xxmax(npk_extra),afwxmax(npk_extra)
              go to 1
            endif
          end do  
        endif
 1      continue
      end do

      call dele_extra(npk_extra,xxmax,yymax,afwxmax)

 500  format(/,'Be careful1 the peak in ',f7.3,' can be an impurity.' 
     *' It has FWHM =',f7.3)
 501  format(/,'Be careful1 the peak in ',f7.3,' can be an impurity.' 
     *' It has FWHM =',f7.3, '  came to the peaksearch ')
      return  
      end
c-----------------------------------
      subroutine dele_extra(npk_extra,xxmax,yymax,afwxmax)
      USE Riflessi
      USE xdataMod
      USE Conteggi
      USE General
      USE arrayutil

      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common /peak/xmax(200),ymax(200),fw(200),npk,asm(200)
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      dimension xxmax(nrefl),yymax(nrefl),afwxmax(nrefl)
c
      do i=1,npk_extra
c          if(xxmax(i)<thmin) goto 1
          if(xxmax(i)<theta_int(1,7)) goto 1
!corr          inizz = anint((xxmax(i) - theta_int(1,7))/thstep )+1
          inizz = clocate(theta_int(:npunti,7),xxmax(i))
c         inizz = int ( ( xxmax(i) - thmin ) / thstep ) + 2
          nstep=anint((afwxmax(i))/thstep) !��a lo mejor es mejor con int??
          iniz=max0(1,inizz-nstep)
          ifin=min0(npunti,inizz+nstep)
c         write(6,*) 'DELE',i,theta_int(iniz,7),theta_int(ifin,7)
c    *               ,afwxmax(i),yymax(i),npk_extra
          yminnn=999999999.0
          do j=iniz,ifin
            if(theta_int(j,2).lt.yminnn) yminnn=theta_int(j,2)
          enddo 
          yint=yymax(i)
          if(afwxmax(i).eq.0.0) go to 1
          const=-4.0*alog(2.0)/(afwxmax(i)**2)
          const1=(2.0*sqrt(alog(2.0)/pi))/afwxmax(i)

          do j=iniz,ifin
            dth=theta_int(j,7)-xxmax(i)
            asi=1-(asym*sign(1.0,dth)*
     *          dth**2/atan(xxmax(i)))
            funct=exp(const*(dth**2))
c           funct=asi*const1*exp(const*(dth**2))
c           write(6,*)'GAUSS',j,theta_int(j,7),theta_int(j,2),yint*funct
            theta_int(j,2)=theta_int(j,2)-yint*funct
            if(theta_int(j,2).lt.yminnn)theta_int(j,2)=yminnn
            if(theta_int(j,2).lt.back_int(j,1)) 
     *             theta_int(j,2)=back_int(j,1)
c           write(6,*) 'GAUSS',j,theta_int(j,7),theta_int(j,2)
          enddo 
  1   continue
      enddo   

c     do i=1,npunti
c       write(6,*) 'PICCHIDOPO',i,theta_int(i,7),theta_int(i,2)
c     end do
      do i=1,npunti
        theta_int(i,5)=theta_int(i,2)
      end do
c     write(6,*)'DELE_'
      call ysfr37(npunti)
c
      return  
      end
c-----------------------------------------------------------------------
      subroutine profrefnew(thminref,thmaxref) 
      USE Riflessi
      USE xdataMod
      USE Conteggi
!qt      USE grexpomod, only:gr_setcolor,gr_line
      USE General
      USE Molcom      
      USE PatternRef
      USE arrayutil
      USE view, only: Profile_Curves
      USE plot2, only: add_plot
      USE iso_c_binding, only: c_null_char
c
c-- calcola il profilo (Pearson,Psvoigt,Gauss) associato
c   ai riflessi che cadono entro l'intervallo 'thmaxref,thminref'
c
c   vuole in input solo i valori di THMINREF e di THMAXREF gia'
c   corretti per lo zero.
c
c-- idrprof(j) = nr. conteggi del riflesso j-esimo
c--           (j = progressivo nell'intervallo)
c-- ipprof  = codice del primo riflesso nell'intervallo
c--           (progressivo del riflesso nella lista di tutti i
c--           riflessi ordinati in funzione di 2-theta)
c-- nrprof  = nr. tot. di riflessi che cadono nell'intervallo
c-- countref(n) = vettore contenente i conteggi di tutti i riflessi
c--              che cadono nell'interv. I valori sono memorizzati
c--              in modo sequenziale; i puntatori ai conteggi di ogni
c--              rifl. vanno CALCOLATI aggiungendo il valore relativo
c--              al rifl. (contenuto in idrprof) alla somma dei valori
c--              precedenti
      common /profp/dumpp,nprof,ipol
      common/genob/irho,thetamin
      common /bbbb/ oscalef,gpror,natso
      common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,iequi_corrado     !!! c'e' un iEqui(9800) in molcom.inc
      common /direx/ncycle,icycle,nosing,izero ,zeroprof,asym,scal,frac
     *              ,noint,ialt,sigma,if92,nocell
      common/anna/ncounmax
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      dimension idrprof(nrefl,3)
      allocatable :: countrefn(:)
!qt      integer, dimension(0:9) :: vetcolor
      real, dimension(:), allocatable :: xpvet,ypvet
!qt!
!qt!     Definisci i colori da usare nel disegnare le curve
!qt      vetcolor(0) = color_LIGHTMAGENTA
!qt      vetcolor(1) = color_LIGHTBLUE
!qt      vetcolor(2) = color_LIGHTGREEN
!qt      vetcolor(3) = color_LIGHTCYAN
!qt      vetcolor(4) = color_LIGHTRED
!qt      vetcolor(5) = color_LIGHTRED
!qt      vetcolor(6) = color_YELLOW
!qt      vetcolor(7) = color_LIGHTMAGENTA
!qt      vetcolor(8) = color_LIGHTBLUE
!qt      vetcolor(9) = color_LIGHTBLUE
!
      !if (iriet == 1) then
      !    call decomponi_spettro(thminref,thmaxref)
      !    return
      !endif
corrado
!!! corrado-patch per calcolo approssimato della massima ampiezza di picco
              ncounmax = 2.0*maxval(phkl(:nrefl,5))/thstep  
              !!!!write(6,*)'NCOUNMAX=',ncounmax
!!!              
      idimmax = nrefl*ncounmax
      allocate(countrefn(idimmax))
c
!corr      kkprog = mod(kprog,10)
      ier = 0
!corr      if(kkprog.ne.5) numint=nnt
      numint = nnt
!corr      ksh = -1
      ksh = numint
c
!corr      if(nnt.eq.1.and.kkprog.eq.4)then
!corr                       ier=5
!corr                       go to 500
!corr                       endif
      do 10 i=1,numint
      if(thminref.ge.thet1(i).and.thmaxref.le.thet2(i)) then
          ksh = i
          go to 20
      endif
   10 continue
   20 continue
      if(ksh.lt.0) then
         ier = 1
         go to 500
      end if
c
      THMINSAV = THMIN
      THMAXSAV = THMAX
      THMIN = THMIN -2.0*zeroprof
      THMAX = THMAX -2.0*zeroprof
!corr      iniref = int ( ( thminref - thmin ) / thstep ) + 1
!corr      if(iniref.gt.npunti) iniref = npunti
!corr      ifiref = int ( ( thmaxref - thmin ) / thstep ) + 1
!corr      if(ifiref.gt.npunti) ifiref = npunti
!corr      if(ifiref.lt.iniref) then
!corr         ier = 2
!corr         go to 500
!corr      end if
      iniref = clocate(theta_int(:npunti,7),thminref)
      ifiref = clocate(theta_int(:npunti,7),thmaxref)
      !if(ifiref.lt.iniref) then
      !   ier = 2
      !   go to 500
      !end if
      scalant=scal
      zero=0.00001
      nrprof = 0
      ipprof = 0
      do i=nref1(ksh),nref2(ksh)
         if(TThet(i).ge.thminref.and.TThet(i).lt.thmaxref) then
            if(ipprof.eq.0) ipprof = i
            nrprof = nrprof + 1
         endif
      enddo
   60 continue
      if(ipprof.lt.1.or.nrprof.lt.1) then
         ier = 3
         go to 500
      end if
      nrptot = 0
      do 100 jj=1,nrprof
      j=ipprof+jj-1
c---
      if(neutro.eq.0.and.nsyn.eq.0) then
         alp = 1.0 + 0.8*(cos(TThet(j)*dtor))**2
      else
         alp = 1.0
      endif
      blp = sin(0.5*TThet(j)*dtor) * sin(TThet(j)*dtor)
      clp(j)=1.0
      if(abs(blp).gt.zero) clp(j)=alp/blp
c---
      rdeg = 0.5 * TThet(j) * dtor
      tdeg = sin(rdeg) / cos(rdeg)
      tdeg2 = tdeg * tdeg
      cdeg=cos(rdeg)
      uvwg=phkl(j,6)
      uvw2=phkl(j,5)
      uvwqg=uvwg**2
      if(uvwg.lt.0.00001)then
         ier=5
         go to 500
      endif
      theta0=TThet(j)
      thminn=amax1(theta0-uvw2,thmin)
      thmaxx=amin1(theta0+uvw2,thmax)
!corr      ranth=thminn-thmin
!corr      iniz = int ( ( thminn - thmin ) / thstep ) + 1
!corr      if(amod(ranth,thstep).gt.0.0)iniz=iniz+1
!corr      if(iniz.gt.npunti) iniz = npunti
!corr      ifin = int ( ( thmaxx - thmin ) / thstep ) + 1
!corr      if(ifin.gt.npunti) ifin = npunti
!corr      if(ifin.lt.iniz) go to 201
      iniz = clocate(theta_int(:npunti,7),thminn)
      ifin = clocate(theta_int(:npunti,7),thmaxx)
      if(ifin.lt.iniz) go to 201
      iniref = min0(iniref,iniz)
      ifiref = max0(ifiref,ifin)
!corr      if (kkprog.eq.5) then
!corr          ffx = pesov(j)*Mult(j)*(fcv(j)**2)
!corr       else
C         ffx = Mult(j)*clp(j)*(fx(j)**2)
          ffx = fx(j)
!corr      endif
cc
      do 200 nnn=iniz,ifin
      nrptot = nrptot + 1
      if(nrptot.gt.idimmax) then
         ier = 4
         go to 500
      end if
      countrefn(nrptot) = 0.0
      th = theta_int(nnn,7)
      deltath=th-theta0
      deltath2=deltath**2
      if(nprof.eq.1)then
      cc=(1.0+phkl(j,2)*deltath2)
      ffunct=phkl(j,4)*phkl(j,1)*(cc**(-phkl(j,3)))
      asnum=asym*(deltath**3)
      asd1=deltath2
      asd2=1.0/phkl(j,2)
      asden=(asd1+asd2)**1.5
      asterm=asnum/asden+1.0
      elseif(nprof.eq.2)then
      cc=-phkl(j,2)*deltath2
      ffunct=phkl(j,1)*exp(cc)
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.3)then
      cc=1.0+phkl(j,2)*deltath2
      ffunct=phkl(j,1)/cc
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      elseif(nprof.eq.4)then
      cc1=-phkl(j,2)*deltath2
      ffunct1=phkl(j,1)*exp(cc1)
      cc2=1.0+phkl(j,4)*deltath2
      ffunct2=phkl(j,3)/cc2
      eta=uvwt(4)+uvwt(5)*tdeg+uvwt(6)*tdeg2
      ffunct=eta*ffunct1+(1.0-eta)*ffunct2
      asterm=1.0-(asym*sign(1.0,deltath)*deltath2)/tdeg
      endif
      countrefn(nrptot) = scalant*ffunct*ffx*asterm
  200 continue
      idrprof(jj,1)=iniz
      idrprof(jj,2)=ifin
      idrprof(jj,3)=nrptot
c     write(*,*)'jj,iniz,ifin,nrptot',jj,iniz,ifin,nrptot
  201 continue
  100 continue
c
      THMIN = THMINSAV
      THMAX = THMAXSAV
c
      nc1 = 1
      allocate(xpvet(ncounmax),ypvet(ncounmax))
      do j=1,nrprof
         jj = j + ipprof - 1
         iColor = nint((real(jj) / 10. - jj / 10) * 10.)  ! il colore e' l'ultima cifra di j
         ini = idrprof(j,1)
!qt         ifi = idrprof(j,2)
         nc2 = idrprof(j,3)
!         write(71,*)'NC1=',j,nc2-nc1+1,ncounmax
         np = 0
         do i=nc1,nc2
            x1 = Theta_int(ini+i-nc1,7)
            y1 = countrefn(i) + back_int(ini+i-nc1,1)
            np = np + 1
            xpvet(np) = x1
            ypvet(np) = y1
         enddo
         call add_plot(xpvet(:np),ypvet(:np),np,
     *                 Profile_Curves,1,wavel,c_null_char)
!qt         x1 = Theta_int(ini,7)
!qt         y1 = countrefn(nc1) + back_int(ini,1)
!qt         do 250 i=nc1+1, nc2
!qt            x2 = Theta_int(ini+i-nc1,7)
!qt            if (x2 > thmaxref) exit
!qt            y2 = countrefn(i) + back_int(ini+i-nc1,1)
!qt            if (x1 > thminref) then
!qt                call gr_setcolor(vetcolor(iColor))
!qt                call gr_line(x1,y1,x2,y2)
!qt            endif
!qt            x1 = x2
!qt            y1 = y2
!qt  250    continue
         nc1 = nc2 + 1
      enddo
      return
  500 continue
      return
      end
!---------------------------------------------------------------------      
      subroutine provajsys()
      USE Symmetry
      k = jsys
      return
      end
!---------------------------------------------------------------------
      subroutine variance2
      USE Conteggi
      USE nr
      USE VIEW
      USE ProfileApp
      USE General
      USE Riflessi
      USE Symmetry
      USE xdataMod
      USE arrayutil
      USE extramodule, only: icare
!corr      include 'rando.fi'
      USE randofi
!corr      common/care/ icare(3000)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/popt/inor,iproff,iext,npseu,cpse(2),npse(12),nsetint,iknow
     *,ipror,iorie(3),gpror
      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      dimension tin1(500),tin2(500)
      dimension ninte(500),ninteb(500),nintev(500)
      dimension smedia(500),svaria(500),smediab(500),svariab(500),
     *          nrug(500),nrif(500),reff(500),
     *          svaria1(500),irumo(500),smedia1(500)
      dimension ff1(nrefl),ff2(nrefl)
!
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
!
c
      ymaxim=-9999999.0
      do i=1,npunti
        if(theta_int(i,2).gt.ymaxim)then
           ymaxim=theta_int(i,2)
           imaxim=i
        endif
      enddo
      yminim=99999999.0
      ima1=max0(1,imaxim-50)
      ima2=min0(npunti,imaxim+50)
      do i=ima1,ima2                       
        if(theta_int(i,2).lt.yminim)yminim=theta_int(i,2)
      enddo
      ymaxim=ymaxim-yminim
      i1b=0
      i2b=0
      do i=imaxim-1,1,-1
        if((theta_int(i,2)-yminim).lt.ymaxim*0.5)then
           i1b=i
           go to 133
        endif
      enddo
 133  continue
      do i=imaxim+1,npunti
        if((theta_int(i,2)-yminim).lt.ymaxim*0.5)then
           i2b=i
           go to 144
        endif
      enddo
 144  continue
      if(i2b.lt.i1b.or.i2b.eq.0.or.i1b.eq.0)then
        i1b=max0(1,imaxim-9)
        i2b=min0(npunti,imaxim+9)
      endif
      if((i2b-i1b+1).lt.10)i2b=i1b+9
      uvw2=theta_int(i2b,7)-theta_int(i1b,7)
      rsog=0.5
      if(iknow.gt.0)then
        reffee=0.0
        ff1(1:nrefl)=sqrt(fx(1:nrefl)/(clp(1:nrefl)*Mult(1:nrefl)))
        ff2(1:nrefl)=fxsav(1:nrefl)
        scalaf=sum(ff2(1:nrefl))/sum(ff1(1:nrefl))
        sumeffe1=sum(abs(scalaf*ff1(1:nrefl)-ff2(1:nrefl)))
        sumeffe2=sum(ff2(1:nrefl))
        if(sumeffe2.gt.0.0)reffee=sumeffe1/sumeffe2
        dmax0=alambda/(2.0*sin(0.5*dtor*theta_int(npunti,7)))
      endif
      icare(1:nrefl)=0
      tin1=0.0
      tin2=0.0
      irumo=0
      tin1(1)=theta_int(1,7)
      thth=amax1(0.3,20.0*thstep)
      nntht=nint(thth/thstep)
      nnthth=min0(20,nntht)     
      dthh=thth*0.9
      nthint=1                           
      vsog=1.05
 10   continue
      ithtt=0
      do i=1,npunti
           if(theta_int(i,7).ge.(tin1(nthint)+thth).
     *        and.theta_int(i,2).le.vsog*back_int(i,1))then
             tin2(nthint)=theta_int(i,7)
             tin1(nthint+1)=tin2(nthint)
             ii=min0(npunti,i+20)
             ii=min0(npunti,i+nnthth)
             dthmin=theta_int(i,2)
            do j=i+1,ii       
              if(theta_int(j,2).le.dthmin)then
                dthmin=theta_int(j,2)
                tin2(nthint)=theta_int(j,7)
                tin1(nthint+1)=tin2(nthint)
              endif
            enddo
 20          continue
             nthint=nthint+1
             ithtt=1
             go to 10
           endif
      enddo
      if(ithtt.eq.0)then
          if((theta_int(npunti,7)-tin1(nthint)).gt.dthh)then
           tin2(nthint)=theta_int(npunti,7)
          else
           nthint=nthint-1
           tin2(nthint)=theta_int(npunti,7)
          endif
      endif
      call AllocaProfileApp(1)
      theta_app(1:npunti,2)=theta_int(1:npunti,2)
      theta_int(1:npunti,2)=theta_int(1:npunti,5)
      theta_app(:npunti,1)=0.0
      variamed=0.0                 
      do i=1,nthint
         ninte(i)=0
         ninteb(i)=0
         nintev(i)=0
         smediab(i)=0.0
         smedia(i)=0.0                    
         svaria(i)=0.0
         svariab(i)=0.0
         nrug(i)=0
         nrif(i)=0
         reff(i)=0.0
         sumeffe1=0.0
         sumeffe2=0.0
         do jj=1,nrefl
             if(TThet(jj).ge.tin1(i).and.TThet(jj).le.tin2(i))then
               nrif(i)=nrif(i)+1
               if(iknow.eq.1)then
                 sumeffe1=sumeffe1+abs(scalaf*ff1(jj)-ff2(jj))
                 sumeffe2=sumeffe2+ff2(jj)
               endif
             endif
         enddo
         if(iknow.eq.1.and.sumeffe2.gt.0.0)reff(i)=sumeffe1/sumeffe2
         do j=1,npunti
           if(theta_int(j,7).ge.tin1(i).and.
     *        theta_int(j,7).lt.tin2(i))then
             ninte(i)=ninte(i)+1
             smedia(i)=smedia(i)+theta_int(j,2)-back_int(j,1)
             smediab(i)=smediab(i)+back_int(j,1)   
           endif
         enddo
         smedia(i)=(smedia(i)/float(ninte(i)))
         smediab(i)=(smediab(i)/float(ninte(i)))
         do j=1,npunti
           if(theta_int(j,7).ge.tin1(i).
     *        and.theta_int(j,7).lt.tin2(i))then
              if((theta_int(j,2)-back_int(j,1)).ge.smedia(i))then
                svaria(i)=svaria(i)+
     *          (theta_int(j,2)-back_int(j,1)-smedia(i))**2
                nintev(i)=nintev(i)+1
              endif
              if(back_int(j,1).ge.smediab(i))then
                svariab(i)=svariab(i)+
     *          (back_int(j,1)-smediab(i))**2
                ninteb(i)=ninteb(i)+1
              endif
             if(j.ne.1.and.j.ne.npunti)then
               if((theta_int(j,2)-back_int(j,1)).gt.smedia(i).
     *          and.(theta_int(j-1,2)-back_int(j-1,1)).gt.smedia(i).
     *          and.(theta_int(j+1,2)-back_int(j+1,1)).gt.smedia(i))then
                 theta_app(j,1)=1.0
                 nrug(i)=nrug(i)+1
               endif
               if((theta_int(j,2)-back_int(j,1)).lt.smedia(i).
     *          and.(theta_int(j-1,2)-back_int(j-1,1)).lt.smedia(i).
     *          and.(theta_int(j+1,2)-back_int(j+1,1)).lt.smedia(i))then
                 theta_app(j,1)=1.0
                 nrug(i)=nrug(i)+1
               endif
             endif
           endif
         enddo
         svaria(i)=sqrt(svaria(i)/float(nintev(i)))
         svariab(i)=sqrt(svariab(i)/float(ninteb(i)))
      enddo
      iisav=0
      iisav2=0
      iisav3=0
      smediamin=99999999.0
      smediamin2=99999999.0
      smediamin3=99999999.0
      rsogmin=1.0
      do i=1,nthint
         if(nrif(i).eq.0.)then
         if(svaria(i).lt.smediamin)then
              smediamin=svaria(i)
              iisav=i
         endif
         endif
      enddo
      do i=1,nthint
         if(svaria(i)*svariab(i)*float(nrug(i))/float(ninte(i)).
     *     lt.smediamin2.and.float(nrug(i))/float(ninte(i)).le.rsog)then
              smediamin2=svaria(i)*svariab(i)*
     *        float(nrug(i))/float(ninte(i))
              iisav2=i
         endif
      enddo
      do i=1,nthint
!        if(svariab(i)*svaria(i)*float(nrug(i))/float(ninte(i)).
!    *     lt.smediamin3.and.i.lt.nthint/2)then
!             smediamin3=
!    *        svariab(i)*svaria(i)*float(nrug(i))/float(ninte(i))
!             iisav3=i
!        endif
         if(float(nrug(i))/float(ninte(i)).lt.rsogmin)then
              rsogmin=float(nrug(i))/float(ninte(i))
              iisav3=i
         endif
      enddo
      if(iisav.gt.0)then
        variamed=svaria(iisav)
      elseif(iisav2.gt.0)then
        iisav=iisav2
        variamed=svaria(iisav2)
      elseif(iisav3.gt.0)then
        iisav=iisav3
!       variamed=svaria(iisav2)
        variamed=svaria(iisav3)
      endif
      if (ispaceindexing==0) then
      write(lo,'(a)')'    '
      write(lo,'(a)')' |----------------------------------------------|'
      write(lo,'(a)')' |         PROFILE STATISTICAL ANALYSIS         |'
      write(lo,'(a)')' |  The stared profile zones may be critical    |'
      write(lo,'(a)')' |  For each zone:                              |'
      write(lo,'(a)')' |   2theta-min, 2theta-max,#points,count-aver.,|'
      write(lo,'(a)')' |   back-aver.,count-stdv, back-stdv,#reflec., |'
      write(lo,'(a)')' |   noise-param.                               |'
      write(lo,'(a,f10.3,a)')' |   reference variance = '
     *,variamed,'            |'
      write(lo,'(a)')' |----------------------------------------------|'
      write(lo,'(a)')'    '
      endif
      do i=1,nthint
         rsog=0.5
         if((float(nrug(i))/float(ninte(i))).gt.0.79)rsog=0.0
         if((float(nrug(i))/float(ninte(i))).le.rsog.or. 
     *      svaria(i).lt.1.15*variamed)then
              irumo(i)=1
              if (ispaceindexing==0) then
              write(6,'(a,2f8.2,i4,4f10.3,i4,2f10.3,a)')
     *                 'info '
     *                 ,tin1(i),
     *                 tin2(i),ninte(i),smedia(i),smediab(i),svaria(i),
     *                 svariab(i),nrif(i),
     *                 float(nrug(i))/float(ninte(i)),
     *                 reff(i)
     *                 ,' **'
              endif
         else
              if (ispaceindexing==0) then
              write(6,'(a,2f8.2,i4,4f10.3,i4,2f10.3,3x)')'info '
     *                 ,tin1(i),
     *                 tin2(i),ninte(i),smedia(i),smediab(i),svaria(i)
     *                 ,svariab(i),nrif(i),
     *                 float(nrug(i))/float(ninte(i)),
     *                 reff(i)
              endif
         endif
      enddo
      do i=1,nthint
        if(irumo(i).gt.0)then
         if(i.gt.1)then
          if(irumo(i-1).eq.0)then
!corr            i1 = int ( ( tin1(i) - thmin ) / thstep ) + 1
            i1 = clocate(theta_int(:npunti,7),tin1(i))
            if(i1.gt.1)then
             do j=i1,2,-1
              if(theta_int(j,7).ge.tin1(i-1).and.
     *          ((theta_int(j,2)-back_int(j,1)).lt.1.05*smedia(i).or. 
     *          theta_int(j,2).lt.1.06*theta_int(j-1,2)))then
                smedia(i)=(smedia(i)*ninte(i)+
     *                    theta_int(j,2)-back_int(j,1))/(ninte(i)+1)
                ninte(i)=ninte(i)+1
                tin2(i-1)=theta_int(j,7)
                tin1(i)=theta_int(j,7)
              else
                go to 333
              endif
             enddo
            endif
 333        continue
          endif
         endif
         if(i.lt.nthint)then
          if(irumo(i+1).eq.0)then
!corr            i2 = int ( ( tin2(i) - thmin ) / thstep ) + 1
            i2 = clocate(theta_int(:npunti,7),tin2(i))
            if(i2.lt.2)i2=2
            do j=i2,npunti
              if(theta_int(j,7).le.tin2(i+1).and.
     *          ((theta_int(j,2)-back_int(j,1)).lt.1.05*smedia(i).or.
     *          theta_int(j,2).lt.1.06*theta_int(j-1,2)))then
                smedia(i)=(smedia(i)*ninte(i)+
     *                    theta_int(j,2)-back_int(j,1))/(ninte(i)+1)
                ninte(i)=ninte(i)+1
                tin2(i)=theta_int(j,7)
                tin1(i+1)=theta_int(j,7)
              else
                go to 444
              endif
            enddo
 444        continue
          endif
         endif
        endif
      enddo
      if (ispaceindexing==0) write(6,'(a)')'    '
      do i=1,nthint
        if(irumo(i).gt.0.0)then
          do jj=1,nrefl
             if(TThet(jj).ge.tin1(i).
     *         and.TThet(jj).le.tin2(i))then
               icare(jj)=1
             endif
          enddo
          if (ispaceindexing==0) then
          write(6,'(a,2f8.2)')'noisy interval ',tin1(i),tin2(i)
          endif
c       else
c         write(6,'(a,2f8.2)')'infointerval ',tin1(i),tin2(i)
        endif
      enddo
      do i=1,nrefl
        if(icare(i).eq.1)cycle
        theta0=TThet(i)
        if(i.eq.1)then
          if((TThet(i+1)-TThet(i)).le.2.0*uvw2)cycle
        elseif(i.eq.nrefl)then
          if((TThet(i)-TThet(i-1)).le.2.0*uvw2)cycle
        else
          if((TThet(i+1)-TThet(i)).le.2.0*uvw2)cycle
          if((TThet(i)-TThet(i-1)).le.2.0*uvw2)cycle
        endif
        thminn=amax1(theta0-uvw2*5.0,thmin)
        thmaxx=amin1(theta0+uvw2*5.0,thmax)
        if(i.gt.1)thminn=amax1(theta0-(TThet(i)-TThet(i-1))*0.5,thmin)
        if(i.lt.nrefl)
     *  thmaxx=amin1(theta0+(TThet(i+1)-TThet(i))*0.5,thmax)
!corr        iniz = int ( ( thminn - thmin ) / thstep )+1
!corr        ifin = int ( ( thmaxx - thmin ) / thstep )+1
        iniz = clocate(theta_int(:npunti,7),thminn)
        ifin = clocate(theta_int(:npunti,7),thmaxx)
        if(ifin.le.iniz)cycle
        nco=0
        sco=0.0
         do j=iniz,ifin
             nco=nco+1
             sco=sco+theta_int(j,2)-back_int(j,1)
         enddo
         sco=sco/float(nco)
         svo=0.0
         nvo=0
         nro=0
         do j=iniz,ifin
              if((theta_int(j,2)-back_int(j,1)).ge.sco)then
                svo=svo+(theta_int(j,2)-back_int(j,1)-sco)**2
                nvo=nvo+1
              endif
             if(j.ne.1.and.j.ne.npunti)then
               if((theta_int(j,2)-back_int(j,1)).gt.sco.
     *          and.(theta_int(j-1,2)-back_int(j-1,1)).gt.sco.
     *          and.(theta_int(j+1,2)-back_int(j+1,1)).gt.sco)then
                nro=nro+1
               endif
               if((theta_int(j,2)-back_int(j,1)).lt.sco.
     *          and.(theta_int(j-1,2)-back_int(j-1,1)).lt.sco.
     *          and.(theta_int(j+1,2)-back_int(j+1,1)).lt.sco)then
                nro=nro+1
               endif
             endif
         enddo
         svo=sqrt(svo/float(nvo))
         if(svo.lt.1.15*variamed)then
      if (ispaceindexing==0) then
          write(6,'(a,i4,3i4,f10.3)')' critical reflection',
     *          i,IndHKL(i,1:3),TThet(i)
      endif
          icare(i)=1
          endif
      enddo
      call AllocaProfileApp(2)
      return
      end
c-----------------------------------------------------------------------
      subroutine indagine_back
      USE Conteggi
      USE nr
      USE VIEW
      USE ProfileApp
      USE General
      USE Riflessi
      USE Symmetry
      USE xdataMod
      dimension tin1(500),tin2(500)
      dimension ninte(500),ninteb(500),nrug(500)
      real, allocatable :: back_sav(:)
c
      allocate(back_sav(npunti))
      back_sav(:npunti)=back_int(:npunti,1)
      back_int(1:npunti,2)=0.0
        tin1=0.0
        tin2=0.0
        tin1(1)=theta_int(1,7)
        thth=1.0
        nthint=1
 10     continue
        ithtt=0
        do i=1,npunti
           if(theta_int(i,7).ge.(tin1(nthint)+thth).
     *        and.theta_int(i,2).lt.1.05*back_int(i,1))then
             tin2(nthint)=theta_int(i,7)
             tin1(nthint+1)=tin2(nthint)
             nthint=nthint+1
             ithtt=1
             go to 10
           endif
        enddo
        if(ithtt.eq.0)then
          if((theta_int(npunti,7)-tin1(nthint)).gt.1.0)then
           tin2(nthint)=theta_int(npunti,7)
          else
           nthint=nthint-1
           tin2(nthint)=theta_int(npunti,7)
          endif
        endif
      do i=1,nthint
         ninte(i)=0
         ninteb(i)=0
         nrug(i)=0
         do j=1,npunti
         if(theta_int(j,7).ge.tin1(i).and.theta_int(j,7).lt.tin2(i))then
             ninte(i)=ninte(i)+1
             if(back_int(j,1).ge.theta_int(j,2))ninteb(i)=ninteb(i)+1
             if(j.eq.1)nrug(i)=nrug(i)+1
             if(j.eq.2)nrug(i)=nrug(i)+1
             if(j.ge.3)then
             prod1=theta_int(j,2)-theta_int(j-1,2)
             prod2=theta_int(j-1,2)-theta_int(j-2,2)
             if((prod1*prod2).gt.0.0)nrug(i)=nrug(i)+1
             endif
         endif
         enddo
         if((float(nrug(i))/float(ninte(i))).ge.0.45)cycle
         if((float(ninteb(i))/float(ninte(i))).lt.0.1)then
             do k=1,50
               bstep=1.0+float(k)*0.5
               nlargeb=0
               do j=1,npunti
                 if(theta_int(j,7).ge.tin1(i).
     *            and.theta_int(j,7).lt.tin2(i))then
                  back_int(j,1)=back_sav(j)*bstep
                  if(back_int(j,1).ge.theta_int(j,2))
     *              nlargeb=nlargeb+1
                 endif
               enddo
               if((float(nlargeb)/float(ninte(i))).ge.0.1.and.
     *            (float(nlargeb)/float(ninte(i))).lt.0.2)go to 1000
             enddo
             do j=1,npunti
                 if(theta_int(j,7).ge.tin1(i).
     *             and.theta_int(j,7).lt.tin2(i))then
                   back_int(j,1)=back_sav(j)
                 endif
             enddo
 1000        continue
         endif
         if((float(ninteb(i))/float(ninte(i))).gt.0.2)then
             do k=1,50
               bstep=1.0+float(k)*0.5
               nlargeb=0
               do j=1,npunti
                 if(theta_int(j,7).ge.tin1(i).
     *            and.theta_int(j,7).lt.tin2(i))then
                  back_int(j,1)=back_sav(j)*bstep
                  if(back_int(j,1).ge.theta_int(j,2))
     *               nlargeb=nlargeb+1
                 endif
               enddo
               if((float(nlargeb)/float(ninte(i))).ge.0.1.and.
     *            (float(nlargeb)/float(ninte(i))).lt.0.2)go to 2000
             enddo
             do j=1,npunti
                 if(theta_int(j,7).ge.tin1(i).
     *             and.theta_int(j,7).lt.tin2(i))then
                   back_int(j,1)=back_sav(j)
                 endif
             enddo
 2000        continue
         endif
      enddo
      do j=1,npunti
         if(back_int(j,1).gt.theta_int(j,2))back_int(j,1)=theta_int(j,2)
      enddo
      back_int(1:npunti,2)=back_int(1:npunti,1)
      deallocate(back_sav)
      return
      end
